CREATE TABLE ARA_DISTRICT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcenter VARCHAR(255), xcity VARCHAR(64), xcityCode VARCHAR(255), xdistrict VARCHAR(64), xlevel VARCHAR(255), xname VARCHAR(255), xprovince VARCHAR(64), xsha VARCHAR(255), xzipCode VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ARA_DISTRICT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_ATTENDANCE_ADMIN (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xadminLevel VARCHAR(96), xadminName VARCHAR(96), xunitName VARCHAR(255), xunitOu VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ATDC_ATTENDANCE_ADMIN_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_ATTENDANCE_APPEALINFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xaddress VARCHAR(255), xappealDateString VARCHAR(32), xappealDescription CLOB, xappealReason VARCHAR(64), xarchiveTime VARCHAR(32), xcurrentProcessor VARCHAR(255), xdetailId VARCHAR(64), xempName VARCHAR(255), xendTime VARCHAR(32), xmonthString VARCHAR(16), xopinion1 VARCHAR(255), xopinion2 VARCHAR(255), xprocessPerson1 VARCHAR(255), xprocessPerson2 VARCHAR(255), xprocessPersonTopUnit1 VARCHAR(255), xprocessPersonTopUnit2 VARCHAR(255), xprocessPersonUnit1 VARCHAR(255), xprocessPersonUnit2 VARCHAR(255), xprocessTime1 TIMESTAMP, xprocessTime2 TIMESTAMP, xreason CLOB, xrecordDate TIMESTAMP, xrecordDateString VARCHAR(32), xselfHolidayType VARCHAR(64), xstartTime VARCHAR(32), xstatus INTEGER, xtopUnitName VARCHAR(255), xunitName VARCHAR(255), xyearString VARCHAR(16), PRIMARY KEY (xid), CONSTRAINT ATDC_ATTENDANCE_APPEALINFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_ATTENDANCE_DETAIL (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xabnormalDutyDayTime VARCHAR(32), xabsence DOUBLE, xabsentDayTime VARCHAR(32), xappealDescription CLOB, xappealProcessor VARCHAR(255), xappealReason VARCHAR(64), xappealStatus INTEGER, xarchiveTime VARCHAR(32), xattendance DOUBLE, xbatchName VARCHAR(96), xcycleMonth VARCHAR(16), xcycleYear VARCHAR(16), xdescription VARCHAR(255), xempName VARCHAR(96), xempNo VARCHAR(96), xgetSelfHolidayDays DOUBLE, xisAbnormalDuty BOOLEAN, xisAbsent BOOLEAN, xisGetSelfHolidays BOOLEAN, xisHoliday BOOLEAN, xisLackOfTime BOOLEAN, xisLate BOOLEAN, xisLeaveEarlier BOOLEAN, xisWeekend BOOLEAN, xisWorkOvertime BOOLEAN, xisWorkday BOOLEAN, xlateTimeDuration BIGINT, xleaveEarlierTimeDuration BIGINT, xmonthString VARCHAR(16), xoffDutyTime VARCHAR(32), xoffWorkTime VARCHAR(32), xonDutyTime VARCHAR(32), xonWorkTime VARCHAR(32), xrecordDate TIMESTAMP, xrecordDateString VARCHAR(32), xrecordStatus INTEGER, xselfHolidayDayTime VARCHAR(32), xtopUnitName VARCHAR(255), xunitName VARCHAR(255), xworkOvertimeTimeDuration BIGINT, xworkTimeDuration BIGINT, xyearString VARCHAR(16), PRIMARY KEY (xid), CONSTRAINT ATDC_ATTENDANCE_DETAIL_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_ATTENDANCE_DETAIL_MOBILE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdescription VARCHAR(255), xempName VARCHAR(96), xempNo VARCHAR(96), xlatitude VARCHAR(32), xlongitude VARCHAR(32), xoptMachineType VARCHAR(32), xoptSystemName VARCHAR(32), xrecordAddress VARCHAR(255), xrecordDate TIMESTAMP, xrecordDateString VARCHAR(32), xrecordStatus INTEGER, xsignDescription VARCHAR(128), xsignTime VARCHAR(32), PRIMARY KEY (xid), CONSTRAINT ATDC_ATTENDANCE_DETAIL_MOBILE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_ATTENDANCE_DINGTALK (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xbaseCheckTime BIGINT, xcheckType VARCHAR(32), xddID BIGINT, xgroupId BIGINT, xlocationResult VARCHAR(32), xo2Unit VARCHAR(128), xo2User VARCHAR(128), xplanId BIGINT, xrecordId BIGINT, xsourceType VARCHAR(32), xtimeResult VARCHAR(32), xuserCheckTime BIGINT, xuserCheckTimeDate TIMESTAMP, xuserId VARCHAR(96), xworkDate BIGINT, PRIMARY KEY (xid), CONSTRAINT ATDC_ATTENDANCE_DINGTALK_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_ATTENDANCE_EMPLOYEE_CONFIG (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xconfigType VARCHAR(16), xempInTopUnitTime VARCHAR(32), xemployeeName VARCHAR(96), xemployeeNumber VARCHAR(96), xtopUnitName VARCHAR(255), xtopUnitOu VARCHAR(255), xunitName VARCHAR(255), xunitOu VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ATDC_ATTENDANCE_EMPLOYEE_CONFIG_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_ATTENDANCE_IMPORTFILE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcreatorUid VARCHAR(64), xcurrentProcessName VARCHAR(32), xdataContent CLOB, xdescription VARCHAR(255), xendDate TIMESTAMP, xerrorContent CLOB, xextension VARCHAR(16), xfileBody BLOB, xfileName VARCHAR(255), xfileStatus VARCHAR(16), xlastUpdateTime TIMESTAMP, xlength BIGINT, xname VARCHAR(255), xprocessCount BIGINT, xprocessing BOOLEAN, xrecordTotle BIGINT, xrowCount BIGINT, xsite VARCHAR(64), xstartDate TIMESTAMP, xtempFilePath VARCHAR(255), xvalidateOk BOOLEAN, PRIMARY KEY (xid), CONSTRAINT ATDC_ATTENDANCE_IMPORTFILE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_ATTENDANCE_QYWX (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcheckin_time BIGINT, xcheckin_type VARCHAR(128), xexception_type VARCHAR(255), xgroupname VARCHAR(128), xlocation_detail VARCHAR(255), xlocation_title VARCHAR(255), xnotes VARCHAR(255), xuserid VARCHAR(96), xwifiname VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ATDC_ATTENDANCE_QYWX_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_ATTENDANCE_SCHEDULE_SETTING (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xabsenceStartTime VARCHAR(32), xlateStartTime VARCHAR(32), xleaveEarlyStartTime VARCHAR(32), xoffDutyTime VARCHAR(32), xonDutyTime VARCHAR(32), xtopUnitName VARCHAR(255), xunitName VARCHAR(255), xunitOu VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ATDC_ATTENDANCE_SCHEDULE_SETTING_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_ATTENDANCE_SELFHOLIDAYS (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xbatchFlag VARCHAR(64), xdescription VARCHAR(255), xdocId VARCHAR(64), xemployeeName VARCHAR(96), xemployeeNumber VARCHAR(32), xendTime TIMESTAMP, xleaveDayNumber DOUBLE, xleaveType VARCHAR(32), xstartTime TIMESTAMP, xtopUnitName VARCHAR(255), xtopUnitOu VARCHAR(255), xunitName VARCHAR(255), xunitOu VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ATDC_ATTENDANCE_SELFHOLIDAYS_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_ATTENDANCE_SETTING (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xconfigCode VARCHAR(96), xconfigName VARCHAR(96), xconfigValue VARCHAR(255), xdescription VARCHAR(255), xisMultiple BOOLEAN, xorderNumber INTEGER, xselectContent VARCHAR(255), xvalueType VARCHAR(16), PRIMARY KEY (xid), CONSTRAINT ATDC_ATTENDANCE_SETTING_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_ATTENDANCE_STATISTIC_REQUIRELOG (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdescription CLOB, xprocessStatus VARCHAR(255), xprocessTime TIMESTAMP, xstatisticDay VARCHAR(96), xstatisticKey VARCHAR(96), xstatisticMonth VARCHAR(96), xstatisticName VARCHAR(96), xstatisticType VARCHAR(96), xstatisticYear VARCHAR(96), PRIMARY KEY (xid), CONSTRAINT ATDC_ATTENDANCE_STATISTIC_REQUIRELOG_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_ATTENDANCE_WORKDAYCONFIG (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xconfigDate VARCHAR(32), xconfigMonth VARCHAR(16), xconfigName VARCHAR(96), xconfigType VARCHAR(16), xconfigYear VARCHAR(16), xdescription VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ATDC_ATTENDANCE_WORKDAYCONFIG_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_DD_QYWX_RECORD (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdateFrom BIGINT, xdateTo BIGINT, xsyncEndTime TIMESTAMP, xexceptionMessage VARCHAR(255), xsyncStartTime TIMESTAMP, xstatus VARCHAR(32), xtype VARCHAR(32), PRIMARY KEY (xid), CONSTRAINT ATDC_DD_QYWX_RECORD_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_STATISTIC_CYCLE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcycleEndDate TIMESTAMP, xcycleEndDateString VARCHAR(32), xcycleMonth VARCHAR(16), xcycleStartDate TIMESTAMP, xcycleStartDateString VARCHAR(32), xcycleYear VARCHAR(16), xdescription VARCHAR(255), xtopUnitName VARCHAR(255), xunitName VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ATDC_STATISTIC_CYCLE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_STATISTIC_DD_PERSON_FORMONTH (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xAbsenteeismTimes BIGINT, xlateTimes BIGINT, xleaveEarlyTimes BIGINT, xNotSignedCount BIGINT, xo2Unit VARCHAR(128), xo2User VARCHAR(128), xoffDutyTimes BIGINT, xonDutyTimes BIGINT, xresultNormal BIGINT, xSeriousLateTimes BIGINT, xstatisticMonth VARCHAR(16), xstatisticYear VARCHAR(16), xworkDayCount BIGINT, PRIMARY KEY (xid), CONSTRAINT ATDC_STATISTIC_DD_PERSON_FORMONTH_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_STATISTIC_DD_UNIT_FORDAY (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xAbsenteeismTimes BIGINT, xlateTimes BIGINT, xleaveEarlyTimes BIGINT, xNotSignedCount BIGINT, xo2Unit VARCHAR(128), xoffDutyTimes BIGINT, xonDutyTimes BIGINT, xresultNormal BIGINT, xSeriousLateTimes BIGINT, xstatisticDate VARCHAR(16), xstatisticMonth VARCHAR(16), xstatisticYear VARCHAR(16), xworkDayCount BIGINT, PRIMARY KEY (xid), CONSTRAINT ATDC_STATISTIC_DD_UNIT_FORDAY_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_STATISTIC_DD_UNIT_FORMONTH (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xAbsenteeismTimes BIGINT, xlateTimes BIGINT, xleaveEarlyTimes BIGINT, xNotSignedCount BIGINT, xo2Unit VARCHAR(128), xoffDutyTimes BIGINT, xonDutyTimes BIGINT, xresultNormal BIGINT, xSeriousLateTimes BIGINT, xstatisticMonth VARCHAR(16), xstatisticYear VARCHAR(16), xworkDayCount BIGINT, PRIMARY KEY (xid), CONSTRAINT ATDC_STATISTIC_DD_UNIT_FORMONTH_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_STATISTIC_PERSON_FORMONTH (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xabNormalDutyCount BIGINT, xabsenceDayCount DOUBLE, xemployeeName VARCHAR(96), xlackOfTimeCount BIGINT, xlateTimes BIGINT, xleaveEarlyTimes BIGINT, xoffDutyTimes BIGINT, xonDutyDayCount DOUBLE, xonDutyTimes BIGINT, xonSelfHolidayCount DOUBLE, xstatisticMonth VARCHAR(16), xstatisticYear VARCHAR(16), xtopUnitName VARCHAR(255), xunitName VARCHAR(255), xworkDayCount DOUBLE, PRIMARY KEY (xid), CONSTRAINT ATDC_STATISTIC_PERSON_FORMONTH_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_STATISTIC_TOPUNIT_FORDAY (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xabNormalDutyCount BIGINT, xabsenceDayCount DOUBLE, xemployeeCount DOUBLE, xlackOfTimeCount BIGINT, xlateCount BIGINT, xleaveEarlyCount BIGINT, xoffDutyCount BIGINT, xonDutyCount BIGINT, xonDutyEmployeeCount DOUBLE, xonSelfHolidayEmployeeCount DOUBLE, xstatisticDate VARCHAR(16), xstatisticMonth VARCHAR(16), xstatisticYear VARCHAR(16), xtopUnitName VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ATDC_STATISTIC_TOPUNIT_FORDAY_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_STATISTIC_TOPUNIT_FORMONTH (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xabNormalDutyCount BIGINT, xabsenceDayCount DOUBLE, xemployeeCount DOUBLE, xlackOfTimeCount BIGINT, xlateCount BIGINT, xleaveEarlyCount BIGINT, xoffDutyCount BIGINT, xonDutyCount BIGINT, xonDutyEmployeeCount DOUBLE, xonSelfHolidayCount DOUBLE, xstatisticMonth VARCHAR(16), xstatisticYear VARCHAR(16), xtopUnitName VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ATDC_STATISTIC_TOPUNIT_FORMONTH_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_STATISTIC_UNIT_FORDAY (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xabNormalDutyCount BIGINT, xabsenceDayCount DOUBLE, xemployeeCount DOUBLE, xlackOfTimeCount BIGINT, xlateCount BIGINT, xleaveEarlyCount BIGINT, xoffDutyCount BIGINT, xonDutyCount BIGINT, xonDutyEmployeeCount DOUBLE, xonSelfHolidayEmployeeCount DOUBLE, xstatisticDate VARCHAR(16), xstatisticMonth VARCHAR(16), xstatisticYear VARCHAR(16), xtopUnitName VARCHAR(255), xunitName VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ATDC_STATISTIC_UNIT_FORDAY_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_STATISTIC_UNIT_FORMONTH (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xabNormalDutyCount BIGINT, xabsenceDayCount DOUBLE, xemployeeCount DOUBLE, xlackOfTimeCount BIGINT, xlateCount BIGINT, xleaveEarlyCount BIGINT, xoffDutyCount BIGINT, xonDutyCount BIGINT, xonDutyEmployeeCount DOUBLE, xonSelfHolidayCount DOUBLE, xstatisticMonth VARCHAR(16), xstatisticYear VARCHAR(16), xtopUnitName VARCHAR(255), xunitName VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ATDC_STATISTIC_UNIT_FORMONTH_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ATDC_WORK_PLACE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcreator VARCHAR(255), xdescription VARCHAR(255), xerrorRange INTEGER, xlatitude VARCHAR(32), xlongitude VARCHAR(32), xplaceAlias VARCHAR(255), xplaceName VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ATDC_WORK_PLACE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE BBS_CONFIGSETTING (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xconfigCode VARCHAR(32), xconfigName VARCHAR(32), xconfigValue VARCHAR(255), xdescription VARCHAR(255), xisMultiple BOOLEAN, xorderNumber INTEGER, xselectContent VARCHAR(255), xvalueType VARCHAR(16), PRIMARY KEY (xid), CONSTRAINT BBS_CONFIGSETTING_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE BBS_FORUMINFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcreatorName VARCHAR(255), xforumColor VARCHAR(32), xforumIndexStyle VARCHAR(16), xforumName VARCHAR(128), xforumNotice CLOB, xforumStatus VARCHAR(16), xforumVisible VARCHAR(16), xindexListStyle VARCHAR(16), xindexRecommendable BOOLEAN, xorderNumber INTEGER, xreplyMessageNotify BOOLEAN, xreplyMessageNotifyType VARCHAR(16), xreplyNeedAudit BOOLEAN, xreplyPublishAble VARCHAR(16), xreplyTotal BIGINT, xreplyTotalToday BIGINT, xsectionCreateAble BOOLEAN, xsectionTotal BIGINT, xsubjectMessageNotify BOOLEAN, xsubjectMessageNotifyType VARCHAR(16), xsubjectNeedAudit BOOLEAN, xsubjectPublishAble VARCHAR(16), xsubjectTotal BIGINT, xsubjectTotalToday BIGINT, xsubjectType VARCHAR(255), xtypeCategory VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT BBS_FORUMINFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE BBS_FORUMINFO_forumManagerList (BBSFORUMINFO_XID VARCHAR(64), xforumManagerList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE BBS_FORUMINFO_publishPermissionList (BBSFORUMINFO_XID VARCHAR(64), xpublishPermissionList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE BBS_FORUMINFO_replyPermissionList (BBSFORUMINFO_XID VARCHAR(64), xreplyPermissionList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE BBS_FORUMINFO_visiblePermissionList (BBSFORUMINFO_XID VARCHAR(64), xvisiblePermissionList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE BBS_OPERATIONRECORD (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xforumId VARCHAR(64), xforumName VARCHAR(128), xhostIp VARCHAR(32), xhostname VARCHAR(32), xmainSectionId VARCHAR(64), xmainSectionName VARCHAR(128), xobjectId VARCHAR(255), xobjectName VARCHAR(255), xobjectType VARCHAR(16), xoperatorName VARCHAR(255), xoptType VARCHAR(16), xsectionId VARCHAR(64), xsectionName VARCHAR(128), xsubjectId VARCHAR(64), xtitle VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT BBS_OPERATIONRECORD_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE BBS_PERMISSIONINFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdescription VARCHAR(255), xforumId VARCHAR(64), xforumName VARCHAR(128), xmainSectionId VARCHAR(64), xmainSectionName VARCHAR(128), xorderNumber INTEGER, xpermissionCode VARCHAR(255), xpermissionFunction VARCHAR(64), xpermissionName VARCHAR(255), xpermissionType VARCHAR(32), xsectionId VARCHAR(64), xsectionName VARCHAR(128), PRIMARY KEY (xid), CONSTRAINT BBS_PERMISSIONINFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE BBS_PERMISSIONROLE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdescription VARCHAR(255), xforumId VARCHAR(64), xforumName VARCHAR(128), xmainSectionId VARCHAR(64), xmainSectionName VARCHAR(128), xorderNumber INTEGER, xpermissionCode VARCHAR(255), xpermissionName VARCHAR(255), xpermissionType VARCHAR(32), xroleCode VARCHAR(255), xroleId VARCHAR(64), xroleName VARCHAR(255), xsectionId VARCHAR(64), xsectionName VARCHAR(128), PRIMARY KEY (xid), CONSTRAINT BBS_PERMISSIONROLE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE BBS_REPLYINFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xauditorName VARCHAR(255), xcontent CLOB, xcreatorName VARCHAR(255), xforumId VARCHAR(64), xforumName VARCHAR(128), xhostIp VARCHAR(32), xmachineName VARCHAR(32), xmainSectionId VARCHAR(64), xmainSectionName VARCHAR(128), xorderNumber INTEGER, xparentId VARCHAR(64), xpicId VARCHAR(64), xreplyAuditStatus VARCHAR(16), xsectionId VARCHAR(64), xsectionName VARCHAR(128), xsubjectId VARCHAR(64), xsystemType VARCHAR(64), xtitle VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT BBS_REPLYINFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE BBS_ROLEINFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcreatorName VARCHAR(255), xdescription VARCHAR(255), xforumId VARCHAR(64), xforumName VARCHAR(128), xmainSectionId VARCHAR(64), xmainSectionName VARCHAR(128), xorderNumber INTEGER, xroleCode VARCHAR(255), xroleName VARCHAR(255), xroleType VARCHAR(32), xsectionId VARCHAR(64), xsectionName VARCHAR(128), PRIMARY KEY (xid), CONSTRAINT BBS_ROLEINFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE BBS_SECTIONINFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcreatorName VARCHAR(255), xforumId VARCHAR(64), xforumName VARCHAR(128), xicon CLOB, xindexRecommendable BOOLEAN, xmainSectionId VARCHAR(64), xmainSectionName VARCHAR(128), xorderNumber INTEGER, xreplyMessageNotify BOOLEAN, xreplyMessageNotifyType VARCHAR(16), xreplyNeedAudit BOOLEAN, xreplyPublishAble VARCHAR(16), xreplyTotal BIGINT, xreplyTotalToday BIGINT, xsectionDescription CLOB, xsectionLevel VARCHAR(16), xsectionName VARCHAR(128), xsectionNotice CLOB, xsectionStatus VARCHAR(16), xsectionType VARCHAR(32), xsectionVisible VARCHAR(16), xsubSectionCreateAble BOOLEAN, xsubjectMessageNotify BOOLEAN, xsubjectMessageNotifyType VARCHAR(16), xsubjectNeedAudit BOOLEAN, xsubjectPublishAble VARCHAR(16), xsubjectTotal BIGINT, xsubjectTotalToday BIGINT, xsubjectType VARCHAR(255), xtypeCategory VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT BBS_SECTIONINFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE BBS_SECTIONINFO_moderatorNames (BBSSECTIONINFO_XID VARCHAR(64), xmoderatorNames VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE BBS_SECTIONINFO_publishPermissionList (BBSSECTIONINFO_XID VARCHAR(64), xpublishPermissionList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE BBS_SECTIONINFO_replyPermissionList (BBSSECTIONINFO_XID VARCHAR(64), xreplyPermissionList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE BBS_SECTIONINFO_visiblePermissionList (BBSSECTIONINFO_XID VARCHAR(64), xvisiblePermissionList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE BBS_SUBJECTATTACHMENT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcreatorUid VARCHAR(64), xdeepPath BOOLEAN, xdescription VARCHAR(255), xextension VARCHAR(16), xfileHost VARCHAR(32), xfileName VARCHAR(255), xfilePath VARCHAR(255), xforumId VARCHAR(64), xforumName VARCHAR(128), xlastUpdateTime TIMESTAMP, xlength BIGINT, xmainSectionId VARCHAR(64), xmainSectionName VARCHAR(128), xname VARCHAR(255), xsectionId VARCHAR(64), xsectionName VARCHAR(128), xsite VARCHAR(64), xstorage VARCHAR(64), xsubjectId VARCHAR(64), xtitle VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT BBS_SUBJECTATTACHMENT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE BBS_SUBJECTCONTENT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcontent CLOB, PRIMARY KEY (xid), CONSTRAINT BBS_SUBJECTCONTENT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE BBS_SUBJECTINFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xacceptReplyId VARCHAR(64), xauditorName VARCHAR(255), xbBSIndexSetterName VARCHAR(32), xbBSIndexSetterTime TIMESTAMP, xcreatorName VARCHAR(255), xforumId VARCHAR(64), xforumIndexSetterName VARCHAR(255), xforumIndexSetterTime TIMESTAMP, xforumName VARCHAR(128), xhostIp VARCHAR(64), xhot BIGINT, xisCompleted BOOLEAN, xisCreamSubject BOOLEAN, xisOriginalSubject BOOLEAN, xisRecommendSubject BOOLEAN, xisTopSubject BOOLEAN, xlatestReplyId VARCHAR(64), xlatestReplyTime TIMESTAMP, xlatestReplyUser VARCHAR(255), xmachineName VARCHAR(64), xmainSectionId VARCHAR(64), xmainSectionName VARCHAR(128), xorderNumber INTEGER, xoriginalSetterName VARCHAR(255), xoriginalSetterTime TIMESTAMP, xpicId VARCHAR(64), xrecommendTime TIMESTAMP, xrecommendToBBSIndex BOOLEAN, xrecommendToForumIndex BOOLEAN, xrecommendorName VARCHAR(255), xreplyTotal BIGINT, xscreamSetterName VARCHAR(255), xscreamSetterTime TIMESTAMP, xsectionId VARCHAR(64), xsectionName VARCHAR(128), xstopReply BOOLEAN, xsubjectAuditStatus VARCHAR(16), xsubjectStatus VARCHAR(16), xsummary VARCHAR(255), xsystemType VARCHAR(64), xtitle VARCHAR(128), xtopToBBS BOOLEAN, xtopToForum BOOLEAN, xtopToMainSection BOOLEAN, xtopToSection BOOLEAN, xtype VARCHAR(64), xtypeCategory VARCHAR(64), xviewTotal BIGINT, xvoteLimitTime TIMESTAMP, xvotePersonVisible BOOLEAN, xvoteResultVisible BOOLEAN, PRIMARY KEY (xid), CONSTRAINT BBS_SUBJECTINFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE BBS_SUBJECTINFO_attachmentList (BBSSUBJECTINFO_XID VARCHAR(64), xattachmentList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE BBS_SUBJECT_VOTERESULT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xforumId VARCHAR(64), xmainSectionId VARCHAR(64), xsectionId VARCHAR(64), xstatisticContent CLOB, PRIMARY KEY (xid), CONSTRAINT BBS_SUBJECT_VOTERESULT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE BBS_USERINFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcardId VARCHAR(32), xcreamCount BIGINT, xcredit BIGINT, xfansCount BIGINT, xlastOperationTime TIMESTAMP, xlastVisitTime TIMESTAMP, xmobile VARCHAR(16), xnickName VARCHAR(255), xonline BOOLEAN, xorderNumber INTEGER, xoriginalCount BIGINT, xpermissionContent CLOB, xpopularity BIGINT, xreplyCount BIGINT, xreplyCountToday BIGINT, xsex INTEGER, xsignContent CLOB, xsubjectCount BIGINT, xsubjectCountToday BIGINT, xuserName VARCHAR(255), xuserStatus VARCHAR(16), PRIMARY KEY (xid), CONSTRAINT BBS_USERINFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE BBS_USERROLE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xforumId VARCHAR(64), xmainSectionId VARCHAR(64), xobjectName VARCHAR(255), xobjectType VARCHAR(16), xorderNumber INTEGER, xroleCode VARCHAR(255), xroleId VARCHAR(255), xroleName VARCHAR(255), xsectionId VARCHAR(64), xtopUnitName VARCHAR(255), xuniqueId VARCHAR(255), xunitName VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT BBS_USERROLE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE BBS_VOTEOPTION (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xchooseCount INTEGER, xcreatorName VARCHAR(255), xforumId VARCHAR(64), xmainSectionId VARCHAR(64), xoptionContentType VARCHAR(32), xoptionGroupId VARCHAR(64), xoptionPictureId VARCHAR(64), xoptionTextContent VARCHAR(255), xorderNumber INTEGER, xsectionId VARCHAR(64), xsubjectId VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT BBS_VOTEOPTION_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE BBS_VOTEOPTIONGROUP (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcreatorName VARCHAR(255), xforumId VARCHAR(64), xgroupName VARCHAR(255), xmainSectionId VARCHAR(64), xorderNumber INTEGER, xsectionId VARCHAR(64), xsubjectId VARCHAR(64), xvoteChooseCount INTEGER, PRIMARY KEY (xid), CONSTRAINT BBS_VOTEOPTIONGROUP_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE BBS_VOTERECORD (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xforumId VARCHAR(64), xmainSectionId VARCHAR(64), xoptionGroupId VARCHAR(64), xoptionId VARCHAR(64), xoptionValue VARCHAR(255), xsectionId VARCHAR(64), xsubjectId VARCHAR(64), xvotorName VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT BBS_VOTERECORD_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CAL_CALENDAR (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcolor VARCHAR(8), xcreateor VARCHAR(255), xdescription VARCHAR(255), xisPublic BOOLEAN, xname VARCHAR(64), xsource VARCHAR(16), xstatus VARCHAR(16), xtarget VARCHAR(255), xtype VARCHAR(16), PRIMARY KEY (xid), CONSTRAINT CAL_CALENDAR_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CAL_CALENDAR_followers (CALENDAR_XID VARCHAR(64), xfollowers VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CAL_CALENDAR_manageablePersonList (CALENDAR_XID VARCHAR(64), xmanageablePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CAL_CALENDAR_publishableGroupList (CALENDAR_XID VARCHAR(64), xpublishableGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CAL_CALENDAR_publishablePersonList (CALENDAR_XID VARCHAR(64), xpublishablePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CAL_CALENDAR_publishableUnitList (CALENDAR_XID VARCHAR(64), xpublishableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CAL_CALENDAR_viewableGroupList (CALENDAR_XID VARCHAR(64), xviewableGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CAL_CALENDAR_viewablePersonList (CALENDAR_XID VARCHAR(64), xviewablePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CAL_CALENDAR_viewableUnitList (CALENDAR_XID VARCHAR(64), xviewableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CAL_EVENT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalarm BOOLEAN, xalarmAlready BOOLEAN, xalarmTime TIMESTAMP, xbundle VARCHAR(255), xcalendarId VARCHAR(64), xcolor VARCHAR(8), xcomment VARCHAR(255), xcommentId VARCHAR(64), xcreatePerson VARCHAR(255), xdaysOfDuration INTEGER, xendTime TIMESTAMP, xendTimeStr VARCHAR(32), xeventType VARCHAR(16), xisAllDayEvent BOOLEAN, xisPublic BOOLEAN, xlatitude VARCHAR(32), xlocationName VARCHAR(255), xlongitude VARCHAR(32), xrecurrenceExc VARCHAR(255), xrecurrenceRule VARCHAR(255), xrepeatMasterId VARCHAR(64), xsource VARCHAR(16), xstartTime TIMESTAMP, xstartTimeStr VARCHAR(32), xtargetType VARCHAR(16), xtitle VARCHAR(128), xupdatePerson VARCHAR(255), xvalarmTime_config VARCHAR(32), xvalarm_Summary VARCHAR(128), xvalarm_description VARCHAR(255), xvalarm_mailto VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT CAL_EVENT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CAL_EVENT_COMMENT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcheckTime TIMESTAMP, lobValue CLOB, PRIMARY KEY (xid), CONSTRAINT CAL_EVENT_COMMENT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CAL_EVENT_manageablePersonList (CALENDAR_EVENT_XID VARCHAR(64), xmanageablePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CAL_EVENT_participants (CALENDAR_EVENT_XID VARCHAR(64), xparticipants VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CAL_EVENT_REPM (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalarm BOOLEAN, xalarmTime TIMESTAMP, xcalendarId VARCHAR(64), xcolor VARCHAR(8), xcomment VARCHAR(255), xcommentId VARCHAR(64), xcreatePerson VARCHAR(255), xdaysOfDuration INTEGER, xendTime TIMESTAMP, xeventType VARCHAR(16), xisAllDayEvent BOOLEAN, xisPublic BOOLEAN, xlatitude VARCHAR(32), xlocationName VARCHAR(255), xlongitude VARCHAR(32), xrecurrenceExc VARCHAR(255), xrecurrenceRule VARCHAR(255), xrecurrenceStartTime TIMESTAMP, xrepeatStatus VARCHAR(16), xsource VARCHAR(16), xstartTime TIMESTAMP, xtargetType VARCHAR(16), xtitle VARCHAR(128), xupdatePerson VARCHAR(255), xvalarmTime_config VARCHAR(32), xvalarm_Summary VARCHAR(128), xvalarm_description VARCHAR(255), xvalarm_mailto VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT CAL_EVENT_REPM_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CAL_EVENT_REPM_createdMonthList (CALENDAR_EVENTREPEATMASTER_XID VARCHAR(64), xcreatedMonthList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CAL_EVENT_REPM_manageablePersonList (CALENDAR_EVENTREPEATMASTER_XID VARCHAR(64), xmanageablePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CAL_EVENT_REPM_participants (CALENDAR_EVENTREPEATMASTER_XID VARCHAR(64), xparticipants VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CAL_EVENT_REPM_viewableGroupList (CALENDAR_EVENTREPEATMASTER_XID VARCHAR(64), xviewableGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CAL_EVENT_REPM_viewablePersonList (CALENDAR_EVENTREPEATMASTER_XID VARCHAR(64), xviewablePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CAL_EVENT_REPM_viewableUnitList (CALENDAR_EVENTREPEATMASTER_XID VARCHAR(64), xviewableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CAL_EVENT_viewableGroupList (CALENDAR_EVENT_XID VARCHAR(64), xviewableGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CAL_EVENT_viewablePersonList (CALENDAR_EVENT_XID VARCHAR(64), xviewablePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CAL_EVENT_viewableUnitList (CALENDAR_EVENT_XID VARCHAR(64), xviewableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CAL_SETTING (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xconfigCode VARCHAR(96), xconfigName VARCHAR(96), xconfigValue VARCHAR(255), xdescription VARCHAR(255), xisLob BOOLEAN, xisMultiple BOOLEAN, xorderNumber INTEGER, xselectContent VARCHAR(255), xvalueType VARCHAR(16), PRIMARY KEY (xid), CONSTRAINT CAL_SETTING_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CAL_SETTING_LOBVALUE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xlobValue CLOB, PRIMARY KEY (xid), CONSTRAINT CAL_SETTING_LOBVALUE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_APPDICTITEM (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xappId VARCHAR(64), xbooleanValue BOOLEAN, xbundle VARCHAR(255), xdateTimeValue TIMESTAMP, xdateValue DATE, xitemCategory VARCHAR(16), xitemPrimitiveType VARCHAR(1), xitemStringValueType VARCHAR(2), xitemType VARCHAR(1), xnumberValue DOUBLE, xpath0 VARCHAR(64), xpath0Location INTEGER, xpath1 VARCHAR(64), xpath1Location INTEGER, xpath2 VARCHAR(64), xpath2Location INTEGER, xpath3 VARCHAR(64), xpath3Location INTEGER, xpath4 VARCHAR(64), xpath4Location INTEGER, xpath5 VARCHAR(64), xpath5Location INTEGER, xpath6 VARCHAR(64), xpath6Location INTEGER, xpath7 VARCHAR(64), xpath7Location INTEGER, xstringLongValue CLOB, xstringShortValue VARCHAR(255), xtimeValue TIME, PRIMARY KEY (xid), CONSTRAINT CMS_APPDICTITEM_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_APPINFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xallPeoplePublish BOOLEAN, xallPeopleView BOOLEAN, xanonymousAble BOOLEAN, xappAlias VARCHAR(96), xappIcon CLOB, xappInfoSeq VARCHAR(96), xappMemo VARCHAR(255), xappName VARCHAR(96), xappType VARCHAR(255), xcreatorIdentity VARCHAR(255), xcreatorPerson VARCHAR(255), xcreatorTopUnitName VARCHAR(255), xcreatorUnitName VARCHAR(255), xdescription VARCHAR(255), xdocumentType VARCHAR(16), xiconColor VARCHAR(16), xsendNotify BOOLEAN, xshowAllDocuments BOOLEAN, PRIMARY KEY (xid), CONSTRAINT CMS_APPINFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_APPINFO_categoryList (APPINFO_XID VARCHAR(64), xcategoryList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_APPINFO_CONFIG (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xconfig CLOB, PRIMARY KEY (xid), CONSTRAINT CMS_APPINFO_CONFIG_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_APPINFO_manageableGroupList (APPINFO_XID VARCHAR(64), xmanageableGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_APPINFO_manageablePersonList (APPINFO_XID VARCHAR(64), xmanageablePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_APPINFO_manageableUnitList (APPINFO_XID VARCHAR(64), xmanageableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_APPINFO_publishableGroupList (APPINFO_XID VARCHAR(64), xpublishableGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_APPINFO_publishablePersonList (APPINFO_XID VARCHAR(64), xpublishablePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_APPINFO_publishableUnitList (APPINFO_XID VARCHAR(64), xpublishableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_APPINFO_viewableGroupList (APPINFO_XID VARCHAR(64), xviewableGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_APPINFO_viewablePersonList (APPINFO_XID VARCHAR(64), xviewablePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_APPINFO_viewableUnitList (APPINFO_XID VARCHAR(64), xviewableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_APPNDICT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xappId VARCHAR(64), xcreatorUid VARCHAR(64), xdescription VARCHAR(255), xname VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT CMS_APPNDICT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_BATCH_OPERATION (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xbundle VARCHAR(255), xdescription VARCHAR(255), xerrorCount INTEGER, xisRunning BOOLEAN, xobjType VARCHAR(16), xoldInfo VARCHAR(255), xoptType VARCHAR(16), PRIMARY KEY (xid), CONSTRAINT CMS_BATCH_OPERATION_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_CATEGORYEXT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcontent CLOB, PRIMARY KEY (xid), CONSTRAINT CMS_CATEGORYEXT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_CATEGORYINFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xallPeoplePublish BOOLEAN, xallPeopleView BOOLEAN, xanonymousAble BOOLEAN, xappId VARCHAR(64), xappName VARCHAR(96), xcategoryAlias VARCHAR(96), xcategoryIcon CLOB, xcategoryMemo VARCHAR(255), xcategoryName VARCHAR(96), xcategorySeq VARCHAR(96), xcreatorIdentity VARCHAR(255), xcreatorPerson VARCHAR(255), xcreatorTopUnitName VARCHAR(255), xcreatorUnitName VARCHAR(255), xdefaultViewId VARCHAR(64), xdefaultViewName VARCHAR(96), xdescription VARCHAR(255), xdocumentType VARCHAR(16), xformId VARCHAR(64), xformName VARCHAR(96), ximportViewAppId VARCHAR(64), ximportViewId VARCHAR(64), ximportViewName VARCHAR(64), xparentId VARCHAR(64), xreadFormId VARCHAR(64), xreadFormName VARCHAR(96), xsendNotify BOOLEAN, xworkflowAppId VARCHAR(64), xworkflowAppName VARCHAR(255), xworkflowFlag VARCHAR(64), xworkflowName VARCHAR(255), xworkflowType VARCHAR(32), PRIMARY KEY (xid), CONSTRAINT CMS_CATEGORYINFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_CATEGORYINFO_manageableGroupList (CATEGORYINFO_XID VARCHAR(64), xmanageableGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_CATEGORYINFO_manageablePersonList (CATEGORYINFO_XID VARCHAR(64), xmanageablePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_CATEGORYINFO_manageableUnitList (CATEGORYINFO_XID VARCHAR(64), xmanageableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_CATEGORYINFO_publishableGroupList (CATEGORYINFO_XID VARCHAR(64), xpublishableGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_CATEGORYINFO_publishablePersonList (CATEGORYINFO_XID VARCHAR(64), xpublishablePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_CATEGORYINFO_publishableUnitList (CATEGORYINFO_XID VARCHAR(64), xpublishableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_CATEGORYINFO_viewableGroupList (CATEGORYINFO_XID VARCHAR(64), xviewableGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_CATEGORYINFO_viewablePersonList (CATEGORYINFO_XID VARCHAR(64), xviewablePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_CATEGORYINFO_viewableUnitList (CATEGORYINFO_XID VARCHAR(64), xviewableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_DOCUMENT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xappAlias VARCHAR(96), xappId VARCHAR(64), xappName VARCHAR(96), xcategoryAlias VARCHAR(96), xcategoryId VARCHAR(64), xcategoryName VARCHAR(96), xcommendCount BIGINT, xcommentCount BIGINT, xcreatorIdentity VARCHAR(255), xcreatorPerson VARCHAR(255), xcreatorTopUnitName VARCHAR(255), xcreatorUnitName VARCHAR(255), xdescription VARCHAR(255), xdocStatus VARCHAR(16), xdocumentType VARCHAR(16), xform VARCHAR(64), xformName VARCHAR(96), xhasIndexPic BOOLEAN, ximportBatchName VARCHAR(128), xisTop BOOLEAN, xmodifyTime TIMESTAMP, xpublishTime TIMESTAMP, xreadFormId VARCHAR(64), xreadFormName VARCHAR(96), xreviewed BOOLEAN, xsequenceAppAlias VARCHAR(255), xsequenceCategoryAlias VARCHAR(255), xsequenceCreatorPerson VARCHAR(255), xsequenceCreatorUnitName VARCHAR(255), xsequenceTitle VARCHAR(255), xsummary VARCHAR(255), xtitle VARCHAR(255), xviewCount BIGINT, PRIMARY KEY (xid), CONSTRAINT CMS_DOCUMENT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_DOCUMENT_authorGroupList (DOCUMENT_XID VARCHAR(64), xauthorGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_DOCUMENT_authorPersonList (DOCUMENT_XID VARCHAR(64), xauthorPersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_DOCUMENT_authorUnitList (DOCUMENT_XID VARCHAR(64), xauthorUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_DOCUMENT_COMMEND (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcommendPerson VARCHAR(255), xdocumentId VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT CMS_DOCUMENT_COMMEND_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_DOCUMENT_COMMENTCOMMEND (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcommendPerson VARCHAR(255), xcommentId VARCHAR(64), xdocumentId VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT CMS_DOCUMENT_COMMENTCOMMEND_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_DOCUMENT_COMMENTCONTENT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcontent CLOB, PRIMARY KEY (xid), CONSTRAINT CMS_DOCUMENT_COMMENTCONTENT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_DOCUMENT_COMMENTINFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xappId VARCHAR(64), xappName VARCHAR(96), xauditorName VARCHAR(255), xcategoryId VARCHAR(64), xcategoryName VARCHAR(96), xcommendCount BIGINT, xcommentAuditStatus VARCHAR(16), xcreatorName VARCHAR(255), xdocumentId VARCHAR(64), xisPrivate BOOLEAN, xorderNumber INTEGER, xparentId VARCHAR(64), xtitle VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT CMS_DOCUMENT_COMMENTINFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_DOCUMENT_managerList (DOCUMENT_XID VARCHAR(64), xmanagerList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_DOCUMENT_pictureList (DOCUMENT_XID VARCHAR(64), xpictureList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_DOCUMENT_readGroupList (DOCUMENT_XID VARCHAR(64), xreadGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_DOCUMENT_readPersonList (DOCUMENT_XID VARCHAR(64), xreadPersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_DOCUMENT_readUnitList (DOCUMENT_XID VARCHAR(64), xreadUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_DOCUMENT_remindGroupList (DOCUMENT_XID VARCHAR(64), xremindGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_DOCUMENT_remindPersonList (DOCUMENT_XID VARCHAR(64), xremindPersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_DOCUMENT_remindUnitList (DOCUMENT_XID VARCHAR(64), xremindUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_DOCUMENT_VIEWRECORD (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xappId VARCHAR(64), xappName VARCHAR(96), xcategoryId VARCHAR(64), xcategoryName VARCHAR(96), xdocumentId VARCHAR(64), xlastViewTime TIMESTAMP, xtitle VARCHAR(255), xviewCount INTEGER, xviewerName VARCHAR(255), xviewerTopUnitName VARCHAR(255), xviewerUnitName VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT CMS_DOCUMENT_VIEWRECORD_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_E_QUERYVIEW (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xafterCalculateGridScriptText CLOB, xafterGridScriptText CLOB, xafterGroupGridScriptText CLOB, xalias VARCHAR(255), xappId VARCHAR(64), xappName VARCHAR(64), xcode CLOB, xcreatorPerson VARCHAR(255), xdata CLOB, xdescription VARCHAR(255), xdisplay BOOLEAN, xicon CLOB, xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xlayout CLOB, xname VARCHAR(255), xtimingEnable BOOLEAN, xtimingInterval INTEGER, xtimingTouch INTEGER, PRIMARY KEY (xid), CONSTRAINT CMS_E_QUERYVIEW_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_E_QUERYVIEW_availableIdentityList (QUERYVIEW_XID VARCHAR(64), xavailableIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_E_QUERYVIEW_availablePersonList (QUERYVIEW_XID VARCHAR(64), xavailablePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_E_QUERYVIEW_availableUnitList (QUERYVIEW_XID VARCHAR(64), xavailableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_E_QUERYVIEW_controllerList (QUERYVIEW_XID VARCHAR(64), xcontrollerList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_FILE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xappId VARCHAR(64), xdata CLOB, xdescription VARCHAR(255), xfileName VARCHAR(255), xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xlength BIGINT, xname VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT CMS_FILE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_FILEINFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xappId VARCHAR(64), xcategoryId VARCHAR(64), xcloudId VARCHAR(64), xcreatorUid VARCHAR(255), xdeepPath BOOLEAN, xdescription VARCHAR(255), xdocumentId VARCHAR(64), xextension VARCHAR(16), xfileExtType VARCHAR(16), xfileHost VARCHAR(32), xfileName VARCHAR(255), xfilePath VARCHAR(255), xfileType VARCHAR(16), xlastUpdateTime TIMESTAMP, xlength BIGINT, xname VARCHAR(255), xseqNumber INTEGER, xsite VARCHAR(64), xstorage VARCHAR(64), xtext CLOB, xtype VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT CMS_FILEINFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_FILEINFO_controllerIdentityList (FILEINFO_XID VARCHAR(64), xcontrollerIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_FILEINFO_controllerUnitList (FILEINFO_XID VARCHAR(64), xcontrollerUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_FILEINFO_editIdentityList (FILEINFO_XID VARCHAR(64), xeditIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_FILEINFO_editUnitList (FILEINFO_XID VARCHAR(64), xeditUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_FILEINFO_readIdentityList (FILEINFO_XID VARCHAR(64), xreadIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_FILEINFO_readUnitList (FILEINFO_XID VARCHAR(64), xreadUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_FORM (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xappId VARCHAR(64), xdata CLOB, xdescription VARCHAR(255), xeditor VARCHAR(255), xmobileData CLOB, xname VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT CMS_FORM_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_FORMFIELD (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xappId VARCHAR(64), xdataType VARCHAR(32), xform VARCHAR(64), xname VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT CMS_FORMFIELD_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_LOG (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xappId VARCHAR(64), xcategoryId VARCHAR(64), xdescription VARCHAR(255), xdocumentId VARCHAR(64), xfileId VARCHAR(64), xoperationLevel VARCHAR(32), xoperationType VARCHAR(32), xoperatorName VARCHAR(255), xoperatorUid VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT CMS_LOG_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_READREMIND (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xappId VARCHAR(64), xcategoryId VARCHAR(64), xdocumentId VARCHAR(64), xreadTime TIMESTAMP, xreaded BOOLEAN, xreaderFlagName VARCHAR(255), xreaderFlagType VARCHAR(16), xremindReader VARCHAR(255), xremindTime TIMESTAMP, xreminded BOOLEAN, xtitle VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT CMS_READREMIND_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_REVIEW (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xappAlias VARCHAR(255), xappId VARCHAR(64), xappName VARCHAR(255), xcategoryAlias VARCHAR(255), xcategoryId VARCHAR(64), xcategoryName VARCHAR(255), xcommendCount BIGINT, xcommentCount BIGINT, xcreatorIdentity VARCHAR(255), xcreatorPerson VARCHAR(255), xcreatorTopUnitName VARCHAR(255), xcreatorUnitName VARCHAR(255), xdocCreateTime TIMESTAMP, xdocId VARCHAR(64), xdocSequence VARCHAR(64), xdocStatus VARCHAR(32), xdocumentType VARCHAR(16), xhasIndexPic BOOLEAN, ximportBatchName VARCHAR(128), xisTop BOOLEAN, xmodifyTime TIMESTAMP, xpermissionObj VARCHAR(255), xpermissionObjType VARCHAR(16), xpublishTime TIMESTAMP, xsequenceAppAlias VARCHAR(255), xsequenceCategoryAlias VARCHAR(255), xsequenceCreatorPerson VARCHAR(255), xsequenceCreatorUnitName VARCHAR(255), xsequenceTitle VARCHAR(255), xtitle VARCHAR(255), xviewCount BIGINT, PRIMARY KEY (xid), CONSTRAINT CMS_REVIEW_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_SCRIPT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xappId VARCHAR(64), xcreatorPerson VARCHAR(255), xdescription VARCHAR(255), xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xname VARCHAR(255), xtext CLOB, xvalidated BOOLEAN, PRIMARY KEY (xid), CONSTRAINT CMS_SCRIPT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_SCRIPT_dependScriptList (SCRIPT_XID VARCHAR(64), xdependScriptList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CMS_TEMPLATEFORM (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xcategory VARCHAR(255), xdata CLOB, xdescription VARCHAR(255), xicon CLOB, xmobileData CLOB, xname VARCHAR(255), xoutline CLOB, PRIMARY KEY (xid), CONSTRAINT CMS_TEMPLATEFORM_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_VIEW (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xappId VARCHAR(64), xcontent CLOB, xdescription VARCHAR(255), xeditor VARCHAR(255), xformId VARCHAR(64), xname VARCHAR(255), xorderField VARCHAR(128), xorderFieldType VARCHAR(128), xorderType VARCHAR(128), xpageSize INTEGER, PRIMARY KEY (xid), CONSTRAINT CMS_VIEW_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_VIEWCATEGORY (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcategoryId VARCHAR(64), xeditor VARCHAR(255), xviewId VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT CMS_VIEWCATEGORY_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_VIEWFIELD_CONFIG (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdescription VARCHAR(255), xeditor VARCHAR(255), xfieldName VARCHAR(128), xfieldTitle VARCHAR(128), xshowSequence INTEGER, xviewId VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT CMS_VIEWFIELD_CONFIG_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CMS_VIEW_fieldConfigList (VIEW_XID VARCHAR(64), xfieldConfigList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CPT_COMPONENT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xiconPath VARCHAR(255), xname VARCHAR(255), xorderNumber INTEGER, xpath VARCHAR(255), xtitle VARCHAR(255), xtype VARCHAR(16), xvisible BOOLEAN, PRIMARY KEY (xid), CONSTRAINT CPT_COMPONENT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CPT_COMPONENT_allowList (COMPONENT_XID VARCHAR(64), xallowList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CPT_COMPONENT_denyList (COMPONENT_XID VARCHAR(64), xdenyList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE CTE_AGENT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xcron VARCHAR(64), xdescription VARCHAR(255), xenable BOOLEAN, xlastEndTime TIMESTAMP, xlastStartTime TIMESTAMP, xname VARCHAR(255), xtext CLOB, xvalidated BOOLEAN, PRIMARY KEY (xid), CONSTRAINT CTE_AGENT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CTE_CAPTCHA (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xanswer VARCHAR(16), xmeta VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT CTE_CAPTCHA_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CTE_CODE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xanswer VARCHAR(16), xmeta VARCHAR(255), xmobile VARCHAR(16), PRIMARY KEY (xid), CONSTRAINT CTE_CODE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CTE_INVOKE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xdescription VARCHAR(255), xenable BOOLEAN, xlastEndTime TIMESTAMP, xlastStartTime TIMESTAMP, xname VARCHAR(255), xremoteAddrRegex VARCHAR(255), xtext CLOB, xvalidated BOOLEAN, PRIMARY KEY (xid), CONSTRAINT CTE_INVOKE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CTE_PROMPTERRORLOG (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcollected BOOLEAN, xexceptionClass VARCHAR(255), xloggerName VARCHAR(255), xmessage CLOB, xoccurTime TIMESTAMP, xperson VARCHAR(255), xrequestBody CLOB, xrequestBodyLength BIGINT, xrequestHead CLOB, xrequestMethod VARCHAR(8), xrequestRemoteAddr VARCHAR(255), xrequestRemoteHost VARCHAR(255), xrequestUrl CLOB, xstackTrace CLOB, xversion VARCHAR(32), PRIMARY KEY (xid), CONSTRAINT CTE_PROMPTERRORLOG_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CTE_SCHEDULELOG (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xapplication VARCHAR(255), xclassName VARCHAR(255), xelapsed BIGINT, xfireTime TIMESTAMP, xnode VARCHAR(255), xstackTrace CLOB, xsuccess BOOLEAN, xtype VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT CTE_SCHEDULELOG_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CTE_STRUCTURE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdata CLOB, xdeepPath BOOLEAN, xdescription VARCHAR(255), xdescriptionLob CLOB, xextension VARCHAR(64), xlastUpdateTime TIMESTAMP, xlength BIGINT, xname VARCHAR(255), xstorage VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT CTE_STRUCTURE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CTE_UNEXPECTEDERRORLOG (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcollected BOOLEAN, xexceptionClass VARCHAR(255), xloggerName VARCHAR(255), xmessage CLOB, xoccurTime TIMESTAMP, xperson VARCHAR(255), xrequestBody CLOB, xrequestBodyLength BIGINT, xrequestHead CLOB, xrequestMethod VARCHAR(8), xrequestRemoteAddr VARCHAR(255), xrequestRemoteHost VARCHAR(255), xrequestUrl CLOB, xstackTrace CLOB, xversion VARCHAR(32), PRIMARY KEY (xid), CONSTRAINT CTE_UNEXPECTEDERRORLOG_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE CTE_WARNLOG (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcollected BOOLEAN, xloggerName VARCHAR(255), xmessage CLOB, xoccurTime TIMESTAMP, xversion VARCHAR(32), PRIMARY KEY (xid), CONSTRAINT CTE_WARNLOG_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE FILE_ATTACHMENT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdeepPath BOOLEAN, xextension VARCHAR(64), xfolder VARCHAR(64), xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xlength BIGINT, xname VARCHAR(255), xperson VARCHAR(255), xstorage VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT FILE_ATTACHMENT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE FILE_ATTACHMENT2 (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xextension VARCHAR(64), xfolder VARCHAR(64), xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xlength BIGINT, xname VARCHAR(255), xoriginFile VARCHAR(64), xperson VARCHAR(255), xstatus VARCHAR(16), xtype VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT FILE_ATTACHMENT2_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE FILE_ATTACHMENT_editorList (ATTACHMENT_XID VARCHAR(64), xeditorList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE FILE_ATTACHMENT_shareList (ATTACHMENT_XID VARCHAR(64), xshareList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE FILE_FILE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdeepPath BOOLEAN, xextension VARCHAR(64), xlastNotExistedTime TIMESTAMP, xlastUpdateTime TIMESTAMP, xlength BIGINT, xname VARCHAR(255), xperson VARCHAR(255), xreference VARCHAR(255), xreferenceType VARCHAR(64), xstorage VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT FILE_FILE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE FILE_FOLDER (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xname VARCHAR(255), xperson VARCHAR(255), xsuperior VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT FILE_FOLDER_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE FILE_FOLDER2 (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xlastUpdateTime TIMESTAMP, xname VARCHAR(255), xperson VARCHAR(255), xstatus VARCHAR(16), xsuperior VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT FILE_FOLDER2_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE FILE_ORIGINFILE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdeepPath BOOLEAN, xextension VARCHAR(64), xfileMd5 VARCHAR(64), xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xlength BIGINT, xname VARCHAR(255), xperson VARCHAR(255), xstorage VARCHAR(64), xtype VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT FILE_ORIGINFILE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE FILE_RECYCLE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xextension VARCHAR(64), xfileId VARCHAR(64), xfileType VARCHAR(64), xlength BIGINT, xname VARCHAR(255), xperson VARCHAR(255), xvalidTime TIMESTAMP, PRIMARY KEY (xid), CONSTRAINT FILE_RECYCLE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE FILE_SHARE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xextension VARCHAR(64), xfileId VARCHAR(64), xfileType VARCHAR(64), xlastUpdateTime TIMESTAMP, xlength BIGINT, xname VARCHAR(255), xpassword VARCHAR(64), xperson VARCHAR(255), xshareType VARCHAR(64), xvalidTime TIMESTAMP, PRIMARY KEY (xid), CONSTRAINT FILE_SHARE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE FILE_SHARE_shareOrgList (SHARE_XID VARCHAR(64), xshareOrgList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE FILE_SHARE_shareUserList (SHARE_XID VARCHAR(64), xshareUserList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE FILE_SHARE_shieldUserList (SHARE_XID VARCHAR(64), xshieldUserList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE HOT_PICTURE_INFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xapplication VARCHAR(64), xcreator VARCHAR(64), xinfoId VARCHAR(64), xpicId VARCHAR(255), xsummary VARCHAR(255), xtitle VARCHAR(255), xurl VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT HOT_PICTURE_INFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE MIND_BASE_INFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcooperative BOOLEAN, xcooperative_sequence VARCHAR(255), xcreator VARCHAR(255), xcreatorUnit VARCHAR(255), xcreatorUnit_sequence VARCHAR(255), xcreator_sequence VARCHAR(255), xdescription VARCHAR(255), xfileVersion INTEGER, xfolderId VARCHAR(64), xfolder_sequence VARCHAR(255), xicon VARCHAR(255), xname VARCHAR(255), xshared BOOLEAN, xshared_sequence VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT MIND_BASE_INFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE MIND_BASE_INFO_editorList (MINDBASEINFO_XID VARCHAR(64), xeditorList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE MIND_BASE_INFO_shareGroupList (MINDBASEINFO_XID VARCHAR(64), xshareGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE MIND_BASE_INFO_sharePersonList (MINDBASEINFO_XID VARCHAR(64), xsharePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE MIND_BASE_INFO_shareUnitList (MINDBASEINFO_XID VARCHAR(64), xshareUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE MIND_CONTENT_INFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcontent CLOB, PRIMARY KEY (xid), CONSTRAINT MIND_CONTENT_INFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE MIND_FOLDER_INFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcreator VARCHAR(255), xcreatorUnit VARCHAR(255), xdescription VARCHAR(255), xname VARCHAR(255), xorderNumber INTEGER, xparentId VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT MIND_FOLDER_INFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE MIND_ICON_INFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcontent CLOB, PRIMARY KEY (xid), CONSTRAINT MIND_ICON_INFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE MIND_RECYCLE_INFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcreator VARCHAR(255), xcreatorUnit VARCHAR(255), xcreatorUnit_sequence VARCHAR(255), xcreator_sequence VARCHAR(255), xdeleteor VARCHAR(255), xdescription VARCHAR(255), xfileCreateTime TIMESTAMP, xfileVersion INTEGER, xfolderId VARCHAR(64), xfolder_sequence VARCHAR(255), xname VARCHAR(255), xshared BOOLEAN, xshared_sequence VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT MIND_RECYCLE_INFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE MIND_SHARE_RECORED (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xfileId VARCHAR(64), xfileStatus VARCHAR(16), xfileType VARCHAR(16), xname VARCHAR(255), xshareType VARCHAR(16), xsource VARCHAR(255), xtarget VARCHAR(255), xtargetType VARCHAR(16), PRIMARY KEY (xid), CONSTRAINT MIND_SHARE_RECORED_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE MIND_VERSION_CONTENT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcontent CLOB, PRIMARY KEY (xid), CONSTRAINT MIND_VERSION_CONTENT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE MIND_VERSION_INFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcreator VARCHAR(255), xcreatorUnit VARCHAR(255), xdescription VARCHAR(255), xfileVersion INTEGER, xfolderId VARCHAR(64), xmindId VARCHAR(64), xname VARCHAR(255), xshared BOOLEAN, PRIMARY KEY (xid), CONSTRAINT MIND_VERSION_INFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE MSG_IM_CONVERSATION (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xadminPerson VARCHAR(255), xlastMessageTime TIMESTAMP, xnote VARCHAR(255), xtitle VARCHAR(255), xtype VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT MSG_IM_CONVERSATION_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE MSG_IM_CONVERSATION_EXT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xconversationId VARCHAR(64), xisTop BOOLEAN, xlastReadTime TIMESTAMP, xperson VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT MSG_IM_CONVERSATION_EXT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE MSG_IM_CONVERSATION_personList (IMCONVERSATION_XID VARCHAR(64), xpersonList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE MSG_IM_MESSAGE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xbody CLOB, xconversationId VARCHAR(64), xcreatePerson VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT MSG_IM_MESSAGE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE MSG_INSTANT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xbody CLOB, xconsumed BOOLEAN, xperson VARCHAR(255), xtitle VARCHAR(255), xtype VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT MSG_INSTANT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE MSG_INSTANT_consumerList (INSTANT_XID VARCHAR(64), xconsumerList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE MSG_MASS (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xbody CLOB, xcreatorPerson VARCHAR(255), xtype VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT MSG_MASS_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE MSG_MASS_groupList (MASS_XID VARCHAR(64), xgroupList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE MSG_MASS_identityList (MASS_XID VARCHAR(64), xidentityList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE MSG_MASS_personList (MASS_XID VARCHAR(64), xpersonList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE MSG_MASS_sendPersonList (MASS_XID VARCHAR(64), xsendPersonList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE MSG_MASS_unitList (MASS_XID VARCHAR(64), xunitList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE MSG_MESSAGE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xbody CLOB, xconsumed BOOLEAN, xconsumer VARCHAR(255), xinstant VARCHAR(64), xperson VARCHAR(255), xtitle VARCHAR(255), xtype VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT MSG_MESSAGE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE MSG_ORG (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xbody CLOB, xconsumed BOOLEAN, xconsumedModule VARCHAR(255), xoperDataId VARCHAR(96), xoperType VARCHAR(32), xoperUerId VARCHAR(96), xorgType VARCHAR(32), xreceiveSystem VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT MSG_ORG_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE MT_ATTACHMENT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdeepPath BOOLEAN, xextension VARCHAR(16), xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xlength BIGINT, xmeeting VARCHAR(64), xname VARCHAR(255), xstorage VARCHAR(64), xsummary BOOLEAN, PRIMARY KEY (xid), CONSTRAINT MT_ATTACHMENT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE MT_BUILDING (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xaddress VARCHAR(255), xname VARCHAR(255), xpinyin VARCHAR(255), xpinyinInitial VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT MT_BUILDING_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE MT_MEETING (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xactualCompletedTime TIME, xactualStartTime TIME, xapplicant VARCHAR(255), xauditor VARCHAR(255), xcompletedTime TIMESTAMP, xconfirmStatus VARCHAR(8), xdescription VARCHAR(255), xmanualCompleted BOOLEAN, xmemo CLOB, xpinyin VARCHAR(255), xpinyinInitial VARCHAR(255), xroom VARCHAR(64), xstartTime TIMESTAMP, xsubject VARCHAR(255), xsummary CLOB, PRIMARY KEY (xid), CONSTRAINT MT_MEETING_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE MT_MEETING_acceptPersonList (MEETING_XID VARCHAR(64), xacceptPersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE MT_MEETING_checkinPersonList (MEETING_XID VARCHAR(64), xcheckinPersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE MT_MEETING_invitePersonList (MEETING_XID VARCHAR(64), xinvitePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE MT_MEETING_rejectPersonList (MEETING_XID VARCHAR(64), xrejectPersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE MT_ROOM (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xauditor VARCHAR(255), xavailable BOOLEAN, xbuilding VARCHAR(64), xcapacity INTEGER, xdevice CLOB, xfloor INTEGER, xname VARCHAR(255), xphoneNumber VARCHAR(255), xphoto CLOB, xpinyin VARCHAR(255), xpinyinInitial VARCHAR(255), xroomNumber VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT MT_ROOM_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_ATTACHMENTFILEINFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcenterId VARCHAR(64), xcreatorUid VARCHAR(255), xdeepPath BOOLEAN, xdescription VARCHAR(255), xextension VARCHAR(16), xfileHost VARCHAR(64), xfileName VARCHAR(255), xfilePath VARCHAR(255), xkey VARCHAR(64), xlastUpdateTime TIMESTAMP, xlength BIGINT, xname VARCHAR(255), xparentType VARCHAR(32), xsite VARCHAR(64), xstatus VARCHAR(16), xstorage VARCHAR(64), xworkInfoId VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT OKR_ATTACHMENTFILEINFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_CENTERWORKINFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcompletedWorkCount BIGINT, xcreatorIdentity VARCHAR(255), xcreatorName VARCHAR(255), xcreatorTopUnitName VARCHAR(255), xcreatorUnitName VARCHAR(255), xdefaultCompleteDateLimit TIMESTAMP, xdefaultCompleteDateLimitStr VARCHAR(32), xdefaultWorkLevel VARCHAR(64), xdefaultWorkType VARCHAR(64), xdeployDateStr VARCHAR(32), xdeployMonth VARCHAR(16), xdeployYear VARCHAR(8), xdeployerIdentity VARCHAR(255), xdeployerName VARCHAR(255), xdeployerTopUnitName VARCHAR(255), xdeployerUnitName VARCHAR(255), xdescription CLOB, xdraftWorkCount BIGINT, xisNeedAudit BOOLEAN, xovertimeWorkCount BIGINT, xprocessStatus VARCHAR(32), xprocessingWorkCount BIGINT, xstatus VARCHAR(16), xtitle VARCHAR(255), xworkTotal BIGINT, PRIMARY KEY (xid), CONSTRAINT OKR_CENTERWORKINFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_CENTERWORKINFO_attachmentList (OKRCENTERWORKINFO_XID VARCHAR(64), xattachmentList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_CENTERWORKINFO_defaultLeaderIdentityList (OKRCENTERWORKINFO_XID VARCHAR(64), xdefaultLeaderIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_CENTERWORKINFO_defaultLeaderList (OKRCENTERWORKINFO_XID VARCHAR(64), xdefaultLeaderList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_CENTERWORKINFO_reportAuditLeaderIdentityList (OKRCENTERWORKINFO_XID VARCHAR(64), xreportAuditLeaderIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_CENTERWORKINFO_reportAuditLeaderNameList (OKRCENTERWORKINFO_XID VARCHAR(64), xreportAuditLeaderNameList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_CENTERWORKINFO_reportAuditLeaderTopUnitNameList (OKRCENTERWORKINFO_XID VARCHAR(64), xreportAuditLeaderTopUnitNameList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_CENTERWORKINFO_reportAuditLeaderUnitNameList (OKRCENTERWORKINFO_XID VARCHAR(64), xreportAuditLeaderUnitNameList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_CONFIG_SECRETARY (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdescription VARCHAR(255), xleaderIdentity VARCHAR(255), xleaderName VARCHAR(255), xleaderTopUnitName VARCHAR(255), xleaderUnitName VARCHAR(255), xsecretaryIdentity VARCHAR(255), xsecretaryName VARCHAR(255), xsecretaryTopUnitName VARCHAR(255), xsecretaryUnitName VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT OKR_CONFIG_SECRETARY_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_CONFIG_SYSTEM (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xconfigCode VARCHAR(32), xconfigName VARCHAR(32), xconfigValue VARCHAR(255), xdescription VARCHAR(255), xisMultiple BOOLEAN, xorderNumber INTEGER, xselectContent VARCHAR(255), xvalueType VARCHAR(16), PRIMARY KEY (xid), CONSTRAINT OKR_CONFIG_SYSTEM_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_CONFIG_WORKLEVEL (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdescription VARCHAR(255), xorderNumber INTEGER, xworkLevelName VARCHAR(32), PRIMARY KEY (xid), CONSTRAINT OKR_CONFIG_WORKLEVEL_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_CONFIG_WORKTYPE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdescription VARCHAR(255), xorderNumber INTEGER, xworkTypeName VARCHAR(32), PRIMARY KEY (xid), CONSTRAINT OKR_CONFIG_WORKTYPE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_ERRROIDENTITY (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xflag VARCHAR(255), xidentity VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT OKR_ERRROIDENTITY_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_ERRROIDENTITYRECORDS (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xflag VARCHAR(255), xidentity VARCHAR(255), xrecordsJson CLOB, PRIMARY KEY (xid), CONSTRAINT OKR_ERRROIDENTITYRECORDS_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_STATISTIC_REPORT_CONTENT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xadminSuperviseInfo CLOB, xcenterId VARCHAR(64), xcenterTitle VARCHAR(255), xcycleType VARCHAR(32), xisCompleted BOOLEAN, xisOverTime BOOLEAN, xmemo CLOB, xopinion CLOB, xparentId VARCHAR(64), xprogressDescription CLOB, xreportDayInCycle INTEGER, xreportId VARCHAR(64), xreportStatus VARCHAR(32), xresponsibilityEmployeeName VARCHAR(255), xresponsibilityIdentity VARCHAR(255), xresponsibilityTopUnitName VARCHAR(255), xresponsibilityUnitName VARCHAR(255), xstatisticMonth INTEGER, xstatisticTime TIMESTAMP, xstatisticTimeFlag VARCHAR(32), xstatisticWeek INTEGER, xstatisticYear INTEGER, xstatus VARCHAR(16), xworkId VARCHAR(64), xworkLevel VARCHAR(32), xworkPlan CLOB, xworkPointAndRequirements CLOB, xworkProcessStatus VARCHAR(16), xworkTitle VARCHAR(255), xworkType VARCHAR(32), PRIMARY KEY (xid), CONSTRAINT OKR_STATISTIC_REPORT_CONTENT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_STATISTIC_REPORT_STATUS (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcenterId VARCHAR(64), xcenterTitle VARCHAR(255), xcompleteDateLimitStr VARCHAR(32), xdeployDateStr VARCHAR(32), xoverallProgress INTEGER, xparentId VARCHAR(64), xreportCycle VARCHAR(32), xreportDayInCycle INTEGER, xreportStatistic CLOB, xresponsibilityEmployeeName VARCHAR(255), xresponsibilityIdentity VARCHAR(255), xresponsibilityTopUnitName VARCHAR(255), xresponsibilityUnitName VARCHAR(255), xstatisticTimeFlag VARCHAR(32), xstatisticYear INTEGER, xstatus VARCHAR(16), xworkDateTimeType VARCHAR(16), xworkId VARCHAR(64), xworkLevel VARCHAR(32), xworkProcessStatus VARCHAR(16), xworkTitle VARCHAR(255), xworkType VARCHAR(32), PRIMARY KEY (xid), CONSTRAINT OKR_STATISTIC_REPORT_STATUS_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_TASK (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xactivityName VARCHAR(255), xarriveDateTime TIMESTAMP, xarriveDateTimeStr VARCHAR(32), xcenterId VARCHAR(64), xcenterTitle VARCHAR(255), xdynamicObjectId VARCHAR(64), xdynamicObjectTitle VARCHAR(255), xdynamicObjectType VARCHAR(32), xprocessType VARCHAR(32), xstatus VARCHAR(16), xtargetIdentity VARCHAR(255), xtargetName VARCHAR(255), xtargetTopUnitName VARCHAR(255), xtargetUnitName VARCHAR(255), xtitle VARCHAR(255), xviewUrl VARCHAR(255), xworkId VARCHAR(64), xworkTitle VARCHAR(255), xworkType VARCHAR(32), PRIMARY KEY (xid), CONSTRAINT OKR_TASK_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_TASKHANDLED (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xactivityName VARCHAR(255), xarriveDateTime TIMESTAMP, xarriveDateTimeStr VARCHAR(32), xcenterId VARCHAR(64), xcenterTitle VARCHAR(255), xduration BIGINT, xdynamicObjectId VARCHAR(64), xdynamicObjectTitle VARCHAR(255), xdynamicObjectType VARCHAR(32), xprocessDateTime TIMESTAMP, xprocessDateTimeStr VARCHAR(32), xprocessType VARCHAR(32), xstatus VARCHAR(16), xtargetIdentity VARCHAR(255), xtargetName VARCHAR(255), xtargetTopUnitName VARCHAR(255), xtargetUnitName VARCHAR(255), xtitle VARCHAR(255), xviewUrl VARCHAR(255), xworkId VARCHAR(64), xworkTitle VARCHAR(255), xworkType VARCHAR(32), PRIMARY KEY (xid), CONSTRAINT OKR_TASKHANDLED_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_USERINFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcustomContent CLOB, xuserName VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT OKR_USERINFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_WORKAPPRAISEINFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xactivityName VARCHAR(64), xcenterId VARCHAR(64), xcenterTitle VARCHAR(255), xstatus VARCHAR(32), xtitle VARCHAR(255), xwf_jobId VARCHAR(64), xwf_workId VARCHAR(64), xworkId VARCHAR(64), xworkTitle VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT OKR_WORKAPPRAISEINFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_WORKBASEINFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xappraiseTimes INTEGER, xarchiveDate TIMESTAMP, xcenterId VARCHAR(64), xcenterTitle VARCHAR(255), xcompleteDateLimit TIMESTAMP, xcompleteDateLimitStr VARCHAR(32), xcompleteTime TIMESTAMP, xconfirmDateStr VARCHAR(32), xcreatorIdentity VARCHAR(255), xcreatorName VARCHAR(255), xcreatorTopUnitName VARCHAR(255), xcreatorUnitName VARCHAR(255), xcurrentActivityName VARCHAR(32), xcurrentAppraiseInfoId VARCHAR(64), xcurrentAppraiseJobId VARCHAR(64), xcurrentAppraiseStatus VARCHAR(32), xcurrentAppraiseTitle VARCHAR(255), xcurrentAppraiseWorkId VARCHAR(64), xdeployDateStr VARCHAR(32), xdeployMonth VARCHAR(16), xdeployYear VARCHAR(16), xdeployerIdentity VARCHAR(255), xdeployerName VARCHAR(255), xdeployerTopUnitName VARCHAR(255), xdeployerUnitName VARCHAR(255), xisCompleted BOOLEAN, xisNeedReport BOOLEAN, xisOverTime BOOLEAN, xlastReportTime TIMESTAMP, xnextReportTime TIMESTAMP, xoverallProgress INTEGER, xparentWorkId VARCHAR(64), xparentWorkTitle VARCHAR(255), xprogressAnalyseTime VARCHAR(32), xreportAdminIdentity VARCHAR(255), xreportAdminName VARCHAR(255), xreportCount INTEGER, xreportCycle VARCHAR(32), xreportDayInCycle INTEGER, xreportNeedAdminAudit BOOLEAN, xreportTimeQue CLOB, xresponsibilityEmployeeName VARCHAR(255), xresponsibilityIdentity VARCHAR(255), xresponsibilityTopUnitName VARCHAR(255), xresponsibilityUnitName VARCHAR(255), xshortDutyDescription VARCHAR(255), xshortLandmarkDescription VARCHAR(255), xshortMajorIssuesDescription VARCHAR(255), xshortProgressAction VARCHAR(255), xshortProgressPlan VARCHAR(255), xshortResultDescription VARCHAR(255), xshortWorkDetail VARCHAR(255), xstatus VARCHAR(16), xtitle VARCHAR(255), xworkAuditLevel INTEGER, xworkDateTimeType VARCHAR(16), xworkLevel VARCHAR(32), xworkProcessStatus VARCHAR(16), xworkType VARCHAR(32), PRIMARY KEY (xid), CONSTRAINT OKR_WORKBASEINFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_WORKBASEINFO_appraiseInfoList (OKRWORKBASEINFO_XID VARCHAR(64), xappraiseInfoList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_WORKBASEINFO_attachmentList (OKRWORKBASEINFO_XID VARCHAR(64), xattachmentList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_WORKBASEINFO_cooperateEmployeeNameList (OKRWORKBASEINFO_XID VARCHAR(64), xcooperateEmployeeNameList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_WORKBASEINFO_cooperateIdentityList (OKRWORKBASEINFO_XID VARCHAR(64), xcooperateIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_WORKBASEINFO_cooperateTopUnitNameList (OKRWORKBASEINFO_XID VARCHAR(64), xcooperateTopUnitNameList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_WORKBASEINFO_cooperateUnitNameList (OKRWORKBASEINFO_XID VARCHAR(64), xcooperateUnitNameList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_WORKBASEINFO_readLeaderIdentityList (OKRWORKBASEINFO_XID VARCHAR(64), xreadLeaderIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_WORKBASEINFO_readLeaderNameList (OKRWORKBASEINFO_XID VARCHAR(64), xreadLeaderNameList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_WORKBASEINFO_readLeaderTopUnitNameList (OKRWORKBASEINFO_XID VARCHAR(64), xreadLeaderTopUnitNameList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_WORKBASEINFO_readLeaderUnitNameList (OKRWORKBASEINFO_XID VARCHAR(64), xreadLeaderUnitNameList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_WORKCHAT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcenterId VARCHAR(64), xcenterTitle VARCHAR(255), xcontent CLOB, xdescription VARCHAR(255), xsenderIdentity VARCHAR(255), xsenderName VARCHAR(255), xtargetIdentity VARCHAR(255), xtargetName VARCHAR(255), xworkId VARCHAR(64), xworkTitle VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT OKR_WORKCHAT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_WORKDETAILINFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcenterId VARCHAR(64), xdutyDescription CLOB, xlandmarkDescription CLOB, xmajorIssuesDescription CLOB, xprogressAction CLOB, xprogressPlan CLOB, xresultDescription CLOB, xstatus VARCHAR(16), xworkDetail CLOB, PRIMARY KEY (xid), CONSTRAINT OKR_WORKDETAILINFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_WORKDYNAMICS (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcenterId VARCHAR(64), xcenterTitle VARCHAR(255), xcontent VARCHAR(255), xdateTime TIMESTAMP, xdateTimeStr VARCHAR(32), xdescription VARCHAR(255), xdynamicObjectId VARCHAR(64), xdynamicObjectTitle VARCHAR(255), xdynamicObjectType VARCHAR(32), xdynamicType VARCHAR(32), xoperatorName VARCHAR(255), xstatus VARCHAR(16), xtargetIdentity VARCHAR(255), xtargetName VARCHAR(255), xviewUrl VARCHAR(255), xworkId VARCHAR(64), xworkTitle VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT OKR_WORKDYNAMICS_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_WORK_AUTHORIZE_RECORD (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcenterId VARCHAR(64), xcenterTitle VARCHAR(255), xdelegateDateTime TIMESTAMP, xdelegateDateTimeStr VARCHAR(32), xdelegateLevel INTEGER, xdelegateOpinion VARCHAR(255), xdelegatorIdentity VARCHAR(255), xdelegatorName VARCHAR(255), xdelegatorTopUnitName VARCHAR(255), xdelegatorUnitName VARCHAR(255), xstatus VARCHAR(16), xtakebackDateTime TIMESTAMP, xtargetIdentity VARCHAR(255), xtargetName VARCHAR(255), xtargetTopUnitName VARCHAR(255), xtargetUnitName VARCHAR(255), xtitle VARCHAR(255), xworkId VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT OKR_WORK_AUTHORIZE_RECORD_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_WORK_PERSON (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xauthorizeRecordId VARCHAR(64), xcenterId VARCHAR(64), xcenterTitle VARCHAR(255), xcompleteDateLimit TIMESTAMP, xcompleteDateLimitStr VARCHAR(32), xdeployDateStr VARCHAR(32), xdeployMonth VARCHAR(16), xdeployYear VARCHAR(16), xdiscription VARCHAR(255), xemployeeIdentity VARCHAR(255), xemployeeName VARCHAR(255), xisCompleted BOOLEAN, xisDelegateTarget BOOLEAN, xisOverTime BOOLEAN, xparentWorkId VARCHAR(64), xprocessIdentity VARCHAR(32), xrecordType VARCHAR(32), xstatus VARCHAR(16), xtopUnitName VARCHAR(255), xunitName VARCHAR(255), xviewTime VARCHAR(32), xworkCreateDateStr VARCHAR(32), xworkDateTimeType VARCHAR(16), xworkId VARCHAR(64), xworkLevel VARCHAR(32), xworkProcessStatus VARCHAR(16), xworkTitle VARCHAR(255), xworkType VARCHAR(32), PRIMARY KEY (xid), CONSTRAINT OKR_WORK_PERSON_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_WORK_REPORTBASEINFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xactivityName VARCHAR(64), xcenterId VARCHAR(64), xcenterTitle VARCHAR(255), xcreatorIdentity VARCHAR(255), xcreatorName VARCHAR(255), xcreatorTopUnitName VARCHAR(255), xcreatorUnitName VARCHAR(255), xcurrentProcessLevel INTEGER, xdescription VARCHAR(255), xisWorkCompleted BOOLEAN, xneedAdminAudit BOOLEAN, xneedLeaderRead BOOLEAN, xprocessStatus VARCHAR(16), xprocessType VARCHAR(16), xprogressPercent INTEGER, xreportCount INTEGER, xreportWorkflowType VARCHAR(32), xreporterIdentity VARCHAR(255), xreporterName VARCHAR(255), xreporterTopUnitName VARCHAR(255), xreporterUnitName VARCHAR(255), xshortTitle VARCHAR(255), xstatus VARCHAR(16), xsubmitTime TIMESTAMP, xtitle VARCHAR(255), xworkAdminIdentity VARCHAR(255), xworkAdminName VARCHAR(255), xworkId VARCHAR(64), xworkTitle VARCHAR(255), xworkType VARCHAR(32), PRIMARY KEY (xid), CONSTRAINT OKR_WORK_REPORTBASEINFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_WORK_REPORTBASEINFO_attachmentList (OKRWORKREPORTBASEINFO_XID VARCHAR(64), xattachmentList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_WORK_REPORTBASEINFO_currentProcessorIdentityList (OKRWORKREPORTBASEINFO_XID VARCHAR(64), xcurrentProcessorIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_WORK_REPORTBASEINFO_currentProcessorNameList (OKRWORKREPORTBASEINFO_XID VARCHAR(64), xcurrentProcessorNameList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_WORK_REPORTBASEINFO_currentProcessorTopUnitNameList (OKRWORKREPORTBASEINFO_XID VARCHAR(64), xcurrentProcessorTopUnitNameList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_WORK_REPORTBASEINFO_currentProcessorUnitNameList (OKRWORKREPORTBASEINFO_XID VARCHAR(64), xcurrentProcessorUnitNameList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_WORK_REPORTBASEINFO_readLeadersIdentityList (OKRWORKREPORTBASEINFO_XID VARCHAR(64), xreadLeadersIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_WORK_REPORTBASEINFO_readLeadersNameList (OKRWORKREPORTBASEINFO_XID VARCHAR(64), xreadLeadersNameList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE OKR_WORK_REPORTDETAILINFO (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xadminSuperviseInfo CLOB, xcenterId VARCHAR(64), xmemo CLOB, xprogressDescription CLOB, xshortTitle VARCHAR(255), xstatus VARCHAR(16), xtitle VARCHAR(255), xworkId VARCHAR(64), xworkPlan CLOB, xworkPointAndRequirements CLOB, PRIMARY KEY (xid), CONSTRAINT OKR_WORK_REPORTDETAILINFO_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_WORK_REPORT_PERSONLINK (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xactivityName VARCHAR(255), xcenterId VARCHAR(64), xcenterTitle VARCHAR(255), xprocessLevel INTEGER, xprocessStatus VARCHAR(16), xprocessorIdentity VARCHAR(255), xprocessorName VARCHAR(255), xprocessorTopUnitName VARCHAR(255), xprocessorUnitName VARCHAR(255), xstatus VARCHAR(16), xtitle VARCHAR(255), xworkId VARCHAR(64), xworkReportId VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT OKR_WORK_REPORT_PERSONLINK_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE OKR_WORK_REPORT_PROCESSLOG (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xactivityName VARCHAR(255), xarriveTime TIMESTAMP, xarriveTimeStr VARCHAR(32), xcenterId VARCHAR(64), xcenterTitle VARCHAR(255), xdecision VARCHAR(32), xopinion CLOB, xprocessLevel INTEGER, xprocessStatus VARCHAR(16), xprocessTime TIMESTAMP, xprocessTimeStr VARCHAR(32), xprocessorIdentity VARCHAR(255), xprocessorName VARCHAR(255), xprocessorTopUnitName VARCHAR(255), xprocessorUnitName VARCHAR(255), xreportTitle VARCHAR(255), xstatus VARCHAR(16), xstayTime BIGINT, xtitle VARCHAR(255), xworkId VARCHAR(64), xworkReportId VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT OKR_WORK_REPORT_PROCESSLOG_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ORG_A_EMPOWER (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xapplication VARCHAR(64), xapplicationAlias VARCHAR(255), xapplicationName VARCHAR(255), xcompletedTime TIMESTAMP, xenable BOOLEAN, xfilterListData CLOB, xfromIdentity VARCHAR(255), xfromPerson VARCHAR(255), xprocess VARCHAR(64), xprocessAlias VARCHAR(255), xprocessName VARCHAR(255), xstartTime TIMESTAMP, xtoIdentity VARCHAR(255), xtoPerson VARCHAR(255), xtype VARCHAR(32), PRIMARY KEY (xid), CONSTRAINT ORG_A_EMPOWER_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ORG_A_EMPOWERLOG (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xactivity VARCHAR(64), xactivityAlias VARCHAR(255), xactivityName VARCHAR(255), xapplication VARCHAR(64), xapplicationAlias VARCHAR(255), xapplicationName VARCHAR(255), xempowerTime TIMESTAMP, xfromIdentity VARCHAR(255), xfromPerson VARCHAR(255), xjob VARCHAR(64), xprocess VARCHAR(64), xprocessAlias VARCHAR(255), xprocessName VARCHAR(255), xtitle VARCHAR(255), xtoIdentity VARCHAR(255), xtoPerson VARCHAR(255), xwork VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT ORG_A_EMPOWERLOG_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ORG_BIND (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xmeta VARCHAR(255), xname VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ORG_BIND_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ORG_CUSTOM (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdata CLOB, xname VARCHAR(255), xperson VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT ORG_CUSTOM_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ORG_DEFINTION (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdata CLOB, xname VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ORG_DEFINTION_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ORG_GROUP (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdescription VARCHAR(255), xdistinguishedName VARCHAR(255), xname VARCHAR(255), xorderNumber INTEGER, xpinyin VARCHAR(255), xpinyinInitial VARCHAR(255), xunique VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ORG_GROUP_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ORG_GROUP_groupList (GROUP_XID VARCHAR(64), xgroupList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE ORG_GROUP_personList (GROUP_XID VARCHAR(64), xpersonList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE ORG_GROUP_unitList (GROUP_XID VARCHAR(64), xunitList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE ORG_IDENTITY (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdescription VARCHAR(255), xdistinguishedName VARCHAR(255), xmajor BOOLEAN, xname VARCHAR(255), xorderNumber INTEGER, xperson VARCHAR(64), xpinyin VARCHAR(255), xpinyinInitial VARCHAR(255), xunique VARCHAR(255), xunit VARCHAR(64), xunitLevel INTEGER, xunitLevelName CLOB, xunitName VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ORG_IDENTITY_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ORG_OAUTHCODE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xaccessToken VARCHAR(64), xclientId VARCHAR(255), xcode VARCHAR(64), xcodeUsed BOOLEAN, xperson VARCHAR(64), xscope VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ORG_OAUTHCODE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ORG_PERMISSIONSETTING (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xexplain VARCHAR(255), xextend1 VARCHAR(255), xextend2 VARCHAR(255), xextend3 VARCHAR(255), xstatus VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ORG_PERMISSIONSETTING_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ORG_PERMISSIONSETTING_excludePerson (PERMISSIONSETTING_XID VARCHAR(64), xexcludePerson VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE ORG_PERMISSIONSETTING_excludeUnit (PERMISSIONSETTING_XID VARCHAR(64), xexcludeUnit VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE ORG_PERMISSIONSETTING_limitQueryAll (PERMISSIONSETTING_XID VARCHAR(64), xlimitQueryAll VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE ORG_PERMISSIONSETTING_limitQueryOuter (PERMISSIONSETTING_XID VARCHAR(64), xlimitQueryOuter VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE ORG_PERSON (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xage INTEGER, xbirthday DATE, xboardDate DATE, xchangePasswordTime DATE, xdescription VARCHAR(255), xdingdingHash VARCHAR(255), xdingdingId VARCHAR(255), xdistinguishedName VARCHAR(255), xemployee VARCHAR(255), xfailureCount INTEGER, xfailureTime TIMESTAMP, xgenderType VARCHAR(1), xhiddenMobile BOOLEAN, xicon CLOB, xiconLdpi CLOB, xiconMdpi CLOB, xlastLoginAddress VARCHAR(64), xlastLoginClient VARCHAR(32), xlastLoginTime DATE, xmail VARCHAR(64), xmobile VARCHAR(32), xname VARCHAR(255), xofficePhone VARCHAR(32), xopen1Id VARCHAR(255), xopen2Id VARCHAR(255), xopen3Id VARCHAR(255), xopen4Id VARCHAR(255), xopen5Id VARCHAR(255), xorderNumber INTEGER, xpassword VARCHAR(255), xpasswordExpiredTime DATE, xpinyin VARCHAR(255), xpinyinInitial VARCHAR(255), xqiyeweixinHash VARCHAR(255), xqiyeweixinId VARCHAR(255), xqq VARCHAR(64), xsignature VARCHAR(255), xsuperior VARCHAR(64), xunique VARCHAR(255), xweixin VARCHAR(64), xzhengwuDingdingHash VARCHAR(255), xzhengwuDingdingId VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ORG_PERSON_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ORG_PERSONATTRIBUTE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdescription VARCHAR(255), xdistinguishedName VARCHAR(255), xname VARCHAR(255), xorderNumber INTEGER, xperson VARCHAR(64), xpinyin VARCHAR(255), xpinyinInitial VARCHAR(255), xunique VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ORG_PERSONATTRIBUTE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ORG_PERSONATTRIBUTE_attributeList (PERSONATTRIBUTE_XID VARCHAR(64), xattributeList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE ORG_PERSONCARD (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xaddress VARCHAR(255), xdescription VARCHAR(255), xdistinguishedName VARCHAR(255), xextend1 VARCHAR(255), xextend2 VARCHAR(255), xextend3 VARCHAR(255), xgenderType VARCHAR(1), xgroupType VARCHAR(255), xinputTime VARCHAR(255), xmobile VARCHAR(32), xname VARCHAR(255), xofficePhone VARCHAR(32), xorderNumber INTEGER, xpinyin VARCHAR(255), xpinyinInitial VARCHAR(255), xstatus VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ORG_PERSONCARD_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ORG_PERSON_controllerList (PERSON_XID VARCHAR(64), xcontrollerList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE ORG_PERSON_topUnitList (PERSON_XID VARCHAR(64), xtopUnitList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE ORG_ROLE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdescription VARCHAR(255), xdistinguishedName VARCHAR(255), xname VARCHAR(255), xorderNumber INTEGER, xpinyin VARCHAR(255), xpinyinInitial VARCHAR(255), xunique VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ORG_ROLE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ORG_ROLE_groupList (ROLE_XID VARCHAR(64), xgroupList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE ORG_ROLE_personList (ROLE_XID VARCHAR(64), xpersonList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE ORG_UNIT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdescription VARCHAR(255), xdingdingHash VARCHAR(255), xdingdingId VARCHAR(255), xdistinguishedName VARCHAR(255), xlevel INTEGER, xlevelName CLOB, xname VARCHAR(255), xorderNumber INTEGER, xpinyin VARCHAR(255), xpinyinInitial VARCHAR(255), xqiyeweixinHash VARCHAR(255), xqiyeweixinId VARCHAR(255), xshortName VARCHAR(255), xsuperior VARCHAR(64), xunique VARCHAR(255), xzhengwuDingdingHash VARCHAR(255), xzhengwuDingdingId VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT ORG_UNIT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ORG_UNITATTRIBUTE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdescription VARCHAR(255), xdistinguishedName VARCHAR(255), xname VARCHAR(255), xorderNumber INTEGER, xpinyin VARCHAR(255), xpinyinInitial VARCHAR(255), xunique VARCHAR(255), xunit VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT ORG_UNITATTRIBUTE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ORG_UNITATTRIBUTE_attributeList (UNITATTRIBUTE_XID VARCHAR(64), xattributeList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE ORG_UNITDUTY (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdescription VARCHAR(255), xdistinguishedName VARCHAR(255), xname VARCHAR(255), xorderNumber INTEGER, xpinyin VARCHAR(255), xpinyinInitial VARCHAR(255), xunique VARCHAR(255), xunit VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT ORG_UNITDUTY_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE ORG_UNITDUTY_identityList (UNITDUTY_XID VARCHAR(64), xidentityList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE ORG_UNIT_controllerList (UNIT_XID VARCHAR(64), xcontrollerList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE ORG_UNIT_inheritedControllerList (UNIT_XID VARCHAR(64), xinheritedControllerList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE ORG_UNIT_typeList (UNIT_XID VARCHAR(64), xtypeList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_C_ATTACHMENT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xactivity VARCHAR(64), xactivityName VARCHAR(255), xactivityToken VARCHAR(64), xactivityType VARCHAR(16), xapplication VARCHAR(64), xcompleted BOOLEAN, xdeepPath BOOLEAN, xextension VARCHAR(16), xjob VARCHAR(64), xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xlength BIGINT, xname VARCHAR(255), xorderNumber INTEGER, xperson VARCHAR(255), xprocess VARCHAR(64), xsite VARCHAR(64), xstorage VARCHAR(64), xtext CLOB, xtype VARCHAR(255), xwork VARCHAR(64), xworkCompleted VARCHAR(64), xworkCreateTime TIMESTAMP, PRIMARY KEY (xid), CONSTRAINT PP_C_ATTACHMENT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_C_ATTACHMENT_controllerIdentityList (ATTACHMENT_XID VARCHAR(64), xcontrollerIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_C_ATTACHMENT_controllerUnitList (ATTACHMENT_XID VARCHAR(64), xcontrollerUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_C_ATTACHMENT_divisionList (ATTACHMENT_XID VARCHAR(64), xdivisionList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_C_ATTACHMENT_editIdentityList (ATTACHMENT_XID VARCHAR(64), xeditIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_C_ATTACHMENT_editUnitList (ATTACHMENT_XID VARCHAR(64), xeditUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_C_ATTACHMENT_readIdentityList (ATTACHMENT_XID VARCHAR(64), xreadIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_C_ATTACHMENT_readUnitList (ATTACHMENT_XID VARCHAR(64), xreadUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_C_DOCUMENTVERSION (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xactivity VARCHAR(64), xactivityAlias VARCHAR(255), xactivityDescription VARCHAR(255), xactivityName VARCHAR(255), xactivityToken VARCHAR(64), xactivityType VARCHAR(16), xapplication VARCHAR(64), xcategory VARCHAR(255), xcompleted BOOLEAN, xdata CLOB, xjob VARCHAR(64), xperson VARCHAR(255), xprocess VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT PP_C_DOCUMENTVERSION_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_C_DRAFT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xapplication VARCHAR(64), xapplicationAlias VARCHAR(255), xapplicationName VARCHAR(255), xidentity VARCHAR(255), xperson VARCHAR(255), xprocess VARCHAR(64), xprocessAlias VARCHAR(255), xprocessName VARCHAR(255), xproperties CLOB, xtitle VARCHAR(255), xunit VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT PP_C_DRAFT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_C_KEYLOCK (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xkey VARCHAR(255), xperson VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT PP_C_KEYLOCK_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_C_READ (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xactivity VARCHAR(64), xactivityAlias VARCHAR(255), xactivityDescription VARCHAR(255), xactivityName VARCHAR(255), xactivityToken VARCHAR(64), xactivityType VARCHAR(16), xapplication VARCHAR(64), xapplicationAlias VARCHAR(255), xapplicationName VARCHAR(255), xbooleanValue01 BOOLEAN, xbooleanValue02 BOOLEAN, xcompleted BOOLEAN, xcreatorIdentity VARCHAR(255), xcreatorPerson VARCHAR(255), xcreatorUnit VARCHAR(255), xcurrentActivityName VARCHAR(255), xdateTimeValue01 TIMESTAMP, xdateTimeValue02 TIMESTAMP, xdateTimeValue03 TIMESTAMP, xdateTimeValue04 TIMESTAMP, xdateTimeValue05 TIMESTAMP, xdateValue01 DATE, xdateValue02 DATE, xdoubleValue01 DOUBLE, xdoubleValue02 DOUBLE, xdoubleValue03 DOUBLE, xdoubleValue04 DOUBLE, xdoubleValue05 DOUBLE, xidentity VARCHAR(255), xjob VARCHAR(64), xlongValue01 BIGINT, xlongValue02 BIGINT, xlongValue03 BIGINT, xlongValue04 BIGINT, xlongValue05 BIGINT, xopinion VARCHAR(255), xopinionLob CLOB, xperson VARCHAR(255), xprocess VARCHAR(64), xprocessAlias VARCHAR(255), xprocessName VARCHAR(255), xproperties CLOB, xserial VARCHAR(128), xstartTime TIMESTAMP, xstartTimeMonth VARCHAR(16), xstringValue01 VARCHAR(255), xstringValue02 VARCHAR(255), xstringValue03 VARCHAR(255), xstringValue04 VARCHAR(255), xstringValue05 VARCHAR(255), xstringValue06 VARCHAR(255), xstringValue07 VARCHAR(255), xstringValue08 VARCHAR(255), xstringValue09 VARCHAR(255), xstringValue10 VARCHAR(255), xtimeValue01 TIME, xtimeValue02 TIME, xtitle VARCHAR(255), xunit VARCHAR(255), xviewed BOOLEAN, xwork VARCHAR(64), xworkCompleted VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT PP_C_READ_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_C_READCOMPLETED (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xactivity VARCHAR(64), xactivityAlias VARCHAR(255), xactivityDescription VARCHAR(255), xactivityName VARCHAR(255), xactivityToken VARCHAR(64), xactivityType VARCHAR(16), xapplication VARCHAR(64), xapplicationAlias VARCHAR(255), xapplicationName VARCHAR(255), xbooleanValue01 BOOLEAN, xbooleanValue02 BOOLEAN, xcompleted BOOLEAN, xcompletedTime TIMESTAMP, xcompletedTimeMonth VARCHAR(16), xcreatorIdentity VARCHAR(255), xcreatorPerson VARCHAR(255), xcreatorUnit VARCHAR(255), xcurrentActivityName VARCHAR(255), xdateTimeValue01 TIMESTAMP, xdateTimeValue02 TIMESTAMP, xdateTimeValue03 TIMESTAMP, xdateTimeValue04 TIMESTAMP, xdateTimeValue05 TIMESTAMP, xdateValue01 DATE, xdateValue02 DATE, xdoubleValue01 DOUBLE, xdoubleValue02 DOUBLE, xdoubleValue03 DOUBLE, xdoubleValue04 DOUBLE, xdoubleValue05 DOUBLE, xduration BIGINT, xidentity VARCHAR(255), xjob VARCHAR(64), xlongValue01 BIGINT, xlongValue02 BIGINT, xlongValue03 BIGINT, xlongValue04 BIGINT, xlongValue05 BIGINT, xopinion VARCHAR(255), xopinionLob CLOB, xperson VARCHAR(255), xprocess VARCHAR(64), xprocessAlias VARCHAR(255), xprocessName VARCHAR(255), xproperties CLOB, xread VARCHAR(64), xserial VARCHAR(128), xstartTime TIMESTAMP, xstartTimeMonth VARCHAR(16), xstringValue01 VARCHAR(255), xstringValue02 VARCHAR(255), xstringValue03 VARCHAR(255), xstringValue04 VARCHAR(255), xstringValue05 VARCHAR(255), xstringValue06 VARCHAR(255), xstringValue07 VARCHAR(255), xstringValue08 VARCHAR(255), xstringValue09 VARCHAR(255), xstringValue10 VARCHAR(255), xtimeValue01 TIME, xtimeValue02 TIME, xtitle VARCHAR(255), xunit VARCHAR(255), xwork VARCHAR(64), xworkCompleted VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT PP_C_READCOMPLETED_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_C_Record (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xapplication VARCHAR(64), xarrivedActivity VARCHAR(64), xarrivedActivityAlias VARCHAR(255), xarrivedActivityName VARCHAR(255), xarrivedActivityToken VARCHAR(64), xarrivedActivityType VARCHAR(16), xcompleted BOOLEAN, xdisplay BOOLEAN, xfromActivity VARCHAR(64), xfromActivityAlias VARCHAR(255), xfromActivityName VARCHAR(255), xfromActivityToken VARCHAR(64), xfromActivityType VARCHAR(16), xidentity VARCHAR(255), xjob VARCHAR(64), xorder BIGINT, xperson VARCHAR(255), xprocess VARCHAR(64), xproperties CLOB, xrecordTime TIMESTAMP, xtype VARCHAR(64), xunit VARCHAR(255), xwork VARCHAR(64), xworkCompleted VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT PP_C_Record_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_C_REVIEW (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xapplication VARCHAR(64), xapplicationAlias VARCHAR(255), xapplicationName VARCHAR(255), xbooleanValue01 BOOLEAN, xbooleanValue02 BOOLEAN, xcompleted BOOLEAN, xcompletedTime TIMESTAMP, xcompletedTimeMonth VARCHAR(16), xcreatorIdentity VARCHAR(255), xcreatorPerson VARCHAR(255), xcreatorUnit VARCHAR(255), xcurrentActivityName VARCHAR(255), xdateTimeValue01 TIMESTAMP, xdateTimeValue02 TIMESTAMP, xdateTimeValue03 TIMESTAMP, xdateTimeValue04 TIMESTAMP, xdateTimeValue05 TIMESTAMP, xdateValue01 DATE, xdateValue02 DATE, xdoubleValue01 DOUBLE, xdoubleValue02 DOUBLE, xdoubleValue03 DOUBLE, xdoubleValue04 DOUBLE, xdoubleValue05 DOUBLE, xjob VARCHAR(64), xlongValue01 BIGINT, xlongValue02 BIGINT, xlongValue03 BIGINT, xlongValue04 BIGINT, xlongValue05 BIGINT, xperson VARCHAR(255), xprocess VARCHAR(64), xprocessAlias VARCHAR(255), xprocessName VARCHAR(255), xproperties CLOB, xserial VARCHAR(128), xstartTime TIMESTAMP, xstartTimeMonth VARCHAR(16), xstringValue01 VARCHAR(255), xstringValue02 VARCHAR(255), xstringValue03 VARCHAR(255), xstringValue04 VARCHAR(255), xstringValue05 VARCHAR(255), xstringValue06 VARCHAR(255), xstringValue07 VARCHAR(255), xstringValue08 VARCHAR(255), xstringValue09 VARCHAR(255), xstringValue10 VARCHAR(255), xtimeValue01 TIME, xtimeValue02 TIME, xtitle VARCHAR(255), xwork VARCHAR(64), xworkCompleted VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT PP_C_REVIEW_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_C_SERIALNUMBER (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xapplication VARCHAR(64), xname VARCHAR(255), xprocess VARCHAR(64), xserial INTEGER, PRIMARY KEY (xid), CONSTRAINT PP_C_SERIALNUMBER_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_C_TASK (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xactivity VARCHAR(64), xactivityAlias VARCHAR(255), xactivityDescription VARCHAR(255), xactivityName VARCHAR(255), xactivityToken VARCHAR(64), xactivityType VARCHAR(16), xallowRapid BOOLEAN, xapplication VARCHAR(64), xapplicationAlias VARCHAR(255), xapplicationName VARCHAR(255), xbooleanValue01 BOOLEAN, xbooleanValue02 BOOLEAN, xcreatorIdentity VARCHAR(255), xcreatorPerson VARCHAR(255), xcreatorUnit VARCHAR(255), xdateTimeValue01 TIMESTAMP, xdateTimeValue02 TIMESTAMP, xdateTimeValue03 TIMESTAMP, xdateTimeValue04 TIMESTAMP, xdateTimeValue05 TIMESTAMP, xdateValue01 DATE, xdateValue02 DATE, xdoubleValue01 DOUBLE, xdoubleValue02 DOUBLE, xdoubleValue03 DOUBLE, xdoubleValue04 DOUBLE, xdoubleValue05 DOUBLE, xempowerFromIdentity VARCHAR(255), xexpireTime TIMESTAMP, xexpired BOOLEAN, xfirst BOOLEAN, xidentity VARCHAR(255), xjob VARCHAR(64), xlongValue01 BIGINT, xlongValue02 BIGINT, xlongValue03 BIGINT, xlongValue04 BIGINT, xlongValue05 BIGINT, xmediaOpinion VARCHAR(255), xmodified BOOLEAN, xopinion VARCHAR(255), xopinionLob CLOB, xperson VARCHAR(255), xprocess VARCHAR(64), xprocessAlias VARCHAR(255), xprocessName VARCHAR(255), xproperties CLOB, xrouteName VARCHAR(255), xserial VARCHAR(128), xseries VARCHAR(64), xstartTime TIMESTAMP, xstartTimeMonth VARCHAR(16), xstringValue01 VARCHAR(255), xstringValue02 VARCHAR(255), xstringValue03 VARCHAR(255), xstringValue04 VARCHAR(255), xstringValue05 VARCHAR(255), xstringValue06 VARCHAR(255), xstringValue07 VARCHAR(255), xstringValue08 VARCHAR(255), xstringValue09 VARCHAR(255), xstringValue10 VARCHAR(255), xtimeValue01 TIME, xtimeValue02 TIME, xtitle VARCHAR(255), xunit VARCHAR(255), xurgeTime TIMESTAMP, xurged BOOLEAN, xviewed BOOLEAN, xwork VARCHAR(64), xworkCreateType VARCHAR(16), PRIMARY KEY (xid), CONSTRAINT PP_C_TASK_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_C_TASKCOMPLETED (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xactivity VARCHAR(64), xactivityAlias VARCHAR(255), xactivityDescription VARCHAR(255), xactivityName VARCHAR(255), xactivityToken VARCHAR(64), xactivityType VARCHAR(16), xapplication VARCHAR(64), xapplicationAlias VARCHAR(255), xapplicationName VARCHAR(255), xbooleanValue01 BOOLEAN, xbooleanValue02 BOOLEAN, xcompleted BOOLEAN, xcompletedTime TIMESTAMP, xcompletedTimeMonth VARCHAR(16), xcreatorIdentity VARCHAR(255), xcreatorPerson VARCHAR(255), xcreatorUnit VARCHAR(255), xcurrentActivityName VARCHAR(255), xdateTimeValue01 TIMESTAMP, xdateTimeValue02 TIMESTAMP, xdateTimeValue03 TIMESTAMP, xdateTimeValue04 TIMESTAMP, xdateTimeValue05 TIMESTAMP, xdateValue01 DATE, xdateValue02 DATE, xdoubleValue01 DOUBLE, xdoubleValue02 DOUBLE, xdoubleValue03 DOUBLE, xdoubleValue04 DOUBLE, xdoubleValue05 DOUBLE, xduration BIGINT, xempowerFromIdentity VARCHAR(255), xempowerToIdentity VARCHAR(255), xexpireTime TIMESTAMP, xexpired BOOLEAN, xidentity VARCHAR(255), xjob VARCHAR(64), xjoinInquire BOOLEAN, xlatest BOOLEAN, xlongValue01 BIGINT, xlongValue02 BIGINT, xlongValue03 BIGINT, xlongValue04 BIGINT, xlongValue05 BIGINT, xmediaOpinion VARCHAR(255), xopinion VARCHAR(255), xopinionLob CLOB, xperson VARCHAR(255), xpressActivityToken VARCHAR(64), xpressCount INTEGER, xpressTime TIMESTAMP, xprocess VARCHAR(64), xprocessAlias VARCHAR(255), xprocessName VARCHAR(255), xprocessingType VARCHAR(16), xproperties CLOB, xretractTime TIMESTAMP, xrouteName VARCHAR(255), xserial VARCHAR(128), xstartTime TIMESTAMP, xstartTimeMonth VARCHAR(16), xstringValue01 VARCHAR(255), xstringValue02 VARCHAR(255), xstringValue03 VARCHAR(255), xstringValue04 VARCHAR(255), xstringValue05 VARCHAR(255), xstringValue06 VARCHAR(255), xstringValue07 VARCHAR(255), xstringValue08 VARCHAR(255), xstringValue09 VARCHAR(255), xstringValue10 VARCHAR(255), xtask VARCHAR(64), xtimeValue01 TIME, xtimeValue02 TIME, xtitle VARCHAR(255), xunit VARCHAR(255), xwork VARCHAR(64), xworkCompleted VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT PP_C_TASKCOMPLETED_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_C_TASK_routeDecisionOpinionList (TASK_XID VARCHAR(64), xrouteDecisionOpinionList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_C_TASK_routeList (TASK_XID VARCHAR(64), xrouteList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE PP_C_TASK_routeNameList (TASK_XID VARCHAR(64), xrouteNameList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_C_TASK_routeOpinionList (TASK_XID VARCHAR(64), xrouteOpinionList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_C_WORK (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xactivity VARCHAR(64), xactivityAlias VARCHAR(255), xactivityArrivedTime TIMESTAMP, xactivityDescription VARCHAR(255), xactivityName VARCHAR(255), xactivityToken VARCHAR(64), xactivityType VARCHAR(16), xapplication VARCHAR(64), xapplicationAlias VARCHAR(255), xapplicationName VARCHAR(255), xbeforeExecuted BOOLEAN, xbooleanValue01 BOOLEAN, xbooleanValue02 BOOLEAN, xcreatorIdentity VARCHAR(255), xcreatorPerson VARCHAR(255), xcreatorUnit VARCHAR(255), xcreatorUnitLevelName CLOB, xdataChanged BOOLEAN, xdateTimeValue01 TIMESTAMP, xdateTimeValue02 TIMESTAMP, xdateTimeValue03 TIMESTAMP, xdateTimeValue04 TIMESTAMP, xdateTimeValue05 TIMESTAMP, xdateValue01 DATE, xdateValue02 DATE, xdestinationActivity VARCHAR(64), xdestinationActivityType VARCHAR(16), xdestinationRoute VARCHAR(64), xdestinationRouteName VARCHAR(255), xdoubleValue01 DOUBLE, xdoubleValue02 DOUBLE, xdoubleValue03 DOUBLE, xdoubleValue04 DOUBLE, xdoubleValue05 DOUBLE, xembedTargetWork VARCHAR(64), xexpireTime TIMESTAMP, xform VARCHAR(64), xjob VARCHAR(64), xlongValue01 BIGINT, xlongValue02 BIGINT, xlongValue03 BIGINT, xlongValue04 BIGINT, xlongValue05 BIGINT, xmanualTaskIdentityText VARCHAR(255), xprocess VARCHAR(64), xprocessAlias VARCHAR(255), xprocessName VARCHAR(255), xproperties CLOB, xserial VARCHAR(128), xsplitToken VARCHAR(64), xsplitValue VARCHAR(255), xsplitting BOOLEAN, xstartTime TIMESTAMP, xstartTimeMonth VARCHAR(16), xstringValue01 VARCHAR(255), xstringValue02 VARCHAR(255), xstringValue03 VARCHAR(255), xstringValue04 VARCHAR(255), xstringValue05 VARCHAR(255), xstringValue06 VARCHAR(255), xstringValue07 VARCHAR(255), xstringValue08 VARCHAR(255), xstringValue09 VARCHAR(255), xstringValue10 VARCHAR(255), xtimeValue01 TIME, xtimeValue02 TIME, xtitle VARCHAR(255), xtitleLob CLOB, xworkCreateType VARCHAR(16), xworkStatus VARCHAR(16), xworkThroughManual BOOLEAN, PRIMARY KEY (xid), CONSTRAINT PP_C_WORK_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_C_WORKCOMPLETED (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xallowRollback BOOLEAN, xapplication VARCHAR(64), xapplicationAlias VARCHAR(255), xapplicationName VARCHAR(255), xbooleanValue01 BOOLEAN, xbooleanValue02 BOOLEAN, xcompletedTime TIMESTAMP, xcompletedTimeMonth VARCHAR(16), xcreatorIdentity VARCHAR(255), xcreatorPerson VARCHAR(255), xcreatorUnit VARCHAR(255), xcreatorUnitLevelName CLOB, xdateTimeValue01 TIMESTAMP, xdateTimeValue02 TIMESTAMP, xdateTimeValue03 TIMESTAMP, xdateTimeValue04 TIMESTAMP, xdateTimeValue05 TIMESTAMP, xdateValue01 DATE, xdateValue02 DATE, xdoubleValue01 DOUBLE, xdoubleValue02 DOUBLE, xdoubleValue03 DOUBLE, xdoubleValue04 DOUBLE, xdoubleValue05 DOUBLE, xduration BIGINT, xexpireTime TIMESTAMP, xexpired BOOLEAN, xform VARCHAR(64), xformData CLOB, xformMobileData CLOB, xjob VARCHAR(64), xlongValue01 BIGINT, xlongValue02 BIGINT, xlongValue03 BIGINT, xlongValue04 BIGINT, xlongValue05 BIGINT, xmerged BOOLEAN, xprocess VARCHAR(64), xprocessAlias VARCHAR(255), xprocessName VARCHAR(255), xproperties CLOB, xserial VARCHAR(128), xstartTime TIMESTAMP, xstartTimeMonth VARCHAR(16), xstringValue01 VARCHAR(255), xstringValue02 VARCHAR(255), xstringValue03 VARCHAR(255), xstringValue04 VARCHAR(255), xstringValue05 VARCHAR(255), xstringValue06 VARCHAR(255), xstringValue07 VARCHAR(255), xstringValue08 VARCHAR(255), xstringValue09 VARCHAR(255), xstringValue10 VARCHAR(255), xtimeValue01 TIME, xtimeValue02 TIME, xtitle VARCHAR(255), xtitleLob CLOB, xwork VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT PP_C_WORKCOMPLETED_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_C_WORKLOG (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xapplication VARCHAR(64), xapplicationAlias VARCHAR(255), xapplicationName VARCHAR(255), xarrivedActivity VARCHAR(64), xarrivedActivityAlias VARCHAR(255), xarrivedActivityName VARCHAR(255), xarrivedActivityToken VARCHAR(64), xarrivedActivityType VARCHAR(16), xarrivedGroup VARCHAR(255), xarrivedOpinionGroup VARCHAR(255), xarrivedTime TIMESTAMP, xcompleted BOOLEAN, xconnected BOOLEAN, xduration BIGINT, xfromActivity VARCHAR(64), xfromActivityAlias VARCHAR(255), xfromActivityName VARCHAR(255), xfromActivityToken VARCHAR(64), xfromActivityType VARCHAR(16), xfromGroup VARCHAR(255), xfromOpinionGroup VARCHAR(255), xfromTime TIMESTAMP, xjob VARCHAR(64), xprocess VARCHAR(64), xprocessAlias VARCHAR(255), xprocessName VARCHAR(255), xproperties CLOB, xroute VARCHAR(64), xrouteName VARCHAR(255), xsplitToken VARCHAR(64), xsplitValue VARCHAR(255), xsplitWork VARCHAR(64), xsplitting BOOLEAN, xwork VARCHAR(64), xworkCompleted VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT PP_C_WORKLOG_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_C_WORK_manualTaskIdentityList (WORK_XID VARCHAR(64), xmanualTaskIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_C_WORK_splitTokenList (WORK_XID VARCHAR(64), xsplitTokenList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE PP_E_AGENT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xafterArriveScript VARCHAR(255), xafterArriveScriptText CLOB, xafterExecuteScript VARCHAR(255), xafterExecuteScriptText CLOB, xafterInquireScript VARCHAR(255), xafterInquireScriptText CLOB, xagentInterruptScript VARCHAR(255), xagentInterruptScriptText CLOB, xalias VARCHAR(255), xallowReroute BOOLEAN, xallowRerouteTo BOOLEAN, xbeforeArriveScript VARCHAR(255), xbeforeArriveScriptText CLOB, xbeforeExecuteScript VARCHAR(255), xbeforeExecuteScriptText CLOB, xbeforeInquireScript VARCHAR(255), xbeforeInquireScriptText CLOB, xdescription VARCHAR(255), xdisplayLogScript VARCHAR(255), xdisplayLogScriptText CLOB, xedition VARCHAR(255), xextension CLOB, xform VARCHAR(64), xgroup VARCHAR(255), xname VARCHAR(255), xopinionGroup VARCHAR(255), xposition VARCHAR(32), xprocess VARCHAR(64), xreadDuty CLOB, xreadScript VARCHAR(255), xreadScriptText CLOB, xreviewDuty CLOB, xreviewScript VARCHAR(255), xreviewScriptText CLOB, xroute VARCHAR(64), xscript VARCHAR(255), xscriptText CLOB, PRIMARY KEY (xid), CONSTRAINT PP_E_AGENT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_AGENT_readDataPathList (AGENT_XID VARCHAR(64), xreadDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_AGENT_readGroupList (AGENT_XID VARCHAR(64), xreadGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_AGENT_readIdentityList (AGENT_XID VARCHAR(64), xreadIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_AGENT_readUnitList (AGENT_XID VARCHAR(64), xreadUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_AGENT_reviewDataPathList (AGENT_XID VARCHAR(64), xreviewDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_AGENT_reviewGroupList (AGENT_XID VARCHAR(64), xreviewGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_AGENT_reviewIdentityList (AGENT_XID VARCHAR(64), xreviewIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_AGENT_reviewUnitList (AGENT_XID VARCHAR(64), xreviewUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_APPLICATION (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xapplicationCategory VARCHAR(255), xcreatorPerson VARCHAR(255), xdescription VARCHAR(255), xicon CLOB, xiconHue VARCHAR(8), xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xname VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT PP_E_APPLICATION_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_APPLICATIONDICT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xapplication VARCHAR(64), xdescription VARCHAR(255), xname VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT PP_E_APPLICATIONDICT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_APPLICATIONDICTITEM (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xapplication VARCHAR(64), xbooleanValue BOOLEAN, xbundle VARCHAR(255), xdateTimeValue TIMESTAMP, xdateValue DATE, xitemCategory VARCHAR(16), xitemPrimitiveType VARCHAR(1), xitemStringValueType VARCHAR(2), xitemType VARCHAR(1), xnumberValue DOUBLE, xpath0 VARCHAR(64), xpath0Location INTEGER, xpath1 VARCHAR(64), xpath1Location INTEGER, xpath2 VARCHAR(64), xpath2Location INTEGER, xpath3 VARCHAR(64), xpath3Location INTEGER, xpath4 VARCHAR(64), xpath4Location INTEGER, xpath5 VARCHAR(64), xpath5Location INTEGER, xpath6 VARCHAR(64), xpath6Location INTEGER, xpath7 VARCHAR(64), xpath7Location INTEGER, xstringLongValue CLOB, xstringShortValue VARCHAR(255), xtimeValue TIME, PRIMARY KEY (xid), CONSTRAINT PP_E_APPLICATIONDICTITEM_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_APPLICATION_availableIdentityList (APPLICATION_XID VARCHAR(64), xavailableIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_APPLICATION_availableUnitList (APPLICATION_XID VARCHAR(64), xavailableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_APPLICATION_controllerList (APPLICATION_XID VARCHAR(64), xcontrollerList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_BEGIN (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xafterArriveScript VARCHAR(255), xafterArriveScriptText CLOB, xafterExecuteScript VARCHAR(255), xafterExecuteScriptText CLOB, xafterInquireScript VARCHAR(255), xafterInquireScriptText CLOB, xalias VARCHAR(255), xallowReroute BOOLEAN, xallowRerouteTo BOOLEAN, xbeforeArriveScript VARCHAR(255), xbeforeArriveScriptText CLOB, xbeforeExecuteScript VARCHAR(255), xbeforeExecuteScriptText CLOB, xbeforeInquireScript VARCHAR(255), xbeforeInquireScriptText CLOB, xdescription VARCHAR(255), xdisplayLogScript VARCHAR(255), xdisplayLogScriptText CLOB, xedition VARCHAR(255), xextension CLOB, xform VARCHAR(64), xgroup VARCHAR(255), xname VARCHAR(255), xopinionGroup VARCHAR(255), xposition VARCHAR(32), xprocess VARCHAR(64), xreadDuty CLOB, xreadScript VARCHAR(255), xreadScriptText CLOB, xreviewDuty CLOB, xreviewScript VARCHAR(255), xreviewScriptText CLOB, xroute VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT PP_E_BEGIN_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_BEGIN_readDataPathList (BEGIN_XID VARCHAR(64), xreadDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_BEGIN_readGroupList (BEGIN_XID VARCHAR(64), xreadGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_BEGIN_readIdentityList (BEGIN_XID VARCHAR(64), xreadIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_BEGIN_readUnitList (BEGIN_XID VARCHAR(64), xreadUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_BEGIN_reviewDataPathList (BEGIN_XID VARCHAR(64), xreviewDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_BEGIN_reviewGroupList (BEGIN_XID VARCHAR(64), xreviewGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_BEGIN_reviewIdentityList (BEGIN_XID VARCHAR(64), xreviewIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_BEGIN_reviewUnitList (BEGIN_XID VARCHAR(64), xreviewUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_CANCEL (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xafterArriveScript VARCHAR(255), xafterArriveScriptText CLOB, xafterExecuteScript VARCHAR(255), xafterExecuteScriptText CLOB, xafterInquireScript VARCHAR(255), xafterInquireScriptText CLOB, xalias VARCHAR(255), xallowReroute BOOLEAN, xallowRerouteTo BOOLEAN, xbeforeArriveScript VARCHAR(255), xbeforeArriveScriptText CLOB, xbeforeExecuteScript VARCHAR(255), xbeforeExecuteScriptText CLOB, xbeforeInquireScript VARCHAR(255), xbeforeInquireScriptText CLOB, xdescription VARCHAR(255), xdisplayLogScript VARCHAR(255), xdisplayLogScriptText CLOB, xedition VARCHAR(255), xextension CLOB, xform VARCHAR(64), xgroup VARCHAR(255), xname VARCHAR(255), xopinionGroup VARCHAR(255), xposition VARCHAR(32), xprocess VARCHAR(64), xreadDuty CLOB, xreadScript VARCHAR(255), xreadScriptText CLOB, xreviewDuty CLOB, xreviewScript VARCHAR(255), xreviewScriptText CLOB, PRIMARY KEY (xid), CONSTRAINT PP_E_CANCEL_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_CANCEL_readDataPathList (CANCEL_XID VARCHAR(64), xreadDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_CANCEL_readGroupList (CANCEL_XID VARCHAR(64), xreadGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_CANCEL_readIdentityList (CANCEL_XID VARCHAR(64), xreadIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_CANCEL_readUnitList (CANCEL_XID VARCHAR(64), xreadUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_CANCEL_reviewDataPathList (CANCEL_XID VARCHAR(64), xreviewDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_CANCEL_reviewGroupList (CANCEL_XID VARCHAR(64), xreviewGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_CANCEL_reviewIdentityList (CANCEL_XID VARCHAR(64), xreviewIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_CANCEL_reviewUnitList (CANCEL_XID VARCHAR(64), xreviewUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_CHOICE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xafterArriveScript VARCHAR(255), xafterArriveScriptText CLOB, xafterExecuteScript VARCHAR(255), xafterExecuteScriptText CLOB, xafterInquireScript VARCHAR(255), xafterInquireScriptText CLOB, xalias VARCHAR(255), xallowReroute BOOLEAN, xallowRerouteTo BOOLEAN, xbeforeArriveScript VARCHAR(255), xbeforeArriveScriptText CLOB, xbeforeExecuteScript VARCHAR(255), xbeforeExecuteScriptText CLOB, xbeforeInquireScript VARCHAR(255), xbeforeInquireScriptText CLOB, xdescription VARCHAR(255), xdisplayLogScript VARCHAR(255), xdisplayLogScriptText CLOB, xedition VARCHAR(255), xextension CLOB, xform VARCHAR(64), xgroup VARCHAR(255), xname VARCHAR(255), xopinionGroup VARCHAR(255), xposition VARCHAR(32), xprocess VARCHAR(64), xreadDuty CLOB, xreadScript VARCHAR(255), xreadScriptText CLOB, xreviewDuty CLOB, xreviewScript VARCHAR(255), xreviewScriptText CLOB, PRIMARY KEY (xid), CONSTRAINT PP_E_CHOICE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_CHOICE_readDataPathList (CHOICE_XID VARCHAR(64), xreadDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_CHOICE_readGroupList (CHOICE_XID VARCHAR(64), xreadGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_CHOICE_readIdentityList (CHOICE_XID VARCHAR(64), xreadIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_CHOICE_readUnitList (CHOICE_XID VARCHAR(64), xreadUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_CHOICE_reviewDataPathList (CHOICE_XID VARCHAR(64), xreviewDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_CHOICE_reviewGroupList (CHOICE_XID VARCHAR(64), xreviewGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_CHOICE_reviewIdentityList (CHOICE_XID VARCHAR(64), xreviewIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_CHOICE_reviewUnitList (CHOICE_XID VARCHAR(64), xreviewUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_CHOICE_routeList (CHOICE_XID VARCHAR(64), xrouteList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE PP_E_DELAY (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xafterArriveScript VARCHAR(255), xafterArriveScriptText CLOB, xafterExecuteScript VARCHAR(255), xafterExecuteScriptText CLOB, xafterInquireScript VARCHAR(255), xafterInquireScriptText CLOB, xalias VARCHAR(255), xallowReroute BOOLEAN, xallowRerouteTo BOOLEAN, xbeforeArriveScript VARCHAR(255), xbeforeArriveScriptText CLOB, xbeforeExecuteScript VARCHAR(255), xbeforeExecuteScriptText CLOB, xbeforeInquireScript VARCHAR(255), xbeforeInquireScriptText CLOB, xdelayDataPath VARCHAR(255), xdelayMinute INTEGER, xdelayMode VARCHAR(16), xdelayScript VARCHAR(255), xdelayScriptText CLOB, xdelayTime TIMESTAMP, xdescription VARCHAR(255), xdisplayLogScript VARCHAR(255), xdisplayLogScriptText CLOB, xedition VARCHAR(255), xextension CLOB, xform VARCHAR(64), xgroup VARCHAR(255), xname VARCHAR(255), xopinionGroup VARCHAR(255), xposition VARCHAR(32), xprocess VARCHAR(64), xreadDuty CLOB, xreadScript VARCHAR(255), xreadScriptText CLOB, xreviewDuty CLOB, xreviewScript VARCHAR(255), xreviewScriptText CLOB, xroute VARCHAR(64), xworkMinute BOOLEAN, PRIMARY KEY (xid), CONSTRAINT PP_E_DELAY_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_DELAY_readDataPathList (DELAY_XID VARCHAR(64), xreadDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_DELAY_readGroupList (DELAY_XID VARCHAR(64), xreadGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_DELAY_readIdentityList (DELAY_XID VARCHAR(64), xreadIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_DELAY_readUnitList (DELAY_XID VARCHAR(64), xreadUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_DELAY_reviewDataPathList (DELAY_XID VARCHAR(64), xreviewDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_DELAY_reviewGroupList (DELAY_XID VARCHAR(64), xreviewGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_DELAY_reviewIdentityList (DELAY_XID VARCHAR(64), xreviewIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_DELAY_reviewUnitList (DELAY_XID VARCHAR(64), xreviewUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_EMBED (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xafterArriveScript VARCHAR(255), xafterArriveScriptText CLOB, xafterExecuteScript VARCHAR(255), xafterExecuteScriptText CLOB, xafterInquireScript VARCHAR(255), xafterInquireScriptText CLOB, xalias VARCHAR(255), xallowReroute BOOLEAN, xallowRerouteTo BOOLEAN, xasync BOOLEAN, xbeforeArriveScript VARCHAR(255), xbeforeArriveScriptText CLOB, xbeforeExecuteScript VARCHAR(255), xbeforeExecuteScriptText CLOB, xbeforeInquireScript VARCHAR(255), xbeforeInquireScriptText CLOB, xdescription VARCHAR(255), xdisplayLogScript VARCHAR(255), xdisplayLogScriptText CLOB, xedition VARCHAR(255), xembedCreatorType VARCHAR(16), xextension CLOB, xform VARCHAR(64), xgroup VARCHAR(255), xinheritAttachment BOOLEAN, xinheritData BOOLEAN, xname VARCHAR(255), xopinionGroup VARCHAR(255), xposition VARCHAR(32), xprocess VARCHAR(64), xreadDuty CLOB, xreadScript VARCHAR(255), xreadScriptText CLOB, xreviewDuty CLOB, xreviewScript VARCHAR(255), xreviewScriptText CLOB, xroute VARCHAR(64), xtargetApplication VARCHAR(64), xtargetApplicationAlias VARCHAR(255), xtargetApplicationName VARCHAR(255), xtargetAssginDataScript VARCHAR(255), xtargetAssginDataScriptText CLOB, xtargetIdentity VARCHAR(255), xtargetIdentityScript VARCHAR(255), xtargetIdentityScriptText CLOB, xtargetProcess VARCHAR(64), xtargetProcessAlias VARCHAR(255), xtargetProcessName VARCHAR(255), xtargetTitleScript VARCHAR(255), xtargetTitleScriptText CLOB, PRIMARY KEY (xid), CONSTRAINT PP_E_EMBED_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_EMBED_readDataPathList (EMBED_XID VARCHAR(64), xreadDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_EMBED_readGroupList (EMBED_XID VARCHAR(64), xreadGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_EMBED_readIdentityList (EMBED_XID VARCHAR(64), xreadIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_EMBED_readUnitList (EMBED_XID VARCHAR(64), xreadUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_EMBED_reviewDataPathList (EMBED_XID VARCHAR(64), xreviewDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_EMBED_reviewGroupList (EMBED_XID VARCHAR(64), xreviewGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_EMBED_reviewIdentityList (EMBED_XID VARCHAR(64), xreviewIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_EMBED_reviewUnitList (EMBED_XID VARCHAR(64), xreviewUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_END (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xafterArriveScript VARCHAR(255), xafterArriveScriptText CLOB, xafterExecuteScript VARCHAR(255), xafterExecuteScriptText CLOB, xafterInquireScript VARCHAR(255), xafterInquireScriptText CLOB, xalias VARCHAR(255), xallowReroute BOOLEAN, xallowRerouteTo BOOLEAN, xallowRollback BOOLEAN, xbeforeArriveScript VARCHAR(255), xbeforeArriveScriptText CLOB, xbeforeExecuteScript VARCHAR(255), xbeforeExecuteScriptText CLOB, xbeforeInquireScript VARCHAR(255), xbeforeInquireScriptText CLOB, xdescription VARCHAR(255), xdisplayLogScript VARCHAR(255), xdisplayLogScriptText CLOB, xedition VARCHAR(255), xextension CLOB, xform VARCHAR(64), xgroup VARCHAR(255), xname VARCHAR(255), xopinionGroup VARCHAR(255), xposition VARCHAR(32), xprocess VARCHAR(64), xreadDuty CLOB, xreadScript VARCHAR(255), xreadScriptText CLOB, xreviewDuty CLOB, xreviewScript VARCHAR(255), xreviewScriptText CLOB, PRIMARY KEY (xid), CONSTRAINT PP_E_END_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_END_readDataPathList (END_XID VARCHAR(64), xreadDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_END_readGroupList (END_XID VARCHAR(64), xreadGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_END_readIdentityList (END_XID VARCHAR(64), xreadIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_END_readUnitList (END_XID VARCHAR(64), xreadUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_END_reviewDataPathList (END_XID VARCHAR(64), xreviewDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_END_reviewGroupList (END_XID VARCHAR(64), xreviewGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_END_reviewIdentityList (END_XID VARCHAR(64), xreviewIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_END_reviewUnitList (END_XID VARCHAR(64), xreviewUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_FILE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xapplication VARCHAR(64), xdata CLOB, xdescription VARCHAR(255), xfileName VARCHAR(255), xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xlength BIGINT, xname VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT PP_E_FILE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_FORM (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xapplication VARCHAR(64), xcategory VARCHAR(255), xdata CLOB, xdescription VARCHAR(255), xhasMobile BOOLEAN, xicon CLOB, xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xmobileData CLOB, xname VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT PP_E_FORM_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_FORMFIELD (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xapplication VARCHAR(64), xdataType VARCHAR(32), xform VARCHAR(64), xname VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT PP_E_FORMFIELD_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_FORMVERSION (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdata CLOB, xform VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT PP_E_FORMVERSION_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_INVOKE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xafterArriveScript VARCHAR(255), xafterArriveScriptText CLOB, xafterExecuteScript VARCHAR(255), xafterExecuteScriptText CLOB, xafterInquireScript VARCHAR(255), xafterInquireScriptText CLOB, xalias VARCHAR(255), xallowReroute BOOLEAN, xallowRerouteTo BOOLEAN, xasync BOOLEAN, xbeforeArriveScript VARCHAR(255), xbeforeArriveScriptText CLOB, xbeforeExecuteScript VARCHAR(255), xbeforeExecuteScriptText CLOB, xbeforeInquireScript VARCHAR(255), xbeforeInquireScriptText CLOB, xdescription VARCHAR(255), xdisplayLogScript VARCHAR(255), xdisplayLogScriptText CLOB, xedition VARCHAR(255), xextension CLOB, xform VARCHAR(64), xgroup VARCHAR(255), xinternal BOOLEAN, xinternalProject VARCHAR(255), xinvokeMode VARCHAR(16), xjaxrsAddress VARCHAR(255), xjaxrsBodyScript VARCHAR(255), xjaxrsBodyScriptText CLOB, xjaxrsContentType VARCHAR(128), xjaxrsHeadScript VARCHAR(255), xjaxrsHeadScriptText CLOB, xjaxrsMethod VARCHAR(8), xjaxrsParameterScript VARCHAR(255), xjaxrsParameterScriptText CLOB, xjaxrsResponseScript VARCHAR(255), xjaxrsResponseScriptText CLOB, xjaxrsWithCipher BOOLEAN, xjaxwsAddress VARCHAR(255), xjaxwsMethod VARCHAR(128), xjaxwsParameterScript VARCHAR(255), xjaxwsParameterScriptText CLOB, xjaxwsResponseScript VARCHAR(255), xjaxwsResponseScriptText CLOB, xname VARCHAR(255), xopinionGroup VARCHAR(255), xposition VARCHAR(32), xprocess VARCHAR(64), xreadDuty CLOB, xreadScript VARCHAR(255), xreadScriptText CLOB, xreviewDuty CLOB, xreviewScript VARCHAR(255), xreviewScriptText CLOB, xroute VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT PP_E_INVOKE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_INVOKE_readDataPathList (INVOKE_XID VARCHAR(64), xreadDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_INVOKE_readGroupList (INVOKE_XID VARCHAR(64), xreadGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_INVOKE_readIdentityList (INVOKE_XID VARCHAR(64), xreadIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_INVOKE_readUnitList (INVOKE_XID VARCHAR(64), xreadUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_INVOKE_reviewDataPathList (INVOKE_XID VARCHAR(64), xreviewDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_INVOKE_reviewGroupList (INVOKE_XID VARCHAR(64), xreviewGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_INVOKE_reviewIdentityList (INVOKE_XID VARCHAR(64), xreviewIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_INVOKE_reviewUnitList (INVOKE_XID VARCHAR(64), xreviewUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MANUAL (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xafterArriveScript VARCHAR(255), xafterArriveScriptText CLOB, xafterExecuteScript VARCHAR(255), xafterExecuteScriptText CLOB, xafterInquireScript VARCHAR(255), xafterInquireScriptText CLOB, xalias VARCHAR(255), xallowAddSplit BOOLEAN, xallowDeleteWork BOOLEAN, xallowPress BOOLEAN, xallowRapid BOOLEAN, xallowReroute BOOLEAN, xallowRerouteTo BOOLEAN, xallowReset BOOLEAN, xallowRetract BOOLEAN, xallowRollback BOOLEAN, xbeforeArriveScript VARCHAR(255), xbeforeArriveScriptText CLOB, xbeforeExecuteScript VARCHAR(255), xbeforeExecuteScriptText CLOB, xbeforeInquireScript VARCHAR(255), xbeforeInquireScriptText CLOB, xdescription VARCHAR(255), xdisplayLogScript VARCHAR(255), xdisplayLogScriptText CLOB, xedition VARCHAR(255), xextension CLOB, xform VARCHAR(64), xgroup VARCHAR(255), xmanualAfterTaskScript VARCHAR(255), xmanualAfterTaskScriptText CLOB, xmanualBeforeTaskScript VARCHAR(255), xmanualBeforeTaskScriptText CLOB, xmanualMergeSameJobActivity BOOLEAN, xmanualMode VARCHAR(16), xmanualStayScript VARCHAR(255), xmanualStayScriptText CLOB, xname VARCHAR(255), xopinionGroup VARCHAR(255), xposition VARCHAR(32), xprocess VARCHAR(64), xreadDuty CLOB, xreadScript VARCHAR(255), xreadScriptText CLOB, xresetCount INTEGER, xresetRange VARCHAR(16), xreviewDuty CLOB, xreviewScript VARCHAR(255), xreviewScriptText CLOB, xtaskDuty CLOB, xtaskExpireDay INTEGER, xtaskExpireHour INTEGER, xtaskExpireScript VARCHAR(255), xtaskExpireScriptText CLOB, xtaskExpireType VARCHAR(16), xtaskExpireWorkTime BOOLEAN, xtaskScript VARCHAR(255), xtaskScriptText CLOB, PRIMARY KEY (xid), CONSTRAINT PP_E_MANUAL_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_MANUAL_readDataPathList (MANUAL_XID VARCHAR(64), xreadDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MANUAL_readGroupList (MANUAL_XID VARCHAR(64), xreadGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MANUAL_readIdentityList (MANUAL_XID VARCHAR(64), xreadIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MANUAL_readUnitList (MANUAL_XID VARCHAR(64), xreadUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MANUAL_reviewDataPathList (MANUAL_XID VARCHAR(64), xreviewDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MANUAL_reviewGroupList (MANUAL_XID VARCHAR(64), xreviewGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MANUAL_reviewIdentityList (MANUAL_XID VARCHAR(64), xreviewIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MANUAL_reviewUnitList (MANUAL_XID VARCHAR(64), xreviewUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MANUAL_routeList (MANUAL_XID VARCHAR(64), xrouteList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE PP_E_MANUAL_taskDataPathList (MANUAL_XID VARCHAR(64), xtaskDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MANUAL_taskGroupList (MANUAL_XID VARCHAR(64), xtaskGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MANUAL_taskIdentityList (MANUAL_XID VARCHAR(64), xtaskIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MANUAL_taskUnitList (MANUAL_XID VARCHAR(64), xtaskUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MAPPING (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xapplication VARCHAR(64), xdata CLOB, xdescription VARCHAR(255), xenable BOOLEAN, xname VARCHAR(255), xprocess VARCHAR(64), xtableName VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT PP_E_MAPPING_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_MERGE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xafterArriveScript VARCHAR(255), xafterArriveScriptText CLOB, xafterExecuteScript VARCHAR(255), xafterExecuteScriptText CLOB, xafterInquireScript VARCHAR(255), xafterInquireScriptText CLOB, xalias VARCHAR(255), xallowReroute BOOLEAN, xallowRerouteTo BOOLEAN, xbeforeArriveScript VARCHAR(255), xbeforeArriveScriptText CLOB, xbeforeExecuteScript VARCHAR(255), xbeforeExecuteScriptText CLOB, xbeforeInquireScript VARCHAR(255), xbeforeInquireScriptText CLOB, xdescription VARCHAR(255), xdisplayLogScript VARCHAR(255), xdisplayLogScriptText CLOB, xedition VARCHAR(255), xextension CLOB, xform VARCHAR(64), xgroup VARCHAR(255), xname VARCHAR(255), xopinionGroup VARCHAR(255), xposition VARCHAR(32), xprocess VARCHAR(64), xreadDuty CLOB, xreadScript VARCHAR(255), xreadScriptText CLOB, xreviewDuty CLOB, xreviewScript VARCHAR(255), xreviewScriptText CLOB, xroute VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT PP_E_MERGE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_MERGE_readDataPathList (MERGE_XID VARCHAR(64), xreadDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MERGE_readGroupList (MERGE_XID VARCHAR(64), xreadGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MERGE_readIdentityList (MERGE_XID VARCHAR(64), xreadIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MERGE_readUnitList (MERGE_XID VARCHAR(64), xreadUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MERGE_reviewDataPathList (MERGE_XID VARCHAR(64), xreviewDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MERGE_reviewGroupList (MERGE_XID VARCHAR(64), xreviewGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MERGE_reviewIdentityList (MERGE_XID VARCHAR(64), xreviewIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MERGE_reviewUnitList (MERGE_XID VARCHAR(64), xreviewUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MESSAGE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xafterArriveScript VARCHAR(255), xafterArriveScriptText CLOB, xafterExecuteScript VARCHAR(255), xafterExecuteScriptText CLOB, xafterInquireScript VARCHAR(255), xafterInquireScriptText CLOB, xalias VARCHAR(255), xallowReroute BOOLEAN, xallowRerouteTo BOOLEAN, xbeforeArriveScript VARCHAR(255), xbeforeArriveScriptText CLOB, xbeforeExecuteScript VARCHAR(255), xbeforeExecuteScriptText CLOB, xbeforeInquireScript VARCHAR(255), xbeforeInquireScriptText CLOB, xdescription VARCHAR(255), xdisplayLogScript VARCHAR(255), xdisplayLogScriptText CLOB, xedition VARCHAR(255), xextension CLOB, xform VARCHAR(64), xgroup VARCHAR(255), xname VARCHAR(255), xopinionGroup VARCHAR(255), xposition VARCHAR(32), xprocess VARCHAR(64), xreadDuty CLOB, xreadScript VARCHAR(255), xreadScriptText CLOB, xreviewDuty CLOB, xreviewScript VARCHAR(255), xreviewScriptText CLOB, xroute VARCHAR(64), xscript VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT PP_E_MESSAGE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_MESSAGE_readDataPathList (MESSAGE_XID VARCHAR(64), xreadDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MESSAGE_readGroupList (MESSAGE_XID VARCHAR(64), xreadGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MESSAGE_readIdentityList (MESSAGE_XID VARCHAR(64), xreadIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MESSAGE_readUnitList (MESSAGE_XID VARCHAR(64), xreadUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MESSAGE_reviewDataPathList (MESSAGE_XID VARCHAR(64), xreviewDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MESSAGE_reviewGroupList (MESSAGE_XID VARCHAR(64), xreviewGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MESSAGE_reviewIdentityList (MESSAGE_XID VARCHAR(64), xreviewIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_MESSAGE_reviewUnitList (MESSAGE_XID VARCHAR(64), xreviewUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_PARALLEL (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xafterArriveScript VARCHAR(255), xafterArriveScriptText CLOB, xafterExecuteScript VARCHAR(255), xafterExecuteScriptText CLOB, xafterInquireScript VARCHAR(255), xafterInquireScriptText CLOB, xalias VARCHAR(255), xallowReroute BOOLEAN, xallowRerouteTo BOOLEAN, xbeforeArriveScript VARCHAR(255), xbeforeArriveScriptText CLOB, xbeforeExecuteScript VARCHAR(255), xbeforeExecuteScriptText CLOB, xbeforeInquireScript VARCHAR(255), xbeforeInquireScriptText CLOB, xdescription VARCHAR(255), xdisplayLogScript VARCHAR(255), xdisplayLogScriptText CLOB, xedition VARCHAR(255), xextension CLOB, xform VARCHAR(64), xgroup VARCHAR(255), xname VARCHAR(255), xopinionGroup VARCHAR(255), xposition VARCHAR(32), xprocess VARCHAR(64), xreadDuty CLOB, xreadScript VARCHAR(255), xreadScriptText CLOB, xreviewDuty CLOB, xreviewScript VARCHAR(255), xreviewScriptText CLOB, PRIMARY KEY (xid), CONSTRAINT PP_E_PARALLEL_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_PARALLEL_readDataPathList (PARALLEL_XID VARCHAR(64), xreadDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_PARALLEL_readGroupList (PARALLEL_XID VARCHAR(64), xreadGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_PARALLEL_readIdentityList (PARALLEL_XID VARCHAR(64), xreadIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_PARALLEL_readUnitList (PARALLEL_XID VARCHAR(64), xreadUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_PARALLEL_reviewDataPathList (PARALLEL_XID VARCHAR(64), xreviewDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_PARALLEL_reviewGroupList (PARALLEL_XID VARCHAR(64), xreviewGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_PARALLEL_reviewIdentityList (PARALLEL_XID VARCHAR(64), xreviewIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_PARALLEL_reviewUnitList (PARALLEL_XID VARCHAR(64), xreviewUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_PARALLEL_routeList (PARALLEL_XID VARCHAR(64), xrouteList VARCHAR(64), xorderColumn INTEGER);
CREATE TABLE PP_E_PROCESS (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xafterArriveScript VARCHAR(255), xafterArriveScriptText CLOB, xafterBeginScript VARCHAR(255), xafterBeginScriptText CLOB, xafterEndScript VARCHAR(255), xafterEndScriptText CLOB, xafterExecuteScript VARCHAR(255), xafterExecuteScriptText CLOB, xafterInquireScript VARCHAR(255), xafterInquireScriptText CLOB, xalias VARCHAR(255), xapplication VARCHAR(64), xbeforeArriveScript VARCHAR(255), xbeforeArriveScriptText CLOB, xbeforeBeginScript VARCHAR(255), xbeforeBeginScriptText CLOB, xbeforeEndScript VARCHAR(255), xbeforeEndScriptText CLOB, xbeforeExecuteScript VARCHAR(255), xbeforeExecuteScriptText CLOB, xbeforeInquireScript VARCHAR(255), xbeforeInquireScriptText CLOB, xcheckDraft BOOLEAN, xcreatorPerson VARCHAR(255), xdefaultStartMode VARCHAR(16), xdescription VARCHAR(255), xedition VARCHAR(255), xeditionDes VARCHAR(255), xeditionEnable BOOLEAN, xeditionName VARCHAR(255), xeditionNumber DOUBLE, xexpireDay INTEGER, xexpireHour INTEGER, xexpireScript VARCHAR(255), xexpireScriptText CLOB, xexpireType VARCHAR(16), xexpireWorkTime BOOLEAN, xicon CLOB, xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xname VARCHAR(255), xprojection CLOB, xprojectionFully BOOLEAN, xrouteNameAsOpinion BOOLEAN, xserialActivity VARCHAR(64), xserialPhase VARCHAR(32), xserialTexture CLOB, PRIMARY KEY (xid), CONSTRAINT PP_E_PROCESS_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_PROCESSVERSION (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdata CLOB, xprocess VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT PP_E_PROCESSVERSION_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_PROCESS_controllerList (PROCESS_XID VARCHAR(64), xcontrollerList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_PROCESS_startableIdentityList (PROCESS_XID VARCHAR(64), xstartableIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_PROCESS_startableUnitList (PROCESS_XID VARCHAR(64), xstartableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_QUERYSTAT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xapplication VARCHAR(64), xcreatorPerson VARCHAR(255), xdata CLOB, xdescription VARCHAR(255), xicon CLOB, xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xlayout CLOB, xname VARCHAR(255), xqueryView VARCHAR(64), xqueryViewAlias VARCHAR(255), xqueryViewName VARCHAR(255), xresult CLOB, xtimingEnable BOOLEAN, xtimingInterval INTEGER, PRIMARY KEY (xid), CONSTRAINT PP_E_QUERYSTAT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_QUERYSTATTIMED (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xexpiredTime TIMESTAMP, xproject VARCHAR(64), xqueryStat VARCHAR(64), xscheduleTime TIMESTAMP, xtimingInterval INTEGER, PRIMARY KEY (xid), CONSTRAINT PP_E_QUERYSTATTIMED_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_QUERYSTAT_availableIdentityList (QUERYSTAT_XID VARCHAR(64), xavailableIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_QUERYSTAT_availablePersonList (QUERYSTAT_XID VARCHAR(64), xavailablePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_QUERYSTAT_availableUnitList (QUERYSTAT_XID VARCHAR(64), xavailableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_QUERYSTAT_controllerList (QUERYSTAT_XID VARCHAR(64), xcontrollerList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_QUERYVIEW (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xafterCalculateGridScriptText CLOB, xafterGridScriptText CLOB, xafterGroupGridScriptText CLOB, xalias VARCHAR(255), xapplication VARCHAR(64), xcode CLOB, xcreatorPerson VARCHAR(255), xdata CLOB, xdescription VARCHAR(255), xdisplay BOOLEAN, xicon CLOB, xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xlayout CLOB, xname VARCHAR(255), xtimingEnable BOOLEAN, xtimingInterval INTEGER, xtimingTouch INTEGER, PRIMARY KEY (xid), CONSTRAINT PP_E_QUERYVIEW_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_QUERYVIEW_availableIdentityList (QUERYVIEW_XID VARCHAR(64), xavailableIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_QUERYVIEW_availablePersonList (QUERYVIEW_XID VARCHAR(64), xavailablePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_QUERYVIEW_availableUnitList (QUERYVIEW_XID VARCHAR(64), xavailableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_QUERYVIEW_controllerList (QUERYVIEW_XID VARCHAR(64), xcontrollerList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_ROUTE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xactivity VARCHAR(64), xactivityType VARCHAR(16), xalias VARCHAR(255), xappendTaskIdentityScript VARCHAR(255), xappendTaskIdentityScriptText CLOB, xappendTaskIdentityType VARCHAR(64), xdecisionOpinion VARCHAR(255), xdescription VARCHAR(255), xdisplayNameScript VARCHAR(255), xdisplayNameScriptText CLOB, xedition VARCHAR(255), xhiddenScript VARCHAR(255), xhiddenScriptText CLOB, xname VARCHAR(255), xopinion VARCHAR(255), xopinionRequired BOOLEAN, xorderNumber INTEGER, xpassExpired BOOLEAN, xpassSameTarget BOOLEAN, xposition VARCHAR(255), xprocess VARCHAR(64), xscript VARCHAR(255), xscriptText CLOB, xselectConfig CLOB, xsole BOOLEAN, xtrack VARCHAR(255), xtype VARCHAR(64), xvalidationScript VARCHAR(255), xvalidationScriptText CLOB, PRIMARY KEY (xid), CONSTRAINT PP_E_ROUTE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_SCRIPT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xapplication VARCHAR(64), xcreatorPerson VARCHAR(255), xdescription VARCHAR(255), xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xname VARCHAR(255), xtext CLOB, xvalidated BOOLEAN, PRIMARY KEY (xid), CONSTRAINT PP_E_SCRIPT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_SCRIPTVERSION (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdata CLOB, xscript VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT PP_E_SCRIPTVERSION_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_SCRIPT_dependScriptList (SCRIPT_XID VARCHAR(64), xdependScriptList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_SERVICE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xafterArriveScript VARCHAR(255), xafterArriveScriptText CLOB, xafterExecuteScript VARCHAR(255), xafterExecuteScriptText CLOB, xafterInquireScript VARCHAR(255), xafterInquireScriptText CLOB, xalias VARCHAR(255), xallowReroute BOOLEAN, xallowRerouteTo BOOLEAN, xbeforeArriveScript VARCHAR(255), xbeforeArriveScriptText CLOB, xbeforeExecuteScript VARCHAR(255), xbeforeExecuteScriptText CLOB, xbeforeInquireScript VARCHAR(255), xbeforeInquireScriptText CLOB, xdescription VARCHAR(255), xdisplayLogScript VARCHAR(255), xdisplayLogScriptText CLOB, xedition VARCHAR(255), xextension CLOB, xform VARCHAR(64), xgroup VARCHAR(255), xname VARCHAR(255), xopinionGroup VARCHAR(255), xposition VARCHAR(32), xprocess VARCHAR(64), xreadDuty CLOB, xreadScript VARCHAR(255), xreadScriptText CLOB, xreviewDuty CLOB, xreviewScript VARCHAR(255), xreviewScriptText CLOB, xroute VARCHAR(64), xscript VARCHAR(255), xscriptText CLOB, PRIMARY KEY (xid), CONSTRAINT PP_E_SERVICE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_SERVICE_readDataPathList (SERVICE_XID VARCHAR(64), xreadDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_SERVICE_readGroupList (SERVICE_XID VARCHAR(64), xreadGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_SERVICE_readIdentityList (SERVICE_XID VARCHAR(64), xreadIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_SERVICE_readUnitList (SERVICE_XID VARCHAR(64), xreadUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_SERVICE_reviewDataPathList (SERVICE_XID VARCHAR(64), xreviewDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_SERVICE_reviewGroupList (SERVICE_XID VARCHAR(64), xreviewGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_SERVICE_reviewIdentityList (SERVICE_XID VARCHAR(64), xreviewIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_SERVICE_reviewUnitList (SERVICE_XID VARCHAR(64), xreviewUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_SERVICE_trustAddressList (SERVICE_XID VARCHAR(64), xtrustAddressList VARCHAR(32), xorderColumn INTEGER);
CREATE TABLE PP_E_SPLIT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xafterArriveScript VARCHAR(255), xafterArriveScriptText CLOB, xafterExecuteScript VARCHAR(255), xafterExecuteScriptText CLOB, xafterInquireScript VARCHAR(255), xafterInquireScriptText CLOB, xalias VARCHAR(255), xallowReroute BOOLEAN, xallowRerouteTo BOOLEAN, xbeforeArriveScript VARCHAR(255), xbeforeArriveScriptText CLOB, xbeforeExecuteScript VARCHAR(255), xbeforeExecuteScriptText CLOB, xbeforeInquireScript VARCHAR(255), xbeforeInquireScriptText CLOB, xdescription VARCHAR(255), xdisplayLogScript VARCHAR(255), xdisplayLogScriptText CLOB, xedition VARCHAR(255), xextension CLOB, xform VARCHAR(64), xgroup VARCHAR(255), xname VARCHAR(255), xopinionGroup VARCHAR(255), xposition VARCHAR(32), xprocess VARCHAR(64), xreadDuty CLOB, xreadScript VARCHAR(255), xreadScriptText CLOB, xreviewDuty CLOB, xreviewScript VARCHAR(255), xreviewScriptText CLOB, xroute VARCHAR(64), xscript VARCHAR(255), xscriptText CLOB, PRIMARY KEY (xid), CONSTRAINT PP_E_SPLIT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_E_SPLIT_readDataPathList (SPLIT_XID VARCHAR(64), xreadDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_SPLIT_readGroupList (SPLIT_XID VARCHAR(64), xreadGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_SPLIT_readIdentityList (SPLIT_XID VARCHAR(64), xreadIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_SPLIT_readUnitList (SPLIT_XID VARCHAR(64), xreadUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_SPLIT_reviewDataPathList (SPLIT_XID VARCHAR(64), xreviewDataPathList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_SPLIT_reviewGroupList (SPLIT_XID VARCHAR(64), xreviewGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_SPLIT_reviewIdentityList (SPLIT_XID VARCHAR(64), xreviewIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_SPLIT_reviewUnitList (SPLIT_XID VARCHAR(64), xreviewUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PP_E_TEMPLATEFORM (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xcategory VARCHAR(255), xdata CLOB, xdescription VARCHAR(255), xicon CLOB, xmobileData CLOB, xname VARCHAR(255), xoutline CLOB, PRIMARY KEY (xid), CONSTRAINT PP_E_TEMPLATEFORM_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_L_PROCESSINGERROR (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdata CLOB, xmessage VARCHAR(255), xwork VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT PP_L_PROCESSINGERROR_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_T_SERVICEVALUE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xapplication VARCHAR(64), xprocess VARCHAR(64), xservice VARCHAR(64), xvalue CLOB, xwork VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT PP_T_SERVICEVALUE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PP_T_TRIGGERWORKRECORD (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xlastSequence VARCHAR(128), PRIMARY KEY (xid), CONSTRAINT PP_T_TRIGGERWORKRECORD_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PTL_FILE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xdata CLOB, xdescription VARCHAR(255), xfileName VARCHAR(255), xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xlength BIGINT, xname VARCHAR(255), xportal VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT PTL_FILE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PTL_PAGE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xdata CLOB, xdescription VARCHAR(255), xhasMobile BOOLEAN, xmobileData CLOB, xname VARCHAR(255), xportal VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT PTL_PAGE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PTL_PORTAL (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xcreatorPerson VARCHAR(255), xdescription VARCHAR(255), xfirstPage VARCHAR(64), xicon CLOB, xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xmobileClient BOOLEAN, xname VARCHAR(255), xpcClient BOOLEAN, xportalCategory VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT PTL_PORTAL_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PTL_PORTAL_availableIdentityList (PORTAL_XID VARCHAR(64), xavailableIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PTL_PORTAL_availableUnitList (PORTAL_XID VARCHAR(64), xavailableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PTL_PORTAL_controllerList (PORTAL_XID VARCHAR(64), xcontrollerList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PTL_SCRIPT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xcreatorPerson VARCHAR(255), xdescription VARCHAR(255), xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xname VARCHAR(255), xportal VARCHAR(64), xtext CLOB, xvalidated BOOLEAN, PRIMARY KEY (xid), CONSTRAINT PTL_SCRIPT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PTL_SCRIPT_dependScriptList (SCRIPT_XID VARCHAR(64), xdependScriptList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PTL_TEMPLATEPAGE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xcategory VARCHAR(255), xcreatorPerson VARCHAR(255), xdata CLOB, xdescription VARCHAR(255), xicon CLOB, xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xmobileData CLOB, xname VARCHAR(255), xpreview CLOB, PRIMARY KEY (xid), CONSTRAINT PTL_TEMPLATEPAGE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE PTL_TEMPLATEPAGE_availableIdentityList (TEMPLATEPAGE_XID VARCHAR(64), xavailableIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PTL_TEMPLATEPAGE_availableUnitList (TEMPLATEPAGE_XID VARCHAR(64), xavailableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PTL_TEMPLATEPAGE_controllerList (TEMPLATEPAGE_XID VARCHAR(64), xcontrollerList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE PTL_WIDGET (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xdata CLOB, xdescription VARCHAR(255), xhasMobile BOOLEAN, xmobileData CLOB, xname VARCHAR(255), xportal VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT PTL_WIDGET_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE QRY_ITEM (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xbooleanValue BOOLEAN, xbundle VARCHAR(255), xdateTimeValue TIMESTAMP, xdateValue DATE, xitemCategory VARCHAR(16), xitemPrimitiveType VARCHAR(1), xitemStringValueType VARCHAR(2), xitemType VARCHAR(1), xnumberValue DOUBLE, xpath0 VARCHAR(64), xpath0Location INTEGER, xpath1 VARCHAR(64), xpath1Location INTEGER, xpath2 VARCHAR(64), xpath2Location INTEGER, xpath3 VARCHAR(64), xpath3Location INTEGER, xpath4 VARCHAR(64), xpath4Location INTEGER, xpath5 VARCHAR(64), xpath5Location INTEGER, xpath6 VARCHAR(64), xpath6Location INTEGER, xpath7 VARCHAR(64), xpath7Location INTEGER, xstringLongValue CLOB, xstringShortValue VARCHAR(255), xtimeValue TIME, PRIMARY KEY (xid), CONSTRAINT QRY_ITEM_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE QRY_NRL_ENTRY (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xbundle VARCHAR(255), xinValueCount INTEGER, xmodel VARCHAR(64), xoutValueCount INTEGER, xtitle VARCHAR(255), xtype VARCHAR(32), PRIMARY KEY (xid), CONSTRAINT QRY_NRL_ENTRY_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE QRY_NRL_ENTRY_inValueLabelList (ENTRY_XID VARCHAR(64), xinValueLabelList INTEGER, xorderColumn INTEGER);
CREATE TABLE QRY_NRL_ENTRY_outValueLabelList (ENTRY_XID VARCHAR(64), xoutValueLabelList INTEGER, xorderColumn INTEGER);
CREATE TABLE QRY_NRL_INTEXT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcount INTEGER, xmodel VARCHAR(64), xserial INTEGER, xtext VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT QRY_NRL_INTEXT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE QRY_NRL_INVALUE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcount INTEGER, xinTextSerial INTEGER, xmodel VARCHAR(64), xserial INTEGER, xtext VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT QRY_NRL_INVALUE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE QRY_NRL_MODEL (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xanalyzeType VARCHAR(32), xattachmentScriptText CLOB, xdataType VARCHAR(32), xdescription VARCHAR(255), xeffectiveEntryCount INTEGER, xendDate TIMESTAMP, xentryCount INTEGER, xgeneratingPercent INTEGER, xinValueCount INTEGER, xinValueScriptText CLOB, xintermediateNnet CLOB, xlearnEntryCount INTEGER, xmaxResult INTEGER, xname VARCHAR(255), xneuralNetworkType VARCHAR(32), xnnet CLOB, xoutValueCount INTEGER, xoutValueScriptText CLOB, xstartDate TIMESTAMP, xstatus VARCHAR(32), xtotalError DOUBLE, xvalidationEntryCount INTEGER, xvalidationMeanSquareError DOUBLE, PRIMARY KEY (xid), CONSTRAINT QRY_NRL_MODEL_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE QRY_NRL_MODEL_applicationList (MODEL_XID VARCHAR(64), xapplicationList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE QRY_NRL_MODEL_processList (MODEL_XID VARCHAR(64), xprocessList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE QRY_NRL_MODEL_propertyMap (MODEL_XID VARCHAR(64), xkey VARCHAR(255), xpropertyMap VARCHAR(255));
CREATE TABLE QRY_NRL_OUTTEXT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcount INTEGER, xmodel VARCHAR(64), xserial INTEGER, xtext VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT QRY_NRL_OUTTEXT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE QRY_NRL_OUTVALUE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcount INTEGER, xmodel VARCHAR(64), xserial INTEGER, xtext VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT QRY_NRL_OUTVALUE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE QRY_PGM_ARGUMENT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xname VARCHAR(255), xstringValue VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT QRY_PGM_ARGUMENT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE QRY_QUERY (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xcreatorPerson VARCHAR(255), xdescription VARCHAR(255), xicon CLOB, xiconHue VARCHAR(8), xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xname VARCHAR(255), xqueryCategory VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT QRY_QUERY_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE QRY_QUERY_availableIdentityList (QUERY_XID VARCHAR(64), xavailableIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE QRY_QUERY_availableUnitList (QUERY_XID VARCHAR(64), xavailableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE QRY_QUERY_controllerList (QUERY_XID VARCHAR(64), xcontrollerList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE QRY_REVEAL (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xdescription VARCHAR(255), xname VARCHAR(255), xquery VARCHAR(64), xstat VARCHAR(64), xview VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT QRY_REVEAL_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE QRY_REVEAL_availableIdentityList (REVEAL_XID VARCHAR(64), xavailableIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE QRY_REVEAL_availableUnitList (REVEAL_XID VARCHAR(64), xavailableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE QRY_SCH_STATEMENT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xcreatorPerson VARCHAR(255), xdata CLOB, xdescription VARCHAR(255), xentityCategory VARCHAR(16), xentityClassName VARCHAR(255), xformat VARCHAR(32), xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xname VARCHAR(255), xquery VARCHAR(64), xscriptText CLOB, xtable VARCHAR(64), xtype VARCHAR(16), PRIMARY KEY (xid), CONSTRAINT QRY_SCH_STATEMENT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE QRY_SCH_STATEMENT_executePersonList (STATEMENT_XID VARCHAR(64), xexecutePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE QRY_SCH_STATEMENT_executeUnitList (STATEMENT_XID VARCHAR(64), xexecuteUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE QRY_SCH_TABLE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(64), xbuildSuccess BOOLEAN, xcreatorPerson VARCHAR(255), xdata CLOB, xdescription VARCHAR(255), xdraftData CLOB, xlastUpdatePerson VARCHAR(255), xlastUpdateTime TIMESTAMP, xname VARCHAR(64), xquery VARCHAR(64), xstatus VARCHAR(32), PRIMARY KEY (xid), CONSTRAINT QRY_SCH_TABLE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE QRY_SCH_TABLE_editPersonList (TABLE_XID VARCHAR(64), xeditPersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE QRY_SCH_TABLE_editUnitList (TABLE_XID VARCHAR(64), xeditUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE QRY_SCH_TABLE_readPersonList (TABLE_XID VARCHAR(64), xreadPersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE QRY_SCH_TABLE_readUnitList (TABLE_XID VARCHAR(64), xreadUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE QRY_SEG_ENTRY (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xappId VARCHAR(64), xappName VARCHAR(255), xapplication VARCHAR(64), xapplicationName VARCHAR(255), xbundle VARCHAR(255), xcategoryId VARCHAR(64), xcategoryName VARCHAR(255), xcreatorPerson VARCHAR(255), xcreatorUnit VARCHAR(255), xlastUpdateTime TIMESTAMP, xprocess VARCHAR(64), xprocessName VARCHAR(255), xreference VARCHAR(64), xsummary VARCHAR(255), xtitle VARCHAR(255), xtype VARCHAR(32), xwait BOOLEAN, PRIMARY KEY (xid), CONSTRAINT QRY_SEG_ENTRY_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE QRY_SEG_WORD (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xapplication VARCHAR(64), xbundle VARCHAR(64), xcount INTEGER, xentry VARCHAR(64), xlabel VARCHAR(32), xtag VARCHAR(64), xtype VARCHAR(32), xvalue VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT QRY_SEG_WORD_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE QRY_STAT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xalias VARCHAR(255), xdata CLOB, xdescription VARCHAR(255), xname VARCHAR(255), xquery VARCHAR(64), xview VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT QRY_STAT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE QRY_STAT_availableIdentityList (STAT_XID VARCHAR(64), xavailableIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE QRY_STAT_availableUnitList (STAT_XID VARCHAR(64), xavailableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE QRY_VIEW (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xafterCalculateGridScriptText CLOB, xafterGridScriptText CLOB, xafterGroupGridScriptText CLOB, xalias VARCHAR(255), xcacheAccess BOOLEAN, xcode CLOB, xcount INTEGER, xdata CLOB, xdescription VARCHAR(255), xdisplay BOOLEAN, xenableCache BOOLEAN, xlayout CLOB, xname VARCHAR(255), xpageSize INTEGER, xquery VARCHAR(64), xtoolbar CLOB, xtype VARCHAR(32), PRIMARY KEY (xid), CONSTRAINT QRY_VIEW_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE QRY_VIEW_availableIdentityList (VIEW_XID VARCHAR(64), xavailableIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE QRY_VIEW_availableUnitList (VIEW_XID VARCHAR(64), xavailableUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE SAMPLE_JPUSH_TABLENAME (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdate TIMESTAMP, xname VARCHAR(255), xorderNumber INTEGER, PRIMARY KEY (xid), CONSTRAINT SAMPLE_JPUSH_TABLENAME_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_ATTACHMENT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xbundleObjType VARCHAR(8), xcreatorUid VARCHAR(255), xdeepPath BOOLEAN, xdescription VARCHAR(255), xextension VARCHAR(16), xfileHost VARCHAR(32), xfileName VARCHAR(255), xfilePath VARCHAR(255), xfileType VARCHAR(16), xlastUpdateTime TIMESTAMP, xlength BIGINT, xname VARCHAR(255), xprojectId VARCHAR(64), xseqNumber INTEGER, xsite VARCHAR(64), xstorage VARCHAR(64), xtaskId VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT TEW_ATTACHMENT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_BATCHOPERATION (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xbundle VARCHAR(255), xdescription VARCHAR(255), xerrorCount INTEGER, xisRunning BOOLEAN, xobjType VARCHAR(16), xoldInfo VARCHAR(255), xoptType VARCHAR(16), PRIMARY KEY (xid), CONSTRAINT TEW_BATCHOPERATION_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_CHAT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcontent VARCHAR(255), xdeleted BOOLEAN, xdescription VARCHAR(255), xfileId BOOLEAN, xisFile BOOLEAN, xisLob BOOLEAN, xprojectId VARCHAR(64), xprojectTitle VARCHAR(255), xsender VARCHAR(255), xtarget VARCHAR(255), xtaskId VARCHAR(64), xtaskTitle VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT TEW_CHAT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_CHATCONTENT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcontent CLOB, PRIMARY KEY (xid), CONSTRAINT TEW_CHATCONTENT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_DYNAMIC (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xbundle VARCHAR(64), xcontent VARCHAR(255), xdateTimeStr VARCHAR(32), xdescription VARCHAR(255), xobjectType VARCHAR(64), xoperator VARCHAR(255), xoptTime TIMESTAMP, xoptType VARCHAR(64), xpersonal BOOLEAN, xprojectId VARCHAR(64), xprojectTitle VARCHAR(255), xtarget VARCHAR(255), xtaskId VARCHAR(64), xtaskTitle VARCHAR(255), xtitle VARCHAR(255), xviewUrl VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT TEW_DYNAMIC_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_DYNAMIC_DETAIL (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcontent CLOB, PRIMARY KEY (xid), CONSTRAINT TEW_DYNAMIC_DETAIL_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_PROJECT (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xarchive BOOLEAN, xcompleted BOOLEAN, xcreatorPerson VARCHAR(255), xdeleted BOOLEAN, xexecutor VARCHAR(255), xgroupCount INTEGER, xicon VARCHAR(64), xorder INTEGER, xprogress INTEGER, xtitle VARCHAR(255), xtype VARCHAR(16), PRIMARY KEY (xid), CONSTRAINT TEW_PROJECT_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_PROJECTDETAIL (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdescription CLOB, PRIMARY KEY (xid), CONSTRAINT TEW_PROJECTDETAIL_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_PROJECTEXTFIELD_RELE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdescription VARCHAR(255), xdisplayName VARCHAR(64), xdisplayType VARCHAR(16), xextFieldName VARCHAR(16), xnullable BOOLEAN, xoptionsData CLOB, xorder INTEGER, xprojectId VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT TEW_PROJECTEXTFIELD_RELE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_PROJECTGROUP (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcreatorPerson VARCHAR(255), xname VARCHAR(255), xorder INTEGER, xowner VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT TEW_PROJECTGROUP_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_PROJECTGROUP_RELE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xgroupId VARCHAR(255), xprojectId VARCHAR(255), PRIMARY KEY (xid), CONSTRAINT TEW_PROJECTGROUP_RELE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_PROJECT_manageablePersonList (PROJECT_XID VARCHAR(64), xmanageablePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE TEW_PROJECT_participantGroupList (PROJECT_XID VARCHAR(64), xparticipantGroupList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE TEW_PROJECT_participantIdentityList (PROJECT_XID VARCHAR(64), xparticipantIdentityList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE TEW_PROJECT_participantPersonList (PROJECT_XID VARCHAR(64), xparticipantPersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE TEW_PROJECT_participantUnitList (PROJECT_XID VARCHAR(64), xparticipantUnitList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE TEW_PROJECT_starPersonList (PROJECT_XID VARCHAR(64), xstarPersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE TEW_REVIEW (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xarchive BOOLEAN, xclaimed BOOLEAN, xcompleted BOOLEAN, xcreatorPerson VARCHAR(255), xdeleted BOOLEAN, xendTime TIMESTAMP, xexecutor VARCHAR(255), xexecutorIdentity VARCHAR(255), xexecutorUnit VARCHAR(255), xmemoDouble1 DOUBLE, xmemoDouble2 DOUBLE, xmemoInteger1 INTEGER, xmemoInteger2 INTEGER, xmemoInteger3 INTEGER, xmemoString255_1 VARCHAR(255), xmemoString255_2 VARCHAR(255), xmemoString64_1 VARCHAR(64), xmemoString64_2 VARCHAR(64), xmemoString64_3 VARCHAR(255), xname VARCHAR(255), xorder INTEGER, xovertime BOOLEAN, xparent VARCHAR(64), xpermissionObj VARCHAR(255), xpermissionObjType VARCHAR(16), xpriority VARCHAR(32), xprogress INTEGER, xproject VARCHAR(64), xprojectName VARCHAR(64), xremindRelevance BOOLEAN, xstartTime TIMESTAMP, xtagContent VARCHAR(255), xtaskId VARCHAR(64), xtaskSequence VARCHAR(128), xworkStatus VARCHAR(32), PRIMARY KEY (xid), CONSTRAINT TEW_REVIEW_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_SYSTEMCONFIG (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xconfigCode VARCHAR(96), xconfigName VARCHAR(96), xconfigValue VARCHAR(255), xdescription VARCHAR(255), xisLob BOOLEAN, xisMultiple BOOLEAN, xorderNumber INTEGER, xselectContent VARCHAR(255), xvalueType VARCHAR(16), PRIMARY KEY (xid), CONSTRAINT TEW_SYSTEMCONFIG_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_SYSTEMCONFIG_LOB (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xlobValue CLOB, PRIMARY KEY (xid), CONSTRAINT TEW_SYSTEMCONFIG_LOB_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_TAG (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xowner VARCHAR(255), xproject VARCHAR(64), xtag VARCHAR(64), xtagColor VARCHAR(16), PRIMARY KEY (xid), CONSTRAINT TEW_TAG_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_TASK (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xarchive BOOLEAN, xclaimed BOOLEAN, xcompleted BOOLEAN, xcreatorPerson VARCHAR(255), xdeleted BOOLEAN, xendTime TIMESTAMP, xexecutor VARCHAR(255), xexecutorIdentity VARCHAR(255), xexecutorUnit VARCHAR(255), xname VARCHAR(128), xorder INTEGER, xovertime BOOLEAN, xparent VARCHAR(64), xpriority VARCHAR(16), xprogress INTEGER, xproject VARCHAR(64), xprojectName VARCHAR(64), xremindRelevance BOOLEAN, xreviewed BOOLEAN, xstartTime TIMESTAMP, xsummay VARCHAR(255), xworkStatus VARCHAR(16), PRIMARY KEY (xid), CONSTRAINT TEW_TASK_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_TASKDETAIL (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xdescription CLOB, xdetail CLOB, xproject VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT TEW_TASKDETAIL_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_TASKEXTFIELD (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xmemoString_1 VARCHAR(255), xmemoString_1_lob CLOB, xmemoString_2 VARCHAR(255), xmemoString_2_lob CLOB, xmemoString_3 VARCHAR(255), xmemoString_3_lob CLOB, xmemoString_4 VARCHAR(255), xmemoString_4_lob CLOB, xmemoString_5 VARCHAR(255), xmemoString_6 VARCHAR(255), xmemoString_7 VARCHAR(255), xmemoString_8 VARCHAR(255), xname VARCHAR(128), xproject VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT TEW_TASKEXTFIELD_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_TASKGROUP (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcompletedTotal INTEGER, xcreatorPerson VARCHAR(255), xmemo VARCHAR(255), xname VARCHAR(96), xorder INTEGER, xovertimeTotal INTEGER, xowner VARCHAR(255), xproject VARCHAR(64), xtaskTotal INTEGER, PRIMARY KEY (xid), CONSTRAINT TEW_TASKGROUP_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_TASKGROUP_RELE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xorder INTEGER, xproject VARCHAR(64), xtaskGroupId VARCHAR(64), xtaskId VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT TEW_TASKGROUP_RELE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_TASKLIST (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcreatorPerson VARCHAR(255), xdeleted BOOLEAN, xmemo VARCHAR(255), xname VARCHAR(96), xorder INTEGER, xowner VARCHAR(255), xproject VARCHAR(64), xtaskGroup VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT TEW_TASKLIST_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_TASKLIST_RELE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xorder INTEGER, xproject VARCHAR(64), xtaskGroupId VARCHAR(64), xtaskId VARCHAR(64), xtaskListId VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT TEW_TASKLIST_RELE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_TASKRELEVANCE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xbundle VARCHAR(64), xcreatorPerson VARCHAR(255), xname VARCHAR(64), xproject VARCHAR(64), xtask VARCHAR(64), xtype VARCHAR(16), PRIMARY KEY (xid), CONSTRAINT TEW_TASKRELEVANCE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_TASKTAG_RELE (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xorder INTEGER, xowner VARCHAR(255), xproject VARCHAR(64), xtagId VARCHAR(64), xtaskId VARCHAR(64), PRIMARY KEY (xid), CONSTRAINT TEW_TASKTAG_RELE_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_TASKVIEW (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xcreatorPerson VARCHAR(255), xname VARCHAR(16), xisExcutor BOOLEAN, xmemo VARCHAR(255), xorder INTEGER, xorderField VARCHAR(16), xorderType VARCHAR(16), xowner VARCHAR(255), xproject VARCHAR(64), xworkCompleted INTEGER, xworkOverTime INTEGER, PRIMARY KEY (xid), CONSTRAINT TEW_TASKVIEW_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE TEW_TASKVIEW_choosePriority (TASKVIEW_XID VARCHAR(64), xchoosePriority VARCHAR(32), xorderColumn INTEGER);
CREATE TABLE TEW_TASKVIEW_chooseWorkTag (TASKVIEW_XID VARCHAR(64), xchooseWorkTag VARCHAR(32), xorderColumn INTEGER);
CREATE TABLE TEW_TASK_manageablePersonList (TASK_XID VARCHAR(64), xmanageablePersonList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE TEW_TASK_participantList (TASK_XID VARCHAR(64), xparticipantList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE VAL_META (xid VARCHAR(64) NOT NULL, xcreateTime TIMESTAMP, xscratchBoolean BOOLEAN, xscratchDate TIMESTAMP, xscratchInteger TIMESTAMP, xscratchString VARCHAR(255), xsequence VARCHAR(128), xupdateTime TIMESTAMP, xdistributeFactor INTEGER, xbooleanValue BOOLEAN, xdateTimeValue TIMESTAMP, xdateValue DATE, xdoubleValue DOUBLE, xintegerValue INTEGER, xlongValue BIGINT, xstringLobValue CLOB, xstringValue VARCHAR(255), xtimeValue TIME, PRIMARY KEY (xid), CONSTRAINT VAL_META_DUC UNIQUE (xid, xcreateTime, xupdateTime, xsequence));
CREATE TABLE VAL_META_listValueList (META_XID VARCHAR(64), xlistValueList VARCHAR(255), xorderColumn INTEGER);
CREATE TABLE VAL_META_mapValueMap (META_XID VARCHAR(64), xkey VARCHAR(255), xmapValueMap VARCHAR(255));
CREATE INDEX ARA_DISTRICT_center ON ARA_DISTRICT (xcenter);
CREATE INDEX ARA_DISTRICT_city ON ARA_DISTRICT (xcity);
CREATE INDEX ARA_DISTRICT_cityCode ON ARA_DISTRICT (xcityCode);
CREATE INDEX ARA_DISTRICT_district ON ARA_DISTRICT (xdistrict);
CREATE INDEX ARA_DISTRICT_level ON ARA_DISTRICT (xlevel);
CREATE INDEX ARA_DISTRICT_name ON ARA_DISTRICT (xname);
CREATE INDEX ARA_DISTRICT_province ON ARA_DISTRICT (xprovince);
CREATE INDEX ARA_DISTRICT_sha ON ARA_DISTRICT (xsha);
CREATE INDEX ARA_DISTRICT_zipCode ON ARA_DISTRICT (xzipCode);
CREATE INDEX ATDC_ATTENDANCE_ADMIN_adminName ON ATDC_ATTENDANCE_ADMIN (xadminName);
CREATE INDEX ATDC_ATTENDANCE_ADMIN_unitOu ON ATDC_ATTENDANCE_ADMIN (xunitOu);
CREATE INDEX ATDC_ATTENDANCE_IMPORTFILE_lastUpdateTime ON ATDC_ATTENDANCE_IMPORTFILE (xlastUpdateTime);
CREATE INDEX BBS_CONFIGSETTING_configCode ON BBS_CONFIGSETTING (xconfigCode);
CREATE INDEX BBS_CONFIGSETTING_description ON BBS_CONFIGSETTING (xdescription);
CREATE INDEX BBS_FORUMINFO_forumStatus ON BBS_FORUMINFO (xforumStatus);
CREATE INDEX BBS_FORUMINFO_forumVisible ON BBS_FORUMINFO (xforumVisible);
CREATE INDEX BBS_FORUMINFO_replyMessageNotify ON BBS_FORUMINFO (xreplyMessageNotify);
CREATE INDEX BBS_FORUMINFO_subjectMessageNotify ON BBS_FORUMINFO (xsubjectMessageNotify);
CREATE INDEX BBS_FORUMINFO_subjectPublishAble ON BBS_FORUMINFO (xsubjectPublishAble);
CREATE INDEX BBS_FORUMINFO_forumManagerList_element ON BBS_FORUMINFO_forumManagerList (xforumManagerList);
CREATE INDEX BBS_FORUMINFO_forumManagerList_join ON BBS_FORUMINFO_forumManagerList (BBSFORUMINFO_XID);
CREATE INDEX BBS_FORUMINFO_publishPermissionList_element ON BBS_FORUMINFO_publishPermissionList (xpublishPermissionList);
CREATE INDEX BBS_FORUMINFO_publishPermissionList_join ON BBS_FORUMINFO_publishPermissionList (BBSFORUMINFO_XID);
CREATE INDEX BBS_FORUMINFO_replyPermissionList_element ON BBS_FORUMINFO_replyPermissionList (xreplyPermissionList);
CREATE INDEX BBS_FORUMINFO_replyPermissionList_join ON BBS_FORUMINFO_replyPermissionList (BBSFORUMINFO_XID);
CREATE INDEX BBS_FORUMINFO_visiblePermissionList_element ON BBS_FORUMINFO_visiblePermissionList (xvisiblePermissionList);
CREATE INDEX BBS_FORUMINFO_visiblePermissionList_join ON BBS_FORUMINFO_visiblePermissionList (BBSFORUMINFO_XID);
CREATE INDEX BBS_OPERATIONRECORD_forumId ON BBS_OPERATIONRECORD (xforumId);
CREATE INDEX BBS_OPERATIONRECORD_hostname ON BBS_OPERATIONRECORD (xhostname);
CREATE INDEX BBS_OPERATIONRECORD_mainSectionId ON BBS_OPERATIONRECORD (xmainSectionId);
CREATE INDEX BBS_OPERATIONRECORD_mainSectionName ON BBS_OPERATIONRECORD (xmainSectionName);
CREATE INDEX BBS_OPERATIONRECORD_objectId ON BBS_OPERATIONRECORD (xobjectId);
CREATE INDEX BBS_OPERATIONRECORD_objectName ON BBS_OPERATIONRECORD (xobjectName);
CREATE INDEX BBS_OPERATIONRECORD_objectType ON BBS_OPERATIONRECORD (xobjectType);
CREATE INDEX BBS_OPERATIONRECORD_operatorName ON BBS_OPERATIONRECORD (xoperatorName);
CREATE INDEX BBS_OPERATIONRECORD_optType ON BBS_OPERATIONRECORD (xoptType);
CREATE INDEX BBS_OPERATIONRECORD_sectionId ON BBS_OPERATIONRECORD (xsectionId);
CREATE INDEX BBS_OPERATIONRECORD_sectionName ON BBS_OPERATIONRECORD (xsectionName);
CREATE INDEX BBS_OPERATIONRECORD_subjectId ON BBS_OPERATIONRECORD (xsubjectId);
CREATE INDEX BBS_OPERATIONRECORD_title ON BBS_OPERATIONRECORD (xtitle);
CREATE INDEX BBS_PERMISSIONINFO_forumId ON BBS_PERMISSIONINFO (xforumId);
CREATE INDEX BBS_PERMISSIONINFO_mainSectionId ON BBS_PERMISSIONINFO (xmainSectionId);
CREATE INDEX BBS_PERMISSIONINFO_permissionCode ON BBS_PERMISSIONINFO (xpermissionCode);
CREATE INDEX BBS_PERMISSIONINFO_permissionFunction ON BBS_PERMISSIONINFO (xpermissionFunction);
CREATE INDEX BBS_PERMISSIONINFO_permissionName ON BBS_PERMISSIONINFO (xpermissionName);
CREATE INDEX BBS_PERMISSIONINFO_permissionType ON BBS_PERMISSIONINFO (xpermissionType);
CREATE INDEX BBS_PERMISSIONINFO_sectionId ON BBS_PERMISSIONINFO (xsectionId);
CREATE INDEX BBS_PERMISSIONROLE_forumId ON BBS_PERMISSIONROLE (xforumId);
CREATE INDEX BBS_PERMISSIONROLE_mainSectionId ON BBS_PERMISSIONROLE (xmainSectionId);
CREATE INDEX BBS_PERMISSIONROLE_permissionCode ON BBS_PERMISSIONROLE (xpermissionCode);
CREATE INDEX BBS_PERMISSIONROLE_permissionType ON BBS_PERMISSIONROLE (xpermissionType);
CREATE INDEX BBS_PERMISSIONROLE_roleCode ON BBS_PERMISSIONROLE (xroleCode);
CREATE INDEX BBS_PERMISSIONROLE_roleId ON BBS_PERMISSIONROLE (xroleId);
CREATE INDEX BBS_PERMISSIONROLE_sectionId ON BBS_PERMISSIONROLE (xsectionId);
CREATE INDEX BBS_REPLYINFO_auditorName ON BBS_REPLYINFO (xauditorName);
CREATE INDEX BBS_REPLYINFO_creatorName ON BBS_REPLYINFO (xcreatorName);
CREATE INDEX BBS_REPLYINFO_forumId ON BBS_REPLYINFO (xforumId);
CREATE INDEX BBS_REPLYINFO_hostIp ON BBS_REPLYINFO (xhostIp);
CREATE INDEX BBS_REPLYINFO_machineName ON BBS_REPLYINFO (xmachineName);
CREATE INDEX BBS_REPLYINFO_mainSectionId ON BBS_REPLYINFO (xmainSectionId);
CREATE INDEX BBS_REPLYINFO_parentId ON BBS_REPLYINFO (xparentId);
CREATE INDEX BBS_REPLYINFO_picId ON BBS_REPLYINFO (xpicId);
CREATE INDEX BBS_REPLYINFO_replyAuditStatus ON BBS_REPLYINFO (xreplyAuditStatus);
CREATE INDEX BBS_REPLYINFO_sectionId ON BBS_REPLYINFO (xsectionId);
CREATE INDEX BBS_REPLYINFO_subjectId ON BBS_REPLYINFO (xsubjectId);
CREATE INDEX BBS_REPLYINFO_systemType ON BBS_REPLYINFO (xsystemType);
CREATE INDEX BBS_REPLYINFO_title ON BBS_REPLYINFO (xtitle);
CREATE INDEX BBS_ROLEINFO_creatorName ON BBS_ROLEINFO (xcreatorName);
CREATE INDEX BBS_ROLEINFO_forumId ON BBS_ROLEINFO (xforumId);
CREATE INDEX BBS_ROLEINFO_mainSectionId ON BBS_ROLEINFO (xmainSectionId);
CREATE INDEX BBS_ROLEINFO_roleCode ON BBS_ROLEINFO (xroleCode);
CREATE INDEX BBS_ROLEINFO_roleType ON BBS_ROLEINFO (xroleType);
CREATE INDEX BBS_ROLEINFO_sectionId ON BBS_ROLEINFO (xsectionId);
CREATE INDEX BBS_SECTIONINFO_forumId ON BBS_SECTIONINFO (xforumId);
CREATE INDEX BBS_SECTIONINFO_mainSectionId ON BBS_SECTIONINFO (xmainSectionId);
CREATE INDEX BBS_SECTIONINFO_replyMessageNotify ON BBS_SECTIONINFO (xreplyMessageNotify);
CREATE INDEX BBS_SECTIONINFO_sectionLevel ON BBS_SECTIONINFO (xsectionLevel);
CREATE INDEX BBS_SECTIONINFO_sectionName ON BBS_SECTIONINFO (xsectionName);
CREATE INDEX BBS_SECTIONINFO_sectionStatus ON BBS_SECTIONINFO (xsectionStatus);
CREATE INDEX BBS_SECTIONINFO_sectionVisible ON BBS_SECTIONINFO (xsectionVisible);
CREATE INDEX BBS_SECTIONINFO_subjectMessageNotify ON BBS_SECTIONINFO (xsubjectMessageNotify);
CREATE INDEX BBS_SECTIONINFO_moderatorNames_element ON BBS_SECTIONINFO_moderatorNames (xmoderatorNames);
CREATE INDEX BBS_SECTIONINFO_moderatorNames_join ON BBS_SECTIONINFO_moderatorNames (BBSSECTIONINFO_XID);
CREATE INDEX BBS_SECTIONINFO_publishPermissionList_element ON BBS_SECTIONINFO_publishPermissionList (xpublishPermissionList);
CREATE INDEX BBS_SECTIONINFO_publishPermissionList_join ON BBS_SECTIONINFO_publishPermissionList (BBSSECTIONINFO_XID);
CREATE INDEX BBS_SECTIONINFO_replyPermissionList_element ON BBS_SECTIONINFO_replyPermissionList (xreplyPermissionList);
CREATE INDEX BBS_SECTIONINFO_replyPermissionList_join ON BBS_SECTIONINFO_replyPermissionList (BBSSECTIONINFO_XID);
CREATE INDEX BBS_SECTIONINFO_visiblePermissionList_element ON BBS_SECTIONINFO_visiblePermissionList (xvisiblePermissionList);
CREATE INDEX BBS_SECTIONINFO_visiblePermissionList_join ON BBS_SECTIONINFO_visiblePermissionList (BBSSECTIONINFO_XID);
CREATE INDEX BBS_SUBJECTATTACHMENT_creatorUid ON BBS_SUBJECTATTACHMENT (xcreatorUid);
CREATE INDEX BBS_SUBJECTATTACHMENT_deepPath ON BBS_SUBJECTATTACHMENT (xdeepPath);
CREATE INDEX BBS_SUBJECTATTACHMENT_forumId ON BBS_SUBJECTATTACHMENT (xforumId);
CREATE INDEX BBS_SUBJECTATTACHMENT_lastUpdateTime ON BBS_SUBJECTATTACHMENT (xlastUpdateTime);
CREATE INDEX BBS_SUBJECTATTACHMENT_mainSectionId ON BBS_SUBJECTATTACHMENT (xmainSectionId);
CREATE INDEX BBS_SUBJECTATTACHMENT_sectionId ON BBS_SUBJECTATTACHMENT (xsectionId);
CREATE INDEX BBS_SUBJECTATTACHMENT_site ON BBS_SUBJECTATTACHMENT (xsite);
CREATE INDEX BBS_SUBJECTATTACHMENT_storage ON BBS_SUBJECTATTACHMENT (xstorage);
CREATE INDEX BBS_SUBJECTATTACHMENT_subjectId ON BBS_SUBJECTATTACHMENT (xsubjectId);
CREATE INDEX BBS_SUBJECTINFO_forumId ON BBS_SUBJECTINFO (xforumId);
CREATE INDEX BBS_SUBJECTINFO_mainSectionId ON BBS_SUBJECTINFO (xmainSectionId);
CREATE INDEX BBS_SUBJECTINFO_sectionId ON BBS_SUBJECTINFO (xsectionId);
CREATE INDEX BBS_SUBJECTINFO_type ON BBS_SUBJECTINFO (xtype);
CREATE INDEX BBS_SUBJECTINFO_typeCategory ON BBS_SUBJECTINFO (xtypeCategory);
CREATE INDEX BBS_SUBJECTINFO_attachmentList_element ON BBS_SUBJECTINFO_attachmentList (xattachmentList);
CREATE INDEX BBS_SUBJECTINFO_attachmentList_join ON BBS_SUBJECTINFO_attachmentList (BBSSUBJECTINFO_XID);
CREATE INDEX BBS_SUBJECT_VOTERESULT_forumId ON BBS_SUBJECT_VOTERESULT (xforumId);
CREATE INDEX BBS_SUBJECT_VOTERESULT_mainSectionId ON BBS_SUBJECT_VOTERESULT (xmainSectionId);
CREATE INDEX BBS_SUBJECT_VOTERESULT_sectionId ON BBS_SUBJECT_VOTERESULT (xsectionId);
CREATE INDEX BBS_USERINFO_userName ON BBS_USERINFO (xuserName);
CREATE INDEX BBS_USERROLE_forumId ON BBS_USERROLE (xforumId);
CREATE INDEX BBS_USERROLE_mainSectionId ON BBS_USERROLE (xmainSectionId);
CREATE INDEX BBS_USERROLE_objectType ON BBS_USERROLE (xobjectType);
CREATE INDEX BBS_USERROLE_roleCode ON BBS_USERROLE (xroleCode);
CREATE INDEX BBS_USERROLE_roleId ON BBS_USERROLE (xroleId);
CREATE INDEX BBS_USERROLE_sectionId ON BBS_USERROLE (xsectionId);
CREATE INDEX BBS_USERROLE_topUnitName ON BBS_USERROLE (xtopUnitName);
CREATE INDEX BBS_USERROLE_uniqueId ON BBS_USERROLE (xuniqueId);
CREATE INDEX BBS_USERROLE_unitName ON BBS_USERROLE (xunitName);
CREATE INDEX BBS_VOTEOPTION_forumId ON BBS_VOTEOPTION (xforumId);
CREATE INDEX BBS_VOTEOPTION_mainSectionId ON BBS_VOTEOPTION (xmainSectionId);
CREATE INDEX BBS_VOTEOPTION_sectionId ON BBS_VOTEOPTION (xsectionId);
CREATE INDEX BBS_VOTEOPTION_subjectId ON BBS_VOTEOPTION (xsubjectId);
CREATE INDEX BBS_VOTEOPTIONGROUP_forumId ON BBS_VOTEOPTIONGROUP (xforumId);
CREATE INDEX BBS_VOTEOPTIONGROUP_mainSectionId ON BBS_VOTEOPTIONGROUP (xmainSectionId);
CREATE INDEX BBS_VOTEOPTIONGROUP_sectionId ON BBS_VOTEOPTIONGROUP (xsectionId);
CREATE INDEX BBS_VOTEOPTIONGROUP_subjectId ON BBS_VOTEOPTIONGROUP (xsubjectId);
CREATE INDEX BBS_VOTERECORD_forumId ON BBS_VOTERECORD (xforumId);
CREATE INDEX BBS_VOTERECORD_mainSectionId ON BBS_VOTERECORD (xmainSectionId);
CREATE INDEX BBS_VOTERECORD_sectionId ON BBS_VOTERECORD (xsectionId);
CREATE INDEX BBS_VOTERECORD_subjectId ON BBS_VOTERECORD (xsubjectId);
CREATE INDEX CAL_CALENDAR_createor ON CAL_CALENDAR (xcreateor);
CREATE INDEX CAL_CALENDAR_isPublic ON CAL_CALENDAR (xisPublic);
CREATE INDEX CAL_CALENDAR_name ON CAL_CALENDAR (xname);
CREATE INDEX CAL_CALENDAR_status ON CAL_CALENDAR (xstatus);
CREATE INDEX CAL_CALENDAR_target ON CAL_CALENDAR (xtarget);
CREATE INDEX CAL_CALENDAR_type ON CAL_CALENDAR (xtype);
CREATE INDEX CAL_CALENDAR_followers_element ON CAL_CALENDAR_followers (xfollowers);
CREATE INDEX CAL_CALENDAR_followers_join ON CAL_CALENDAR_followers (CALENDAR_XID);
CREATE INDEX CAL_CALENDAR_manageablePersonList_element ON CAL_CALENDAR_manageablePersonList (xmanageablePersonList);
CREATE INDEX CAL_CALENDAR_manageablePersonList_join ON CAL_CALENDAR_manageablePersonList (CALENDAR_XID);
CREATE INDEX CAL_CALENDAR_publishableGroupList_element ON CAL_CALENDAR_publishableGroupList (xpublishableGroupList);
CREATE INDEX CAL_CALENDAR_publishableGroupList_join ON CAL_CALENDAR_publishableGroupList (CALENDAR_XID);
CREATE INDEX CAL_CALENDAR_publishablePersonList_element ON CAL_CALENDAR_publishablePersonList (xpublishablePersonList);
CREATE INDEX CAL_CALENDAR_publishablePersonList_join ON CAL_CALENDAR_publishablePersonList (CALENDAR_XID);
CREATE INDEX CAL_CALENDAR_publishableUnitList_element ON CAL_CALENDAR_publishableUnitList (xpublishableUnitList);
CREATE INDEX CAL_CALENDAR_publishableUnitList_join ON CAL_CALENDAR_publishableUnitList (CALENDAR_XID);
CREATE INDEX CAL_CALENDAR_viewableGroupList_element ON CAL_CALENDAR_viewableGroupList (xviewableGroupList);
CREATE INDEX CAL_CALENDAR_viewableGroupList_join ON CAL_CALENDAR_viewableGroupList (CALENDAR_XID);
CREATE INDEX CAL_CALENDAR_viewablePersonList_element ON CAL_CALENDAR_viewablePersonList (xviewablePersonList);
CREATE INDEX CAL_CALENDAR_viewablePersonList_join ON CAL_CALENDAR_viewablePersonList (CALENDAR_XID);
CREATE INDEX CAL_CALENDAR_viewableUnitList_element ON CAL_CALENDAR_viewableUnitList (xviewableUnitList);
CREATE INDEX CAL_CALENDAR_viewableUnitList_join ON CAL_CALENDAR_viewableUnitList (CALENDAR_XID);
CREATE INDEX CAL_EVENT_bundle ON CAL_EVENT (xbundle);
CREATE INDEX CAL_EVENT_calendarId ON CAL_EVENT (xcalendarId);
CREATE INDEX CAL_EVENT_createPerson ON CAL_EVENT (xcreatePerson);
CREATE INDEX CAL_EVENT_daysOfDuration ON CAL_EVENT (xdaysOfDuration);
CREATE INDEX CAL_EVENT_endTime ON CAL_EVENT (xendTime);
CREATE INDEX CAL_EVENT_endTimeStr ON CAL_EVENT (xendTimeStr);
CREATE INDEX CAL_EVENT_eventType ON CAL_EVENT (xeventType);
CREATE INDEX CAL_EVENT_isAllDayEvent ON CAL_EVENT (xisAllDayEvent);
CREATE INDEX CAL_EVENT_isPublic ON CAL_EVENT (xisPublic);
CREATE INDEX CAL_EVENT_repeatMasterId ON CAL_EVENT (xrepeatMasterId);
CREATE INDEX CAL_EVENT_source ON CAL_EVENT (xsource);
CREATE INDEX CAL_EVENT_startTime ON CAL_EVENT (xstartTime);
CREATE INDEX CAL_EVENT_startTimeStr ON CAL_EVENT (xstartTimeStr);
CREATE INDEX CAL_EVENT_targetType ON CAL_EVENT (xtargetType);
CREATE INDEX CAL_EVENT_updatePerson ON CAL_EVENT (xupdatePerson);
CREATE INDEX CAL_EVENT_manageablePersonList_element ON CAL_EVENT_manageablePersonList (xmanageablePersonList);
CREATE INDEX CAL_EVENT_manageablePersonList_join ON CAL_EVENT_manageablePersonList (CALENDAR_EVENT_XID);
CREATE INDEX CAL_EVENT_participants_element ON CAL_EVENT_participants (xparticipants);
CREATE INDEX CAL_EVENT_participants_join ON CAL_EVENT_participants (CALENDAR_EVENT_XID);
CREATE INDEX CAL_EVENT_REPM_calendarId ON CAL_EVENT_REPM (xcalendarId);
CREATE INDEX CAL_EVENT_REPM_createPerson ON CAL_EVENT_REPM (xcreatePerson);
CREATE INDEX CAL_EVENT_REPM_daysOfDuration ON CAL_EVENT_REPM (xdaysOfDuration);
CREATE INDEX CAL_EVENT_REPM_endTime ON CAL_EVENT_REPM (xendTime);
CREATE INDEX CAL_EVENT_REPM_eventType ON CAL_EVENT_REPM (xeventType);
CREATE INDEX CAL_EVENT_REPM_isAllDayEvent ON CAL_EVENT_REPM (xisAllDayEvent);
CREATE INDEX CAL_EVENT_REPM_isPublic ON CAL_EVENT_REPM (xisPublic);
CREATE INDEX CAL_EVENT_REPM_repeatStatus ON CAL_EVENT_REPM (xrepeatStatus);
CREATE INDEX CAL_EVENT_REPM_source ON CAL_EVENT_REPM (xsource);
CREATE INDEX CAL_EVENT_REPM_startTime ON CAL_EVENT_REPM (xstartTime);
CREATE INDEX CAL_EVENT_REPM_targetType ON CAL_EVENT_REPM (xtargetType);
CREATE INDEX CAL_EVENT_REPM_updatePerson ON CAL_EVENT_REPM (xupdatePerson);
CREATE INDEX CAL_EVENT_REPM_createdMonthList_element ON CAL_EVENT_REPM_createdMonthList (xcreatedMonthList);
CREATE INDEX CAL_EVENT_REPM_createdMonthList_join ON CAL_EVENT_REPM_createdMonthList (CALENDAR_EVENTREPEATMASTER_XID);
CREATE INDEX CAL_EVENT_REPM_manageablePersonList_element ON CAL_EVENT_REPM_manageablePersonList (xmanageablePersonList);
CREATE INDEX CAL_EVENT_REPM_manageablePersonList_join ON CAL_EVENT_REPM_manageablePersonList (CALENDAR_EVENTREPEATMASTER_XID);
CREATE INDEX CAL_EVENT_REPM_participants_element ON CAL_EVENT_REPM_participants (xparticipants);
CREATE INDEX CAL_EVENT_REPM_participants_join ON CAL_EVENT_REPM_participants (CALENDAR_EVENTREPEATMASTER_XID);
CREATE INDEX CAL_EVENT_REPM_viewableGroupList_element ON CAL_EVENT_REPM_viewableGroupList (xviewableGroupList);
CREATE INDEX CAL_EVENT_REPM_viewableGroupList_join ON CAL_EVENT_REPM_viewableGroupList (CALENDAR_EVENTREPEATMASTER_XID);
CREATE INDEX CAL_EVENT_REPM_viewablePersonList_element ON CAL_EVENT_REPM_viewablePersonList (xviewablePersonList);
CREATE INDEX CAL_EVENT_REPM_viewablePersonList_join ON CAL_EVENT_REPM_viewablePersonList (CALENDAR_EVENTREPEATMASTER_XID);
CREATE INDEX CAL_EVENT_REPM_viewableUnitList_element ON CAL_EVENT_REPM_viewableUnitList (xviewableUnitList);
CREATE INDEX CAL_EVENT_REPM_viewableUnitList_join ON CAL_EVENT_REPM_viewableUnitList (CALENDAR_EVENTREPEATMASTER_XID);
CREATE INDEX CAL_EVENT_viewableGroupList_element ON CAL_EVENT_viewableGroupList (xviewableGroupList);
CREATE INDEX CAL_EVENT_viewableGroupList_join ON CAL_EVENT_viewableGroupList (CALENDAR_EVENT_XID);
CREATE INDEX CAL_EVENT_viewablePersonList_element ON CAL_EVENT_viewablePersonList (xviewablePersonList);
CREATE INDEX CAL_EVENT_viewablePersonList_join ON CAL_EVENT_viewablePersonList (CALENDAR_EVENT_XID);
CREATE INDEX CAL_EVENT_viewableUnitList_element ON CAL_EVENT_viewableUnitList (xviewableUnitList);
CREATE INDEX CAL_EVENT_viewableUnitList_join ON CAL_EVENT_viewableUnitList (CALENDAR_EVENT_XID);
CREATE INDEX CAL_SETTING_configCode ON CAL_SETTING (xconfigCode);
CREATE INDEX CMS_APPDICTITEM_appId ON CMS_APPDICTITEM (xappId);
CREATE INDEX CMS_APPDICTITEM_booleanValue ON CMS_APPDICTITEM (xbooleanValue);
CREATE INDEX CMS_APPDICTITEM_bundle ON CMS_APPDICTITEM (xbundle);
CREATE INDEX CMS_APPDICTITEM_dateTimeValue ON CMS_APPDICTITEM (xdateTimeValue);
CREATE INDEX CMS_APPDICTITEM_dateValue ON CMS_APPDICTITEM (xdateValue);
CREATE INDEX CMS_APPDICTITEM_itemCategory ON CMS_APPDICTITEM (xitemCategory);
CREATE INDEX CMS_APPDICTITEM_itemPrimitiveType ON CMS_APPDICTITEM (xitemPrimitiveType);
CREATE INDEX CMS_APPDICTITEM_itemStringValueType ON CMS_APPDICTITEM (xitemStringValueType);
CREATE INDEX CMS_APPDICTITEM_itemType ON CMS_APPDICTITEM (xitemType);
CREATE INDEX CMS_APPDICTITEM_numberValue ON CMS_APPDICTITEM (xnumberValue);
CREATE INDEX CMS_APPDICTITEM_path0 ON CMS_APPDICTITEM (xpath0);
CREATE INDEX CMS_APPDICTITEM_path0Location ON CMS_APPDICTITEM (xpath0Location);
CREATE INDEX CMS_APPDICTITEM_path1 ON CMS_APPDICTITEM (xpath1);
CREATE INDEX CMS_APPDICTITEM_path1Location ON CMS_APPDICTITEM (xpath1Location);
CREATE INDEX CMS_APPDICTITEM_path2 ON CMS_APPDICTITEM (xpath2);
CREATE INDEX CMS_APPDICTITEM_path2Location ON CMS_APPDICTITEM (xpath2Location);
CREATE INDEX CMS_APPDICTITEM_path3 ON CMS_APPDICTITEM (xpath3);
CREATE INDEX CMS_APPDICTITEM_path3Location ON CMS_APPDICTITEM (xpath3Location);
CREATE INDEX CMS_APPDICTITEM_path4 ON CMS_APPDICTITEM (xpath4);
CREATE INDEX CMS_APPDICTITEM_path4Location ON CMS_APPDICTITEM (xpath4Location);
CREATE INDEX CMS_APPDICTITEM_path5 ON CMS_APPDICTITEM (xpath5);
CREATE INDEX CMS_APPDICTITEM_path5Location ON CMS_APPDICTITEM (xpath5Location);
CREATE INDEX CMS_APPDICTITEM_path6 ON CMS_APPDICTITEM (xpath6);
CREATE INDEX CMS_APPDICTITEM_path6Location ON CMS_APPDICTITEM (xpath6Location);
CREATE INDEX CMS_APPDICTITEM_path7 ON CMS_APPDICTITEM (xpath7);
CREATE INDEX CMS_APPDICTITEM_path7Location ON CMS_APPDICTITEM (xpath7Location);
CREATE INDEX CMS_APPDICTITEM_stringShortValue ON CMS_APPDICTITEM (xstringShortValue);
CREATE INDEX CMS_APPDICTITEM_timeValue ON CMS_APPDICTITEM (xtimeValue);
CREATE INDEX CMS_APPINFO_allPeoplePublish ON CMS_APPINFO (xallPeoplePublish);
CREATE INDEX CMS_APPINFO_allPeopleView ON CMS_APPINFO (xallPeopleView);
CREATE INDEX CMS_APPINFO_anonymousAble ON CMS_APPINFO (xanonymousAble);
CREATE INDEX CMS_APPINFO_appAlias ON CMS_APPINFO (xappAlias);
CREATE INDEX CMS_APPINFO_appName ON CMS_APPINFO (xappName);
CREATE INDEX CMS_APPINFO_documentType ON CMS_APPINFO (xdocumentType);
CREATE INDEX CMS_APPINFO_sendNotify ON CMS_APPINFO (xsendNotify);
CREATE INDEX CMS_APPINFO_categoryList_element ON CMS_APPINFO_categoryList (xcategoryList);
CREATE INDEX CMS_APPINFO_categoryList_join ON CMS_APPINFO_categoryList (APPINFO_XID);
CREATE INDEX CMS_APPINFO_manageableGroupList_element ON CMS_APPINFO_manageableGroupList (xmanageableGroupList);
CREATE INDEX CMS_APPINFO_manageableGroupList_join ON CMS_APPINFO_manageableGroupList (APPINFO_XID);
CREATE INDEX CMS_APPINFO_manageablePersonList_element ON CMS_APPINFO_manageablePersonList (xmanageablePersonList);
CREATE INDEX CMS_APPINFO_manageablePersonList_join ON CMS_APPINFO_manageablePersonList (APPINFO_XID);
CREATE INDEX CMS_APPINFO_manageableUnitList_element ON CMS_APPINFO_manageableUnitList (xmanageableUnitList);
CREATE INDEX CMS_APPINFO_manageableUnitList_join ON CMS_APPINFO_manageableUnitList (APPINFO_XID);
CREATE INDEX CMS_APPINFO_publishableGroupList_element ON CMS_APPINFO_publishableGroupList (xpublishableGroupList);
CREATE INDEX CMS_APPINFO_publishableGroupList_join ON CMS_APPINFO_publishableGroupList (APPINFO_XID);
CREATE INDEX CMS_APPINFO_publishablePersonList_element ON CMS_APPINFO_publishablePersonList (xpublishablePersonList);
CREATE INDEX CMS_APPINFO_publishablePersonList_join ON CMS_APPINFO_publishablePersonList (APPINFO_XID);
CREATE INDEX CMS_APPINFO_publishableUnitList_element ON CMS_APPINFO_publishableUnitList (xpublishableUnitList);
CREATE INDEX CMS_APPINFO_publishableUnitList_join ON CMS_APPINFO_publishableUnitList (APPINFO_XID);
CREATE INDEX CMS_APPINFO_viewableGroupList_element ON CMS_APPINFO_viewableGroupList (xviewableGroupList);
CREATE INDEX CMS_APPINFO_viewableGroupList_join ON CMS_APPINFO_viewableGroupList (APPINFO_XID);
CREATE INDEX CMS_APPINFO_viewablePersonList_element ON CMS_APPINFO_viewablePersonList (xviewablePersonList);
CREATE INDEX CMS_APPINFO_viewablePersonList_join ON CMS_APPINFO_viewablePersonList (APPINFO_XID);
CREATE INDEX CMS_APPINFO_viewableUnitList_element ON CMS_APPINFO_viewableUnitList (xviewableUnitList);
CREATE INDEX CMS_APPINFO_viewableUnitList_join ON CMS_APPINFO_viewableUnitList (APPINFO_XID);
CREATE INDEX CMS_APPNDICT_alias ON CMS_APPNDICT (xalias);
CREATE INDEX CMS_APPNDICT_appId ON CMS_APPNDICT (xappId);
CREATE INDEX CMS_APPNDICT_creatorUid ON CMS_APPNDICT (xcreatorUid);
CREATE INDEX CMS_APPNDICT_description ON CMS_APPNDICT (xdescription);
CREATE INDEX CMS_APPNDICT_name ON CMS_APPNDICT (xname);
CREATE INDEX CMS_CATEGORYINFO_allPeoplePublish ON CMS_CATEGORYINFO (xallPeoplePublish);
CREATE INDEX CMS_CATEGORYINFO_allPeopleView ON CMS_CATEGORYINFO (xallPeopleView);
CREATE INDEX CMS_CATEGORYINFO_anonymousAble ON CMS_CATEGORYINFO (xanonymousAble);
CREATE INDEX CMS_CATEGORYINFO_appId ON CMS_CATEGORYINFO (xappId);
CREATE INDEX CMS_CATEGORYINFO_categoryAlias ON CMS_CATEGORYINFO (xcategoryAlias);
CREATE INDEX CMS_CATEGORYINFO_categoryName ON CMS_CATEGORYINFO (xcategoryName);
CREATE INDEX CMS_CATEGORYINFO_categorySeq ON CMS_CATEGORYINFO (xcategorySeq);
CREATE INDEX CMS_CATEGORYINFO_creatorIdentity ON CMS_CATEGORYINFO (xcreatorIdentity);
CREATE INDEX CMS_CATEGORYINFO_creatorPerson ON CMS_CATEGORYINFO (xcreatorPerson);
CREATE INDEX CMS_CATEGORYINFO_creatorTopUnitName ON CMS_CATEGORYINFO (xcreatorTopUnitName);
CREATE INDEX CMS_CATEGORYINFO_creatorUnitName ON CMS_CATEGORYINFO (xcreatorUnitName);
CREATE INDEX CMS_CATEGORYINFO_documentType ON CMS_CATEGORYINFO (xdocumentType);
CREATE INDEX CMS_CATEGORYINFO_parentId ON CMS_CATEGORYINFO (xparentId);
CREATE INDEX CMS_CATEGORYINFO_sendNotify ON CMS_CATEGORYINFO (xsendNotify);
CREATE INDEX CMS_CATEGORYINFO_manageableGroupList_element ON CMS_CATEGORYINFO_manageableGroupList (xmanageableGroupList);
CREATE INDEX CMS_CATEGORYINFO_manageableGroupList_join ON CMS_CATEGORYINFO_manageableGroupList (CATEGORYINFO_XID);
CREATE INDEX CMS_CATEGORYINFO_manageablePersonList_element ON CMS_CATEGORYINFO_manageablePersonList (xmanageablePersonList);
CREATE INDEX CMS_CATEGORYINFO_manageablePersonList_join ON CMS_CATEGORYINFO_manageablePersonList (CATEGORYINFO_XID);
CREATE INDEX CMS_CATEGORYINFO_manageableUnitList_element ON CMS_CATEGORYINFO_manageableUnitList (xmanageableUnitList);
CREATE INDEX CMS_CATEGORYINFO_manageableUnitList_join ON CMS_CATEGORYINFO_manageableUnitList (CATEGORYINFO_XID);
CREATE INDEX CMS_CATEGORYINFO_publishableGroupList_element ON CMS_CATEGORYINFO_publishableGroupList (xpublishableGroupList);
CREATE INDEX CMS_CATEGORYINFO_publishableGroupList_join ON CMS_CATEGORYINFO_publishableGroupList (CATEGORYINFO_XID);
CREATE INDEX CMS_CATEGORYINFO_publishablePersonList_element ON CMS_CATEGORYINFO_publishablePersonList (xpublishablePersonList);
CREATE INDEX CMS_CATEGORYINFO_publishablePersonList_join ON CMS_CATEGORYINFO_publishablePersonList (CATEGORYINFO_XID);
CREATE INDEX CMS_CATEGORYINFO_publishableUnitList_element ON CMS_CATEGORYINFO_publishableUnitList (xpublishableUnitList);
CREATE INDEX CMS_CATEGORYINFO_publishableUnitList_join ON CMS_CATEGORYINFO_publishableUnitList (CATEGORYINFO_XID);
CREATE INDEX CMS_CATEGORYINFO_viewableGroupList_element ON CMS_CATEGORYINFO_viewableGroupList (xviewableGroupList);
CREATE INDEX CMS_CATEGORYINFO_viewableGroupList_join ON CMS_CATEGORYINFO_viewableGroupList (CATEGORYINFO_XID);
CREATE INDEX CMS_CATEGORYINFO_viewablePersonList_element ON CMS_CATEGORYINFO_viewablePersonList (xviewablePersonList);
CREATE INDEX CMS_CATEGORYINFO_viewablePersonList_join ON CMS_CATEGORYINFO_viewablePersonList (CATEGORYINFO_XID);
CREATE INDEX CMS_CATEGORYINFO_viewableUnitList_element ON CMS_CATEGORYINFO_viewableUnitList (xviewableUnitList);
CREATE INDEX CMS_CATEGORYINFO_viewableUnitList_join ON CMS_CATEGORYINFO_viewableUnitList (CATEGORYINFO_XID);
CREATE INDEX CMS_DOCUMENT_appId ON CMS_DOCUMENT (xappId);
CREATE INDEX CMS_DOCUMENT_categoryAlias ON CMS_DOCUMENT (xcategoryAlias);
CREATE INDEX CMS_DOCUMENT_categoryId ON CMS_DOCUMENT (xcategoryId);
CREATE INDEX CMS_DOCUMENT_docStatus ON CMS_DOCUMENT (xdocStatus);
CREATE INDEX CMS_DOCUMENT_documentType ON CMS_DOCUMENT (xdocumentType);
CREATE INDEX CMS_DOCUMENT_hasIndexPic ON CMS_DOCUMENT (xhasIndexPic);
CREATE INDEX CMS_DOCUMENT_importBatchName ON CMS_DOCUMENT (ximportBatchName);
CREATE INDEX CMS_DOCUMENT_isTop ON CMS_DOCUMENT (xisTop);
CREATE INDEX CMS_DOCUMENT_modifyTime ON CMS_DOCUMENT (xmodifyTime);
CREATE INDEX CMS_DOCUMENT_publishTime ON CMS_DOCUMENT (xpublishTime);
CREATE INDEX CMS_DOCUMENT_reviewed ON CMS_DOCUMENT (xreviewed);
CREATE INDEX CMS_DOCUMENT_sequenceAppAlias ON CMS_DOCUMENT (xsequenceAppAlias);
CREATE INDEX CMS_DOCUMENT_sequenceCategoryAlias ON CMS_DOCUMENT (xsequenceCategoryAlias);
CREATE INDEX CMS_DOCUMENT_sequenceCreatorPerson ON CMS_DOCUMENT (xsequenceCreatorPerson);
CREATE INDEX CMS_DOCUMENT_sequenceCreatorUnitName ON CMS_DOCUMENT (xsequenceCreatorUnitName);
CREATE INDEX CMS_DOCUMENT_sequenceTitle ON CMS_DOCUMENT (xsequenceTitle);
CREATE INDEX CMS_DOCUMENT_title ON CMS_DOCUMENT (xtitle);
CREATE INDEX CMS_DOCUMENT_authorGroupList_element ON CMS_DOCUMENT_authorGroupList (xauthorGroupList);
CREATE INDEX CMS_DOCUMENT_authorGroupList_join ON CMS_DOCUMENT_authorGroupList (DOCUMENT_XID);
CREATE INDEX CMS_DOCUMENT_authorPersonList_element ON CMS_DOCUMENT_authorPersonList (xauthorPersonList);
CREATE INDEX CMS_DOCUMENT_authorPersonList_join ON CMS_DOCUMENT_authorPersonList (DOCUMENT_XID);
CREATE INDEX CMS_DOCUMENT_authorUnitList_element ON CMS_DOCUMENT_authorUnitList (xauthorUnitList);
CREATE INDEX CMS_DOCUMENT_authorUnitList_join ON CMS_DOCUMENT_authorUnitList (DOCUMENT_XID);
CREATE INDEX CMS_DOCUMENT_COMMEND_commendPerson ON CMS_DOCUMENT_COMMEND (xcommendPerson);
CREATE INDEX CMS_DOCUMENT_COMMEND_documentId ON CMS_DOCUMENT_COMMEND (xdocumentId);
CREATE INDEX CMS_DOCUMENT_COMMENTCOMMEND_commendPerson ON CMS_DOCUMENT_COMMENTCOMMEND (xcommendPerson);
CREATE INDEX CMS_DOCUMENT_COMMENTCOMMEND_documentId ON CMS_DOCUMENT_COMMENTCOMMEND (xdocumentId);
CREATE INDEX CMS_DOCUMENT_COMMENTINFO_appId ON CMS_DOCUMENT_COMMENTINFO (xappId);
CREATE INDEX CMS_DOCUMENT_COMMENTINFO_auditorName ON CMS_DOCUMENT_COMMENTINFO (xauditorName);
CREATE INDEX CMS_DOCUMENT_COMMENTINFO_categoryId ON CMS_DOCUMENT_COMMENTINFO (xcategoryId);
CREATE INDEX CMS_DOCUMENT_COMMENTINFO_commentAuditStatus ON CMS_DOCUMENT_COMMENTINFO (xcommentAuditStatus);
CREATE INDEX CMS_DOCUMENT_COMMENTINFO_creatorName ON CMS_DOCUMENT_COMMENTINFO (xcreatorName);
CREATE INDEX CMS_DOCUMENT_COMMENTINFO_documentId ON CMS_DOCUMENT_COMMENTINFO (xdocumentId);
CREATE INDEX CMS_DOCUMENT_COMMENTINFO_isPrivate ON CMS_DOCUMENT_COMMENTINFO (xisPrivate);
CREATE INDEX CMS_DOCUMENT_COMMENTINFO_parentId ON CMS_DOCUMENT_COMMENTINFO (xparentId);
CREATE INDEX CMS_DOCUMENT_managerList_element ON CMS_DOCUMENT_managerList (xmanagerList);
CREATE INDEX CMS_DOCUMENT_managerList_join ON CMS_DOCUMENT_managerList (DOCUMENT_XID);
CREATE INDEX CMS_DOCUMENT_pictureList_element ON CMS_DOCUMENT_pictureList (xpictureList);
CREATE INDEX CMS_DOCUMENT_pictureList_join ON CMS_DOCUMENT_pictureList (DOCUMENT_XID);
CREATE INDEX CMS_DOCUMENT_readGroupList_element ON CMS_DOCUMENT_readGroupList (xreadGroupList);
CREATE INDEX CMS_DOCUMENT_readGroupList_join ON CMS_DOCUMENT_readGroupList (DOCUMENT_XID);
CREATE INDEX CMS_DOCUMENT_readPersonList_element ON CMS_DOCUMENT_readPersonList (xreadPersonList);
CREATE INDEX CMS_DOCUMENT_readPersonList_join ON CMS_DOCUMENT_readPersonList (DOCUMENT_XID);
CREATE INDEX CMS_DOCUMENT_readUnitList_element ON CMS_DOCUMENT_readUnitList (xreadUnitList);
CREATE INDEX CMS_DOCUMENT_readUnitList_join ON CMS_DOCUMENT_readUnitList (DOCUMENT_XID);
CREATE INDEX CMS_DOCUMENT_remindGroupList_element ON CMS_DOCUMENT_remindGroupList (xremindGroupList);
CREATE INDEX CMS_DOCUMENT_remindGroupList_join ON CMS_DOCUMENT_remindGroupList (DOCUMENT_XID);
CREATE INDEX CMS_DOCUMENT_remindPersonList_element ON CMS_DOCUMENT_remindPersonList (xremindPersonList);
CREATE INDEX CMS_DOCUMENT_remindPersonList_join ON CMS_DOCUMENT_remindPersonList (DOCUMENT_XID);
CREATE INDEX CMS_DOCUMENT_remindUnitList_element ON CMS_DOCUMENT_remindUnitList (xremindUnitList);
CREATE INDEX CMS_DOCUMENT_remindUnitList_join ON CMS_DOCUMENT_remindUnitList (DOCUMENT_XID);
CREATE INDEX CMS_DOCUMENT_VIEWRECORD_documentId ON CMS_DOCUMENT_VIEWRECORD (xdocumentId);
CREATE INDEX CMS_DOCUMENT_VIEWRECORD_lastViewTime ON CMS_DOCUMENT_VIEWRECORD (xlastViewTime);
CREATE INDEX CMS_DOCUMENT_VIEWRECORD_title ON CMS_DOCUMENT_VIEWRECORD (xtitle);
CREATE INDEX CMS_DOCUMENT_VIEWRECORD_viewerName ON CMS_DOCUMENT_VIEWRECORD (xviewerName);
CREATE INDEX CMS_E_QUERYVIEW_appId ON CMS_E_QUERYVIEW (xappId);
CREATE INDEX CMS_E_QUERYVIEW_appName ON CMS_E_QUERYVIEW (xappName);
CREATE INDEX CMS_E_QUERYVIEW_creatorPerson ON CMS_E_QUERYVIEW (xcreatorPerson);
CREATE INDEX CMS_E_QUERYVIEW_display ON CMS_E_QUERYVIEW (xdisplay);
CREATE INDEX CMS_E_QUERYVIEW_lastUpdatePerson ON CMS_E_QUERYVIEW (xlastUpdatePerson);
CREATE INDEX CMS_E_QUERYVIEW_lastUpdateTime ON CMS_E_QUERYVIEW (xlastUpdateTime);
CREATE INDEX CMS_E_QUERYVIEW_name ON CMS_E_QUERYVIEW (xname);
CREATE INDEX CMS_E_QUERYVIEW_timingEnable ON CMS_E_QUERYVIEW (xtimingEnable);
CREATE INDEX CMS_E_QUERYVIEW_timingInterval ON CMS_E_QUERYVIEW (xtimingInterval);
CREATE INDEX CMS_E_QUERYVIEW_timingTouch ON CMS_E_QUERYVIEW (xtimingTouch);
CREATE INDEX CMS_E_QUERYVIEW_availableIdentityList_element ON CMS_E_QUERYVIEW_availableIdentityList (xavailableIdentityList);
CREATE INDEX CMS_E_QUERYVIEW_availableIdentityList_join ON CMS_E_QUERYVIEW_availableIdentityList (QUERYVIEW_XID);
CREATE INDEX CMS_E_QUERYVIEW_availablePersonList_element ON CMS_E_QUERYVIEW_availablePersonList (xavailablePersonList);
CREATE INDEX CMS_E_QUERYVIEW_availablePersonList_join ON CMS_E_QUERYVIEW_availablePersonList (QUERYVIEW_XID);
CREATE INDEX CMS_E_QUERYVIEW_availableUnitList_element ON CMS_E_QUERYVIEW_availableUnitList (xavailableUnitList);
CREATE INDEX CMS_E_QUERYVIEW_availableUnitList_join ON CMS_E_QUERYVIEW_availableUnitList (QUERYVIEW_XID);
CREATE INDEX CMS_E_QUERYVIEW_controllerList_element ON CMS_E_QUERYVIEW_controllerList (xcontrollerList);
CREATE INDEX CMS_E_QUERYVIEW_controllerList_join ON CMS_E_QUERYVIEW_controllerList (QUERYVIEW_XID);
CREATE INDEX CMS_FILE_appId ON CMS_FILE (xappId);
CREATE INDEX CMS_FILE_length ON CMS_FILE (xlength);
CREATE INDEX CMS_FILEINFO_deepPath ON CMS_FILEINFO (xdeepPath);
CREATE INDEX CMS_FILEINFO_documentId ON CMS_FILEINFO (xdocumentId);
CREATE INDEX CMS_FILEINFO_lastUpdateTime ON CMS_FILEINFO (xlastUpdateTime);
CREATE INDEX CMS_FILEINFO_length ON CMS_FILEINFO (xlength);
CREATE INDEX CMS_FILEINFO_storage ON CMS_FILEINFO (xstorage);
CREATE INDEX CMS_FILEINFO_controllerIdentityList_element ON CMS_FILEINFO_controllerIdentityList (xcontrollerIdentityList);
CREATE INDEX CMS_FILEINFO_controllerIdentityList_join ON CMS_FILEINFO_controllerIdentityList (FILEINFO_XID);
CREATE INDEX CMS_FILEINFO_controllerUnitList_element ON CMS_FILEINFO_controllerUnitList (xcontrollerUnitList);
CREATE INDEX CMS_FILEINFO_controllerUnitList_join ON CMS_FILEINFO_controllerUnitList (FILEINFO_XID);
CREATE INDEX CMS_FILEINFO_editIdentityList_element ON CMS_FILEINFO_editIdentityList (xeditIdentityList);
CREATE INDEX CMS_FILEINFO_editIdentityList_join ON CMS_FILEINFO_editIdentityList (FILEINFO_XID);
CREATE INDEX CMS_FILEINFO_editUnitList_element ON CMS_FILEINFO_editUnitList (xeditUnitList);
CREATE INDEX CMS_FILEINFO_editUnitList_join ON CMS_FILEINFO_editUnitList (FILEINFO_XID);
CREATE INDEX CMS_FILEINFO_readIdentityList_element ON CMS_FILEINFO_readIdentityList (xreadIdentityList);
CREATE INDEX CMS_FILEINFO_readIdentityList_join ON CMS_FILEINFO_readIdentityList (FILEINFO_XID);
CREATE INDEX CMS_FILEINFO_readUnitList_element ON CMS_FILEINFO_readUnitList (xreadUnitList);
CREATE INDEX CMS_FILEINFO_readUnitList_join ON CMS_FILEINFO_readUnitList (FILEINFO_XID);
CREATE INDEX CMS_FORM_appId ON CMS_FORM (xappId);
CREATE INDEX CMS_FORM_name ON CMS_FORM (xname);
CREATE INDEX CMS_FORMFIELD_appId ON CMS_FORMFIELD (xappId);
CREATE INDEX CMS_FORMFIELD_form ON CMS_FORMFIELD (xform);
CREATE INDEX CMS_LOG_appId ON CMS_LOG (xappId);
CREATE INDEX CMS_LOG_categoryId ON CMS_LOG (xcategoryId);
CREATE INDEX CMS_LOG_operationLevel ON CMS_LOG (xoperationLevel);
CREATE INDEX CMS_LOG_operationType ON CMS_LOG (xoperationType);
CREATE INDEX CMS_LOG_operatorUid ON CMS_LOG (xoperatorUid);
CREATE INDEX CMS_READREMIND_appId ON CMS_READREMIND (xappId);
CREATE INDEX CMS_READREMIND_categoryId ON CMS_READREMIND (xcategoryId);
CREATE INDEX CMS_READREMIND_documentId ON CMS_READREMIND (xdocumentId);
CREATE INDEX CMS_READREMIND_readed ON CMS_READREMIND (xreaded);
CREATE INDEX CMS_READREMIND_reminded ON CMS_READREMIND (xreminded);
CREATE INDEX CMS_REVIEW_appAlias ON CMS_REVIEW (xappAlias);
CREATE INDEX CMS_REVIEW_appId ON CMS_REVIEW (xappId);
CREATE INDEX CMS_REVIEW_appName ON CMS_REVIEW (xappName);
CREATE INDEX CMS_REVIEW_categoryAlias ON CMS_REVIEW (xcategoryAlias);
CREATE INDEX CMS_REVIEW_categoryId ON CMS_REVIEW (xcategoryId);
CREATE INDEX CMS_REVIEW_categoryName ON CMS_REVIEW (xcategoryName);
CREATE INDEX CMS_REVIEW_creatorIdentity ON CMS_REVIEW (xcreatorIdentity);
CREATE INDEX CMS_REVIEW_creatorPerson ON CMS_REVIEW (xcreatorPerson);
CREATE INDEX CMS_REVIEW_creatorUnitName ON CMS_REVIEW (xcreatorUnitName);
CREATE INDEX CMS_REVIEW_docCreateTime ON CMS_REVIEW (xdocCreateTime);
CREATE INDEX CMS_REVIEW_docId ON CMS_REVIEW (xdocId);
CREATE INDEX CMS_REVIEW_docSequence ON CMS_REVIEW (xdocSequence);
CREATE INDEX CMS_REVIEW_docStatus ON CMS_REVIEW (xdocStatus);
CREATE INDEX CMS_REVIEW_documentType ON CMS_REVIEW (xdocumentType);
CREATE INDEX CMS_REVIEW_hasIndexPic ON CMS_REVIEW (xhasIndexPic);
CREATE INDEX CMS_REVIEW_importBatchName ON CMS_REVIEW (ximportBatchName);
CREATE INDEX CMS_REVIEW_isTop ON CMS_REVIEW (xisTop);
CREATE INDEX CMS_REVIEW_modifyTime ON CMS_REVIEW (xmodifyTime);
CREATE INDEX CMS_REVIEW_permissionObj ON CMS_REVIEW (xpermissionObj);
CREATE INDEX CMS_REVIEW_publishTime ON CMS_REVIEW (xpublishTime);
CREATE INDEX CMS_REVIEW_sequenceAppAlias ON CMS_REVIEW (xsequenceAppAlias);
CREATE INDEX CMS_REVIEW_sequenceCategoryAlias ON CMS_REVIEW (xsequenceCategoryAlias);
CREATE INDEX CMS_REVIEW_sequenceCreatorPerson ON CMS_REVIEW (xsequenceCreatorPerson);
CREATE INDEX CMS_REVIEW_sequenceCreatorUnitName ON CMS_REVIEW (xsequenceCreatorUnitName);
CREATE INDEX CMS_REVIEW_sequenceTitle ON CMS_REVIEW (xsequenceTitle);
CREATE INDEX CMS_REVIEW_title ON CMS_REVIEW (xtitle);
CREATE INDEX CMS_SCRIPT_appId ON CMS_SCRIPT (xappId);
CREATE INDEX CMS_SCRIPT_dependScriptList_element ON CMS_SCRIPT_dependScriptList (xdependScriptList);
CREATE INDEX CMS_SCRIPT_dependScriptList_join ON CMS_SCRIPT_dependScriptList (SCRIPT_XID);
CREATE INDEX CMS_TEMPLATEFORM_category ON CMS_TEMPLATEFORM (xcategory);
CREATE INDEX CMS_VIEW_appId ON CMS_VIEW (xappId);
CREATE INDEX CMS_VIEW_formId ON CMS_VIEW (xformId);
CREATE INDEX CMS_VIEWCATEGORY_categoryId ON CMS_VIEWCATEGORY (xcategoryId);
CREATE INDEX CMS_VIEWCATEGORY_viewId ON CMS_VIEWCATEGORY (xviewId);
CREATE INDEX CMS_VIEWFIELD_CONFIG_viewId ON CMS_VIEWFIELD_CONFIG (xviewId);
CREATE INDEX CMS_VIEW_fieldConfigList_element ON CMS_VIEW_fieldConfigList (xfieldConfigList);
CREATE INDEX CMS_VIEW_fieldConfigList_join ON CMS_VIEW_fieldConfigList (VIEW_XID);
CREATE INDEX CPT_COMPONENT_name ON CPT_COMPONENT (xname);
CREATE INDEX CPT_COMPONENT_orderNumber ON CPT_COMPONENT (xorderNumber);
CREATE INDEX CPT_COMPONENT_allowList_element ON CPT_COMPONENT_allowList (xallowList);
CREATE INDEX CPT_COMPONENT_allowList_join ON CPT_COMPONENT_allowList (COMPONENT_XID);
CREATE INDEX CPT_COMPONENT_denyList_element ON CPT_COMPONENT_denyList (xdenyList);
CREATE INDEX CPT_COMPONENT_denyList_join ON CPT_COMPONENT_denyList (COMPONENT_XID);
CREATE INDEX CTE_AGENT_cron ON CTE_AGENT (xcron);
CREATE INDEX CTE_AGENT_enable ON CTE_AGENT (xenable);
CREATE INDEX CTE_AGENT_lastEndTime ON CTE_AGENT (xlastEndTime);
CREATE INDEX CTE_AGENT_lastStartTime ON CTE_AGENT (xlastStartTime);
CREATE INDEX CTE_AGENT_name ON CTE_AGENT (xname);
CREATE INDEX CTE_INVOKE_enable ON CTE_INVOKE (xenable);
CREATE INDEX CTE_INVOKE_lastEndTime ON CTE_INVOKE (xlastEndTime);
CREATE INDEX CTE_INVOKE_lastStartTime ON CTE_INVOKE (xlastStartTime);
CREATE INDEX CTE_INVOKE_name ON CTE_INVOKE (xname);
CREATE INDEX CTE_INVOKE_remoteAddrRegex ON CTE_INVOKE (xremoteAddrRegex);
CREATE INDEX CTE_PROMPTERRORLOG_exceptionClass ON CTE_PROMPTERRORLOG (xexceptionClass);
CREATE INDEX CTE_PROMPTERRORLOG_loggerName ON CTE_PROMPTERRORLOG (xloggerName);
CREATE INDEX CTE_PROMPTERRORLOG_occurTime ON CTE_PROMPTERRORLOG (xoccurTime);
CREATE INDEX CTE_PROMPTERRORLOG_person ON CTE_PROMPTERRORLOG (xperson);
CREATE INDEX CTE_PROMPTERRORLOG_requestRemoteAddr ON CTE_PROMPTERRORLOG (xrequestRemoteAddr);
CREATE INDEX CTE_PROMPTERRORLOG_requestRemoteHost ON CTE_PROMPTERRORLOG (xrequestRemoteHost);
CREATE INDEX CTE_SCHEDULELOG_application ON CTE_SCHEDULELOG (xapplication);
CREATE INDEX CTE_SCHEDULELOG_className ON CTE_SCHEDULELOG (xclassName);
CREATE INDEX CTE_SCHEDULELOG_elapsed ON CTE_SCHEDULELOG (xelapsed);
CREATE INDEX CTE_SCHEDULELOG_fireTime ON CTE_SCHEDULELOG (xfireTime);
CREATE INDEX CTE_SCHEDULELOG_node ON CTE_SCHEDULELOG (xnode);
CREATE INDEX CTE_SCHEDULELOG_success ON CTE_SCHEDULELOG (xsuccess);
CREATE INDEX CTE_SCHEDULELOG_type ON CTE_SCHEDULELOG (xtype);
CREATE INDEX CTE_STRUCTURE_deepPath ON CTE_STRUCTURE (xdeepPath);
CREATE INDEX CTE_STRUCTURE_lastUpdateTime ON CTE_STRUCTURE (xlastUpdateTime);
CREATE INDEX CTE_STRUCTURE_length ON CTE_STRUCTURE (xlength);
CREATE INDEX CTE_STRUCTURE_name ON CTE_STRUCTURE (xname);
CREATE INDEX CTE_STRUCTURE_storage ON CTE_STRUCTURE (xstorage);
CREATE INDEX CTE_UNEXPECTEDERRORLOG_exceptionClass ON CTE_UNEXPECTEDERRORLOG (xexceptionClass);
CREATE INDEX CTE_UNEXPECTEDERRORLOG_loggerName ON CTE_UNEXPECTEDERRORLOG (xloggerName);
CREATE INDEX CTE_UNEXPECTEDERRORLOG_occurTime ON CTE_UNEXPECTEDERRORLOG (xoccurTime);
CREATE INDEX CTE_UNEXPECTEDERRORLOG_person ON CTE_UNEXPECTEDERRORLOG (xperson);
CREATE INDEX CTE_UNEXPECTEDERRORLOG_requestRemoteAddr ON CTE_UNEXPECTEDERRORLOG (xrequestRemoteAddr);
CREATE INDEX CTE_UNEXPECTEDERRORLOG_requestRemoteHost ON CTE_UNEXPECTEDERRORLOG (xrequestRemoteHost);
CREATE INDEX CTE_WARNLOG_loggerName ON CTE_WARNLOG (xloggerName);
CREATE INDEX CTE_WARNLOG_occurTime ON CTE_WARNLOG (xoccurTime);
CREATE INDEX FILE_ATTACHMENT_deepPath ON FILE_ATTACHMENT (xdeepPath);
CREATE INDEX FILE_ATTACHMENT_folder ON FILE_ATTACHMENT (xfolder);
CREATE INDEX FILE_ATTACHMENT_lastUpdatePerson ON FILE_ATTACHMENT (xlastUpdatePerson);
CREATE INDEX FILE_ATTACHMENT_lastUpdateTime ON FILE_ATTACHMENT (xlastUpdateTime);
CREATE INDEX FILE_ATTACHMENT_length ON FILE_ATTACHMENT (xlength);
CREATE INDEX FILE_ATTACHMENT_name ON FILE_ATTACHMENT (xname);
CREATE INDEX FILE_ATTACHMENT_person ON FILE_ATTACHMENT (xperson);
CREATE INDEX FILE_ATTACHMENT_storage ON FILE_ATTACHMENT (xstorage);
CREATE INDEX FILE_ATTACHMENT2_folder ON FILE_ATTACHMENT2 (xfolder);
CREATE INDEX FILE_ATTACHMENT2_lastUpdatePerson ON FILE_ATTACHMENT2 (xlastUpdatePerson);
CREATE INDEX FILE_ATTACHMENT2_lastUpdateTime ON FILE_ATTACHMENT2 (xlastUpdateTime);
CREATE INDEX FILE_ATTACHMENT2_length ON FILE_ATTACHMENT2 (xlength);
CREATE INDEX FILE_ATTACHMENT2_name ON FILE_ATTACHMENT2 (xname);
CREATE INDEX FILE_ATTACHMENT2_originFile ON FILE_ATTACHMENT2 (xoriginFile);
CREATE INDEX FILE_ATTACHMENT2_person ON FILE_ATTACHMENT2 (xperson);
CREATE INDEX FILE_ATTACHMENT_editorList_element ON FILE_ATTACHMENT_editorList (xeditorList);
CREATE INDEX FILE_ATTACHMENT_editorList_join ON FILE_ATTACHMENT_editorList (ATTACHMENT_XID);
CREATE INDEX FILE_ATTACHMENT_shareList_element ON FILE_ATTACHMENT_shareList (xshareList);
CREATE INDEX FILE_ATTACHMENT_shareList_join ON FILE_ATTACHMENT_shareList (ATTACHMENT_XID);
CREATE INDEX FILE_FILE_deepPath ON FILE_FILE (xdeepPath);
CREATE INDEX FILE_FILE_extension ON FILE_FILE (xextension);
CREATE INDEX FILE_FILE_lastNotExistedTime ON FILE_FILE (xlastNotExistedTime);
CREATE INDEX FILE_FILE_lastUpdateTime ON FILE_FILE (xlastUpdateTime);
CREATE INDEX FILE_FILE_length ON FILE_FILE (xlength);
CREATE INDEX FILE_FILE_name ON FILE_FILE (xname);
CREATE INDEX FILE_FILE_person ON FILE_FILE (xperson);
CREATE INDEX FILE_FILE_reference ON FILE_FILE (xreference);
CREATE INDEX FILE_FILE_referenceType ON FILE_FILE (xreferenceType);
CREATE INDEX FILE_FILE_storage ON FILE_FILE (xstorage);
CREATE INDEX FILE_FOLDER_person ON FILE_FOLDER (xperson);
CREATE INDEX FILE_FOLDER_superior ON FILE_FOLDER (xsuperior);
CREATE INDEX FILE_FOLDER2_lastUpdateTime ON FILE_FOLDER2 (xlastUpdateTime);
CREATE INDEX FILE_FOLDER2_person ON FILE_FOLDER2 (xperson);
CREATE INDEX FILE_FOLDER2_superior ON FILE_FOLDER2 (xsuperior);
CREATE INDEX FILE_ORIGINFILE_deepPath ON FILE_ORIGINFILE (xdeepPath);
CREATE INDEX FILE_ORIGINFILE_fileMd5 ON FILE_ORIGINFILE (xfileMd5);
CREATE INDEX FILE_ORIGINFILE_lastUpdatePerson ON FILE_ORIGINFILE (xlastUpdatePerson);
CREATE INDEX FILE_ORIGINFILE_lastUpdateTime ON FILE_ORIGINFILE (xlastUpdateTime);
CREATE INDEX FILE_ORIGINFILE_length ON FILE_ORIGINFILE (xlength);
CREATE INDEX FILE_ORIGINFILE_name ON FILE_ORIGINFILE (xname);
CREATE INDEX FILE_ORIGINFILE_person ON FILE_ORIGINFILE (xperson);
CREATE INDEX FILE_ORIGINFILE_storage ON FILE_ORIGINFILE (xstorage);
CREATE INDEX FILE_RECYCLE_length ON FILE_RECYCLE (xlength);
CREATE INDEX FILE_RECYCLE_name ON FILE_RECYCLE (xname);
CREATE INDEX FILE_RECYCLE_person ON FILE_RECYCLE (xperson);
CREATE INDEX FILE_RECYCLE_validTime ON FILE_RECYCLE (xvalidTime);
CREATE INDEX FILE_SHARE_lastUpdateTime ON FILE_SHARE (xlastUpdateTime);
CREATE INDEX FILE_SHARE_length ON FILE_SHARE (xlength);
CREATE INDEX FILE_SHARE_name ON FILE_SHARE (xname);
CREATE INDEX FILE_SHARE_password ON FILE_SHARE (xpassword);
CREATE INDEX FILE_SHARE_person ON FILE_SHARE (xperson);
CREATE INDEX FILE_SHARE_validTime ON FILE_SHARE (xvalidTime);
CREATE INDEX FILE_SHARE_shareOrgList_element ON FILE_SHARE_shareOrgList (xshareOrgList);
CREATE INDEX FILE_SHARE_shareOrgList_join ON FILE_SHARE_shareOrgList (SHARE_XID);
CREATE INDEX FILE_SHARE_shareUserList_element ON FILE_SHARE_shareUserList (xshareUserList);
CREATE INDEX FILE_SHARE_shareUserList_join ON FILE_SHARE_shareUserList (SHARE_XID);
CREATE INDEX FILE_SHARE_shieldUserList_element ON FILE_SHARE_shieldUserList (xshieldUserList);
CREATE INDEX FILE_SHARE_shieldUserList_join ON FILE_SHARE_shieldUserList (SHARE_XID);
CREATE INDEX HOT_PICTURE_INFO_application ON HOT_PICTURE_INFO (xapplication);
CREATE INDEX MIND_BASE_INFO_cooperative_sequence ON MIND_BASE_INFO (xcooperative_sequence);
CREATE INDEX MIND_BASE_INFO_creator ON MIND_BASE_INFO (xcreator);
CREATE INDEX MIND_BASE_INFO_creatorUnit_sequence ON MIND_BASE_INFO (xcreatorUnit_sequence);
CREATE INDEX MIND_BASE_INFO_creator_sequence ON MIND_BASE_INFO (xcreator_sequence);
CREATE INDEX MIND_BASE_INFO_folderId ON MIND_BASE_INFO (xfolderId);
CREATE INDEX MIND_BASE_INFO_folder_sequence ON MIND_BASE_INFO (xfolder_sequence);
CREATE INDEX MIND_BASE_INFO_name ON MIND_BASE_INFO (xname);
CREATE INDEX MIND_BASE_INFO_shared ON MIND_BASE_INFO (xshared);
CREATE INDEX MIND_BASE_INFO_shared_sequence ON MIND_BASE_INFO (xshared_sequence);
CREATE INDEX MIND_BASE_INFO_editorList_element ON MIND_BASE_INFO_editorList (xeditorList);
CREATE INDEX MIND_BASE_INFO_editorList_join ON MIND_BASE_INFO_editorList (MINDBASEINFO_XID);
CREATE INDEX MIND_BASE_INFO_shareGroupList_element ON MIND_BASE_INFO_shareGroupList (xshareGroupList);
CREATE INDEX MIND_BASE_INFO_shareGroupList_join ON MIND_BASE_INFO_shareGroupList (MINDBASEINFO_XID);
CREATE INDEX MIND_BASE_INFO_sharePersonList_element ON MIND_BASE_INFO_sharePersonList (xsharePersonList);
CREATE INDEX MIND_BASE_INFO_sharePersonList_join ON MIND_BASE_INFO_sharePersonList (MINDBASEINFO_XID);
CREATE INDEX MIND_BASE_INFO_shareUnitList_element ON MIND_BASE_INFO_shareUnitList (xshareUnitList);
CREATE INDEX MIND_BASE_INFO_shareUnitList_join ON MIND_BASE_INFO_shareUnitList (MINDBASEINFO_XID);
CREATE INDEX MIND_FOLDER_INFO_creator ON MIND_FOLDER_INFO (xcreator);
CREATE INDEX MIND_FOLDER_INFO_name ON MIND_FOLDER_INFO (xname);
CREATE INDEX MIND_FOLDER_INFO_parentId ON MIND_FOLDER_INFO (xparentId);
CREATE INDEX MIND_RECYCLE_INFO_creator ON MIND_RECYCLE_INFO (xcreator);
CREATE INDEX MIND_RECYCLE_INFO_creatorUnit_sequence ON MIND_RECYCLE_INFO (xcreatorUnit_sequence);
CREATE INDEX MIND_RECYCLE_INFO_creator_sequence ON MIND_RECYCLE_INFO (xcreator_sequence);
CREATE INDEX MIND_RECYCLE_INFO_deleteor ON MIND_RECYCLE_INFO (xdeleteor);
CREATE INDEX MIND_RECYCLE_INFO_fileCreateTime ON MIND_RECYCLE_INFO (xfileCreateTime);
CREATE INDEX MIND_RECYCLE_INFO_folderId ON MIND_RECYCLE_INFO (xfolderId);
CREATE INDEX MIND_RECYCLE_INFO_folder_sequence ON MIND_RECYCLE_INFO (xfolder_sequence);
CREATE INDEX MIND_RECYCLE_INFO_name ON MIND_RECYCLE_INFO (xname);
CREATE INDEX MIND_RECYCLE_INFO_shared ON MIND_RECYCLE_INFO (xshared);
CREATE INDEX MIND_RECYCLE_INFO_shared_sequence ON MIND_RECYCLE_INFO (xshared_sequence);
CREATE INDEX MIND_SHARE_RECORED_fileId ON MIND_SHARE_RECORED (xfileId);
CREATE INDEX MIND_SHARE_RECORED_fileStatus ON MIND_SHARE_RECORED (xfileStatus);
CREATE INDEX MIND_SHARE_RECORED_fileType ON MIND_SHARE_RECORED (xfileType);
CREATE INDEX MIND_SHARE_RECORED_name ON MIND_SHARE_RECORED (xname);
CREATE INDEX MIND_SHARE_RECORED_shareType ON MIND_SHARE_RECORED (xshareType);
CREATE INDEX MIND_SHARE_RECORED_source ON MIND_SHARE_RECORED (xsource);
CREATE INDEX MIND_SHARE_RECORED_target ON MIND_SHARE_RECORED (xtarget);
CREATE INDEX MIND_SHARE_RECORED_targetType ON MIND_SHARE_RECORED (xtargetType);
CREATE INDEX MIND_VERSION_INFO_mindId ON MIND_VERSION_INFO (xmindId);
CREATE INDEX MSG_IM_CONVERSATIONpersonList_element ON MSG_IM_CONVERSATION_personList (xpersonList);
CREATE INDEX MSG_IM_CONVERSATIONpersonList_join ON MSG_IM_CONVERSATION_personList (IMCONVERSATION_XID);
CREATE INDEX MSG_INSTANT_consumed ON MSG_INSTANT (xconsumed);
CREATE INDEX MSG_INSTANT_person ON MSG_INSTANT (xperson);
CREATE INDEX MSG_INSTANT_title ON MSG_INSTANT (xtitle);
CREATE INDEX MSG_INSTANT_type ON MSG_INSTANT (xtype);
CREATE INDEX MSG_INSTANTconsumerList_element ON MSG_INSTANT_consumerList (xconsumerList);
CREATE INDEX MSG_INSTANTconsumerList_join ON MSG_INSTANT_consumerList (INSTANT_XID);
CREATE INDEX MSG_MASS_creatorPerson ON MSG_MASS (xcreatorPerson);
CREATE INDEX MSG_MASS_type ON MSG_MASS (xtype);
CREATE INDEX MSG_MASSgroupList_element ON MSG_MASS_groupList (xgroupList);
CREATE INDEX MSG_MASSgroupList_join ON MSG_MASS_groupList (MASS_XID);
CREATE INDEX MSG_MASSidentityList_element ON MSG_MASS_identityList (xidentityList);
CREATE INDEX MSG_MASSidentityList_join ON MSG_MASS_identityList (MASS_XID);
CREATE INDEX MSG_MASSpersonList_element ON MSG_MASS_personList (xpersonList);
CREATE INDEX MSG_MASSpersonList_join ON MSG_MASS_personList (MASS_XID);
CREATE INDEX MSG_MASSsendPersonList_element ON MSG_MASS_sendPersonList (xsendPersonList);
CREATE INDEX MSG_MASSsendPersonList_join ON MSG_MASS_sendPersonList (MASS_XID);
CREATE INDEX MSG_MASSunitList_element ON MSG_MASS_unitList (xunitList);
CREATE INDEX MSG_MASSunitList_join ON MSG_MASS_unitList (MASS_XID);
CREATE INDEX MSG_MESSAGE_consumed ON MSG_MESSAGE (xconsumed);
CREATE INDEX MSG_MESSAGE_consumer ON MSG_MESSAGE (xconsumer);
CREATE INDEX MSG_MESSAGE_instant ON MSG_MESSAGE (xinstant);
CREATE INDEX MSG_MESSAGE_person ON MSG_MESSAGE (xperson);
CREATE INDEX MSG_MESSAGE_title ON MSG_MESSAGE (xtitle);
CREATE INDEX MSG_MESSAGE_type ON MSG_MESSAGE (xtype);
CREATE INDEX MT_ATTACHMENT_deepPath ON MT_ATTACHMENT (xdeepPath);
CREATE INDEX MT_ATTACHMENT_lastUpdatePerson ON MT_ATTACHMENT (xlastUpdatePerson);
CREATE INDEX MT_ATTACHMENT_lastUpdateTime ON MT_ATTACHMENT (xlastUpdateTime);
CREATE INDEX MT_ATTACHMENT_length ON MT_ATTACHMENT (xlength);
CREATE INDEX MT_ATTACHMENT_meeting ON MT_ATTACHMENT (xmeeting);
CREATE INDEX MT_ATTACHMENT_name ON MT_ATTACHMENT (xname);
CREATE INDEX MT_ATTACHMENT_storage ON MT_ATTACHMENT (xstorage);
CREATE INDEX MT_ATTACHMENT_summary ON MT_ATTACHMENT (xsummary);
CREATE INDEX MT_BUILDING_address ON MT_BUILDING (xaddress);
CREATE INDEX MT_BUILDING_name ON MT_BUILDING (xname);
CREATE INDEX MT_BUILDING_pinyin ON MT_BUILDING (xpinyin);
CREATE INDEX MT_BUILDING_pinyinInitial ON MT_BUILDING (xpinyinInitial);
CREATE INDEX MT_MEETING_actualCompletedTime ON MT_MEETING (xactualCompletedTime);
CREATE INDEX MT_MEETING_actualStartTime ON MT_MEETING (xactualStartTime);
CREATE INDEX MT_MEETING_applicant ON MT_MEETING (xapplicant);
CREATE INDEX MT_MEETING_auditor ON MT_MEETING (xauditor);
CREATE INDEX MT_MEETING_completedTime ON MT_MEETING (xcompletedTime);
CREATE INDEX MT_MEETING_confirmStatus ON MT_MEETING (xconfirmStatus);
CREATE INDEX MT_MEETING_description ON MT_MEETING (xdescription);
CREATE INDEX MT_MEETING_manualCompleted ON MT_MEETING (xmanualCompleted);
CREATE INDEX MT_MEETING_pinyin ON MT_MEETING (xpinyin);
CREATE INDEX MT_MEETING_pinyinInitial ON MT_MEETING (xpinyinInitial);
CREATE INDEX MT_MEETING_room ON MT_MEETING (xroom);
CREATE INDEX MT_MEETING_startTime ON MT_MEETING (xstartTime);
CREATE INDEX MT_MEETING_subject ON MT_MEETING (xsubject);
CREATE INDEX MT_MEETING_acceptPersonList_element ON MT_MEETING_acceptPersonList (xacceptPersonList);
CREATE INDEX MT_MEETING_acceptPersonList_join ON MT_MEETING_acceptPersonList (MEETING_XID);
CREATE INDEX MT_MEETING_checkinPersonList_element ON MT_MEETING_checkinPersonList (xcheckinPersonList);
CREATE INDEX MT_MEETING_checkinPersonList_join ON MT_MEETING_checkinPersonList (MEETING_XID);
CREATE INDEX MT_MEETING_invitePersonList_element ON MT_MEETING_invitePersonList (xinvitePersonList);
CREATE INDEX MT_MEETING_invitePersonList_join ON MT_MEETING_invitePersonList (MEETING_XID);
CREATE INDEX MT_MEETING_rejectPersonList_element ON MT_MEETING_rejectPersonList (xrejectPersonList);
CREATE INDEX MT_MEETING_rejectPersonList_join ON MT_MEETING_rejectPersonList (MEETING_XID);
CREATE INDEX MT_ROOM_auditor ON MT_ROOM (xauditor);
CREATE INDEX MT_ROOM_available ON MT_ROOM (xavailable);
CREATE INDEX MT_ROOM_building ON MT_ROOM (xbuilding);
CREATE INDEX MT_ROOM_name ON MT_ROOM (xname);
CREATE INDEX MT_ROOM_phoneNumber ON MT_ROOM (xphoneNumber);
CREATE INDEX MT_ROOM_pinyin ON MT_ROOM (xpinyin);
CREATE INDEX MT_ROOM_pinyinInitial ON MT_ROOM (xpinyinInitial);
CREATE INDEX MT_ROOM_roomNumber ON MT_ROOM (xroomNumber);
CREATE INDEX OKR_ATTACHMENTFILEINFO_centerId ON OKR_ATTACHMENTFILEINFO (xcenterId);
CREATE INDEX OKR_ATTACHMENTFILEINFO_deepPath ON OKR_ATTACHMENTFILEINFO (xdeepPath);
CREATE INDEX OKR_ATTACHMENTFILEINFO_lastUpdateTime ON OKR_ATTACHMENTFILEINFO (xlastUpdateTime);
CREATE INDEX OKR_ATTACHMENTFILEINFO_length ON OKR_ATTACHMENTFILEINFO (xlength);
CREATE INDEX OKR_ATTACHMENTFILEINFO_storage ON OKR_ATTACHMENTFILEINFO (xstorage);
CREATE INDEX OKR_ATTACHMENTFILEINFO_workInfoId ON OKR_ATTACHMENTFILEINFO (xworkInfoId);
CREATE INDEX OKR_CENTERWORKINFO_deployMonth ON OKR_CENTERWORKINFO (xdeployMonth);
CREATE INDEX OKR_CENTERWORKINFO_deployYear ON OKR_CENTERWORKINFO (xdeployYear);
CREATE INDEX OKR_CENTERWORKINFO_title ON OKR_CENTERWORKINFO (xtitle);
CREATE INDEX OKR_CENTERWORKINFO_attachmentList_element ON OKR_CENTERWORKINFO_attachmentList (xattachmentList);
CREATE INDEX OKR_CENTERWORKINFO_attachmentList_join ON OKR_CENTERWORKINFO_attachmentList (OKRCENTERWORKINFO_XID);
CREATE INDEX OKR_CENTERWORKINFO_defaultLeaderIdentityList_element ON OKR_CENTERWORKINFO_defaultLeaderIdentityList (xdefaultLeaderIdentityList);
CREATE INDEX OKR_CENTERWORKINFO_defaultLeaderIdentityList_join ON OKR_CENTERWORKINFO_defaultLeaderIdentityList (OKRCENTERWORKINFO_XID);
CREATE INDEX OKR_CENTERWORKINFO_defaultLeaderList_element ON OKR_CENTERWORKINFO_defaultLeaderList (xdefaultLeaderList);
CREATE INDEX OKR_CENTERWORKINFO_defaultLeaderList_join ON OKR_CENTERWORKINFO_defaultLeaderList (OKRCENTERWORKINFO_XID);
CREATE INDEX OKR_CENTERWORKINFO_reportAuditLeaderIdentityList_element ON OKR_CENTERWORKINFO_reportAuditLeaderIdentityList (xreportAuditLeaderIdentityList);
CREATE INDEX OKR_CENTERWORKINFO_reportAuditLeaderIdentityList_join ON OKR_CENTERWORKINFO_reportAuditLeaderIdentityList (OKRCENTERWORKINFO_XID);
CREATE INDEX OKR_CENTERWORKINFO_reportAuditLeaderNameList_element ON OKR_CENTERWORKINFO_reportAuditLeaderNameList (xreportAuditLeaderNameList);
CREATE INDEX OKR_CENTERWORKINFO_reportAuditLeaderNameList_join ON OKR_CENTERWORKINFO_reportAuditLeaderNameList (OKRCENTERWORKINFO_XID);
CREATE INDEX OKR_CENTERWORKINFO_reportAuditLeaderTopUnitNameList_element ON OKR_CENTERWORKINFO_reportAuditLeaderTopUnitNameList (xreportAuditLeaderTopUnitNameList);
CREATE INDEX OKR_CENTERWORKINFO_reportAuditLeaderTopUnitNameList_join ON OKR_CENTERWORKINFO_reportAuditLeaderTopUnitNameList (OKRCENTERWORKINFO_XID);
CREATE INDEX OKR_CENTERWORKINFO_reportAuditLeaderUnitNameList_element ON OKR_CENTERWORKINFO_reportAuditLeaderUnitNameList (xreportAuditLeaderUnitNameList);
CREATE INDEX OKR_CENTERWORKINFO_reportAuditLeaderUnitNameList_join ON OKR_CENTERWORKINFO_reportAuditLeaderUnitNameList (OKRCENTERWORKINFO_XID);
CREATE INDEX OKR_CONFIG_SECRETARY_leaderIdentity ON OKR_CONFIG_SECRETARY (xleaderIdentity);
CREATE INDEX OKR_CONFIG_SECRETARY_secretaryIdentity ON OKR_CONFIG_SECRETARY (xsecretaryIdentity);
CREATE INDEX OKR_CONFIG_SECRETARY_secretaryName ON OKR_CONFIG_SECRETARY (xsecretaryName);
CREATE INDEX OKR_CONFIG_SYSTEM_configCode ON OKR_CONFIG_SYSTEM (xconfigCode);
CREATE INDEX OKR_ERRROIDENTITY_identity ON OKR_ERRROIDENTITY (xidentity);
CREATE INDEX OKR_ERRROIDENTITYRECORDS_flag ON OKR_ERRROIDENTITYRECORDS (xflag);
CREATE INDEX OKR_ERRROIDENTITYRECORDS_identity ON OKR_ERRROIDENTITYRECORDS (xidentity);
CREATE INDEX OKR_STATISTIC_REPORT_CONTENT_centerId ON OKR_STATISTIC_REPORT_CONTENT (xcenterId);
CREATE INDEX OKR_STATISTIC_REPORT_CONTENT_centerTitle ON OKR_STATISTIC_REPORT_CONTENT (xcenterTitle);
CREATE INDEX OKR_STATISTIC_REPORT_CONTENT_workId ON OKR_STATISTIC_REPORT_CONTENT (xworkId);
CREATE INDEX OKR_STATISTIC_REPORT_STATUS_centerId ON OKR_STATISTIC_REPORT_STATUS (xcenterId);
CREATE INDEX OKR_STATISTIC_REPORT_STATUS_statisticTimeFlag ON OKR_STATISTIC_REPORT_STATUS (xstatisticTimeFlag);
CREATE INDEX OKR_STATISTIC_REPORT_STATUS_statisticYear ON OKR_STATISTIC_REPORT_STATUS (xstatisticYear);
CREATE INDEX OKR_STATISTIC_REPORT_STATUS_workId ON OKR_STATISTIC_REPORT_STATUS (xworkId);
CREATE INDEX OKR_TASK_centerId ON OKR_TASK (xcenterId);
CREATE INDEX OKR_TASK_dynamicObjectId ON OKR_TASK (xdynamicObjectId);
CREATE INDEX OKR_TASK_dynamicObjectType ON OKR_TASK (xdynamicObjectType);
CREATE INDEX OKR_TASK_processType ON OKR_TASK (xprocessType);
CREATE INDEX OKR_TASK_status ON OKR_TASK (xstatus);
CREATE INDEX OKR_TASK_targetIdentity ON OKR_TASK (xtargetIdentity);
CREATE INDEX OKR_TASK_workId ON OKR_TASK (xworkId);
CREATE INDEX OKR_TASKHANDLED_centerId ON OKR_TASKHANDLED (xcenterId);
CREATE INDEX OKR_TASKHANDLED_processType ON OKR_TASKHANDLED (xprocessType);
CREATE INDEX OKR_TASKHANDLED_targetIdentity ON OKR_TASKHANDLED (xtargetIdentity);
CREATE INDEX OKR_TASKHANDLED_targetName ON OKR_TASKHANDLED (xtargetName);
CREATE INDEX OKR_TASKHANDLED_workId ON OKR_TASKHANDLED (xworkId);
CREATE INDEX OKR_USERINFO_userName ON OKR_USERINFO (xuserName);
CREATE INDEX OKR_WORKAPPRAISEINFO_centerId ON OKR_WORKAPPRAISEINFO (xcenterId);
CREATE INDEX OKR_WORKAPPRAISEINFO_status ON OKR_WORKAPPRAISEINFO (xstatus);
CREATE INDEX OKR_WORKAPPRAISEINFO_workId ON OKR_WORKAPPRAISEINFO (xworkId);
CREATE INDEX OKR_WORKBASEINFO_centerId ON OKR_WORKBASEINFO (xcenterId);
CREATE INDEX OKR_WORKBASEINFO_deployMonth ON OKR_WORKBASEINFO (xdeployMonth);
CREATE INDEX OKR_WORKBASEINFO_deployYear ON OKR_WORKBASEINFO (xdeployYear);
CREATE INDEX OKR_WORKBASEINFO_parentWorkId ON OKR_WORKBASEINFO (xparentWorkId);
CREATE INDEX OKR_WORKBASEINFO_title ON OKR_WORKBASEINFO (xtitle);
CREATE INDEX OKR_WORKBASEINFO_appraiseInfoList_element ON OKR_WORKBASEINFO_appraiseInfoList (xappraiseInfoList);
CREATE INDEX OKR_WORKBASEINFO_appraiseInfoList_join ON OKR_WORKBASEINFO_appraiseInfoList (OKRWORKBASEINFO_XID);
CREATE INDEX OKR_WORKBASEINFO_attachmentList_element ON OKR_WORKBASEINFO_attachmentList (xattachmentList);
CREATE INDEX OKR_WORKBASEINFO_attachmentList_join ON OKR_WORKBASEINFO_attachmentList (OKRWORKBASEINFO_XID);
CREATE INDEX OKR_WORKBASEINFO_cooperateEmployeeNameList_element ON OKR_WORKBASEINFO_cooperateEmployeeNameList (xcooperateEmployeeNameList);
CREATE INDEX OKR_WORKBASEINFO_cooperateEmployeeNameList_join ON OKR_WORKBASEINFO_cooperateEmployeeNameList (OKRWORKBASEINFO_XID);
CREATE INDEX OKR_WORKBASEINFO_cooperateIdentityList_element ON OKR_WORKBASEINFO_cooperateIdentityList (xcooperateIdentityList);
CREATE INDEX OKR_WORKBASEINFO_cooperateIdentityList_join ON OKR_WORKBASEINFO_cooperateIdentityList (OKRWORKBASEINFO_XID);
CREATE INDEX OKR_WORKBASEINFO_cooperateTopUnitNameList_element ON OKR_WORKBASEINFO_cooperateTopUnitNameList (xcooperateTopUnitNameList);
CREATE INDEX OKR_WORKBASEINFO_cooperateTopUnitNameList_join ON OKR_WORKBASEINFO_cooperateTopUnitNameList (OKRWORKBASEINFO_XID);
CREATE INDEX OKR_WORKBASEINFO_cooperateUnitNameList_element ON OKR_WORKBASEINFO_cooperateUnitNameList (xcooperateUnitNameList);
CREATE INDEX OKR_WORKBASEINFO_cooperateUnitNameList_join ON OKR_WORKBASEINFO_cooperateUnitNameList (OKRWORKBASEINFO_XID);
CREATE INDEX OKR_WORKBASEINFO_readLeaderIdentityList_element ON OKR_WORKBASEINFO_readLeaderIdentityList (xreadLeaderIdentityList);
CREATE INDEX OKR_WORKBASEINFO_readLeaderIdentityList_join ON OKR_WORKBASEINFO_readLeaderIdentityList (OKRWORKBASEINFO_XID);
CREATE INDEX OKR_WORKBASEINFO_readLeaderNameList_element ON OKR_WORKBASEINFO_readLeaderNameList (xreadLeaderNameList);
CREATE INDEX OKR_WORKBASEINFO_readLeaderNameList_join ON OKR_WORKBASEINFO_readLeaderNameList (OKRWORKBASEINFO_XID);
CREATE INDEX OKR_WORKBASEINFO_readLeaderTopUnitNameList_element ON OKR_WORKBASEINFO_readLeaderTopUnitNameList (xreadLeaderTopUnitNameList);
CREATE INDEX OKR_WORKBASEINFO_readLeaderTopUnitNameList_join ON OKR_WORKBASEINFO_readLeaderTopUnitNameList (OKRWORKBASEINFO_XID);
CREATE INDEX OKR_WORKBASEINFO_readLeaderUnitNameList_element ON OKR_WORKBASEINFO_readLeaderUnitNameList (xreadLeaderUnitNameList);
CREATE INDEX OKR_WORKBASEINFO_readLeaderUnitNameList_join ON OKR_WORKBASEINFO_readLeaderUnitNameList (OKRWORKBASEINFO_XID);
CREATE INDEX OKR_WORKCHAT_workId ON OKR_WORKCHAT (xworkId);
CREATE INDEX OKR_WORKDETAILINFO_centerId ON OKR_WORKDETAILINFO (xcenterId);
CREATE INDEX OKR_WORKDYNAMICS_centerId ON OKR_WORKDYNAMICS (xcenterId);
CREATE INDEX OKR_WORKDYNAMICS_dynamicObjectId ON OKR_WORKDYNAMICS (xdynamicObjectId);
CREATE INDEX OKR_WORKDYNAMICS_dynamicObjectType ON OKR_WORKDYNAMICS (xdynamicObjectType);
CREATE INDEX OKR_WORKDYNAMICS_operatorName ON OKR_WORKDYNAMICS (xoperatorName);
CREATE INDEX OKR_WORKDYNAMICS_status ON OKR_WORKDYNAMICS (xstatus);
CREATE INDEX OKR_WORKDYNAMICS_targetIdentity ON OKR_WORKDYNAMICS (xtargetIdentity);
CREATE INDEX OKR_WORKDYNAMICS_workId ON OKR_WORKDYNAMICS (xworkId);
CREATE INDEX OKR_WORK_AUTHORIZE_RECORD_status ON OKR_WORK_AUTHORIZE_RECORD (xstatus);
CREATE INDEX OKR_WORK_AUTHORIZE_RECORD_workId ON OKR_WORK_AUTHORIZE_RECORD (xworkId);
CREATE INDEX OKR_WORK_PERSON_authorizeRecordId ON OKR_WORK_PERSON (xauthorizeRecordId);
CREATE INDEX OKR_WORK_PERSON_centerId ON OKR_WORK_PERSON (xcenterId);
CREATE INDEX OKR_WORK_PERSON_deployMonth ON OKR_WORK_PERSON (xdeployMonth);
CREATE INDEX OKR_WORK_PERSON_deployYear ON OKR_WORK_PERSON (xdeployYear);
CREATE INDEX OKR_WORK_PERSON_employeeIdentity ON OKR_WORK_PERSON (xemployeeIdentity);
CREATE INDEX OKR_WORK_PERSON_employeeName ON OKR_WORK_PERSON (xemployeeName);
CREATE INDEX OKR_WORK_PERSON_isCompleted ON OKR_WORK_PERSON (xisCompleted);
CREATE INDEX OKR_WORK_PERSON_isDelegateTarget ON OKR_WORK_PERSON (xisDelegateTarget);
CREATE INDEX OKR_WORK_PERSON_isOverTime ON OKR_WORK_PERSON (xisOverTime);
CREATE INDEX OKR_WORK_PERSON_parentWorkId ON OKR_WORK_PERSON (xparentWorkId);
CREATE INDEX OKR_WORK_PERSON_processIdentity ON OKR_WORK_PERSON (xprocessIdentity);
CREATE INDEX OKR_WORK_PERSON_status ON OKR_WORK_PERSON (xstatus);
CREATE INDEX OKR_WORK_PERSON_topUnitName ON OKR_WORK_PERSON (xtopUnitName);
CREATE INDEX OKR_WORK_PERSON_unitName ON OKR_WORK_PERSON (xunitName);
CREATE INDEX OKR_WORK_PERSON_workDateTimeType ON OKR_WORK_PERSON (xworkDateTimeType);
CREATE INDEX OKR_WORK_PERSON_workId ON OKR_WORK_PERSON (xworkId);
CREATE INDEX OKR_WORK_PERSON_workLevel ON OKR_WORK_PERSON (xworkLevel);
CREATE INDEX OKR_WORK_PERSON_workProcessStatus ON OKR_WORK_PERSON (xworkProcessStatus);
CREATE INDEX OKR_WORK_PERSON_workType ON OKR_WORK_PERSON (xworkType);
CREATE INDEX OKR_WORK_REPORTBASEINFO_creatorIdentity ON OKR_WORK_REPORTBASEINFO (xcreatorIdentity);
CREATE INDEX OKR_WORK_REPORTBASEINFO_creatorName ON OKR_WORK_REPORTBASEINFO (xcreatorName);
CREATE INDEX OKR_WORK_REPORTBASEINFO_currentProcessLevel ON OKR_WORK_REPORTBASEINFO (xcurrentProcessLevel);
CREATE INDEX OKR_WORK_REPORTBASEINFO_reporterIdentity ON OKR_WORK_REPORTBASEINFO (xreporterIdentity);
CREATE INDEX OKR_WORK_REPORTBASEINFO_reporterName ON OKR_WORK_REPORTBASEINFO (xreporterName);
CREATE INDEX OKR_WORK_REPORTBASEINFO_workId ON OKR_WORK_REPORTBASEINFO (xworkId);
CREATE INDEX OKR_WORK_REPORTBASEINFO_attachmentList_element ON OKR_WORK_REPORTBASEINFO_attachmentList (xattachmentList);
CREATE INDEX OKR_WORK_REPORTBASEINFO_attachmentList_join ON OKR_WORK_REPORTBASEINFO_attachmentList (OKRWORKREPORTBASEINFO_XID);
CREATE INDEX OKR_WORK_REPORTBASEINFO_currentProcessorIdentityList_element ON OKR_WORK_REPORTBASEINFO_currentProcessorIdentityList (xcurrentProcessorIdentityList);
CREATE INDEX OKR_WORK_REPORTBASEINFO_currentProcessorIdentityList_join ON OKR_WORK_REPORTBASEINFO_currentProcessorIdentityList (OKRWORKREPORTBASEINFO_XID);
CREATE INDEX OKR_WORK_REPORTBASEINFO_currentProcessorNameList_element ON OKR_WORK_REPORTBASEINFO_currentProcessorNameList (xcurrentProcessorNameList);
CREATE INDEX OKR_WORK_REPORTBASEINFO_currentProcessorNameList_join ON OKR_WORK_REPORTBASEINFO_currentProcessorNameList (OKRWORKREPORTBASEINFO_XID);
CREATE INDEX OKR_WORK_REPORTBASEINFO_currentProcessorTopUnitNameList_element ON OKR_WORK_REPORTBASEINFO_currentProcessorTopUnitNameList (xcurrentProcessorTopUnitNameList);
CREATE INDEX OKR_WORK_REPORTBASEINFO_currentProcessorTopUnitNameList_join ON OKR_WORK_REPORTBASEINFO_currentProcessorTopUnitNameList (OKRWORKREPORTBASEINFO_XID);
CREATE INDEX OKR_WORK_REPORTBASEINFO_currentProcessorUnitNameList_element ON OKR_WORK_REPORTBASEINFO_currentProcessorUnitNameList (xcurrentProcessorUnitNameList);
CREATE INDEX OKR_WORK_REPORTBASEINFO_currentProcessorUnitNameList_join ON OKR_WORK_REPORTBASEINFO_currentProcessorUnitNameList (OKRWORKREPORTBASEINFO_XID);
CREATE INDEX OKR_WORK_REPORTBASEINFO_readLeadersIdentityList_element ON OKR_WORK_REPORTBASEINFO_readLeadersIdentityList (xreadLeadersIdentityList);
CREATE INDEX OKR_WORK_REPORTBASEINFO_readLeadersIdentityList_join ON OKR_WORK_REPORTBASEINFO_readLeadersIdentityList (OKRWORKREPORTBASEINFO_XID);
CREATE INDEX OKR_WORK_REPORTBASEINFO_readLeadersNameList_element ON OKR_WORK_REPORTBASEINFO_readLeadersNameList (xreadLeadersNameList);
CREATE INDEX OKR_WORK_REPORTBASEINFO_readLeadersNameList_join ON OKR_WORK_REPORTBASEINFO_readLeadersNameList (OKRWORKREPORTBASEINFO_XID);
CREATE INDEX OKR_WORK_REPORT_PERSONLINK_processorIdentity ON OKR_WORK_REPORT_PERSONLINK (xprocessorIdentity);
CREATE INDEX OKR_WORK_REPORT_PERSONLINK_workId ON OKR_WORK_REPORT_PERSONLINK (xworkId);
CREATE INDEX OKR_WORK_REPORT_PERSONLINK_workReportId ON OKR_WORK_REPORT_PERSONLINK (xworkReportId);
CREATE INDEX OKR_WORK_REPORT_PROCESSLOG_centerId ON OKR_WORK_REPORT_PROCESSLOG (xcenterId);
CREATE INDEX OKR_WORK_REPORT_PROCESSLOG_processorIdentity ON OKR_WORK_REPORT_PROCESSLOG (xprocessorIdentity);
CREATE INDEX OKR_WORK_REPORT_PROCESSLOG_workId ON OKR_WORK_REPORT_PROCESSLOG (xworkId);
CREATE INDEX OKR_WORK_REPORT_PROCESSLOG_workReportId ON OKR_WORK_REPORT_PROCESSLOG (xworkReportId);
CREATE INDEX ORG_A_EMPOWER_application ON ORG_A_EMPOWER (xapplication);
CREATE INDEX ORG_A_EMPOWER_applicationAlias ON ORG_A_EMPOWER (xapplicationAlias);
CREATE INDEX ORG_A_EMPOWER_applicationName ON ORG_A_EMPOWER (xapplicationName);
CREATE INDEX ORG_A_EMPOWER_completedTime ON ORG_A_EMPOWER (xcompletedTime);
CREATE INDEX ORG_A_EMPOWER_enable ON ORG_A_EMPOWER (xenable);
CREATE INDEX ORG_A_EMPOWER_fromIdentity ON ORG_A_EMPOWER (xfromIdentity);
CREATE INDEX ORG_A_EMPOWER_fromPerson ON ORG_A_EMPOWER (xfromPerson);
CREATE INDEX ORG_A_EMPOWER_process ON ORG_A_EMPOWER (xprocess);
CREATE INDEX ORG_A_EMPOWER_processAlias ON ORG_A_EMPOWER (xprocessAlias);
CREATE INDEX ORG_A_EMPOWER_processName ON ORG_A_EMPOWER (xprocessName);
CREATE INDEX ORG_A_EMPOWER_startTime ON ORG_A_EMPOWER (xstartTime);
CREATE INDEX ORG_A_EMPOWER_toIdentity ON ORG_A_EMPOWER (xtoIdentity);
CREATE INDEX ORG_A_EMPOWER_toPerson ON ORG_A_EMPOWER (xtoPerson);
CREATE INDEX ORG_A_EMPOWER_type ON ORG_A_EMPOWER (xtype);
CREATE INDEX ORG_A_EMPOWERLOG_activity ON ORG_A_EMPOWERLOG (xactivity);
CREATE INDEX ORG_A_EMPOWERLOG_activityAlias ON ORG_A_EMPOWERLOG (xactivityAlias);
CREATE INDEX ORG_A_EMPOWERLOG_activityName ON ORG_A_EMPOWERLOG (xactivityName);
CREATE INDEX ORG_A_EMPOWERLOG_application ON ORG_A_EMPOWERLOG (xapplication);
CREATE INDEX ORG_A_EMPOWERLOG_applicationAlias ON ORG_A_EMPOWERLOG (xapplicationAlias);
CREATE INDEX ORG_A_EMPOWERLOG_applicationName ON ORG_A_EMPOWERLOG (xapplicationName);
CREATE INDEX ORG_A_EMPOWERLOG_empowerTime ON ORG_A_EMPOWERLOG (xempowerTime);
CREATE INDEX ORG_A_EMPOWERLOG_fromIdentity ON ORG_A_EMPOWERLOG (xfromIdentity);
CREATE INDEX ORG_A_EMPOWERLOG_fromPerson ON ORG_A_EMPOWERLOG (xfromPerson);
CREATE INDEX ORG_A_EMPOWERLOG_job ON ORG_A_EMPOWERLOG (xjob);
CREATE INDEX ORG_A_EMPOWERLOG_process ON ORG_A_EMPOWERLOG (xprocess);
CREATE INDEX ORG_A_EMPOWERLOG_processAlias ON ORG_A_EMPOWERLOG (xprocessAlias);
CREATE INDEX ORG_A_EMPOWERLOG_processName ON ORG_A_EMPOWERLOG (xprocessName);
CREATE INDEX ORG_A_EMPOWERLOG_title ON ORG_A_EMPOWERLOG (xtitle);
CREATE INDEX ORG_A_EMPOWERLOG_toIdentity ON ORG_A_EMPOWERLOG (xtoIdentity);
CREATE INDEX ORG_A_EMPOWERLOG_toPerson ON ORG_A_EMPOWERLOG (xtoPerson);
CREATE INDEX ORG_A_EMPOWERLOG_work ON ORG_A_EMPOWERLOG (xwork);
CREATE INDEX ORG_BIND_meta ON ORG_BIND (xmeta);
CREATE INDEX ORG_BIND_name ON ORG_BIND (xname);
CREATE INDEX ORG_CUSTOM_name ON ORG_CUSTOM (xname);
CREATE INDEX ORG_CUSTOM_person ON ORG_CUSTOM (xperson);
CREATE INDEX ORG_DEFINTION_name ON ORG_DEFINTION (xname);
CREATE INDEX ORG_GROUP_description ON ORG_GROUP (xdescription);
CREATE INDEX ORG_GROUP_distinguishedName ON ORG_GROUP (xdistinguishedName);
CREATE INDEX ORG_GROUP_name ON ORG_GROUP (xname);
CREATE INDEX ORG_GROUP_orderNumber ON ORG_GROUP (xorderNumber);
CREATE INDEX ORG_GROUP_pinyin ON ORG_GROUP (xpinyin);
CREATE INDEX ORG_GROUP_pinyinInitial ON ORG_GROUP (xpinyinInitial);
CREATE INDEX ORG_GROUP_unique ON ORG_GROUP (xunique);
CREATE INDEX ORG_GROUP_groupList_element ON ORG_GROUP_groupList (xgroupList);
CREATE INDEX ORG_GROUP_groupList_join ON ORG_GROUP_groupList (GROUP_XID);
CREATE INDEX ORG_GROUP_personList_element ON ORG_GROUP_personList (xpersonList);
CREATE INDEX ORG_GROUP_personList_join ON ORG_GROUP_personList (GROUP_XID);
CREATE INDEX ORG_GROUP_unitList_element ON ORG_GROUP_unitList (xunitList);
CREATE INDEX ORG_GROUP_unitList_join ON ORG_GROUP_unitList (GROUP_XID);
CREATE INDEX ORG_IDENTITY_description ON ORG_IDENTITY (xdescription);
CREATE INDEX ORG_IDENTITY_distinguishedName ON ORG_IDENTITY (xdistinguishedName);
CREATE INDEX ORG_IDENTITY_major ON ORG_IDENTITY (xmajor);
CREATE INDEX ORG_IDENTITY_name ON ORG_IDENTITY (xname);
CREATE INDEX ORG_IDENTITY_orderNumber ON ORG_IDENTITY (xorderNumber);
CREATE INDEX ORG_IDENTITY_person ON ORG_IDENTITY (xperson);
CREATE INDEX ORG_IDENTITY_pinyin ON ORG_IDENTITY (xpinyin);
CREATE INDEX ORG_IDENTITY_pinyinInitial ON ORG_IDENTITY (xpinyinInitial);
CREATE INDEX ORG_IDENTITY_unique ON ORG_IDENTITY (xunique);
CREATE INDEX ORG_IDENTITY_unit ON ORG_IDENTITY (xunit);
CREATE INDEX ORG_IDENTITY_unitLevel ON ORG_IDENTITY (xunitLevel);
CREATE INDEX ORG_IDENTITY_unitName ON ORG_IDENTITY (xunitName);
CREATE INDEX ORG_OAUTHCODE_clientId ON ORG_OAUTHCODE (xclientId);
CREATE INDEX ORG_OAUTHCODE_code ON ORG_OAUTHCODE (xcode);
CREATE INDEX ORG_OAUTHCODE_codeUsed ON ORG_OAUTHCODE (xcodeUsed);
CREATE INDEX ORG_OAUTHCODE_person ON ORG_OAUTHCODE (xperson);
CREATE INDEX ORG_OAUTHCODE_scope ON ORG_OAUTHCODE (xscope);
CREATE INDEX ORG_PERMISSIONSETTING_explain ON ORG_PERMISSIONSETTING (xexplain);
CREATE INDEX ORG_PERMISSIONSETTING_extend1 ON ORG_PERMISSIONSETTING (xextend1);
CREATE INDEX ORG_PERMISSIONSETTING_extend2 ON ORG_PERMISSIONSETTING (xextend2);
CREATE INDEX ORG_PERMISSIONSETTING_extend3 ON ORG_PERMISSIONSETTING (xextend3);
CREATE INDEX ORG_PERMISSIONSETTING_status ON ORG_PERMISSIONSETTING (xstatus);
CREATE INDEX ORG_PERMISSIONSETTING_excludePerson_element ON ORG_PERMISSIONSETTING_excludePerson (xexcludePerson);
CREATE INDEX ORG_PERMISSIONSETTING_excludePerson_join ON ORG_PERMISSIONSETTING_excludePerson (PERMISSIONSETTING_XID);
CREATE INDEX ORG_PERMISSIONSETTING_excludeUnit_element ON ORG_PERMISSIONSETTING_excludeUnit (xexcludeUnit);
CREATE INDEX ORG_PERMISSIONSETTING_excludeUnit_join ON ORG_PERMISSIONSETTING_excludeUnit (PERMISSIONSETTING_XID);
CREATE INDEX ORG_PERMISSIONSETTING_limitQueryAll_element ON ORG_PERMISSIONSETTING_limitQueryAll (xlimitQueryAll);
CREATE INDEX ORG_PERMISSIONSETTING_limitQueryAll_join ON ORG_PERMISSIONSETTING_limitQueryAll (PERMISSIONSETTING_XID);
CREATE INDEX ORG_PERMISSIONSETTING_limitQueryOuter_element ON ORG_PERMISSIONSETTING_limitQueryOuter (xlimitQueryOuter);
CREATE INDEX ORG_PERMISSIONSETTING_limitQueryOuter_join ON ORG_PERMISSIONSETTING_limitQueryOuter (PERMISSIONSETTING_XID);
CREATE INDEX ORG_PERSON_birthday ON ORG_PERSON (xbirthday);
CREATE INDEX ORG_PERSON_description ON ORG_PERSON (xdescription);
CREATE INDEX ORG_PERSON_dingdingHash ON ORG_PERSON (xdingdingHash);
CREATE INDEX ORG_PERSON_dingdingId ON ORG_PERSON (xdingdingId);
CREATE INDEX ORG_PERSON_distinguishedName ON ORG_PERSON (xdistinguishedName);
CREATE INDEX ORG_PERSON_employee ON ORG_PERSON (xemployee);
CREATE INDEX ORG_PERSON_genderType ON ORG_PERSON (xgenderType);
CREATE INDEX ORG_PERSON_lastLoginAddress ON ORG_PERSON (xlastLoginAddress);
CREATE INDEX ORG_PERSON_lastLoginClient ON ORG_PERSON (xlastLoginClient);
CREATE INDEX ORG_PERSON_lastLoginTime ON ORG_PERSON (xlastLoginTime);
CREATE INDEX ORG_PERSON_mail ON ORG_PERSON (xmail);
CREATE INDEX ORG_PERSON_mobile ON ORG_PERSON (xmobile);
CREATE INDEX ORG_PERSON_name ON ORG_PERSON (xname);
CREATE INDEX ORG_PERSON_open1Id ON ORG_PERSON (xopen1Id);
CREATE INDEX ORG_PERSON_open2Id ON ORG_PERSON (xopen2Id);
CREATE INDEX ORG_PERSON_open3Id ON ORG_PERSON (xopen3Id);
CREATE INDEX ORG_PERSON_open4Id ON ORG_PERSON (xopen4Id);
CREATE INDEX ORG_PERSON_open5Id ON ORG_PERSON (xopen5Id);
CREATE INDEX ORG_PERSON_orderNumber ON ORG_PERSON (xorderNumber);
CREATE INDEX ORG_PERSON_pinyin ON ORG_PERSON (xpinyin);
CREATE INDEX ORG_PERSON_pinyinInitial ON ORG_PERSON (xpinyinInitial);
CREATE INDEX ORG_PERSON_qiyeweixinHash ON ORG_PERSON (xqiyeweixinHash);
CREATE INDEX ORG_PERSON_qiyeweixinId ON ORG_PERSON (xqiyeweixinId);
CREATE INDEX ORG_PERSON_qq ON ORG_PERSON (xqq);
CREATE INDEX ORG_PERSON_superior ON ORG_PERSON (xsuperior);
CREATE INDEX ORG_PERSON_unique ON ORG_PERSON (xunique);
CREATE INDEX ORG_PERSON_weixin ON ORG_PERSON (xweixin);
CREATE INDEX ORG_PERSON_zhengwuDingdingHash ON ORG_PERSON (xzhengwuDingdingHash);
CREATE INDEX ORG_PERSON_zhengwuDingdingId ON ORG_PERSON (xzhengwuDingdingId);
CREATE INDEX ORG_PERSONATTRIBUTE_description ON ORG_PERSONATTRIBUTE (xdescription);
CREATE INDEX ORG_PERSONATTRIBUTE_distinguishedName ON ORG_PERSONATTRIBUTE (xdistinguishedName);
CREATE INDEX ORG_PERSONATTRIBUTE_name ON ORG_PERSONATTRIBUTE (xname);
CREATE INDEX ORG_PERSONATTRIBUTE_orderNumber ON ORG_PERSONATTRIBUTE (xorderNumber);
CREATE INDEX ORG_PERSONATTRIBUTE_person ON ORG_PERSONATTRIBUTE (xperson);
CREATE INDEX ORG_PERSONATTRIBUTE_pinyin ON ORG_PERSONATTRIBUTE (xpinyin);
CREATE INDEX ORG_PERSONATTRIBUTE_pinyinInitial ON ORG_PERSONATTRIBUTE (xpinyinInitial);
CREATE INDEX ORG_PERSONATTRIBUTE_unique ON ORG_PERSONATTRIBUTE (xunique);
CREATE INDEX ORG_PERSONATTRIBUTE_attributeList_element ON ORG_PERSONATTRIBUTE_attributeList (xattributeList);
CREATE INDEX ORG_PERSONATTRIBUTE_attributeList_join ON ORG_PERSONATTRIBUTE_attributeList (PERSONATTRIBUTE_XID);
CREATE INDEX ORG_PERSONCARD_address ON ORG_PERSONCARD (xaddress);
CREATE INDEX ORG_PERSONCARD_description ON ORG_PERSONCARD (xdescription);
CREATE INDEX ORG_PERSONCARD_distinguishedName ON ORG_PERSONCARD (xdistinguishedName);
CREATE INDEX ORG_PERSONCARD_extend1 ON ORG_PERSONCARD (xextend1);
CREATE INDEX ORG_PERSONCARD_extend2 ON ORG_PERSONCARD (xextend2);
CREATE INDEX ORG_PERSONCARD_extend3 ON ORG_PERSONCARD (xextend3);
CREATE INDEX ORG_PERSONCARD_genderType ON ORG_PERSONCARD (xgenderType);
CREATE INDEX ORG_PERSONCARD_groupType ON ORG_PERSONCARD (xgroupType);
CREATE INDEX ORG_PERSONCARD_inputTime ON ORG_PERSONCARD (xinputTime);
CREATE INDEX ORG_PERSONCARD_mobile ON ORG_PERSONCARD (xmobile);
CREATE INDEX ORG_PERSONCARD_name ON ORG_PERSONCARD (xname);
CREATE INDEX ORG_PERSONCARD_orderNumber ON ORG_PERSONCARD (xorderNumber);
CREATE INDEX ORG_PERSONCARD_pinyin ON ORG_PERSONCARD (xpinyin);
CREATE INDEX ORG_PERSONCARD_pinyinInitial ON ORG_PERSONCARD (xpinyinInitial);
CREATE INDEX ORG_PERSONCARD_status ON ORG_PERSONCARD (xstatus);
CREATE INDEX ORG_PERSON_controllerList_element ON ORG_PERSON_controllerList (xcontrollerList);
CREATE INDEX ORG_PERSON_controllerList_join ON ORG_PERSON_controllerList (PERSON_XID);
CREATE INDEX ORG_PERSON_topUnitList_element ON ORG_PERSON_topUnitList (xtopUnitList);
CREATE INDEX ORG_PERSON_topUnitList_join ON ORG_PERSON_topUnitList (PERSON_XID);
CREATE INDEX ORG_ROLE_description ON ORG_ROLE (xdescription);
CREATE INDEX ORG_ROLE_distinguishedName ON ORG_ROLE (xdistinguishedName);
CREATE INDEX ORG_ROLE_name ON ORG_ROLE (xname);
CREATE INDEX ORG_ROLE_orderNumber ON ORG_ROLE (xorderNumber);
CREATE INDEX ORG_ROLE_pinyin ON ORG_ROLE (xpinyin);
CREATE INDEX ORG_ROLE_pinyinInitial ON ORG_ROLE (xpinyinInitial);
CREATE INDEX ORG_ROLE_unique ON ORG_ROLE (xunique);
CREATE INDEX ORG_ROLE_groupList_element ON ORG_ROLE_groupList (xgroupList);
CREATE INDEX ORG_ROLE_groupList_join ON ORG_ROLE_groupList (ROLE_XID);
CREATE INDEX ORG_ROLE_personList_element ON ORG_ROLE_personList (xpersonList);
CREATE INDEX ORG_ROLE_personList_join ON ORG_ROLE_personList (ROLE_XID);
CREATE INDEX ORG_UNIT_description ON ORG_UNIT (xdescription);
CREATE INDEX ORG_UNIT_dingdingHash ON ORG_UNIT (xdingdingHash);
CREATE INDEX ORG_UNIT_dingdingId ON ORG_UNIT (xdingdingId);
CREATE INDEX ORG_UNIT_distinguishedName ON ORG_UNIT (xdistinguishedName);
CREATE INDEX ORG_UNIT_level ON ORG_UNIT (xlevel);
CREATE INDEX ORG_UNIT_name ON ORG_UNIT (xname);
CREATE INDEX ORG_UNIT_orderNumber ON ORG_UNIT (xorderNumber);
CREATE INDEX ORG_UNIT_pinyin ON ORG_UNIT (xpinyin);
CREATE INDEX ORG_UNIT_pinyinInitial ON ORG_UNIT (xpinyinInitial);
CREATE INDEX ORG_UNIT_qiyeweixinHash ON ORG_UNIT (xqiyeweixinHash);
CREATE INDEX ORG_UNIT_qiyeweixinId ON ORG_UNIT (xqiyeweixinId);
CREATE INDEX ORG_UNIT_superior ON ORG_UNIT (xsuperior);
CREATE INDEX ORG_UNIT_unique ON ORG_UNIT (xunique);
CREATE INDEX ORG_UNIT_zhengwuDingdingHash ON ORG_UNIT (xzhengwuDingdingHash);
CREATE INDEX ORG_UNIT_zhengwuDingdingId ON ORG_UNIT (xzhengwuDingdingId);
CREATE INDEX ORG_UNITATTRIBUTE_description ON ORG_UNITATTRIBUTE (xdescription);
CREATE INDEX ORG_UNITATTRIBUTE_distinguishedName ON ORG_UNITATTRIBUTE (xdistinguishedName);
CREATE INDEX ORG_UNITATTRIBUTE_name ON ORG_UNITATTRIBUTE (xname);
CREATE INDEX ORG_UNITATTRIBUTE_orderNumber ON ORG_UNITATTRIBUTE (xorderNumber);
CREATE INDEX ORG_UNITATTRIBUTE_pinyin ON ORG_UNITATTRIBUTE (xpinyin);
CREATE INDEX ORG_UNITATTRIBUTE_pinyinInitial ON ORG_UNITATTRIBUTE (xpinyinInitial);
CREATE INDEX ORG_UNITATTRIBUTE_unique ON ORG_UNITATTRIBUTE (xunique);
CREATE INDEX ORG_UNITATTRIBUTE_unit ON ORG_UNITATTRIBUTE (xunit);
CREATE INDEX ORG_UNITATTRIBUTE_attributeList_element ON ORG_UNITATTRIBUTE_attributeList (xattributeList);
CREATE INDEX ORG_UNITATTRIBUTE_attributeList_join ON ORG_UNITATTRIBUTE_attributeList (UNITATTRIBUTE_XID);
CREATE INDEX ORG_UNITDUTY_description ON ORG_UNITDUTY (xdescription);
CREATE INDEX ORG_UNITDUTY_distinguishedName ON ORG_UNITDUTY (xdistinguishedName);
CREATE INDEX ORG_UNITDUTY_name ON ORG_UNITDUTY (xname);
CREATE INDEX ORG_UNITDUTY_orderNumber ON ORG_UNITDUTY (xorderNumber);
CREATE INDEX ORG_UNITDUTY_pinyin ON ORG_UNITDUTY (xpinyin);
CREATE INDEX ORG_UNITDUTY_pinyinInitial ON ORG_UNITDUTY (xpinyinInitial);
CREATE INDEX ORG_UNITDUTY_unique ON ORG_UNITDUTY (xunique);
CREATE INDEX ORG_UNITDUTY_unit ON ORG_UNITDUTY (xunit);
CREATE INDEX ORG_UNITDUTY_identityList_element ON ORG_UNITDUTY_identityList (xidentityList);
CREATE INDEX ORG_UNITDUTY_identityList_join ON ORG_UNITDUTY_identityList (UNITDUTY_XID);
CREATE INDEX ORG_UNITcontrollerList_element ON ORG_UNIT_controllerList (xcontrollerList);
CREATE INDEX ORG_UNIT_controllerList_join ON ORG_UNIT_controllerList (UNIT_XID);
CREATE INDEX ORG_UNIT_inheritedControllerList_element ON ORG_UNIT_inheritedControllerList (xinheritedControllerList);
CREATE INDEX ORG_UNIT_inheritedControllerList_join ON ORG_UNIT_inheritedControllerList (UNIT_XID);
CREATE INDEX ORG_UNIT_typeList_element ON ORG_UNIT_typeList (xtypeList);
CREATE INDEX ORG_UNIT_typeList_join ON ORG_UNIT_typeList (UNIT_XID);
CREATE INDEX PP_C_ATTACHMENT_activity ON PP_C_ATTACHMENT (xactivity);
CREATE INDEX PP_C_ATTACHMENT_activityName ON PP_C_ATTACHMENT (xactivityName);
CREATE INDEX PP_C_ATTACHMENT_activityToken ON PP_C_ATTACHMENT (xactivityToken);
CREATE INDEX PP_C_ATTACHMENT_activityType ON PP_C_ATTACHMENT (xactivityType);
CREATE INDEX PP_C_ATTACHMENT_application ON PP_C_ATTACHMENT (xapplication);
CREATE INDEX PP_C_ATTACHMENT_completed ON PP_C_ATTACHMENT (xcompleted);
CREATE INDEX PP_C_ATTACHMENT_deepPath ON PP_C_ATTACHMENT (xdeepPath);
CREATE INDEX PP_C_ATTACHMENT_job ON PP_C_ATTACHMENT (xjob);
CREATE INDEX PP_C_ATTACHMENT_lastUpdatePerson ON PP_C_ATTACHMENT (xlastUpdatePerson);
CREATE INDEX PP_C_ATTACHMENT_lastUpdateTime ON PP_C_ATTACHMENT (xlastUpdateTime);
CREATE INDEX PP_C_ATTACHMENT_length ON PP_C_ATTACHMENT (xlength);
CREATE INDEX PP_C_ATTACHMENT_name ON PP_C_ATTACHMENT (xname);
CREATE INDEX PP_C_ATTACHMENT_orderNumber ON PP_C_ATTACHMENT (xorderNumber);
CREATE INDEX PP_C_ATTACHMENT_person ON PP_C_ATTACHMENT (xperson);
CREATE INDEX PP_C_ATTACHMENT_process ON PP_C_ATTACHMENT (xprocess);
CREATE INDEX PP_C_ATTACHMENT_storage ON PP_C_ATTACHMENT (xstorage);
CREATE INDEX PP_C_ATTACHMENT_work ON PP_C_ATTACHMENT (xwork);
CREATE INDEX PP_C_ATTACHMENT_workCompleted ON PP_C_ATTACHMENT (xworkCompleted);
CREATE INDEX PP_C_ATTACHMENT_workCreateTime ON PP_C_ATTACHMENT (xworkCreateTime);
CREATE INDEX PP_C_ATTACHMENT_controllerIdentityList_element ON PP_C_ATTACHMENT_controllerIdentityList (xcontrollerIdentityList);
CREATE INDEX PP_C_ATTACHMENT_controllerIdentityList_join ON PP_C_ATTACHMENT_controllerIdentityList (ATTACHMENT_XID);
CREATE INDEX PP_C_ATTACHMENT_controllerUnitList_element ON PP_C_ATTACHMENT_controllerUnitList (xcontrollerUnitList);
CREATE INDEX PP_C_ATTACHMENT_controllerUnitList_join ON PP_C_ATTACHMENT_controllerUnitList (ATTACHMENT_XID);
CREATE INDEX PP_C_ATTACHMENT_divisionList_element ON PP_C_ATTACHMENT_divisionList (xdivisionList);
CREATE INDEX PP_C_ATTACHMENT_divisionList_join ON PP_C_ATTACHMENT_divisionList (ATTACHMENT_XID);
CREATE INDEX PP_C_ATTACHMENT_editIdentityList_element ON PP_C_ATTACHMENT_editIdentityList (xeditIdentityList);
CREATE INDEX PP_C_ATTACHMENT_editIdentityList_join ON PP_C_ATTACHMENT_editIdentityList (ATTACHMENT_XID);
CREATE INDEX PP_C_ATTACHMENT_editUnitList_element ON PP_C_ATTACHMENT_editUnitList (xeditUnitList);
CREATE INDEX PP_C_ATTACHMENT_editUnitList_join ON PP_C_ATTACHMENT_editUnitList (ATTACHMENT_XID);
CREATE INDEX PP_C_ATTACHMENT_readIdentityList_element ON PP_C_ATTACHMENT_readIdentityList (xreadIdentityList);
CREATE INDEX PP_C_ATTACHMENT_readIdentityList_join ON PP_C_ATTACHMENT_readIdentityList (ATTACHMENT_XID);
CREATE INDEX PP_C_ATTACHMENT_readUnitList_element ON PP_C_ATTACHMENT_readUnitList (xreadUnitList);
CREATE INDEX PP_C_ATTACHMENT_readUnitList_join ON PP_C_ATTACHMENT_readUnitList (ATTACHMENT_XID);
CREATE INDEX PP_C_DOCUMENTVERSION_activity ON PP_C_DOCUMENTVERSION (xactivity);
CREATE INDEX PP_C_DOCUMENTVERSION_activityAlias ON PP_C_DOCUMENTVERSION (xactivityAlias);
CREATE INDEX PP_C_DOCUMENTVERSION_activityDescription ON PP_C_DOCUMENTVERSION (xactivityDescription);
CREATE INDEX PP_C_DOCUMENTVERSION_activityName ON PP_C_DOCUMENTVERSION (xactivityName);
CREATE INDEX PP_C_DOCUMENTVERSION_activityToken ON PP_C_DOCUMENTVERSION (xactivityToken);
CREATE INDEX PP_C_DOCUMENTVERSION_activityType ON PP_C_DOCUMENTVERSION (xactivityType);
CREATE INDEX PP_C_DOCUMENTVERSION_application ON PP_C_DOCUMENTVERSION (xapplication);
CREATE INDEX PP_C_DOCUMENTVERSION_category ON PP_C_DOCUMENTVERSION (xcategory);
CREATE INDEX PP_C_DOCUMENTVERSION_completed ON PP_C_DOCUMENTVERSION (xcompleted);
CREATE INDEX PP_C_DOCUMENTVERSION_job ON PP_C_DOCUMENTVERSION (xjob);
CREATE INDEX PP_C_DOCUMENTVERSION_person ON PP_C_DOCUMENTVERSION (xperson);
CREATE INDEX PP_C_DOCUMENTVERSION_process ON PP_C_DOCUMENTVERSION (xprocess);
CREATE INDEX PP_C_DRAFT_application ON PP_C_DRAFT (xapplication);
CREATE INDEX PP_C_DRAFT_applicationAlias ON PP_C_DRAFT (xapplicationAlias);
CREATE INDEX PP_C_DRAFT_applicationName ON PP_C_DRAFT (xapplicationName);
CREATE INDEX PP_C_DRAFT_identity ON PP_C_DRAFT (xidentity);
CREATE INDEX PP_C_DRAFT_person ON PP_C_DRAFT (xperson);
CREATE INDEX PP_C_DRAFT_process ON PP_C_DRAFT (xprocess);
CREATE INDEX PP_C_DRAFT_processAlias ON PP_C_DRAFT (xprocessAlias);
CREATE INDEX PP_C_DRAFT_processName ON PP_C_DRAFT (xprocessName);
CREATE INDEX PP_C_DRAFT_title ON PP_C_DRAFT (xtitle);
CREATE INDEX PP_C_DRAFT_unit ON PP_C_DRAFT (xunit);
CREATE INDEX PP_C_KEYLOCK_key ON PP_C_KEYLOCK (xkey);
CREATE INDEX PP_C_KEYLOCK_person ON PP_C_KEYLOCK (xperson);
CREATE INDEX PP_C_READ_activity ON PP_C_READ (xactivity);
CREATE INDEX PP_C_READ_activityAlias ON PP_C_READ (xactivityAlias);
CREATE INDEX PP_C_READ_activityDescription ON PP_C_READ (xactivityDescription);
CREATE INDEX PP_C_READ_activityName ON PP_C_READ (xactivityName);
CREATE INDEX PP_C_READ_activityToken ON PP_C_READ (xactivityToken);
CREATE INDEX PP_C_READ_activityType ON PP_C_READ (xactivityType);
CREATE INDEX PP_C_READ_application ON PP_C_READ (xapplication);
CREATE INDEX PP_C_READ_applicationAlias ON PP_C_READ (xapplicationAlias);
CREATE INDEX PP_C_READ_applicationName ON PP_C_READ (xapplicationName);
CREATE INDEX PP_C_READ_booleanValue01 ON PP_C_READ (xbooleanValue01);
CREATE INDEX PP_C_READ_booleanValue02 ON PP_C_READ (xbooleanValue02);
CREATE INDEX PP_C_READ_completed ON PP_C_READ (xcompleted);
CREATE INDEX PP_C_READ_creatorIdentity ON PP_C_READ (xcreatorIdentity);
CREATE INDEX PP_C_READ_creatorPerson ON PP_C_READ (xcreatorPerson);
CREATE INDEX PP_C_READ_creatorUnit ON PP_C_READ (xcreatorUnit);
CREATE INDEX PP_C_READ_currentActivityName ON PP_C_READ (xcurrentActivityName);
CREATE INDEX PP_C_READ_dateTimeValue01 ON PP_C_READ (xdateTimeValue01);
CREATE INDEX PP_C_READ_dateTimeValue02 ON PP_C_READ (xdateTimeValue02);
CREATE INDEX PP_C_READ_dateTimeValue03 ON PP_C_READ (xdateTimeValue03);
CREATE INDEX PP_C_READ_dateTimeValue04 ON PP_C_READ (xdateTimeValue04);
CREATE INDEX PP_C_READ_dateTimeValue05 ON PP_C_READ (xdateTimeValue05);
CREATE INDEX PP_C_READ_dateValue01 ON PP_C_READ (xdateValue01);
CREATE INDEX PP_C_READ_dateValue02 ON PP_C_READ (xdateValue02);
CREATE INDEX PP_C_READ_doubleValue01 ON PP_C_READ (xdoubleValue01);
CREATE INDEX PP_C_READ_doubleValue02 ON PP_C_READ (xdoubleValue02);
CREATE INDEX PP_C_READ_doubleValue03 ON PP_C_READ (xdoubleValue03);
CREATE INDEX PP_C_READ_doubleValue04 ON PP_C_READ (xdoubleValue04);
CREATE INDEX PP_C_READ_doubleValue05 ON PP_C_READ (xdoubleValue05);
CREATE INDEX PP_C_READ_identity ON PP_C_READ (xidentity);
CREATE INDEX PP_C_READ_job ON PP_C_READ (xjob);
CREATE INDEX PP_C_READ_longValue01 ON PP_C_READ (xlongValue01);
CREATE INDEX PP_C_READ_longValue02 ON PP_C_READ (xlongValue02);
CREATE INDEX PP_C_READ_longValue03 ON PP_C_READ (xlongValue03);
CREATE INDEX PP_C_READ_longValue04 ON PP_C_READ (xlongValue04);
CREATE INDEX PP_C_READ_longValue05 ON PP_C_READ (xlongValue05);
CREATE INDEX PP_C_READ_opinion ON PP_C_READ (xopinion);
CREATE INDEX PP_C_READ_person ON PP_C_READ (xperson);
CREATE INDEX PP_C_READ_process ON PP_C_READ (xprocess);
CREATE INDEX PP_C_READ_processAlias ON PP_C_READ (xprocessAlias);
CREATE INDEX PP_C_READ_processName ON PP_C_READ (xprocessName);
CREATE INDEX PP_C_READ_serial ON PP_C_READ (xserial);
CREATE INDEX PP_C_READ_startTime ON PP_C_READ (xstartTime);
CREATE INDEX PP_C_READ_startTimeMonth ON PP_C_READ (xstartTimeMonth);
CREATE INDEX PP_C_READ_stringValue01 ON PP_C_READ (xstringValue01);
CREATE INDEX PP_C_READ_stringValue02 ON PP_C_READ (xstringValue02);
CREATE INDEX PP_C_READ_stringValue03 ON PP_C_READ (xstringValue03);
CREATE INDEX PP_C_READ_stringValue04 ON PP_C_READ (xstringValue04);
CREATE INDEX PP_C_READ_stringValue05 ON PP_C_READ (xstringValue05);
CREATE INDEX PP_C_READ_stringValue06 ON PP_C_READ (xstringValue06);
CREATE INDEX PP_C_READ_stringValue07 ON PP_C_READ (xstringValue07);
CREATE INDEX PP_C_READ_stringValue08 ON PP_C_READ (xstringValue08);
CREATE INDEX PP_C_READ_stringValue09 ON PP_C_READ (xstringValue09);
CREATE INDEX PP_C_READ_stringValue10 ON PP_C_READ (xstringValue10);
CREATE INDEX PP_C_READ_timeValue01 ON PP_C_READ (xtimeValue01);
CREATE INDEX PP_C_READ_timeValue02 ON PP_C_READ (xtimeValue02);
CREATE INDEX PP_C_READ_title ON PP_C_READ (xtitle);
CREATE INDEX PP_C_READ_unit ON PP_C_READ (xunit);
CREATE INDEX PP_C_READ_viewed ON PP_C_READ (xviewed);
CREATE INDEX PP_C_READ_work ON PP_C_READ (xwork);
CREATE INDEX PP_C_READ_workCompleted ON PP_C_READ (xworkCompleted);
CREATE INDEX PP_C_READCOMPLETED_activity ON PP_C_READCOMPLETED (xactivity);
CREATE INDEX PP_C_READCOMPLETED_activityAlias ON PP_C_READCOMPLETED (xactivityAlias);
CREATE INDEX PP_C_READCOMPLETED_activityDescription ON PP_C_READCOMPLETED (xactivityDescription);
CREATE INDEX PP_C_READCOMPLETED_activityName ON PP_C_READCOMPLETED (xactivityName);
CREATE INDEX PP_C_READCOMPLETED_activityToken ON PP_C_READCOMPLETED (xactivityToken);
CREATE INDEX PP_C_READCOMPLETED_activityType ON PP_C_READCOMPLETED (xactivityType);
CREATE INDEX PP_C_READCOMPLETED_application ON PP_C_READCOMPLETED (xapplication);
CREATE INDEX PP_C_READCOMPLETED_applicationAlias ON PP_C_READCOMPLETED (xapplicationAlias);
CREATE INDEX PP_C_READCOMPLETED_applicationName ON PP_C_READCOMPLETED (xapplicationName);
CREATE INDEX PP_C_READCOMPLETED_booleanValue01 ON PP_C_READCOMPLETED (xbooleanValue01);
CREATE INDEX PP_C_READCOMPLETED_booleanValue02 ON PP_C_READCOMPLETED (xbooleanValue02);
CREATE INDEX PP_C_READCOMPLETED_completed ON PP_C_READCOMPLETED (xcompleted);
CREATE INDEX PP_C_READCOMPLETED_completedTime ON PP_C_READCOMPLETED (xcompletedTime);
CREATE INDEX PP_C_READCOMPLETED_completedTimeMonth ON PP_C_READCOMPLETED (xcompletedTimeMonth);
CREATE INDEX PP_C_READCOMPLETED_creatorIdentity ON PP_C_READCOMPLETED (xcreatorIdentity);
CREATE INDEX PP_C_READCOMPLETED_creatorPerson ON PP_C_READCOMPLETED (xcreatorPerson);
CREATE INDEX PP_C_READCOMPLETED_creatorUnit ON PP_C_READCOMPLETED (xcreatorUnit);
CREATE INDEX PP_C_READCOMPLETED_currentActivityName ON PP_C_READCOMPLETED (xcurrentActivityName);
CREATE INDEX PP_C_READCOMPLETED_dateTimeValue01 ON PP_C_READCOMPLETED (xdateTimeValue01);
CREATE INDEX PP_C_READCOMPLETED_dateTimeValue02 ON PP_C_READCOMPLETED (xdateTimeValue02);
CREATE INDEX PP_C_READCOMPLETED_dateTimeValue03 ON PP_C_READCOMPLETED (xdateTimeValue03);
CREATE INDEX PP_C_READCOMPLETED_dateTimeValue04 ON PP_C_READCOMPLETED (xdateTimeValue04);
CREATE INDEX PP_C_READCOMPLETED_dateTimeValue05 ON PP_C_READCOMPLETED (xdateTimeValue05);
CREATE INDEX PP_C_READCOMPLETED_dateValue01 ON PP_C_READCOMPLETED (xdateValue01);
CREATE INDEX PP_C_READCOMPLETED_dateValue02 ON PP_C_READCOMPLETED (xdateValue02);
CREATE INDEX PP_C_READCOMPLETED_doubleValue01 ON PP_C_READCOMPLETED (xdoubleValue01);
CREATE INDEX PP_C_READCOMPLETED_doubleValue02 ON PP_C_READCOMPLETED (xdoubleValue02);
CREATE INDEX PP_C_READCOMPLETED_doubleValue03 ON PP_C_READCOMPLETED (xdoubleValue03);
CREATE INDEX PP_C_READCOMPLETED_doubleValue04 ON PP_C_READCOMPLETED (xdoubleValue04);
CREATE INDEX PP_C_READCOMPLETED_doubleValue05 ON PP_C_READCOMPLETED (xdoubleValue05);
CREATE INDEX PP_C_READCOMPLETED_identity ON PP_C_READCOMPLETED (xidentity);
CREATE INDEX PP_C_READCOMPLETED_job ON PP_C_READCOMPLETED (xjob);
CREATE INDEX PP_C_READCOMPLETED_longValue01 ON PP_C_READCOMPLETED (xlongValue01);
CREATE INDEX PP_C_READCOMPLETED_longValue02 ON PP_C_READCOMPLETED (xlongValue02);
CREATE INDEX PP_C_READCOMPLETED_longValue03 ON PP_C_READCOMPLETED (xlongValue03);
CREATE INDEX PP_C_READCOMPLETED_longValue04 ON PP_C_READCOMPLETED (xlongValue04);
CREATE INDEX PP_C_READCOMPLETED_longValue05 ON PP_C_READCOMPLETED (xlongValue05);
CREATE INDEX PP_C_READCOMPLETED_opinion ON PP_C_READCOMPLETED (xopinion);
CREATE INDEX PP_C_READCOMPLETED_person ON PP_C_READCOMPLETED (xperson);
CREATE INDEX PP_C_READCOMPLETED_process ON PP_C_READCOMPLETED (xprocess);
CREATE INDEX PP_C_READCOMPLETED_processAlias ON PP_C_READCOMPLETED (xprocessAlias);
CREATE INDEX PP_C_READCOMPLETED_processName ON PP_C_READCOMPLETED (xprocessName);
CREATE INDEX PP_C_READCOMPLETED_read ON PP_C_READCOMPLETED (xread);
CREATE INDEX PP_C_READCOMPLETED_serial ON PP_C_READCOMPLETED (xserial);
CREATE INDEX PP_C_READCOMPLETED_startTime ON PP_C_READCOMPLETED (xstartTime);
CREATE INDEX PP_C_READCOMPLETED_startTimeMonth ON PP_C_READCOMPLETED (xstartTimeMonth);
CREATE INDEX PP_C_READCOMPLETED_stringValue01 ON PP_C_READCOMPLETED (xstringValue01);
CREATE INDEX PP_C_READCOMPLETED_stringValue02 ON PP_C_READCOMPLETED (xstringValue02);
CREATE INDEX PP_C_READCOMPLETED_stringValue03 ON PP_C_READCOMPLETED (xstringValue03);
CREATE INDEX PP_C_READCOMPLETED_stringValue04 ON PP_C_READCOMPLETED (xstringValue04);
CREATE INDEX PP_C_READCOMPLETED_stringValue05 ON PP_C_READCOMPLETED (xstringValue05);
CREATE INDEX PP_C_READCOMPLETED_stringValue06 ON PP_C_READCOMPLETED (xstringValue06);
CREATE INDEX PP_C_READCOMPLETED_stringValue07 ON PP_C_READCOMPLETED (xstringValue07);
CREATE INDEX PP_C_READCOMPLETED_stringValue08 ON PP_C_READCOMPLETED (xstringValue08);
CREATE INDEX PP_C_READCOMPLETED_stringValue09 ON PP_C_READCOMPLETED (xstringValue09);
CREATE INDEX PP_C_READCOMPLETED_stringValue10 ON PP_C_READCOMPLETED (xstringValue10);
CREATE INDEX PP_C_READCOMPLETED_timeValue01 ON PP_C_READCOMPLETED (xtimeValue01);
CREATE INDEX PP_C_READCOMPLETED_timeValue02 ON PP_C_READCOMPLETED (xtimeValue02);
CREATE INDEX PP_C_READCOMPLETED_title ON PP_C_READCOMPLETED (xtitle);
CREATE INDEX PP_C_READCOMPLETED_unit ON PP_C_READCOMPLETED (xunit);
CREATE INDEX PP_C_READCOMPLETED_work ON PP_C_READCOMPLETED (xwork);
CREATE INDEX PP_C_READCOMPLETED_workCompleted ON PP_C_READCOMPLETED (xworkCompleted);
CREATE INDEX PP_C_Record_application ON PP_C_Record (xapplication);
CREATE INDEX PP_C_Record_arrivedActivity ON PP_C_Record (xarrivedActivity);
CREATE INDEX PP_C_Record_arrivedActivityAlias ON PP_C_Record (xarrivedActivityAlias);
CREATE INDEX PP_C_Record_arrivedActivityName ON PP_C_Record (xarrivedActivityName);
CREATE INDEX PP_C_Record_arrivedActivityToken ON PP_C_Record (xarrivedActivityToken);
CREATE INDEX PP_C_Record_arrivedActivityType ON PP_C_Record (xarrivedActivityType);
CREATE INDEX PP_C_Record_completed ON PP_C_Record (xcompleted);
CREATE INDEX PP_C_Record_display ON PP_C_Record (xdisplay);
CREATE INDEX PP_C_Record_fromActivity ON PP_C_Record (xfromActivity);
CREATE INDEX PP_C_Record_fromActivityAlias ON PP_C_Record (xfromActivityAlias);
CREATE INDEX PP_C_Record_fromActivityName ON PP_C_Record (xfromActivityName);
CREATE INDEX PP_C_Record_fromActivityToken ON PP_C_Record (xfromActivityToken);
CREATE INDEX PP_C_Record_fromActivityType ON PP_C_Record (xfromActivityType);
CREATE INDEX PP_C_Record_identity ON PP_C_Record (xidentity);
CREATE INDEX PP_C_Record_job ON PP_C_Record (xjob);
CREATE INDEX PP_C_Record_order ON PP_C_Record (xorder);
CREATE INDEX PP_C_Record_person ON PP_C_Record (xperson);
CREATE INDEX PP_C_Record_process ON PP_C_Record (xprocess);
CREATE INDEX PP_C_Record_recordTime ON PP_C_Record (xrecordTime);
CREATE INDEX PP_C_Record_type ON PP_C_Record (xtype);
CREATE INDEX PP_C_Record_unit ON PP_C_Record (xunit);
CREATE INDEX PP_C_Record_work ON PP_C_Record (xwork);
CREATE INDEX PP_C_Record_workCompleted ON PP_C_Record (xworkCompleted);
CREATE INDEX PP_C_REVIEW_application ON PP_C_REVIEW (xapplication);
CREATE INDEX PP_C_REVIEW_applicationAlias ON PP_C_REVIEW (xapplicationAlias);
CREATE INDEX PP_C_REVIEW_applicationName ON PP_C_REVIEW (xapplicationName);
CREATE INDEX PP_C_REVIEW_booleanValue01 ON PP_C_REVIEW (xbooleanValue01);
CREATE INDEX PP_C_REVIEW_booleanValue02 ON PP_C_REVIEW (xbooleanValue02);
CREATE INDEX PP_C_REVIEW_completed ON PP_C_REVIEW (xcompleted);
CREATE INDEX PP_C_REVIEW_completedTime ON PP_C_REVIEW (xcompletedTime);
CREATE INDEX PP_C_REVIEW_completedTimeMonth ON PP_C_REVIEW (xcompletedTimeMonth);
CREATE INDEX PP_C_REVIEW_creatorIdentity ON PP_C_REVIEW (xcreatorIdentity);
CREATE INDEX PP_C_REVIEW_creatorPerson ON PP_C_REVIEW (xcreatorPerson);
CREATE INDEX PP_C_REVIEW_creatorUnit ON PP_C_REVIEW (xcreatorUnit);
CREATE INDEX PP_C_REVIEW_currentActivityName ON PP_C_REVIEW (xcurrentActivityName);
CREATE INDEX PP_C_REVIEW_dateTimeValue01 ON PP_C_REVIEW (xdateTimeValue01);
CREATE INDEX PP_C_REVIEW_dateTimeValue02 ON PP_C_REVIEW (xdateTimeValue02);
CREATE INDEX PP_C_REVIEW_dateTimeValue03 ON PP_C_REVIEW (xdateTimeValue03);
CREATE INDEX PP_C_REVIEW_dateTimeValue04 ON PP_C_REVIEW (xdateTimeValue04);
CREATE INDEX PP_C_REVIEW_dateTimeValue05 ON PP_C_REVIEW (xdateTimeValue05);
CREATE INDEX PP_C_REVIEW_dateValue01 ON PP_C_REVIEW (xdateValue01);
CREATE INDEX PP_C_REVIEW_dateValue02 ON PP_C_REVIEW (xdateValue02);
CREATE INDEX PP_C_REVIEW_doubleValue01 ON PP_C_REVIEW (xdoubleValue01);
CREATE INDEX PP_C_REVIEW_doubleValue02 ON PP_C_REVIEW (xdoubleValue02);
CREATE INDEX PP_C_REVIEW_doubleValue03 ON PP_C_REVIEW (xdoubleValue03);
CREATE INDEX PP_C_REVIEW_doubleValue04 ON PP_C_REVIEW (xdoubleValue04);
CREATE INDEX PP_C_REVIEW_doubleValue05 ON PP_C_REVIEW (xdoubleValue05);
CREATE INDEX PP_C_REVIEW_job ON PP_C_REVIEW (xjob);
CREATE INDEX PP_C_REVIEW_longValue01 ON PP_C_REVIEW (xlongValue01);
CREATE INDEX PP_C_REVIEW_longValue02 ON PP_C_REVIEW (xlongValue02);
CREATE INDEX PP_C_REVIEW_longValue03 ON PP_C_REVIEW (xlongValue03);
CREATE INDEX PP_C_REVIEW_longValue04 ON PP_C_REVIEW (xlongValue04);
CREATE INDEX PP_C_REVIEW_longValue05 ON PP_C_REVIEW (xlongValue05);
CREATE INDEX PP_C_REVIEW_person ON PP_C_REVIEW (xperson);
CREATE INDEX PP_C_REVIEW_process ON PP_C_REVIEW (xprocess);
CREATE INDEX PP_C_REVIEW_processAlias ON PP_C_REVIEW (xprocessAlias);
CREATE INDEX PP_C_REVIEW_processName ON PP_C_REVIEW (xprocessName);
CREATE INDEX PP_C_REVIEW_serial ON PP_C_REVIEW (xserial);
CREATE INDEX PP_C_REVIEW_startTime ON PP_C_REVIEW (xstartTime);
CREATE INDEX PP_C_REVIEW_startTimeMonth ON PP_C_REVIEW (xstartTimeMonth);
CREATE INDEX PP_C_REVIEW_stringValue01 ON PP_C_REVIEW (xstringValue01);
CREATE INDEX PP_C_REVIEW_stringValue02 ON PP_C_REVIEW (xstringValue02);
CREATE INDEX PP_C_REVIEW_stringValue03 ON PP_C_REVIEW (xstringValue03);
CREATE INDEX PP_C_REVIEW_stringValue04 ON PP_C_REVIEW (xstringValue04);
CREATE INDEX PP_C_REVIEW_stringValue05 ON PP_C_REVIEW (xstringValue05);
CREATE INDEX PP_C_REVIEW_stringValue06 ON PP_C_REVIEW (xstringValue06);
CREATE INDEX PP_C_REVIEW_stringValue07 ON PP_C_REVIEW (xstringValue07);
CREATE INDEX PP_C_REVIEW_stringValue08 ON PP_C_REVIEW (xstringValue08);
CREATE INDEX PP_C_REVIEW_stringValue09 ON PP_C_REVIEW (xstringValue09);
CREATE INDEX PP_C_REVIEW_stringValue10 ON PP_C_REVIEW (xstringValue10);
CREATE INDEX PP_C_REVIEW_timeValue01 ON PP_C_REVIEW (xtimeValue01);
CREATE INDEX PP_C_REVIEW_timeValue02 ON PP_C_REVIEW (xtimeValue02);
CREATE INDEX PP_C_REVIEW_title ON PP_C_REVIEW (xtitle);
CREATE INDEX PP_C_REVIEW_work ON PP_C_REVIEW (xwork);
CREATE INDEX PP_C_REVIEW_workCompleted ON PP_C_REVIEW (xworkCompleted);
CREATE INDEX PP_C_SERIALNUMBER_application ON PP_C_SERIALNUMBER (xapplication);
CREATE INDEX PP_C_SERIALNUMBER_name ON PP_C_SERIALNUMBER (xname);
CREATE INDEX PP_C_SERIALNUMBER_process ON PP_C_SERIALNUMBER (xprocess);
CREATE INDEX PP_C_SERIALNUMBER_serial ON PP_C_SERIALNUMBER (xserial);
CREATE INDEX PP_C_TASK_activity ON PP_C_TASK (xactivity);
CREATE INDEX PP_C_TASK_activityAlias ON PP_C_TASK (xactivityAlias);
CREATE INDEX PP_C_TASK_activityDescription ON PP_C_TASK (xactivityDescription);
CREATE INDEX PP_C_TASK_activityName ON PP_C_TASK (xactivityName);
CREATE INDEX PP_C_TASK_activityToken ON PP_C_TASK (xactivityToken);
CREATE INDEX PP_C_TASK_activityType ON PP_C_TASK (xactivityType);
CREATE INDEX PP_C_TASK_application ON PP_C_TASK (xapplication);
CREATE INDEX PP_C_TASK_applicationAlias ON PP_C_TASK (xapplicationAlias);
CREATE INDEX PP_C_TASK_applicationName ON PP_C_TASK (xapplicationName);
CREATE INDEX PP_C_TASK_booleanValue01 ON PP_C_TASK (xbooleanValue01);
CREATE INDEX PP_C_TASK_booleanValue02 ON PP_C_TASK (xbooleanValue02);
CREATE INDEX PP_C_TASK_creatorIdentity ON PP_C_TASK (xcreatorIdentity);
CREATE INDEX PP_C_TASK_creatorPerson ON PP_C_TASK (xcreatorPerson);
CREATE INDEX PP_C_TASK_creatorUnit ON PP_C_TASK (xcreatorUnit);
CREATE INDEX PP_C_TASK_dateTimeValue01 ON PP_C_TASK (xdateTimeValue01);
CREATE INDEX PP_C_TASK_dateTimeValue02 ON PP_C_TASK (xdateTimeValue02);
CREATE INDEX PP_C_TASK_dateTimeValue03 ON PP_C_TASK (xdateTimeValue03);
CREATE INDEX PP_C_TASK_dateTimeValue04 ON PP_C_TASK (xdateTimeValue04);
CREATE INDEX PP_C_TASK_dateTimeValue05 ON PP_C_TASK (xdateTimeValue05);
CREATE INDEX PP_C_TASK_dateValue01 ON PP_C_TASK (xdateValue01);
CREATE INDEX PP_C_TASK_dateValue02 ON PP_C_TASK (xdateValue02);
CREATE INDEX PP_C_TASK_doubleValue01 ON PP_C_TASK (xdoubleValue01);
CREATE INDEX PP_C_TASK_doubleValue02 ON PP_C_TASK (xdoubleValue02);
CREATE INDEX PP_C_TASK_doubleValue03 ON PP_C_TASK (xdoubleValue03);
CREATE INDEX PP_C_TASK_doubleValue04 ON PP_C_TASK (xdoubleValue04);
CREATE INDEX PP_C_TASK_doubleValue05 ON PP_C_TASK (xdoubleValue05);
CREATE INDEX PP_C_TASK_empowerFromIdentity ON PP_C_TASK (xempowerFromIdentity);
CREATE INDEX PP_C_TASK_expired ON PP_C_TASK (xexpired);
CREATE INDEX PP_C_TASK_expireTime ON PP_C_TASK (xexpireTime);
CREATE INDEX PP_C_TASK_identity ON PP_C_TASK (xidentity);
CREATE INDEX PP_C_TASK_job ON PP_C_TASK (xjob);
CREATE INDEX PP_C_TASK_longValue01 ON PP_C_TASK (xlongValue01);
CREATE INDEX PP_C_TASK_longValue02 ON PP_C_TASK (xlongValue02);
CREATE INDEX PP_C_TASK_longValue03 ON PP_C_TASK (xlongValue03);
CREATE INDEX PP_C_TASK_longValue04 ON PP_C_TASK (xlongValue04);
CREATE INDEX PP_C_TASK_longValue05 ON PP_C_TASK (xlongValue05);
CREATE INDEX PP_C_TASK_modified ON PP_C_TASK (xmodified);
CREATE INDEX PP_C_TASK_opinion ON PP_C_TASK (xopinion);
CREATE INDEX PP_C_TASK_person ON PP_C_TASK (xperson);
CREATE INDEX PP_C_TASK_process ON PP_C_TASK (xprocess);
CREATE INDEX PP_C_TASK_processAlias ON PP_C_TASK (xprocessAlias);
CREATE INDEX PP_C_TASK_processName ON PP_C_TASK (xprocessName);
CREATE INDEX PP_C_TASK_serial ON PP_C_TASK (xserial);
CREATE INDEX PP_C_TASK_series ON PP_C_TASK (xseries);
CREATE INDEX PP_C_TASK_startTime ON PP_C_TASK (xstartTime);
CREATE INDEX PP_C_TASK_startTimeMonth ON PP_C_TASK (xstartTimeMonth);
CREATE INDEX PP_C_TASK_stringValue01 ON PP_C_TASK (xstringValue01);
CREATE INDEX PP_C_TASK_stringValue02 ON PP_C_TASK (xstringValue02);
CREATE INDEX PP_C_TASK_stringValue03 ON PP_C_TASK (xstringValue03);
CREATE INDEX PP_C_TASK_stringValue04 ON PP_C_TASK (xstringValue04);
CREATE INDEX PP_C_TASK_stringValue05 ON PP_C_TASK (xstringValue05);
CREATE INDEX PP_C_TASK_stringValue06 ON PP_C_TASK (xstringValue06);
CREATE INDEX PP_C_TASK_stringValue07 ON PP_C_TASK (xstringValue07);
CREATE INDEX PP_C_TASK_stringValue08 ON PP_C_TASK (xstringValue08);
CREATE INDEX PP_C_TASK_stringValue09 ON PP_C_TASK (xstringValue09);
CREATE INDEX PP_C_TASK_stringValue10 ON PP_C_TASK (xstringValue10);
CREATE INDEX PP_C_TASK_timeValue01 ON PP_C_TASK (xtimeValue01);
CREATE INDEX PP_C_TASK_timeValue02 ON PP_C_TASK (xtimeValue02);
CREATE INDEX PP_C_TASK_title ON PP_C_TASK (xtitle);
CREATE INDEX PP_C_TASK_unit ON PP_C_TASK (xunit);
CREATE INDEX PP_C_TASK_urged ON PP_C_TASK (xurged);
CREATE INDEX PP_C_TASK_urgeTime ON PP_C_TASK (xurgeTime);
CREATE INDEX PP_C_TASK_viewed ON PP_C_TASK (xviewed);
CREATE INDEX PP_C_TASK_work ON PP_C_TASK (xwork);
CREATE INDEX PP_C_TASK_workCreateType ON PP_C_TASK (xworkCreateType);
CREATE INDEX PP_C_TASKCOMPLETED_activity ON PP_C_TASKCOMPLETED (xactivity);
CREATE INDEX PP_C_TASKCOMPLETED_activityAlias ON PP_C_TASKCOMPLETED (xactivityAlias);
CREATE INDEX PP_C_TASKCOMPLETED_activityDescription ON PP_C_TASKCOMPLETED (xactivityDescription);
CREATE INDEX PP_C_TASKCOMPLETED_activityName ON PP_C_TASKCOMPLETED (xactivityName);
CREATE INDEX PP_C_TASKCOMPLETED_activityToken ON PP_C_TASKCOMPLETED (xactivityToken);
CREATE INDEX PP_C_TASKCOMPLETED_activityType ON PP_C_TASKCOMPLETED (xactivityType);
CREATE INDEX PP_C_TASKCOMPLETED_application ON PP_C_TASKCOMPLETED (xapplication);
CREATE INDEX PP_C_TASKCOMPLETED_applicationAlias ON PP_C_TASKCOMPLETED (xapplicationAlias);
CREATE INDEX PP_C_TASKCOMPLETED_applicationName ON PP_C_TASKCOMPLETED (xapplicationName);
CREATE INDEX PP_C_TASKCOMPLETED_booleanValue01 ON PP_C_TASKCOMPLETED (xbooleanValue01);
CREATE INDEX PP_C_TASKCOMPLETED_booleanValue02 ON PP_C_TASKCOMPLETED (xbooleanValue02);
CREATE INDEX PP_C_TASKCOMPLETED_completed ON PP_C_TASKCOMPLETED (xcompleted);
CREATE INDEX PP_C_TASKCOMPLETED_completedTime ON PP_C_TASKCOMPLETED (xcompletedTime);
CREATE INDEX PP_C_TASKCOMPLETED_completedTimeMonth ON PP_C_TASKCOMPLETED (xcompletedTimeMonth);
CREATE INDEX PP_C_TASKCOMPLETED_creatorIdentity ON PP_C_TASKCOMPLETED (xcreatorIdentity);
CREATE INDEX PP_C_TASKCOMPLETED_creatorPerson ON PP_C_TASKCOMPLETED (xcreatorPerson);
CREATE INDEX PP_C_TASKCOMPLETED_creatorUnit ON PP_C_TASKCOMPLETED (xcreatorUnit);
CREATE INDEX PP_C_TASKCOMPLETED_currentActivityName ON PP_C_TASKCOMPLETED (xcurrentActivityName);
CREATE INDEX PP_C_TASKCOMPLETED_dateTimeValue01 ON PP_C_TASKCOMPLETED (xdateTimeValue01);
CREATE INDEX PP_C_TASKCOMPLETED_dateTimeValue02 ON PP_C_TASKCOMPLETED (xdateTimeValue02);
CREATE INDEX PP_C_TASKCOMPLETED_dateTimeValue03 ON PP_C_TASKCOMPLETED (xdateTimeValue03);
CREATE INDEX PP_C_TASKCOMPLETED_dateTimeValue04 ON PP_C_TASKCOMPLETED (xdateTimeValue04);
CREATE INDEX PP_C_TASKCOMPLETED_dateTimeValue05 ON PP_C_TASKCOMPLETED (xdateTimeValue05);
CREATE INDEX PP_C_TASKCOMPLETED_dateValue01 ON PP_C_TASKCOMPLETED (xdateValue01);
CREATE INDEX PP_C_TASKCOMPLETED_dateValue02 ON PP_C_TASKCOMPLETED (xdateValue02);
CREATE INDEX PP_C_TASKCOMPLETED_doubleValue01 ON PP_C_TASKCOMPLETED (xdoubleValue01);
CREATE INDEX PP_C_TASKCOMPLETED_doubleValue02 ON PP_C_TASKCOMPLETED (xdoubleValue02);
CREATE INDEX PP_C_TASKCOMPLETED_doubleValue03 ON PP_C_TASKCOMPLETED (xdoubleValue03);
CREATE INDEX PP_C_TASKCOMPLETED_doubleValue04 ON PP_C_TASKCOMPLETED (xdoubleValue04);
CREATE INDEX PP_C_TASKCOMPLETED_doubleValue05 ON PP_C_TASKCOMPLETED (xdoubleValue05);
CREATE INDEX PP_C_TASKCOMPLETED_empowerFromIdentity ON PP_C_TASKCOMPLETED (xempowerFromIdentity);
CREATE INDEX PP_C_TASKCOMPLETED_empowerToIdentity ON PP_C_TASKCOMPLETED (xempowerToIdentity);
CREATE INDEX PP_C_TASKCOMPLETED_expired ON PP_C_TASKCOMPLETED (xexpired);
CREATE INDEX PP_C_TASKCOMPLETED_expireTime ON PP_C_TASKCOMPLETED (xexpireTime);
CREATE INDEX PP_C_TASKCOMPLETED_identity ON PP_C_TASKCOMPLETED (xidentity);
CREATE INDEX PP_C_TASKCOMPLETED_job ON PP_C_TASKCOMPLETED (xjob);
CREATE INDEX PP_C_TASKCOMPLETED_joinInquire ON PP_C_TASKCOMPLETED (xjoinInquire);
CREATE INDEX PP_C_TASKCOMPLETED_latest ON PP_C_TASKCOMPLETED (xlatest);
CREATE INDEX PP_C_TASKCOMPLETED_longValue01 ON PP_C_TASKCOMPLETED (xlongValue01);
CREATE INDEX PP_C_TASKCOMPLETED_longValue02 ON PP_C_TASKCOMPLETED (xlongValue02);
CREATE INDEX PP_C_TASKCOMPLETED_longValue03 ON PP_C_TASKCOMPLETED (xlongValue03);
CREATE INDEX PP_C_TASKCOMPLETED_longValue04 ON PP_C_TASKCOMPLETED (xlongValue04);
CREATE INDEX PP_C_TASKCOMPLETED_longValue05 ON PP_C_TASKCOMPLETED (xlongValue05);
CREATE INDEX PP_C_TASKCOMPLETED_opinion ON PP_C_TASKCOMPLETED (xopinion);
CREATE INDEX PP_C_TASKCOMPLETED_person ON PP_C_TASKCOMPLETED (xperson);
CREATE INDEX PP_C_TASKCOMPLETED_process ON PP_C_TASKCOMPLETED (xprocess);
CREATE INDEX PP_C_TASKCOMPLETED_processAlias ON PP_C_TASKCOMPLETED (xprocessAlias);
CREATE INDEX PP_C_TASKCOMPLETED_processingType ON PP_C_TASKCOMPLETED (xprocessingType);
CREATE INDEX PP_C_TASKCOMPLETED_processName ON PP_C_TASKCOMPLETED (xprocessName);
CREATE INDEX PP_C_TASKCOMPLETED_serial ON PP_C_TASKCOMPLETED (xserial);
CREATE INDEX PP_C_TASKCOMPLETED_startTime ON PP_C_TASKCOMPLETED (xstartTime);
CREATE INDEX PP_C_TASKCOMPLETED_startTimeMonth ON PP_C_TASKCOMPLETED (xstartTimeMonth);
CREATE INDEX PP_C_TASKCOMPLETED_stringValue01 ON PP_C_TASKCOMPLETED (xstringValue01);
CREATE INDEX PP_C_TASKCOMPLETED_stringValue02 ON PP_C_TASKCOMPLETED (xstringValue02);
CREATE INDEX PP_C_TASKCOMPLETED_stringValue03 ON PP_C_TASKCOMPLETED (xstringValue03);
CREATE INDEX PP_C_TASKCOMPLETED_stringValue04 ON PP_C_TASKCOMPLETED (xstringValue04);
CREATE INDEX PP_C_TASKCOMPLETED_stringValue05 ON PP_C_TASKCOMPLETED (xstringValue05);
CREATE INDEX PP_C_TASKCOMPLETED_stringValue06 ON PP_C_TASKCOMPLETED (xstringValue06);
CREATE INDEX PP_C_TASKCOMPLETED_stringValue07 ON PP_C_TASKCOMPLETED (xstringValue07);
CREATE INDEX PP_C_TASKCOMPLETED_stringValue08 ON PP_C_TASKCOMPLETED (xstringValue08);
CREATE INDEX PP_C_TASKCOMPLETED_stringValue09 ON PP_C_TASKCOMPLETED (xstringValue09);
CREATE INDEX PP_C_TASKCOMPLETED_stringValue10 ON PP_C_TASKCOMPLETED (xstringValue10);
CREATE INDEX PP_C_TASKCOMPLETED_task ON PP_C_TASKCOMPLETED (xtask);
CREATE INDEX PP_C_TASKCOMPLETED_timeValue01 ON PP_C_TASKCOMPLETED (xtimeValue01);
CREATE INDEX PP_C_TASKCOMPLETED_timeValue02 ON PP_C_TASKCOMPLETED (xtimeValue02);
CREATE INDEX PP_C_TASKCOMPLETED_title ON PP_C_TASKCOMPLETED (xtitle);
CREATE INDEX PP_C_TASKCOMPLETED_unit ON PP_C_TASKCOMPLETED (xunit);
CREATE INDEX PP_C_TASKCOMPLETED_work ON PP_C_TASKCOMPLETED (xwork);
CREATE INDEX PP_C_TASKCOMPLETED_workCompleted ON PP_C_TASKCOMPLETED (xworkCompleted);
CREATE INDEX PP_C_TASK_routeDecisionOpinionList_join ON PP_C_TASK_routeDecisionOpinionList (TASK_XID);
CREATE INDEX PP_C_TASK_routeList_join ON PP_C_TASK_routeList (TASK_XID);
CREATE INDEX PP_C_TASK_routeNameList_join ON PP_C_TASK_routeNameList (TASK_XID);
CREATE INDEX PP_C_TASK_routeOpinionList_join ON PP_C_TASK_routeOpinionList (TASK_XID);
CREATE INDEX PP_C_WORK_activity ON PP_C_WORK (xactivity);
CREATE INDEX PP_C_WORK_activityAlias ON PP_C_WORK (xactivityAlias);
CREATE INDEX PP_C_WORK_activityArrivedTime ON PP_C_WORK (xactivityArrivedTime);
CREATE INDEX PP_C_WORK_activityDescription ON PP_C_WORK (xactivityDescription);
CREATE INDEX PP_C_WORK_activityName ON PP_C_WORK (xactivityName);
CREATE INDEX PP_C_WORK_activityToken ON PP_C_WORK (xactivityToken);
CREATE INDEX PP_C_WORK_activityType ON PP_C_WORK (xactivityType);
CREATE INDEX PP_C_WORK_application ON PP_C_WORK (xapplication);
CREATE INDEX PP_C_WORK_applicationAlias ON PP_C_WORK (xapplicationAlias);
CREATE INDEX PP_C_WORK_applicationName ON PP_C_WORK (xapplicationName);
CREATE INDEX PP_C_WORK_booleanValue01 ON PP_C_WORK (xbooleanValue01);
CREATE INDEX PP_C_WORK_booleanValue02 ON PP_C_WORK (xbooleanValue02);
CREATE INDEX PP_C_WORK_creatorIdentity ON PP_C_WORK (xcreatorIdentity);
CREATE INDEX PP_C_WORK_creatorPerson ON PP_C_WORK (xcreatorPerson);
CREATE INDEX PP_C_WORK_creatorUnit ON PP_C_WORK (xcreatorUnit);
CREATE INDEX PP_C_WORK_dataChanged ON PP_C_WORK (xdataChanged);
CREATE INDEX PP_C_WORK_dateTimeValue01 ON PP_C_WORK (xdateTimeValue01);
CREATE INDEX PP_C_WORK_dateTimeValue02 ON PP_C_WORK (xdateTimeValue02);
CREATE INDEX PP_C_WORK_dateTimeValue03 ON PP_C_WORK (xdateTimeValue03);
CREATE INDEX PP_C_WORK_dateTimeValue04 ON PP_C_WORK (xdateTimeValue04);
CREATE INDEX PP_C_WORK_dateTimeValue05 ON PP_C_WORK (xdateTimeValue05);
CREATE INDEX PP_C_WORK_dateValue01 ON PP_C_WORK (xdateValue01);
CREATE INDEX PP_C_WORK_dateValue02 ON PP_C_WORK (xdateValue02);
CREATE INDEX PP_C_WORK_destinationActivity ON PP_C_WORK (xdestinationActivity);
CREATE INDEX PP_C_WORK_destinationActivityType ON PP_C_WORK (xdestinationActivityType);
CREATE INDEX PP_C_WORK_doubleValue01 ON PP_C_WORK (xdoubleValue01);
CREATE INDEX PP_C_WORK_doubleValue02 ON PP_C_WORK (xdoubleValue02);
CREATE INDEX PP_C_WORK_doubleValue03 ON PP_C_WORK (xdoubleValue03);
CREATE INDEX PP_C_WORK_doubleValue04 ON PP_C_WORK (xdoubleValue04);
CREATE INDEX PP_C_WORK_doubleValue05 ON PP_C_WORK (xdoubleValue05);
CREATE INDEX PP_C_WORK_embedTargetWork ON PP_C_WORK (xembedTargetWork);
CREATE INDEX PP_C_WORK_expireTime ON PP_C_WORK (xexpireTime);
CREATE INDEX PP_C_WORK_job ON PP_C_WORK (xjob);
CREATE INDEX PP_C_WORK_longValue01 ON PP_C_WORK (xlongValue01);
CREATE INDEX PP_C_WORK_longValue02 ON PP_C_WORK (xlongValue02);
CREATE INDEX PP_C_WORK_longValue03 ON PP_C_WORK (xlongValue03);
CREATE INDEX PP_C_WORK_longValue04 ON PP_C_WORK (xlongValue04);
CREATE INDEX PP_C_WORK_longValue05 ON PP_C_WORK (xlongValue05);
CREATE INDEX PP_C_WORK_process ON PP_C_WORK (xprocess);
CREATE INDEX PP_C_WORK_processAlias ON PP_C_WORK (xprocessAlias);
CREATE INDEX PP_C_WORK_processName ON PP_C_WORK (xprocessName);
CREATE INDEX PP_C_WORK_serial ON PP_C_WORK (xserial);
CREATE INDEX PP_C_WORK_splitting ON PP_C_WORK (xsplitting);
CREATE INDEX PP_C_WORK_startTime ON PP_C_WORK (xstartTime);
CREATE INDEX PP_C_WORK_startTimeMonth ON PP_C_WORK (xstartTimeMonth);
CREATE INDEX PP_C_WORK_stringValue01 ON PP_C_WORK (xstringValue01);
CREATE INDEX PP_C_WORK_stringValue02 ON PP_C_WORK (xstringValue02);
CREATE INDEX PP_C_WORK_stringValue03 ON PP_C_WORK (xstringValue03);
CREATE INDEX PP_C_WORK_stringValue04 ON PP_C_WORK (xstringValue04);
CREATE INDEX PP_C_WORK_stringValue05 ON PP_C_WORK (xstringValue05);
CREATE INDEX PP_C_WORK_stringValue06 ON PP_C_WORK (xstringValue06);
CREATE INDEX PP_C_WORK_stringValue07 ON PP_C_WORK (xstringValue07);
CREATE INDEX PP_C_WORK_stringValue08 ON PP_C_WORK (xstringValue08);
CREATE INDEX PP_C_WORK_stringValue09 ON PP_C_WORK (xstringValue09);
CREATE INDEX PP_C_WORK_stringValue10 ON PP_C_WORK (xstringValue10);
CREATE INDEX PP_C_WORK_timeValue01 ON PP_C_WORK (xtimeValue01);
CREATE INDEX PP_C_WORK_timeValue02 ON PP_C_WORK (xtimeValue02);
CREATE INDEX PP_C_WORK_title ON PP_C_WORK (xtitle);
CREATE INDEX PP_C_WORK_workCreateType ON PP_C_WORK (xworkCreateType);
CREATE INDEX PP_C_WORK_workStatus ON PP_C_WORK (xworkStatus);
CREATE INDEX PP_C_WORK_workThroughManual ON PP_C_WORK (xworkThroughManual);
CREATE INDEX PP_C_WORKCOMPLETED_allowRollback ON PP_C_WORKCOMPLETED (xallowRollback);
CREATE INDEX PP_C_WORKCOMPLETED_application ON PP_C_WORKCOMPLETED (xapplication);
CREATE INDEX PP_C_WORKCOMPLETED_applicationAlias ON PP_C_WORKCOMPLETED (xapplicationAlias);
CREATE INDEX PP_C_WORKCOMPLETED_applicationName ON PP_C_WORKCOMPLETED (xapplicationName);
CREATE INDEX PP_C_WORKCOMPLETED_booleanValue01 ON PP_C_WORKCOMPLETED (xbooleanValue01);
CREATE INDEX PP_C_WORKCOMPLETED_booleanValue02 ON PP_C_WORKCOMPLETED (xbooleanValue02);
CREATE INDEX PP_C_WORKCOMPLETED_completedTime ON PP_C_WORKCOMPLETED (xcompletedTime);
CREATE INDEX PP_C_WORKCOMPLETED_completedTimeMonth ON PP_C_WORKCOMPLETED (xcompletedTimeMonth);
CREATE INDEX PP_C_WORKCOMPLETED_creatorIdentity ON PP_C_WORKCOMPLETED (xcreatorIdentity);
CREATE INDEX PP_C_WORKCOMPLETED_creatorPerson ON PP_C_WORKCOMPLETED (xcreatorPerson);
CREATE INDEX PP_C_WORKCOMPLETED_creatorUnit ON PP_C_WORKCOMPLETED (xcreatorUnit);
CREATE INDEX PP_C_WORKCOMPLETED_dateTimeValue01 ON PP_C_WORKCOMPLETED (xdateTimeValue01);
CREATE INDEX PP_C_WORKCOMPLETED_dateTimeValue02 ON PP_C_WORKCOMPLETED (xdateTimeValue02);
CREATE INDEX PP_C_WORKCOMPLETED_dateTimeValue03 ON PP_C_WORKCOMPLETED (xdateTimeValue03);
CREATE INDEX PP_C_WORKCOMPLETED_dateTimeValue04 ON PP_C_WORKCOMPLETED (xdateTimeValue04);
CREATE INDEX PP_C_WORKCOMPLETED_dateTimeValue05 ON PP_C_WORKCOMPLETED (xdateTimeValue05);
CREATE INDEX PP_C_WORKCOMPLETED_dateValue01 ON PP_C_WORKCOMPLETED (xdateValue01);
CREATE INDEX PP_C_WORKCOMPLETED_dateValue02 ON PP_C_WORKCOMPLETED (xdateValue02);
CREATE INDEX PP_C_WORKCOMPLETED_doubleValue01 ON PP_C_WORKCOMPLETED (xdoubleValue01);
CREATE INDEX PP_C_WORKCOMPLETED_doubleValue02 ON PP_C_WORKCOMPLETED (xdoubleValue02);
CREATE INDEX PP_C_WORKCOMPLETED_doubleValue03 ON PP_C_WORKCOMPLETED (xdoubleValue03);
CREATE INDEX PP_C_WORKCOMPLETED_doubleValue04 ON PP_C_WORKCOMPLETED (xdoubleValue04);
CREATE INDEX PP_C_WORKCOMPLETED_doubleValue05 ON PP_C_WORKCOMPLETED (xdoubleValue05);
CREATE INDEX PP_C_WORKCOMPLETED_expired ON PP_C_WORKCOMPLETED (xexpired);
CREATE INDEX PP_C_WORKCOMPLETED_expireTime ON PP_C_WORKCOMPLETED (xexpireTime);
CREATE INDEX PP_C_WORKCOMPLETED_form ON PP_C_WORKCOMPLETED (xform);
CREATE INDEX PP_C_WORKCOMPLETED_job ON PP_C_WORKCOMPLETED (xjob);
CREATE INDEX PP_C_WORKCOMPLETED_longValue01 ON PP_C_WORKCOMPLETED (xlongValue01);
CREATE INDEX PP_C_WORKCOMPLETED_longValue02 ON PP_C_WORKCOMPLETED (xlongValue02);
CREATE INDEX PP_C_WORKCOMPLETED_longValue03 ON PP_C_WORKCOMPLETED (xlongValue03);
CREATE INDEX PP_C_WORKCOMPLETED_longValue04 ON PP_C_WORKCOMPLETED (xlongValue04);
CREATE INDEX PP_C_WORKCOMPLETED_longValue05 ON PP_C_WORKCOMPLETED (xlongValue05);
CREATE INDEX PP_C_WORKCOMPLETED_merged ON PP_C_WORKCOMPLETED (xmerged);
CREATE INDEX PP_C_WORKCOMPLETED_process ON PP_C_WORKCOMPLETED (xprocess);
CREATE INDEX PP_C_WORKCOMPLETED_processAlias ON PP_C_WORKCOMPLETED (xprocessAlias);
CREATE INDEX PP_C_WORKCOMPLETED_processName ON PP_C_WORKCOMPLETED (xprocessName);
CREATE INDEX PP_C_WORKCOMPLETED_serial ON PP_C_WORKCOMPLETED (xserial);
CREATE INDEX PP_C_WORKCOMPLETED_startTime ON PP_C_WORKCOMPLETED (xstartTime);
CREATE INDEX PP_C_WORKCOMPLETED_startTimeMonth ON PP_C_WORKCOMPLETED (xstartTimeMonth);
CREATE INDEX PP_C_WORKCOMPLETED_stringValue01 ON PP_C_WORKCOMPLETED (xstringValue01);
CREATE INDEX PP_C_WORKCOMPLETED_stringValue02 ON PP_C_WORKCOMPLETED (xstringValue02);
CREATE INDEX PP_C_WORKCOMPLETED_stringValue03 ON PP_C_WORKCOMPLETED (xstringValue03);
CREATE INDEX PP_C_WORKCOMPLETED_stringValue04 ON PP_C_WORKCOMPLETED (xstringValue04);
CREATE INDEX PP_C_WORKCOMPLETED_stringValue05 ON PP_C_WORKCOMPLETED (xstringValue05);
CREATE INDEX PP_C_WORKCOMPLETED_stringValue06 ON PP_C_WORKCOMPLETED (xstringValue06);
CREATE INDEX PP_C_WORKCOMPLETED_stringValue07 ON PP_C_WORKCOMPLETED (xstringValue07);
CREATE INDEX PP_C_WORKCOMPLETED_stringValue08 ON PP_C_WORKCOMPLETED (xstringValue08);
CREATE INDEX PP_C_WORKCOMPLETED_stringValue09 ON PP_C_WORKCOMPLETED (xstringValue09);
CREATE INDEX PP_C_WORKCOMPLETED_stringValue10 ON PP_C_WORKCOMPLETED (xstringValue10);
CREATE INDEX PP_C_WORKCOMPLETED_timeValue01 ON PP_C_WORKCOMPLETED (xtimeValue01);
CREATE INDEX PP_C_WORKCOMPLETED_timeValue02 ON PP_C_WORKCOMPLETED (xtimeValue02);
CREATE INDEX PP_C_WORKCOMPLETED_title ON PP_C_WORKCOMPLETED (xtitle);
CREATE INDEX PP_C_WORKCOMPLETED_work ON PP_C_WORKCOMPLETED (xwork);
CREATE INDEX PP_C_WORKLOG_application ON PP_C_WORKLOG (xapplication);
CREATE INDEX PP_C_WORKLOG_applicationAlias ON PP_C_WORKLOG (xapplicationAlias);
CREATE INDEX PP_C_WORKLOG_applicationName ON PP_C_WORKLOG (xapplicationName);
CREATE INDEX PP_C_WORKLOG_arrivedActivity ON PP_C_WORKLOG (xarrivedActivity);
CREATE INDEX PP_C_WORKLOG_arrivedActivityAlias ON PP_C_WORKLOG (xarrivedActivityAlias);
CREATE INDEX PP_C_WORKLOG_arrivedActivityName ON PP_C_WORKLOG (xarrivedActivityName);
CREATE INDEX PP_C_WORKLOG_arrivedActivityToken ON PP_C_WORKLOG (xarrivedActivityToken);
CREATE INDEX PP_C_WORKLOG_arrivedActivityType ON PP_C_WORKLOG (xarrivedActivityType);
CREATE INDEX PP_C_WORKLOG_arrivedTime ON PP_C_WORKLOG (xarrivedTime);
CREATE INDEX PP_C_WORKLOG_completed ON PP_C_WORKLOG (xcompleted);
CREATE INDEX PP_C_WORKLOG_connected ON PP_C_WORKLOG (xconnected);
CREATE INDEX PP_C_WORKLOG_duration ON PP_C_WORKLOG (xduration);
CREATE INDEX PP_C_WORKLOG_fromActivity ON PP_C_WORKLOG (xfromActivity);
CREATE INDEX PP_C_WORKLOG_fromActivityAlias ON PP_C_WORKLOG (xfromActivityAlias);
CREATE INDEX PP_C_WORKLOG_fromActivityName ON PP_C_WORKLOG (xfromActivityName);
CREATE INDEX PP_C_WORKLOG_fromActivityToken ON PP_C_WORKLOG (xfromActivityToken);
CREATE INDEX PP_C_WORKLOG_fromActivityType ON PP_C_WORKLOG (xfromActivityType);
CREATE INDEX PP_C_WORKLOG_fromTime ON PP_C_WORKLOG (xfromTime);
CREATE INDEX PP_C_WORKLOG_job ON PP_C_WORKLOG (xjob);
CREATE INDEX PP_C_WORKLOG_process ON PP_C_WORKLOG (xprocess);
CREATE INDEX PP_C_WORKLOG_processAlias ON PP_C_WORKLOG (xprocessAlias);
CREATE INDEX PP_C_WORKLOG_processName ON PP_C_WORKLOG (xprocessName);
CREATE INDEX PP_C_WORKLOG_route ON PP_C_WORKLOG (xroute);
CREATE INDEX PP_C_WORKLOG_routeName ON PP_C_WORKLOG (xrouteName);
CREATE INDEX PP_C_WORKLOG_splitWork ON PP_C_WORKLOG (xsplitWork);
CREATE INDEX PP_C_WORKLOG_work ON PP_C_WORKLOG (xwork);
CREATE INDEX PP_C_WORKLOG_workCompleted ON PP_C_WORKLOG (xworkCompleted);
CREATE INDEX PP_C_WORK_manualTaskIdentityList_element ON PP_C_WORK_manualTaskIdentityList (xmanualTaskIdentityList);
CREATE INDEX PP_C_WORK_manualTaskIdentityList_join ON PP_C_WORK_manualTaskIdentityList (WORK_XID);
CREATE INDEX PP_C_WORK_splitTokenList_element ON PP_C_WORK_splitTokenList (xsplitTokenList);
CREATE INDEX PP_C_WORK_splitTokenList_join ON PP_C_WORK_splitTokenList (WORK_XID);
CREATE INDEX PP_E_AGENT_allowReroute ON PP_E_AGENT (xallowReroute);
CREATE INDEX PP_E_AGENT_allowRerouteTo ON PP_E_AGENT (xallowRerouteTo);
CREATE INDEX PP_E_AGENT_form ON PP_E_AGENT (xform);
CREATE INDEX PP_E_AGENT_process ON PP_E_AGENT (xprocess);
CREATE INDEX PP_E_AGENT_readDataPathList_element ON PP_E_AGENT_readDataPathList (xreadDataPathList);
CREATE INDEX PP_E_AGENT_readDataPathList_join ON PP_E_AGENT_readDataPathList (AGENT_XID);
CREATE INDEX PP_E_AGENT_readGroupList_element ON PP_E_AGENT_readGroupList (xreadGroupList);
CREATE INDEX PP_E_AGENT_readGroupList_join ON PP_E_AGENT_readGroupList (AGENT_XID);
CREATE INDEX PP_E_AGENT_readIdentityList_element ON PP_E_AGENT_readIdentityList (xreadIdentityList);
CREATE INDEX PP_E_AGENT_readIdentityList_join ON PP_E_AGENT_readIdentityList (AGENT_XID);
CREATE INDEX PP_E_AGENT_readUnitList_element ON PP_E_AGENT_readUnitList (xreadUnitList);
CREATE INDEX PP_E_AGENT_readUnitList_join ON PP_E_AGENT_readUnitList (AGENT_XID);
CREATE INDEX PP_E_AGENT_reviewDataPathList_element ON PP_E_AGENT_reviewDataPathList (xreviewDataPathList);
CREATE INDEX PP_E_AGENT_reviewDataPathList_join ON PP_E_AGENT_reviewDataPathList (AGENT_XID);
CREATE INDEX PP_E_AGENT_reviewGroupList_element ON PP_E_AGENT_reviewGroupList (xreviewGroupList);
CREATE INDEX PP_E_AGENT_reviewGroupList_join ON PP_E_AGENT_reviewGroupList (AGENT_XID);
CREATE INDEX PP_E_AGENT_reviewIdentityList_element ON PP_E_AGENT_reviewIdentityList (xreviewIdentityList);
CREATE INDEX PP_E_AGENT_reviewIdentityList_join ON PP_E_AGENT_reviewIdentityList (AGENT_XID);
CREATE INDEX PP_E_AGENT_reviewUnitList_element ON PP_E_AGENT_reviewUnitList (xreviewUnitList);
CREATE INDEX PP_E_AGENT_reviewUnitList_join ON PP_E_AGENT_reviewUnitList (AGENT_XID);
CREATE INDEX PP_E_APPLICATIONDICT_alias ON PP_E_APPLICATIONDICT (xalias);
CREATE INDEX PP_E_APPLICATIONDICT_application ON PP_E_APPLICATIONDICT (xapplication);
CREATE INDEX PP_E_APPLICATIONDICT_description ON PP_E_APPLICATIONDICT (xdescription);
CREATE INDEX PP_E_APPLICATIONDICT_name ON PP_E_APPLICATIONDICT (xname);
CREATE INDEX PP_E_APPLICATIONDICTITEM_application ON PP_E_APPLICATIONDICTITEM (xapplication);
CREATE INDEX PP_E_APPLICATIONDICTITEM_booleanValue ON PP_E_APPLICATIONDICTITEM (xbooleanValue);
CREATE INDEX PP_E_APPLICATIONDICTITEM_bundle ON PP_E_APPLICATIONDICTITEM (xbundle);
CREATE INDEX PP_E_APPLICATIONDICTITEM_dateTimeValue ON PP_E_APPLICATIONDICTITEM (xdateTimeValue);
CREATE INDEX PP_E_APPLICATIONDICTITEM_dateValue ON PP_E_APPLICATIONDICTITEM (xdateValue);
CREATE INDEX PP_E_APPLICATIONDICTITEM_itemCategory ON PP_E_APPLICATIONDICTITEM (xitemCategory);
CREATE INDEX PP_E_APPLICATIONDICTITEM_itemPrimitiveType ON PP_E_APPLICATIONDICTITEM (xitemPrimitiveType);
CREATE INDEX PP_E_APPLICATIONDICTITEM_itemStringValueType ON PP_E_APPLICATIONDICTITEM (xitemStringValueType);
CREATE INDEX PP_E_APPLICATIONDICTITEM_itemType ON PP_E_APPLICATIONDICTITEM (xitemType);
CREATE INDEX PP_E_APPLICATIONDICTITEM_numberValue ON PP_E_APPLICATIONDICTITEM (xnumberValue);
CREATE INDEX PP_E_APPLICATIONDICTITEM_path0 ON PP_E_APPLICATIONDICTITEM (xpath0);
CREATE INDEX PP_E_APPLICATIONDICTITEM_path0Location ON PP_E_APPLICATIONDICTITEM (xpath0Location);
CREATE INDEX PP_E_APPLICATIONDICTITEM_path1 ON PP_E_APPLICATIONDICTITEM (xpath1);
CREATE INDEX PP_E_APPLICATIONDICTITEM_path1Location ON PP_E_APPLICATIONDICTITEM (xpath1Location);
CREATE INDEX PP_E_APPLICATIONDICTITEM_path2 ON PP_E_APPLICATIONDICTITEM (xpath2);
CREATE INDEX PP_E_APPLICATIONDICTITEM_path2Location ON PP_E_APPLICATIONDICTITEM (xpath2Location);
CREATE INDEX PP_E_APPLICATIONDICTITEM_path3 ON PP_E_APPLICATIONDICTITEM (xpath3);
CREATE INDEX PP_E_APPLICATIONDICTITEM_path3Location ON PP_E_APPLICATIONDICTITEM (xpath3Location);
CREATE INDEX PP_E_APPLICATIONDICTITEM_path4 ON PP_E_APPLICATIONDICTITEM (xpath4);
CREATE INDEX PP_E_APPLICATIONDICTITEM_path4Location ON PP_E_APPLICATIONDICTITEM (xpath4Location);
CREATE INDEX PP_E_APPLICATIONDICTITEM_path5 ON PP_E_APPLICATIONDICTITEM (xpath5);
CREATE INDEX PP_E_APPLICATIONDICTITEM_path5Location ON PP_E_APPLICATIONDICTITEM (xpath5Location);
CREATE INDEX PP_E_APPLICATIONDICTITEM_path6 ON PP_E_APPLICATIONDICTITEM (xpath6);
CREATE INDEX PP_E_APPLICATIONDICTITEM_path6Location ON PP_E_APPLICATIONDICTITEM (xpath6Location);
CREATE INDEX PP_E_APPLICATIONDICTITEM_path7 ON PP_E_APPLICATIONDICTITEM (xpath7);
CREATE INDEX PP_E_APPLICATIONDICTITEM_path7Location ON PP_E_APPLICATIONDICTITEM (xpath7Location);
CREATE INDEX PP_E_APPLICATIONDICTITEM_stringShortValue ON PP_E_APPLICATIONDICTITEM (xstringShortValue);
CREATE INDEX PP_E_APPLICATIONDICTITEM_timeValue ON PP_E_APPLICATIONDICTITEM (xtimeValue);
CREATE INDEX PP_E_APPLICATION_availableIdentityList_element ON PP_E_APPLICATION_availableIdentityList (xavailableIdentityList);
CREATE INDEX PP_E_APPLICATION_availableIdentityList_join ON PP_E_APPLICATION_availableIdentityList (APPLICATION_XID);
CREATE INDEX PP_E_APPLICATION_availableUnitList_element ON PP_E_APPLICATION_availableUnitList (xavailableUnitList);
CREATE INDEX PP_E_APPLICATION_availableUnitList_join ON PP_E_APPLICATION_availableUnitList (APPLICATION_XID);
CREATE INDEX PP_E_APPLICATION_controllerList_element ON PP_E_APPLICATION_controllerList (xcontrollerList);
CREATE INDEX PP_E_APPLICATION_controllerList_join ON PP_E_APPLICATION_controllerList (APPLICATION_XID);
CREATE INDEX PP_E_BEGIN_allowReroute ON PP_E_BEGIN (xallowReroute);
CREATE INDEX PP_E_BEGIN_allowRerouteTo ON PP_E_BEGIN (xallowRerouteTo);
CREATE INDEX PP_E_BEGIN_form ON PP_E_BEGIN (xform);
CREATE INDEX PP_E_BEGIN_process ON PP_E_BEGIN (xprocess);
CREATE INDEX PP_E_BEGIN_readDataPathList_element ON PP_E_BEGIN_readDataPathList (xreadDataPathList);
CREATE INDEX PP_E_BEGIN_readDataPathList_join ON PP_E_BEGIN_readDataPathList (BEGIN_XID);
CREATE INDEX PP_E_BEGIN_readGroupList_element ON PP_E_BEGIN_readGroupList (xreadGroupList);
CREATE INDEX PP_E_BEGIN_readGroupList_join ON PP_E_BEGIN_readGroupList (BEGIN_XID);
CREATE INDEX PP_E_BEGIN_readIdentityList_element ON PP_E_BEGIN_readIdentityList (xreadIdentityList);
CREATE INDEX PP_E_BEGIN_readIdentityList_join ON PP_E_BEGIN_readIdentityList (BEGIN_XID);
CREATE INDEX PP_E_BEGIN_readUnitList_element ON PP_E_BEGIN_readUnitList (xreadUnitList);
CREATE INDEX PP_E_BEGIN_readUnitList_join ON PP_E_BEGIN_readUnitList (BEGIN_XID);
CREATE INDEX PP_E_BEGIN_reviewDataPathList_element ON PP_E_BEGIN_reviewDataPathList (xreviewDataPathList);
CREATE INDEX PP_E_BEGIN_reviewDataPathList_join ON PP_E_BEGIN_reviewDataPathList (BEGIN_XID);
CREATE INDEX PP_E_BEGIN_reviewGroupList_element ON PP_E_BEGIN_reviewGroupList (xreviewGroupList);
CREATE INDEX PP_E_BEGIN_reviewGroupList_join ON PP_E_BEGIN_reviewGroupList (BEGIN_XID);
CREATE INDEX PP_E_BEGIN_reviewIdentityList_element ON PP_E_BEGIN_reviewIdentityList (xreviewIdentityList);
CREATE INDEX PP_E_BEGIN_reviewIdentityList_join ON PP_E_BEGIN_reviewIdentityList (BEGIN_XID);
CREATE INDEX PP_E_BEGIN_reviewUnitList_element ON PP_E_BEGIN_reviewUnitList (xreviewUnitList);
CREATE INDEX PP_E_BEGIN_reviewUnitList_join ON PP_E_BEGIN_reviewUnitList (BEGIN_XID);
CREATE INDEX PP_E_CANCEL_allowReroute ON PP_E_CANCEL (xallowReroute);
CREATE INDEX PP_E_CANCEL_allowRerouteTo ON PP_E_CANCEL (xallowRerouteTo);
CREATE INDEX PP_E_CANCEL_form ON PP_E_CANCEL (xform);
CREATE INDEX PP_E_CANCEL_process ON PP_E_CANCEL (xprocess);
CREATE INDEX PP_E_CANCEL_readDataPathList_element ON PP_E_CANCEL_readDataPathList (xreadDataPathList);
CREATE INDEX PP_E_CANCEL_readDataPathList_join ON PP_E_CANCEL_readDataPathList (CANCEL_XID);
CREATE INDEX PP_E_CANCEL_readGroupList_element ON PP_E_CANCEL_readGroupList (xreadGroupList);
CREATE INDEX PP_E_CANCEL_readGroupList_join ON PP_E_CANCEL_readGroupList (CANCEL_XID);
CREATE INDEX PP_E_CANCEL_readIdentityList_element ON PP_E_CANCEL_readIdentityList (xreadIdentityList);
CREATE INDEX PP_E_CANCEL_readIdentityList_join ON PP_E_CANCEL_readIdentityList (CANCEL_XID);
CREATE INDEX PP_E_CANCEL_readUnitList_element ON PP_E_CANCEL_readUnitList (xreadUnitList);
CREATE INDEX PP_E_CANCEL_readUnitList_join ON PP_E_CANCEL_readUnitList (CANCEL_XID);
CREATE INDEX PP_E_CANCEL_reviewDataPathList_element ON PP_E_CANCEL_reviewDataPathList (xreviewDataPathList);
CREATE INDEX PP_E_CANCEL_reviewDataPathList_join ON PP_E_CANCEL_reviewDataPathList (CANCEL_XID);
CREATE INDEX PP_E_CANCEL_reviewGroupList_element ON PP_E_CANCEL_reviewGroupList (xreviewGroupList);
CREATE INDEX PP_E_CANCEL_reviewGroupList_join ON PP_E_CANCEL_reviewGroupList (CANCEL_XID);
CREATE INDEX PP_E_CANCEL_reviewIdentityList_element ON PP_E_CANCEL_reviewIdentityList (xreviewIdentityList);
CREATE INDEX PP_E_CANCEL_reviewIdentityList_join ON PP_E_CANCEL_reviewIdentityList (CANCEL_XID);
CREATE INDEX PP_E_CANCEL_reviewUnitList_element ON PP_E_CANCEL_reviewUnitList (xreviewUnitList);
CREATE INDEX PP_E_CANCEL_reviewUnitList_join ON PP_E_CANCEL_reviewUnitList (CANCEL_XID);
CREATE INDEX PP_E_CHOICE_allowReroute ON PP_E_CHOICE (xallowReroute);
CREATE INDEX PP_E_CHOICE_allowRerouteTo ON PP_E_CHOICE (xallowRerouteTo);
CREATE INDEX PP_E_CHOICE_form ON PP_E_CHOICE (xform);
CREATE INDEX PP_E_CHOICE_process ON PP_E_CHOICE (xprocess);
CREATE INDEX PP_E_CHOICE_readDataPathList_element ON PP_E_CHOICE_readDataPathList (xreadDataPathList);
CREATE INDEX PP_E_CHOICE_readDataPathList_join ON PP_E_CHOICE_readDataPathList (CHOICE_XID);
CREATE INDEX PP_E_CHOICE_readGroupList_element ON PP_E_CHOICE_readGroupList (xreadGroupList);
CREATE INDEX PP_E_CHOICE_readGroupList_join ON PP_E_CHOICE_readGroupList (CHOICE_XID);
CREATE INDEX PP_E_CHOICE_readIdentityList_element ON PP_E_CHOICE_readIdentityList (xreadIdentityList);
CREATE INDEX PP_E_CHOICE_readIdentityList_join ON PP_E_CHOICE_readIdentityList (CHOICE_XID);
CREATE INDEX PP_E_CHOICE_readUnitList_element ON PP_E_CHOICE_readUnitList (xreadUnitList);
CREATE INDEX PP_E_CHOICE_readUnitList_join ON PP_E_CHOICE_readUnitList (CHOICE_XID);
CREATE INDEX PP_E_CHOICE_reviewDataPathList_element ON PP_E_CHOICE_reviewDataPathList (xreviewDataPathList);
CREATE INDEX PP_E_CHOICE_reviewDataPathList_join ON PP_E_CHOICE_reviewDataPathList (CHOICE_XID);
CREATE INDEX PP_E_CHOICE_reviewGroupList_element ON PP_E_CHOICE_reviewGroupList (xreviewGroupList);
CREATE INDEX PP_E_CHOICE_reviewGroupList_join ON PP_E_CHOICE_reviewGroupList (CHOICE_XID);
CREATE INDEX PP_E_CHOICE_reviewIdentityList_element ON PP_E_CHOICE_reviewIdentityList (xreviewIdentityList);
CREATE INDEX PP_E_CHOICE_reviewIdentityList_join ON PP_E_CHOICE_reviewIdentityList (CHOICE_XID);
CREATE INDEX PP_E_CHOICE_reviewUnitList_element ON PP_E_CHOICE_reviewUnitList (xreviewUnitList);
CREATE INDEX PP_E_CHOICE_reviewUnitList_join ON PP_E_CHOICE_reviewUnitList (CHOICE_XID);
CREATE INDEX PP_E_CHOICE_routeList_element ON PP_E_CHOICE_routeList (xrouteList);
CREATE INDEX PP_E_CHOICE_routeList_join ON PP_E_CHOICE_routeList (CHOICE_XID);
CREATE INDEX PP_E_DELAY_allowReroute ON PP_E_DELAY (xallowReroute);
CREATE INDEX PP_E_DELAY_allowRerouteTo ON PP_E_DELAY (xallowRerouteTo);
CREATE INDEX PP_E_DELAY_form ON PP_E_DELAY (xform);
CREATE INDEX PP_E_DELAY_process ON PP_E_DELAY (xprocess);
CREATE INDEX PP_E_DELAY_readDataPathList_element ON PP_E_DELAY_readDataPathList (xreadDataPathList);
CREATE INDEX PP_E_DELAY_readDataPathList_join ON PP_E_DELAY_readDataPathList (DELAY_XID);
CREATE INDEX PP_E_DELAY_readGroupList_element ON PP_E_DELAY_readGroupList (xreadGroupList);
CREATE INDEX PP_E_DELAY_readGroupList_join ON PP_E_DELAY_readGroupList (DELAY_XID);
CREATE INDEX PP_E_DELAY_readIdentityList_element ON PP_E_DELAY_readIdentityList (xreadIdentityList);
CREATE INDEX PP_E_DELAY_readIdentityList_join ON PP_E_DELAY_readIdentityList (DELAY_XID);
CREATE INDEX PP_E_DELAY_readUnitList_element ON PP_E_DELAY_readUnitList (xreadUnitList);
CREATE INDEX PP_E_DELAY_readUnitList_join ON PP_E_DELAY_readUnitList (DELAY_XID);
CREATE INDEX PP_E_DELAY_reviewDataPathList_element ON PP_E_DELAY_reviewDataPathList (xreviewDataPathList);
CREATE INDEX PP_E_DELAY_reviewDataPathList_join ON PP_E_DELAY_reviewDataPathList (DELAY_XID);
CREATE INDEX PP_E_DELAY_reviewGroupList_element ON PP_E_DELAY_reviewGroupList (xreviewGroupList);
CREATE INDEX PP_E_DELAY_reviewGroupList_join ON PP_E_DELAY_reviewGroupList (DELAY_XID);
CREATE INDEX PP_E_DELAY_reviewIdentityList_element ON PP_E_DELAY_reviewIdentityList (xreviewIdentityList);
CREATE INDEX PP_E_DELAY_reviewIdentityList_join ON PP_E_DELAY_reviewIdentityList (DELAY_XID);
CREATE INDEX PP_E_DELAY_reviewUnitList_element ON PP_E_DELAY_reviewUnitList (xreviewUnitList);
CREATE INDEX PP_E_DELAY_reviewUnitList_join ON PP_E_DELAY_reviewUnitList (DELAY_XID);
CREATE INDEX PP_E_EMBED_allowReroute ON PP_E_EMBED (xallowReroute);
CREATE INDEX PP_E_EMBED_allowRerouteTo ON PP_E_EMBED (xallowRerouteTo);
CREATE INDEX PP_E_EMBED_form ON PP_E_EMBED (xform);
CREATE INDEX PP_E_EMBED_inheritAttachment ON PP_E_EMBED (xinheritAttachment);
CREATE INDEX PP_E_EMBED_inheritData ON PP_E_EMBED (xinheritData);
CREATE INDEX PP_E_EMBED_process ON PP_E_EMBED (xprocess);
CREATE INDEX PP_E_EMBED_targetApplication ON PP_E_EMBED (xtargetApplication);
CREATE INDEX PP_E_EMBED_targetApplicationAlias ON PP_E_EMBED (xtargetApplicationAlias);
CREATE INDEX PP_E_EMBED_targetApplicationName ON PP_E_EMBED (xtargetApplicationName);
CREATE INDEX PP_E_EMBED_targetIdentity ON PP_E_EMBED (xtargetIdentity);
CREATE INDEX PP_E_EMBED_targetProcess ON PP_E_EMBED (xtargetProcess);
CREATE INDEX PP_E_EMBED_targetProcessAlias ON PP_E_EMBED (xtargetProcessAlias);
CREATE INDEX PP_E_EMBED_targetProcessName ON PP_E_EMBED (xtargetProcessName);
CREATE INDEX PP_E_EMBED_readDataPathList_element ON PP_E_EMBED_readDataPathList (xreadDataPathList);
CREATE INDEX PP_E_EMBED_readDataPathList_join ON PP_E_EMBED_readDataPathList (EMBED_XID);
CREATE INDEX PP_E_EMBED_readGroupList_element ON PP_E_EMBED_readGroupList (xreadGroupList);
CREATE INDEX PP_E_EMBED_readGroupList_join ON PP_E_EMBED_readGroupList (EMBED_XID);
CREATE INDEX PP_E_EMBED_readIdentityList_element ON PP_E_EMBED_readIdentityList (xreadIdentityList);
CREATE INDEX PP_E_EMBED_readIdentityList_join ON PP_E_EMBED_readIdentityList (EMBED_XID);
CREATE INDEX PP_E_EMBED_readUnitList_element ON PP_E_EMBED_readUnitList (xreadUnitList);
CREATE INDEX PP_E_EMBED_readUnitList_join ON PP_E_EMBED_readUnitList (EMBED_XID);
CREATE INDEX PP_E_EMBED_reviewDataPathList_element ON PP_E_EMBED_reviewDataPathList (xreviewDataPathList);
CREATE INDEX PP_E_EMBED_reviewDataPathList_join ON PP_E_EMBED_reviewDataPathList (EMBED_XID);
CREATE INDEX PP_E_EMBED_reviewGroupList_element ON PP_E_EMBED_reviewGroupList (xreviewGroupList);
CREATE INDEX PP_E_EMBED_reviewGroupList_join ON PP_E_EMBED_reviewGroupList (EMBED_XID);
CREATE INDEX PP_E_EMBED_reviewIdentityList_element ON PP_E_EMBED_reviewIdentityList (xreviewIdentityList);
CREATE INDEX PP_E_EMBED_reviewIdentityList_join ON PP_E_EMBED_reviewIdentityList (EMBED_XID);
CREATE INDEX PP_E_EMBED_reviewUnitList_element ON PP_E_EMBED_reviewUnitList (xreviewUnitList);
CREATE INDEX PP_E_EMBED_reviewUnitList_join ON PP_E_EMBED_reviewUnitList (EMBED_XID);
CREATE INDEX PP_E_END_allowReroute ON PP_E_END (xallowReroute);
CREATE INDEX PP_E_END_allowRerouteTo ON PP_E_END (xallowRerouteTo);
CREATE INDEX PP_E_END_form ON PP_E_END (xform);
CREATE INDEX PP_E_END_process ON PP_E_END (xprocess);
CREATE INDEX PP_E_END_readDataPathList_element ON PP_E_END_readDataPathList (xreadDataPathList);
CREATE INDEX PP_E_END_readDataPathList_join ON PP_E_END_readDataPathList (END_XID);
CREATE INDEX PP_E_END_readGroupList_element ON PP_E_END_readGroupList (xreadGroupList);
CREATE INDEX PP_E_END_readGroupList_join ON PP_E_END_readGroupList (END_XID);
CREATE INDEX PP_E_END_readIdentityList_element ON PP_E_END_readIdentityList (xreadIdentityList);
CREATE INDEX PP_E_END_readIdentityList_join ON PP_E_END_readIdentityList (END_XID);
CREATE INDEX PP_E_END_readUnitList_element ON PP_E_END_readUnitList (xreadUnitList);
CREATE INDEX PP_E_END_readUnitList_join ON PP_E_END_readUnitList (END_XID);
CREATE INDEX PP_E_END_reviewDataPathList_element ON PP_E_END_reviewDataPathList (xreviewDataPathList);
CREATE INDEX PP_E_END_reviewDataPathList_join ON PP_E_END_reviewDataPathList (END_XID);
CREATE INDEX PP_E_END_reviewGroupList_element ON PP_E_END_reviewGroupList (xreviewGroupList);
CREATE INDEX PP_E_END_reviewGroupList_join ON PP_E_END_reviewGroupList (END_XID);
CREATE INDEX PP_E_END_reviewIdentityList_element ON PP_E_END_reviewIdentityList (xreviewIdentityList);
CREATE INDEX PP_E_END_reviewIdentityList_join ON PP_E_END_reviewIdentityList (END_XID);
CREATE INDEX PP_E_END_reviewUnitList_element ON PP_E_END_reviewUnitList (xreviewUnitList);
CREATE INDEX PP_E_END_reviewUnitList_join ON PP_E_END_reviewUnitList (END_XID);
CREATE INDEX PP_E_FILE_application ON PP_E_FILE (xapplication);
CREATE INDEX PP_E_FILE_length ON PP_E_FILE (xlength);
CREATE INDEX PP_E_FORM_application ON PP_E_FORM (xapplication);
CREATE INDEX PP_E_FORM_category ON PP_E_FORM (xcategory);
CREATE INDEX PP_E_FORMFIELD_application ON PP_E_FORMFIELD (xapplication);
CREATE INDEX PP_E_FORMFIELD_form ON PP_E_FORMFIELD (xform);
CREATE INDEX PP_E_FORMVERSION_form ON PP_E_FORMVERSION (xform);
CREATE INDEX PP_E_INVOKE_allowReroute ON PP_E_INVOKE (xallowReroute);
CREATE INDEX PP_E_INVOKE_allowRerouteTo ON PP_E_INVOKE (xallowRerouteTo);
CREATE INDEX PP_E_INVOKE_form ON PP_E_INVOKE (xform);
CREATE INDEX PP_E_INVOKE_process ON PP_E_INVOKE (xprocess);
CREATE INDEX PP_E_INVOKE_readDataPathList_element ON PP_E_INVOKE_readDataPathList (xreadDataPathList);
CREATE INDEX PP_E_INVOKE_readDataPathList_join ON PP_E_INVOKE_readDataPathList (INVOKE_XID);
CREATE INDEX PP_E_INVOKE_readGroupList_element ON PP_E_INVOKE_readGroupList (xreadGroupList);
CREATE INDEX PP_E_INVOKE_readGroupList_join ON PP_E_INVOKE_readGroupList (INVOKE_XID);
CREATE INDEX PP_E_INVOKE_readIdentityList_element ON PP_E_INVOKE_readIdentityList (xreadIdentityList);
CREATE INDEX PP_E_INVOKE_readIdentityList_join ON PP_E_INVOKE_readIdentityList (INVOKE_XID);
CREATE INDEX PP_E_INVOKE_readUnitList_element ON PP_E_INVOKE_readUnitList (xreadUnitList);
CREATE INDEX PP_E_INVOKE_readUnitList_join ON PP_E_INVOKE_readUnitList (INVOKE_XID);
CREATE INDEX PP_E_INVOKE_reviewDataPathList_element ON PP_E_INVOKE_reviewDataPathList (xreviewDataPathList);
CREATE INDEX PP_E_INVOKE_reviewDataPathList_join ON PP_E_INVOKE_reviewDataPathList (INVOKE_XID);
CREATE INDEX PP_E_INVOKE_reviewGroupList_element ON PP_E_INVOKE_reviewGroupList (xreviewGroupList);
CREATE INDEX PP_E_INVOKE_reviewGroupList_join ON PP_E_INVOKE_reviewGroupList (INVOKE_XID);
CREATE INDEX PP_E_INVOKE_reviewIdentityList_element ON PP_E_INVOKE_reviewIdentityList (xreviewIdentityList);
CREATE INDEX PP_E_INVOKE_reviewIdentityList_join ON PP_E_INVOKE_reviewIdentityList (INVOKE_XID);
CREATE INDEX PP_E_INVOKE_reviewUnitList_element ON PP_E_INVOKE_reviewUnitList (xreviewUnitList);
CREATE INDEX PP_E_INVOKE_reviewUnitList_join ON PP_E_INVOKE_reviewUnitList (INVOKE_XID);
CREATE INDEX PP_E_MANUAL_allowReroute ON PP_E_MANUAL (xallowReroute);
CREATE INDEX PP_E_MANUAL_allowRerouteTo ON PP_E_MANUAL (xallowRerouteTo);
CREATE INDEX PP_E_MANUAL_form ON PP_E_MANUAL (xform);
CREATE INDEX PP_E_MANUAL_manualMode ON PP_E_MANUAL (xmanualMode);
CREATE INDEX PP_E_MANUAL_process ON PP_E_MANUAL (xprocess);
CREATE INDEX PP_E_MANUAL_taskExpireType ON PP_E_MANUAL (xtaskExpireType);
CREATE INDEX PP_E_MANUAL_readDataPathList_element ON PP_E_MANUAL_readDataPathList (xreadDataPathList);
CREATE INDEX PP_E_MANUAL_readDataPathList_join ON PP_E_MANUAL_readDataPathList (MANUAL_XID);
CREATE INDEX PP_E_MANUAL_readGroupList_element ON PP_E_MANUAL_readGroupList (xreadGroupList);
CREATE INDEX PP_E_MANUAL_readGroupList_join ON PP_E_MANUAL_readGroupList (MANUAL_XID);
CREATE INDEX PP_E_MANUAL_readIdentityList_element ON PP_E_MANUAL_readIdentityList (xreadIdentityList);
CREATE INDEX PP_E_MANUAL_readIdentityList_join ON PP_E_MANUAL_readIdentityList (MANUAL_XID);
CREATE INDEX PP_E_MANUAL_readUnitList_element ON PP_E_MANUAL_readUnitList (xreadUnitList);
CREATE INDEX PP_E_MANUAL_readUnitList_join ON PP_E_MANUAL_readUnitList (MANUAL_XID);
CREATE INDEX PP_E_MANUAL_reviewDataPathList_element ON PP_E_MANUAL_reviewDataPathList (xreviewDataPathList);
CREATE INDEX PP_E_MANUAL_reviewDataPathList_join ON PP_E_MANUAL_reviewDataPathList (MANUAL_XID);
CREATE INDEX PP_E_MANUAL_reviewGroupList_element ON PP_E_MANUAL_reviewGroupList (xreviewGroupList);
CREATE INDEX PP_E_MANUAL_reviewGroupList_join ON PP_E_MANUAL_reviewGroupList (MANUAL_XID);
CREATE INDEX PP_E_MANUAL_reviewIdentityList_element ON PP_E_MANUAL_reviewIdentityList (xreviewIdentityList);
CREATE INDEX PP_E_MANUAL_reviewIdentityList_join ON PP_E_MANUAL_reviewIdentityList (MANUAL_XID);
CREATE INDEX PP_E_MANUAL_reviewUnitList_element ON PP_E_MANUAL_reviewUnitList (xreviewUnitList);
CREATE INDEX PP_E_MANUAL_reviewUnitList_join ON PP_E_MANUAL_reviewUnitList (MANUAL_XID);
CREATE INDEX PP_E_MANUAL_routeList_element ON PP_E_MANUAL_routeList (xrouteList);
CREATE INDEX PP_E_MANUAL_routeList_join ON PP_E_MANUAL_routeList (MANUAL_XID);
CREATE INDEX PP_E_MANUAL_taskDataPathList_element ON PP_E_MANUAL_taskDataPathList (xtaskDataPathList);
CREATE INDEX PP_E_MANUAL_taskDataPathList_join ON PP_E_MANUAL_taskDataPathList (MANUAL_XID);
CREATE INDEX PP_E_MANUAL_taskGroupList_element ON PP_E_MANUAL_taskGroupList (xtaskGroupList);
CREATE INDEX PP_E_MANUAL_taskGroupList_join ON PP_E_MANUAL_taskGroupList (MANUAL_XID);
CREATE INDEX PP_E_MANUAL_taskIdentityList_element ON PP_E_MANUAL_taskIdentityList (xtaskIdentityList);
CREATE INDEX PP_E_MANUAL_taskIdentityList_join ON PP_E_MANUAL_taskIdentityList (MANUAL_XID);
CREATE INDEX PP_E_MANUAL_taskUnitList_element ON PP_E_MANUAL_taskUnitList (xtaskUnitList);
CREATE INDEX PP_E_MANUAL_taskUnitList_join ON PP_E_MANUAL_taskUnitList (MANUAL_XID);
CREATE INDEX PP_E_MAPPING_application ON PP_E_MAPPING (xapplication);
CREATE INDEX PP_E_MAPPING_process ON PP_E_MAPPING (xprocess);
CREATE INDEX PP_E_MAPPING_tableName ON PP_E_MAPPING (xtableName);
CREATE INDEX PP_E_MERGE_allowReroute ON PP_E_MERGE (xallowReroute);
CREATE INDEX PP_E_MERGE_allowRerouteTo ON PP_E_MERGE (xallowRerouteTo);
CREATE INDEX PP_E_MERGE_form ON PP_E_MERGE (xform);
CREATE INDEX PP_E_MERGE_process ON PP_E_MERGE (xprocess);
CREATE INDEX PP_E_MERGE_readDataPathList_element ON PP_E_MERGE_readDataPathList (xreadDataPathList);
CREATE INDEX PP_E_MERGE_readDataPathList_join ON PP_E_MERGE_readDataPathList (MERGE_XID);
CREATE INDEX PP_E_MERGE_readGroupList_element ON PP_E_MERGE_readGroupList (xreadGroupList);
CREATE INDEX PP_E_MERGE_readGroupList_join ON PP_E_MERGE_readGroupList (MERGE_XID);
CREATE INDEX PP_E_MERGE_readIdentityList_element ON PP_E_MERGE_readIdentityList (xreadIdentityList);
CREATE INDEX PP_E_MERGE_readIdentityList_join ON PP_E_MERGE_readIdentityList (MERGE_XID);
CREATE INDEX PP_E_MERGE_readUnitList_element ON PP_E_MERGE_readUnitList (xreadUnitList);
CREATE INDEX PP_E_MERGE_readUnitList_join ON PP_E_MERGE_readUnitList (MERGE_XID);
CREATE INDEX PP_E_MERGE_reviewDataPathList_element ON PP_E_MERGE_reviewDataPathList (xreviewDataPathList);
CREATE INDEX PP_E_MERGE_reviewDataPathList_join ON PP_E_MERGE_reviewDataPathList (MERGE_XID);
CREATE INDEX PP_E_MERGE_reviewGroupList_element ON PP_E_MERGE_reviewGroupList (xreviewGroupList);
CREATE INDEX PP_E_MERGE_reviewGroupList_join ON PP_E_MERGE_reviewGroupList (MERGE_XID);
CREATE INDEX PP_E_MERGE_reviewIdentityList_element ON PP_E_MERGE_reviewIdentityList (xreviewIdentityList);
CREATE INDEX PP_E_MERGE_reviewIdentityList_join ON PP_E_MERGE_reviewIdentityList (MERGE_XID);
CREATE INDEX PP_E_MERGE_reviewUnitList_element ON PP_E_MERGE_reviewUnitList (xreviewUnitList);
CREATE INDEX PP_E_MERGE_reviewUnitList_join ON PP_E_MERGE_reviewUnitList (MERGE_XID);
CREATE INDEX PP_E_MESSAGE_allowReroute ON PP_E_MESSAGE (xallowReroute);
CREATE INDEX PP_E_MESSAGE_allowRerouteTo ON PP_E_MESSAGE (xallowRerouteTo);
CREATE INDEX PP_E_MESSAGE_form ON PP_E_MESSAGE (xform);
CREATE INDEX PP_E_MESSAGE_process ON PP_E_MESSAGE (xprocess);
CREATE INDEX PP_E_MESSAGE_readDataPathList_element ON PP_E_MESSAGE_readDataPathList (xreadDataPathList);
CREATE INDEX PP_E_MESSAGE_readDataPathList_join ON PP_E_MESSAGE_readDataPathList (MESSAGE_XID);
CREATE INDEX PP_E_MESSAGE_readGroupList_element ON PP_E_MESSAGE_readGroupList (xreadGroupList);
CREATE INDEX PP_E_MESSAGE_readGroupList_join ON PP_E_MESSAGE_readGroupList (MESSAGE_XID);
CREATE INDEX PP_E_MESSAGE_readIdentityList_element ON PP_E_MESSAGE_readIdentityList (xreadIdentityList);
CREATE INDEX PP_E_MESSAGE_readIdentityList_join ON PP_E_MESSAGE_readIdentityList (MESSAGE_XID);
CREATE INDEX PP_E_MESSAGE_readUnitList_element ON PP_E_MESSAGE_readUnitList (xreadUnitList);
CREATE INDEX PP_E_MESSAGE_readUnitList_join ON PP_E_MESSAGE_readUnitList (MESSAGE_XID);
CREATE INDEX PP_E_MESSAGE_reviewDataPathList_element ON PP_E_MESSAGE_reviewDataPathList (xreviewDataPathList);
CREATE INDEX PP_E_MESSAGE_reviewDataPathList_join ON PP_E_MESSAGE_reviewDataPathList (MESSAGE_XID);
CREATE INDEX PP_E_MESSAGE_reviewGroupList_element ON PP_E_MESSAGE_reviewGroupList (xreviewGroupList);
CREATE INDEX PP_E_MESSAGE_reviewGroupList_join ON PP_E_MESSAGE_reviewGroupList (MESSAGE_XID);
CREATE INDEX PP_E_MESSAGE_reviewIdentityList_element ON PP_E_MESSAGE_reviewIdentityList (xreviewIdentityList);
CREATE INDEX PP_E_MESSAGE_reviewIdentityList_join ON PP_E_MESSAGE_reviewIdentityList (MESSAGE_XID);
CREATE INDEX PP_E_MESSAGE_reviewUnitList_element ON PP_E_MESSAGE_reviewUnitList (xreviewUnitList);
CREATE INDEX PP_E_MESSAGE_reviewUnitList_join ON PP_E_MESSAGE_reviewUnitList (MESSAGE_XID);
CREATE INDEX PP_E_PARALLEL_allowReroute ON PP_E_PARALLEL (xallowReroute);
CREATE INDEX PP_E_PARALLEL_allowRerouteTo ON PP_E_PARALLEL (xallowRerouteTo);
CREATE INDEX PP_E_PARALLEL_form ON PP_E_PARALLEL (xform);
CREATE INDEX PP_E_PARALLEL_process ON PP_E_PARALLEL (xprocess);
CREATE INDEX PP_E_PARALLEL_readDataPathList_element ON PP_E_PARALLEL_readDataPathList (xreadDataPathList);
CREATE INDEX PP_E_PARALLEL_readDataPathList_join ON PP_E_PARALLEL_readDataPathList (PARALLEL_XID);
CREATE INDEX PP_E_PARALLEL_readGroupList_element ON PP_E_PARALLEL_readGroupList (xreadGroupList);
CREATE INDEX PP_E_PARALLEL_readGroupList_join ON PP_E_PARALLEL_readGroupList (PARALLEL_XID);
CREATE INDEX PP_E_PARALLEL_readIdentityList_element ON PP_E_PARALLEL_readIdentityList (xreadIdentityList);
CREATE INDEX PP_E_PARALLEL_readIdentityList_join ON PP_E_PARALLEL_readIdentityList (PARALLEL_XID);
CREATE INDEX PP_E_PARALLEL_readUnitList_element ON PP_E_PARALLEL_readUnitList (xreadUnitList);
CREATE INDEX PP_E_PARALLEL_readUnitList_join ON PP_E_PARALLEL_readUnitList (PARALLEL_XID);
CREATE INDEX PP_E_PARALLEL_reviewDataPathList_element ON PP_E_PARALLEL_reviewDataPathList (xreviewDataPathList);
CREATE INDEX PP_E_PARALLEL_reviewDataPathList_join ON PP_E_PARALLEL_reviewDataPathList (PARALLEL_XID);
CREATE INDEX PP_E_PARALLEL_reviewGroupList_element ON PP_E_PARALLEL_reviewGroupList (xreviewGroupList);
CREATE INDEX PP_E_PARALLEL_reviewGroupList_join ON PP_E_PARALLEL_reviewGroupList (PARALLEL_XID);
CREATE INDEX PP_E_PARALLEL_reviewIdentityList_element ON PP_E_PARALLEL_reviewIdentityList (xreviewIdentityList);
CREATE INDEX PP_E_PARALLEL_reviewIdentityList_join ON PP_E_PARALLEL_reviewIdentityList (PARALLEL_XID);
CREATE INDEX PP_E_PARALLEL_reviewUnitList_element ON PP_E_PARALLEL_reviewUnitList (xreviewUnitList);
CREATE INDEX PP_E_PARALLEL_reviewUnitList_join ON PP_E_PARALLEL_reviewUnitList (PARALLEL_XID);
CREATE INDEX PP_E_PARALLEL_routeList_element ON PP_E_PARALLEL_routeList (xrouteList);
CREATE INDEX PP_E_PARALLEL_routeList_join ON PP_E_PARALLEL_routeList (PARALLEL_XID);
CREATE INDEX PP_E_PROCESSVERSION_process ON PP_E_PROCESSVERSION (xprocess);
CREATE INDEX PP_E_PROCESS_controllerList_element ON PP_E_PROCESS_controllerList (xcontrollerList);
CREATE INDEX PP_E_PROCESS_controllerList_join ON PP_E_PROCESS_controllerList (PROCESS_XID);
CREATE INDEX PP_E_PROCESS_startableIdentityList ON PP_E_PROCESS_startableIdentityList (PROCESS_XID);
CREATE INDEX PP_E_PROCESS_startableIdentityList_join ON PP_E_PROCESS_startableIdentityList (xstartableIdentityList);
CREATE INDEX PP_E_PROCESS_startableUnitList_element ON PP_E_PROCESS_startableUnitList (xstartableUnitList);
CREATE INDEX PP_E_PROCESS_startableUnitList_join ON PP_E_PROCESS_startableUnitList (PROCESS_XID);
CREATE INDEX PP_E_QUERYSTAT_application ON PP_E_QUERYSTAT (xapplication);
CREATE INDEX PP_E_QUERYSTAT_creatorPerson ON PP_E_QUERYSTAT (xcreatorPerson);
CREATE INDEX PP_E_QUERYSTAT_lastUpdatePerson ON PP_E_QUERYSTAT (xlastUpdatePerson);
CREATE INDEX PP_E_QUERYSTAT_lastUpdateTime ON PP_E_QUERYSTAT (xlastUpdateTime);
CREATE INDEX PP_E_QUERYSTAT_name ON PP_E_QUERYSTAT (xname);
CREATE INDEX PP_E_QUERYSTAT_queryView ON PP_E_QUERYSTAT (xqueryView);
CREATE INDEX PP_E_QUERYSTAT_queryViewAlias ON PP_E_QUERYSTAT (xqueryViewAlias);
CREATE INDEX PP_E_QUERYSTAT_queryViewName ON PP_E_QUERYSTAT (xqueryViewName);
CREATE INDEX PP_E_QUERYSTAT_timingEnable ON PP_E_QUERYSTAT (xtimingEnable);
CREATE INDEX PP_E_QUERYSTAT_timingInterval ON PP_E_QUERYSTAT (xtimingInterval);
CREATE INDEX PP_E_QUERYSTATTIMED_expiredTime ON PP_E_QUERYSTATTIMED (xexpiredTime);
CREATE INDEX PP_E_QUERYSTATTIMED_project ON PP_E_QUERYSTATTIMED (xproject);
CREATE INDEX PP_E_QUERYSTATTIMED_queryStat ON PP_E_QUERYSTATTIMED (xqueryStat);
CREATE INDEX PP_E_QUERYSTATTIMED_scheduleTime ON PP_E_QUERYSTATTIMED (xscheduleTime);
CREATE INDEX PP_E_QUERYSTATTIMED_timingInterval ON PP_E_QUERYSTATTIMED (xtimingInterval);
CREATE INDEX PP_E_QUERYSTAT_availableIdentityList_element ON PP_E_QUERYSTAT_availableIdentityList (xavailableIdentityList);
CREATE INDEX PP_E_QUERYSTAT_availableIdentityList_join ON PP_E_QUERYSTAT_availableIdentityList (QUERYSTAT_XID);
CREATE INDEX PP_E_QUERYSTAT_availablePersonList_element ON PP_E_QUERYSTAT_availablePersonList (xavailablePersonList);
CREATE INDEX PP_E_QUERYSTAT_availablePersonList_join ON PP_E_QUERYSTAT_availablePersonList (QUERYSTAT_XID);
CREATE INDEX PP_E_QUERYSTAT_availableUnitList_element ON PP_E_QUERYSTAT_availableUnitList (xavailableUnitList);
CREATE INDEX PP_E_QUERYSTAT_availableUnitList_join ON PP_E_QUERYSTAT_availableUnitList (QUERYSTAT_XID);
CREATE INDEX PP_E_QUERYSTAT_controllerList_element ON PP_E_QUERYSTAT_controllerList (xcontrollerList);
CREATE INDEX PP_E_QUERYSTAT_controllerList_join ON PP_E_QUERYSTAT_controllerList (QUERYSTAT_XID);
CREATE INDEX PP_E_QUERYVIEW_application ON PP_E_QUERYVIEW (xapplication);
CREATE INDEX PP_E_QUERYVIEW_creatorPerson ON PP_E_QUERYVIEW (xcreatorPerson);
CREATE INDEX PP_E_QUERYVIEW_display ON PP_E_QUERYVIEW (xdisplay);
CREATE INDEX PP_E_QUERYVIEW_lastUpdatePerson ON PP_E_QUERYVIEW (xlastUpdatePerson);
CREATE INDEX PP_E_QUERYVIEW_lastUpdateTime ON PP_E_QUERYVIEW (xlastUpdateTime);
CREATE INDEX PP_E_QUERYVIEW_name ON PP_E_QUERYVIEW (xname);
CREATE INDEX PP_E_QUERYVIEW_timingEnable ON PP_E_QUERYVIEW (xtimingEnable);
CREATE INDEX PP_E_QUERYVIEW_timingInterval ON PP_E_QUERYVIEW (xtimingInterval);
CREATE INDEX PP_E_QUERYVIEW_timingTouch ON PP_E_QUERYVIEW (xtimingTouch);
CREATE INDEX PP_E_QUERYVIEW_availableIdentityList_element ON PP_E_QUERYVIEW_availableIdentityList (xavailableIdentityList);
CREATE INDEX PP_E_QUERYVIEW_availableIdentityList_join ON PP_E_QUERYVIEW_availableIdentityList (QUERYVIEW_XID);
CREATE INDEX PP_E_QUERYVIEW_availablePersonList_element ON PP_E_QUERYVIEW_availablePersonList (xavailablePersonList);
CREATE INDEX PP_E_QUERYVIEW_availablePersonList_join ON PP_E_QUERYVIEW_availablePersonList (QUERYVIEW_XID);
CREATE INDEX PP_E_QUERYVIEW_availableUnitList_element ON PP_E_QUERYVIEW_availableUnitList (xavailableUnitList);
CREATE INDEX PP_E_QUERYVIEW_availableUnitList_join ON PP_E_QUERYVIEW_availableUnitList (QUERYVIEW_XID);
CREATE INDEX PP_E_QUERYVIEW_controllerList_element ON PP_E_QUERYVIEW_controllerList (xcontrollerList);
CREATE INDEX PP_E_QUERYVIEW_controllerList_join ON PP_E_QUERYVIEW_controllerList (QUERYVIEW_XID);
CREATE INDEX PP_E_ROUTE_activity ON PP_E_ROUTE (xactivity);
CREATE INDEX PP_E_ROUTE_activityType ON PP_E_ROUTE (xactivityType);
CREATE INDEX PP_E_ROUTE_orderNumber ON PP_E_ROUTE (xorderNumber);
CREATE INDEX PP_E_ROUTE_process ON PP_E_ROUTE (xprocess);
CREATE INDEX PP_E_SCRIPT_application ON PP_E_SCRIPT (xapplication);
CREATE INDEX PP_E_SCRIPTVERSION_script ON PP_E_SCRIPTVERSION (xscript);
CREATE INDEX PP_E_SCRIPT_dependScriptList_element ON PP_E_SCRIPT_dependScriptList (xdependScriptList);
CREATE INDEX PP_E_SCRIPT_dependScriptList_join ON PP_E_SCRIPT_dependScriptList (SCRIPT_XID);
CREATE INDEX PP_E_SERVICE_allowReroute ON PP_E_SERVICE (xallowReroute);
CREATE INDEX PP_E_SERVICE_allowRerouteTo ON PP_E_SERVICE (xallowRerouteTo);
CREATE INDEX PP_E_SERVICE_form ON PP_E_SERVICE (xform);
CREATE INDEX PP_E_SERVICE_process ON PP_E_SERVICE (xprocess);
CREATE INDEX PP_E_SERVICE_readDataPathList_element ON PP_E_SERVICE_readDataPathList (xreadDataPathList);
CREATE INDEX PP_E_SERVICE_readDataPathList_join ON PP_E_SERVICE_readDataPathList (SERVICE_XID);
CREATE INDEX PP_E_SERVICE_readGroupList_element ON PP_E_SERVICE_readGroupList (xreadGroupList);
CREATE INDEX PP_E_SERVICE_readGroupList_join ON PP_E_SERVICE_readGroupList (SERVICE_XID);
CREATE INDEX PP_E_SERVICE_readIdentityList_element ON PP_E_SERVICE_readIdentityList (xreadIdentityList);
CREATE INDEX PP_E_SERVICE_readIdentityList_join ON PP_E_SERVICE_readIdentityList (SERVICE_XID);
CREATE INDEX PP_E_SERVICE_readUnitList_element ON PP_E_SERVICE_readUnitList (xreadUnitList);
CREATE INDEX PP_E_SERVICE_readUnitList_join ON PP_E_SERVICE_readUnitList (SERVICE_XID);
CREATE INDEX PP_E_SERVICE_reviewDataPathList_element ON PP_E_SERVICE_reviewDataPathList (xreviewDataPathList);
CREATE INDEX PP_E_SERVICE_reviewDataPathList_join ON PP_E_SERVICE_reviewDataPathList (SERVICE_XID);
CREATE INDEX PP_E_SERVICE_reviewGroupList_element ON PP_E_SERVICE_reviewGroupList (xreviewGroupList);
CREATE INDEX PP_E_SERVICE_reviewGroupList_join ON PP_E_SERVICE_reviewGroupList (SERVICE_XID);
CREATE INDEX PP_E_SERVICE_reviewIdentityList_element ON PP_E_SERVICE_reviewIdentityList (xreviewIdentityList);
CREATE INDEX PP_E_SERVICE_reviewIdentityList_join ON PP_E_SERVICE_reviewIdentityList (SERVICE_XID);
CREATE INDEX PP_E_SERVICE_reviewUnitList_element ON PP_E_SERVICE_reviewUnitList (xreviewUnitList);
CREATE INDEX PP_E_SERVICE_reviewUnitList_join ON PP_E_SERVICE_reviewUnitList (SERVICE_XID);
CREATE INDEX PP_E_SERVICE_trustAddressList_element ON PP_E_SERVICE_trustAddressList (xtrustAddressList);
CREATE INDEX PP_E_SERVICE_trustAddressList_join ON PP_E_SERVICE_trustAddressList (SERVICE_XID);
CREATE INDEX PP_E_SPLIT_allowReroute ON PP_E_SPLIT (xallowReroute);
CREATE INDEX PP_E_SPLIT_allowRerouteTo ON PP_E_SPLIT (xallowRerouteTo);
CREATE INDEX PP_E_SPLIT_form ON PP_E_SPLIT (xform);
CREATE INDEX PP_E_SPLIT_process ON PP_E_SPLIT (xprocess);
CREATE INDEX PP_E_SPLIT_readDataPathList_element ON PP_E_SPLIT_readDataPathList (xreadDataPathList);
CREATE INDEX PP_E_SPLIT_readDataPathList_join ON PP_E_SPLIT_readDataPathList (SPLIT_XID);
CREATE INDEX PP_E_SPLIT_readGroupList_element ON PP_E_SPLIT_readGroupList (xreadGroupList);
CREATE INDEX PP_E_SPLIT_readGroupList_join ON PP_E_SPLIT_readGroupList (SPLIT_XID);
CREATE INDEX PP_E_SPLIT_readIdentityList_element ON PP_E_SPLIT_readIdentityList (xreadIdentityList);
CREATE INDEX PP_E_SPLIT_readIdentityList_join ON PP_E_SPLIT_readIdentityList (SPLIT_XID);
CREATE INDEX PP_E_SPLIT_readUnitList_element ON PP_E_SPLIT_readUnitList (xreadUnitList);
CREATE INDEX PP_E_SPLIT_readUnitList_join ON PP_E_SPLIT_readUnitList (SPLIT_XID);
CREATE INDEX PP_E_SPLIT_reviewDataPathList_element ON PP_E_SPLIT_reviewDataPathList (xreviewDataPathList);
CREATE INDEX PP_E_SPLIT_reviewDataPathList_join ON PP_E_SPLIT_reviewDataPathList (SPLIT_XID);
CREATE INDEX PP_E_SPLIT_reviewGroupList_element ON PP_E_SPLIT_reviewGroupList (xreviewGroupList);
CREATE INDEX PP_E_SPLIT_reviewGroupList_join ON PP_E_SPLIT_reviewGroupList (SPLIT_XID);
CREATE INDEX PP_E_SPLIT_reviewIdentityList_element ON PP_E_SPLIT_reviewIdentityList (xreviewIdentityList);
CREATE INDEX PP_E_SPLIT_reviewIdentityList_join ON PP_E_SPLIT_reviewIdentityList (SPLIT_XID);
CREATE INDEX PP_E_SPLIT_reviewUnitList_element ON PP_E_SPLIT_reviewUnitList (xreviewUnitList);
CREATE INDEX PP_E_SPLIT_reviewUnitList_join ON PP_E_SPLIT_reviewUnitList (SPLIT_XID);
CREATE INDEX PP_E_TEMPLATEFORM_category ON PP_E_TEMPLATEFORM (xcategory);
CREATE INDEX PP_L_PROCESSINGERROR_message ON PP_L_PROCESSINGERROR (xmessage);
CREATE INDEX PP_L_PROCESSINGERROR_work ON PP_L_PROCESSINGERROR (xwork);
CREATE INDEX PP_T_SERVICEVALUE_application ON PP_T_SERVICEVALUE (xapplication);
CREATE INDEX PP_T_SERVICEVALUE_process ON PP_T_SERVICEVALUE (xprocess);
CREATE INDEX PP_T_SERVICEVALUE_service ON PP_T_SERVICEVALUE (xservice);
CREATE INDEX PP_T_SERVICEVALUE_work ON PP_T_SERVICEVALUE (xwork);
CREATE INDEX PTL_FILE_length ON PTL_FILE (xlength);
CREATE INDEX PTL_FILE_portal ON PTL_FILE (xportal);
CREATE INDEX PTL_PAGE_alias ON PTL_PAGE (xalias);
CREATE INDEX PTL_PAGE_name ON PTL_PAGE (xname);
CREATE INDEX PTL_PAGE_portal ON PTL_PAGE (xportal);
CREATE INDEX PTL_PORTAL_alias ON PTL_PORTAL (xalias);
CREATE INDEX PTL_PORTAL_creatorPerson ON PTL_PORTAL (xcreatorPerson);
CREATE INDEX PTL_PORTAL_lastUpdatePerson ON PTL_PORTAL (xlastUpdatePerson);
CREATE INDEX PTL_PORTAL_lastUpdateTime ON PTL_PORTAL (xlastUpdateTime);
CREATE INDEX PTL_PORTAL_name ON PTL_PORTAL (xname);
CREATE INDEX PTL_PORTAL_portalCategory ON PTL_PORTAL (xportalCategory);
CREATE INDEX PTL_PORTAL_availableIdentityList_element ON PTL_PORTAL_availableIdentityList (xavailableIdentityList);
CREATE INDEX PTL_PORTAL_availableIdentityList_join ON PTL_PORTAL_availableIdentityList (PORTAL_XID);
CREATE INDEX PTL_PORTAL_availableUnitList_element ON PTL_PORTAL_availableUnitList (xavailableUnitList);
CREATE INDEX PTL_PORTAL_availableUnitList_join ON PTL_PORTAL_availableUnitList (PORTAL_XID);
CREATE INDEX PTL_PORTAL_controllerList_element ON PTL_PORTAL_controllerList (xcontrollerList);
CREATE INDEX PTL_PORTAL_controllerList_join ON PTL_PORTAL_controllerList (PORTAL_XID);
CREATE INDEX PTL_SCRIPT_alias ON PTL_SCRIPT (xalias);
CREATE INDEX PTL_SCRIPT_name ON PTL_SCRIPT (xname);
CREATE INDEX PTL_SCRIPT_portal ON PTL_SCRIPT (xportal);
CREATE INDEX PTL_SCRIPT_dependScriptList_element ON PTL_SCRIPT_dependScriptList (xdependScriptList);
CREATE INDEX PTL_SCRIPT_dependScriptList_join ON PTL_SCRIPT_dependScriptList (SCRIPT_XID);
CREATE INDEX PTL_TEMPLATEPAGE_category ON PTL_TEMPLATEPAGE (xcategory);
CREATE INDEX PTL_TEMPLATEPAGE_creatorPerson ON PTL_TEMPLATEPAGE (xcreatorPerson);
CREATE INDEX PTL_TEMPLATEPAGE_lastUpdatePerson ON PTL_TEMPLATEPAGE (xlastUpdatePerson);
CREATE INDEX PTL_TEMPLATEPAGE_lastUpdateTime ON PTL_TEMPLATEPAGE (xlastUpdateTime);
CREATE INDEX PTL_TEMPLATEPAGE_availableIdentityList_element ON PTL_TEMPLATEPAGE_availableIdentityList (xavailableIdentityList);
CREATE INDEX PTL_TEMPLATEPAGE_availableIdentityList_join ON PTL_TEMPLATEPAGE_availableIdentityList (TEMPLATEPAGE_XID);
CREATE INDEX PTL_TEMPLATEPAGE_availableUnitList ON PTL_TEMPLATEPAGE_availableUnitList (TEMPLATEPAGE_XID);
CREATE INDEX PTL_TEMPLATEPAGE_availableUnitList_element ON PTL_TEMPLATEPAGE_availableUnitList (xavailableUnitList);
CREATE INDEX PTL_TEMPLATEPAGE_controllerList_element ON PTL_TEMPLATEPAGE_controllerList (xcontrollerList);
CREATE INDEX PTL_TEMPLATEPAGE_controllerList_join ON PTL_TEMPLATEPAGE_controllerList (TEMPLATEPAGE_XID);
CREATE INDEX PTL_WIDGET_alias ON PTL_WIDGET (xalias);
CREATE INDEX PTL_WIDGET_name ON PTL_WIDGET (xname);
CREATE INDEX PTL_WIDGET_portal ON PTL_WIDGET (xportal);
CREATE INDEX QRY_ITEM_booleanValue ON QRY_ITEM (xbooleanValue);
CREATE INDEX QRY_ITEM_bundle ON QRY_ITEM (xbundle);
CREATE INDEX QRY_ITEM_dateTimeValue ON QRY_ITEM (xdateTimeValue);
CREATE INDEX QRY_ITEM_dateValue ON QRY_ITEM (xdateValue);
CREATE INDEX QRY_ITEM_itemCategory ON QRY_ITEM (xitemCategory);
CREATE INDEX QRY_ITEM_itemPrimitiveType ON QRY_ITEM (xitemPrimitiveType);
CREATE INDEX QRY_ITEM_itemStringValueType ON QRY_ITEM (xitemStringValueType);
CREATE INDEX QRY_ITEM_itemType ON QRY_ITEM (xitemType);
CREATE INDEX QRY_ITEM_numberValue ON QRY_ITEM (xnumberValue);
CREATE INDEX QRY_ITEM_path0 ON QRY_ITEM (xpath0);
CREATE INDEX QRY_ITEM_path0Location ON QRY_ITEM (xpath0Location);
CREATE INDEX QRY_ITEM_path1 ON QRY_ITEM (xpath1);
CREATE INDEX QRY_ITEM_path1Location ON QRY_ITEM (xpath1Location);
CREATE INDEX QRY_ITEM_path2 ON QRY_ITEM (xpath2);
CREATE INDEX QRY_ITEM_path2Location ON QRY_ITEM (xpath2Location);
CREATE INDEX QRY_ITEM_path3 ON QRY_ITEM (xpath3);
CREATE INDEX QRY_ITEM_path3Location ON QRY_ITEM (xpath3Location);
CREATE INDEX QRY_ITEM_path4 ON QRY_ITEM (xpath4);
CREATE INDEX QRY_ITEM_path4Location ON QRY_ITEM (xpath4Location);
CREATE INDEX QRY_ITEM_path5 ON QRY_ITEM (xpath5);
CREATE INDEX QRY_ITEM_path5Location ON QRY_ITEM (xpath5Location);
CREATE INDEX QRY_ITEM_path6 ON QRY_ITEM (xpath6);
CREATE INDEX QRY_ITEM_path6Location ON QRY_ITEM (xpath6Location);
CREATE INDEX QRY_ITEM_path7 ON QRY_ITEM (xpath7);
CREATE INDEX QRY_ITEM_path7Location ON QRY_ITEM (xpath7Location);
CREATE INDEX QRY_ITEM_stringShortValue ON QRY_ITEM (xstringShortValue);
CREATE INDEX QRY_ITEM_timeValue ON QRY_ITEM (xtimeValue);
CREATE INDEX QRY_NRL_ENTRY_bundle ON QRY_NRL_ENTRY (xbundle);
CREATE INDEX QRY_NRL_ENTRY_inValueCount ON QRY_NRL_ENTRY (xinValueCount);
CREATE INDEX QRY_NRL_ENTRY_model ON QRY_NRL_ENTRY (xmodel);
CREATE INDEX QRY_NRL_ENTRY_outValueCount ON QRY_NRL_ENTRY (xoutValueCount);
CREATE INDEX QRY_NRL_ENTRY_title ON QRY_NRL_ENTRY (xtitle);
CREATE INDEX QRY_NRL_ENTRY_inValueLabelList_element ON QRY_NRL_ENTRY_inValueLabelList (xinValueLabelList);
CREATE INDEX QRY_NRL_ENTRY_inValueLabelList_join ON QRY_NRL_ENTRY_inValueLabelList (ENTRY_XID);
CREATE INDEX QRY_NRL_ENTRY_outValueLabelList_element ON QRY_NRL_ENTRY_outValueLabelList (xoutValueLabelList);
CREATE INDEX QRY_NRL_ENTRY_outValueLabelList_join ON QRY_NRL_ENTRY_outValueLabelList (ENTRY_XID);
CREATE INDEX QRY_NRL_INTEXT_count ON QRY_NRL_INTEXT (xcount);
CREATE INDEX QRY_NRL_INTEXT_model ON QRY_NRL_INTEXT (xmodel);
CREATE INDEX QRY_NRL_INTEXT_serial ON QRY_NRL_INTEXT (xserial);
CREATE INDEX QRY_NRL_INTEXT_text ON QRY_NRL_INTEXT (xtext);
CREATE INDEX QRY_NRL_INVALUE_count ON QRY_NRL_INVALUE (xcount);
CREATE INDEX QRY_NRL_INVALUE_inTextSerial ON QRY_NRL_INVALUE (xinTextSerial);
CREATE INDEX QRY_NRL_INVALUE_model ON QRY_NRL_INVALUE (xmodel);
CREATE INDEX QRY_NRL_INVALUE_serial ON QRY_NRL_INVALUE (xserial);
CREATE INDEX QRY_NRL_INVALUE_text ON QRY_NRL_INVALUE (xtext);
CREATE INDEX QRY_NRL_MODEL_effectiveEntryCount ON QRY_NRL_MODEL (xeffectiveEntryCount);
CREATE INDEX QRY_NRL_MODEL_endDate ON QRY_NRL_MODEL (xendDate);
CREATE INDEX QRY_NRL_MODEL_entryCount ON QRY_NRL_MODEL (xentryCount);
CREATE INDEX QRY_NRL_MODEL_name ON QRY_NRL_MODEL (xname);
CREATE INDEX QRY_NRL_MODEL_startDate ON QRY_NRL_MODEL (xstartDate);
CREATE INDEX QRY_NRL_MODEL_applicationList_element ON QRY_NRL_MODEL_applicationList (xapplicationList);
CREATE INDEX QRY_NRL_MODEL_applicationList_join ON QRY_NRL_MODEL_applicationList (MODEL_XID);
CREATE INDEX QRY_NRL_MODEL_processList_element ON QRY_NRL_MODEL_processList (xprocessList);
CREATE INDEX QRY_NRL_MODEL_processList_join ON QRY_NRL_MODEL_processList (MODEL_XID);
CREATE INDEX QRY_NRL_MODEL_propertyMap_element ON QRY_NRL_MODEL_propertyMap (xpropertyMap);
CREATE INDEX QRY_NRL_MODEL_propertyMap_join ON QRY_NRL_MODEL_propertyMap (MODEL_XID);
CREATE INDEX QRY_NRL_MODEL_propertyMap_key ON QRY_NRL_MODEL_propertyMap (xkey);
CREATE INDEX QRY_NRL_OUTTEXT_count ON QRY_NRL_OUTTEXT (xcount);
CREATE INDEX QRY_NRL_OUTTEXT_model ON QRY_NRL_OUTTEXT (xmodel);
CREATE INDEX QRY_NRL_OUTTEXT_serial ON QRY_NRL_OUTTEXT (xserial);
CREATE INDEX QRY_NRL_OUTTEXT_text ON QRY_NRL_OUTTEXT (xtext);
CREATE INDEX QRY_NRL_OUTVALUE_count ON QRY_NRL_OUTVALUE (xcount);
CREATE INDEX QRY_NRL_OUTVALUE_model ON QRY_NRL_OUTVALUE (xmodel);
CREATE INDEX QRY_NRL_OUTVALUE_serial ON QRY_NRL_OUTVALUE (xserial);
CREATE INDEX QRY_NRL_OUTVALUE_text ON QRY_NRL_OUTVALUE (xtext);
CREATE INDEX QRY_PGM_ARGUMENT_name ON QRY_PGM_ARGUMENT (xname);
CREATE INDEX QRY_PGM_ARGUMENT_stringValue ON QRY_PGM_ARGUMENT (xstringValue);
CREATE INDEX QRY_QUERY_availableIdentityList_element ON QRY_QUERY_availableIdentityList (xavailableIdentityList);
CREATE INDEX QRY_QUERY_availableIdentityList_join ON QRY_QUERY_availableIdentityList (QUERY_XID);
CREATE INDEX QRY_QUERY_availableUnitList_element ON QRY_QUERY_availableUnitList (xavailableUnitList);
CREATE INDEX QRY_QUERY_availableUnitList_join ON QRY_QUERY_availableUnitList (QUERY_XID);
CREATE INDEX QRY_QUERY_controllerList ON QRY_QUERY_controllerList (QUERY_XID);
CREATE INDEX QRY_QUERY_controllerList_element ON QRY_QUERY_controllerList (xcontrollerList);
CREATE INDEX QRY_REVEAL_name ON QRY_REVEAL (xname);
CREATE INDEX QRY_REVEAL_query ON QRY_REVEAL (xquery);
CREATE INDEX QRY_REVEAL_stat ON QRY_REVEAL (xstat);
CREATE INDEX QRY_REVEAL_view ON QRY_REVEAL (xview);
CREATE INDEX QRY_REVEAL_availableIdentityList_element ON QRY_REVEAL_availableIdentityList (xavailableIdentityList);
CREATE INDEX QRY_REVEAL_availableIdentityList_join ON QRY_REVEAL_availableIdentityList (REVEAL_XID);
CREATE INDEX QRY_REVEAL_availableUnitList_element ON QRY_REVEAL_availableUnitList (xavailableUnitList);
CREATE INDEX QRY_REVEAL_availableUnitList_join ON QRY_REVEAL_availableUnitList (REVEAL_XID);
CREATE INDEX QRY_SCH_STATEMENTxquery ON QRY_SCH_STATEMENT (xquery);
CREATE INDEX QRY_SCH_STATEMENT_alias ON QRY_SCH_STATEMENT (xalias);
CREATE INDEX QRY_SCH_STATEMENT_format ON QRY_SCH_STATEMENT (xformat);
CREATE INDEX QRY_SCH_STATEMENT_name ON QRY_SCH_STATEMENT (xname);
CREATE INDEX QRY_SCH_STATEMENT_table ON QRY_SCH_STATEMENT (xtable);
CREATE INDEX QRY_SCH_STATEMENT_type ON QRY_SCH_STATEMENT (xtype);
CREATE INDEX QRY_SCH_STATEMENT_executePersonList_element ON QRY_SCH_STATEMENT_executePersonList (xexecutePersonList);
CREATE INDEX QRY_SCH_STATEMENT_executePersonList_join ON QRY_SCH_STATEMENT_executePersonList (STATEMENT_XID);
CREATE INDEX QRY_SCH_STATEMENT_executeUnitList_element ON QRY_SCH_STATEMENT_executeUnitList (xexecuteUnitList);
CREATE INDEX QRY_SCH_STATEMENT_executeUnitList_join ON QRY_SCH_STATEMENT_executeUnitList (STATEMENT_XID);
CREATE INDEX QRY_SCH_TABLExquery ON QRY_SCH_TABLE (xquery);
CREATE INDEX QRY_SCH_TABLE_alias ON QRY_SCH_TABLE (xalias);
CREATE INDEX QRY_SCH_TABLE_name ON QRY_SCH_TABLE (xname);
CREATE INDEX QRY_SCH_TABLE_editPersonList_element ON QRY_SCH_TABLE_editPersonList (xeditPersonList);
CREATE INDEX QRY_SCH_TABLE_editPersonList_join ON QRY_SCH_TABLE_editPersonList (TABLE_XID);
CREATE INDEX QRY_SCH_TABLE_editUnitList_element ON QRY_SCH_TABLE_editUnitList (xeditUnitList);
CREATE INDEX QRY_SCH_TABLE_editUnitList_join ON QRY_SCH_TABLE_editUnitList (TABLE_XID);
CREATE INDEX QRY_SCH_TABLE_readPersonList_element ON QRY_SCH_TABLE_readPersonList (xreadPersonList);
CREATE INDEX QRY_SCH_TABLE_readPersonList_join ON QRY_SCH_TABLE_readPersonList (TABLE_XID);
CREATE INDEX QRY_SCH_TABLE_readUnitList_element ON QRY_SCH_TABLE_readUnitList (xreadUnitList);
CREATE INDEX QRY_SCH_TABLE_readUnitList_join ON QRY_SCH_TABLE_readUnitList (TABLE_XID);
CREATE INDEX QRY_SEG_ENTRY_appId ON QRY_SEG_ENTRY (xappId);
CREATE INDEX QRY_SEG_ENTRY_application ON QRY_SEG_ENTRY (xapplication);
CREATE INDEX QRY_SEG_ENTRY_applicationName ON QRY_SEG_ENTRY (xapplicationName);
CREATE INDEX QRY_SEG_ENTRY_appName ON QRY_SEG_ENTRY (xappName);
CREATE INDEX QRY_SEG_ENTRY_bundle ON QRY_SEG_ENTRY (xbundle);
CREATE INDEX QRY_SEG_ENTRY_categoryId ON QRY_SEG_ENTRY (xcategoryId);
CREATE INDEX QRY_SEG_ENTRY_categoryName ON QRY_SEG_ENTRY (xcategoryName);
CREATE INDEX QRY_SEG_ENTRY_creatorPerson ON QRY_SEG_ENTRY (xcreatorPerson);
CREATE INDEX QRY_SEG_ENTRY_creatorUnit ON QRY_SEG_ENTRY (xcreatorUnit);
CREATE INDEX QRY_SEG_ENTRY_lastUpdateTime ON QRY_SEG_ENTRY (xlastUpdateTime);
CREATE INDEX QRY_SEG_ENTRY_process ON QRY_SEG_ENTRY (xprocess);
CREATE INDEX QRY_SEG_ENTRY_processName ON QRY_SEG_ENTRY (xprocessName);
CREATE INDEX QRY_SEG_ENTRY_reference ON QRY_SEG_ENTRY (xreference);
CREATE INDEX QRY_SEG_ENTRY_summary ON QRY_SEG_ENTRY (xsummary);
CREATE INDEX QRY_SEG_ENTRY_title ON QRY_SEG_ENTRY (xtitle);
CREATE INDEX QRY_SEG_ENTRY_type ON QRY_SEG_ENTRY (xtype);
CREATE INDEX QRY_SEG_ENTRY_wait ON QRY_SEG_ENTRY (xwait);
CREATE INDEX QRY_SEG_WORD_application ON QRY_SEG_WORD (xapplication);
CREATE INDEX QRY_SEG_WORD_bundle ON QRY_SEG_WORD (xbundle);
CREATE INDEX QRY_SEG_WORD_count ON QRY_SEG_WORD (xcount);
CREATE INDEX QRY_SEG_WORD_entry ON QRY_SEG_WORD (xentry);
CREATE INDEX QRY_SEG_WORD_label ON QRY_SEG_WORD (xlabel);
CREATE INDEX QRY_SEG_WORD_tag ON QRY_SEG_WORD (xtag);
CREATE INDEX QRY_SEG_WORD_type ON QRY_SEG_WORD (xtype);
CREATE INDEX QRY_SEG_WORD_value ON QRY_SEG_WORD (xvalue);
CREATE INDEX QRY_STATxquery ON QRY_STAT (xquery);
CREATE INDEX QRY_STAT_name ON QRY_STAT (xname);
CREATE INDEX QRY_STAT_availableIdentityList_element ON QRY_STAT_availableIdentityList (xavailableIdentityList);
CREATE INDEX QRY_STAT_availableIdentityList_join ON QRY_STAT_availableIdentityList (STAT_XID);
CREATE INDEX QRY_STAT_availableUnitList_element ON QRY_STAT_availableUnitList (xavailableUnitList);
CREATE INDEX QRY_STAT_availableUnitList_join ON QRY_STAT_availableUnitList (STAT_XID);
CREATE INDEX QRY_VIEWxquery ON QRY_VIEW (xquery);
CREATE INDEX QRY_VIEW_display ON QRY_VIEW (xdisplay);
CREATE INDEX QRY_VIEW_enableCache ON QRY_VIEW (xenableCache);
CREATE INDEX QRY_VIEW_availableIdentityList_element ON QRY_VIEW_availableIdentityList (xavailableIdentityList);
CREATE INDEX QRY_VIEW_availableIdentityList_join ON QRY_VIEW_availableIdentityList (VIEW_XID);
CREATE INDEX QRY_VIEW_availableUnitList_element ON QRY_VIEW_availableUnitList (xavailableUnitList);
CREATE INDEX QRY_VIEW_availableUnitList_join ON QRY_VIEW_availableUnitList (VIEW_XID);
CREATE INDEX SAMPLE_JPUSH_TABLENAME_name ON SAMPLE_JPUSH_TABLENAME (xname);
CREATE INDEX TEW_ATTACHMENT_deepPath ON TEW_ATTACHMENT (xdeepPath);
CREATE INDEX TEW_ATTACHMENT_lastUpdateTime ON TEW_ATTACHMENT (xlastUpdateTime);
CREATE INDEX TEW_ATTACHMENT_projectId ON TEW_ATTACHMENT (xprojectId);
CREATE INDEX TEW_ATTACHMENT_storage ON TEW_ATTACHMENT (xstorage);
CREATE INDEX TEW_ATTACHMENT_taskId ON TEW_ATTACHMENT (xtaskId);
CREATE INDEX TEW_CHAT_deleted ON TEW_CHAT (xdeleted);
CREATE INDEX TEW_CHAT_projectId ON TEW_CHAT (xprojectId);
CREATE INDEX TEW_CHAT_sender ON TEW_CHAT (xsender);
CREATE INDEX TEW_CHAT_target ON TEW_CHAT (xtarget);
CREATE INDEX TEW_CHAT_taskId ON TEW_CHAT (xtaskId);
CREATE INDEX TEW_DYNAMIC_bundle ON TEW_DYNAMIC (xbundle);
CREATE INDEX TEW_DYNAMIC_objectType ON TEW_DYNAMIC (xobjectType);
CREATE INDEX TEW_DYNAMIC_operator ON TEW_DYNAMIC (xoperator);
CREATE INDEX TEW_DYNAMIC_personal ON TEW_DYNAMIC (xpersonal);
CREATE INDEX TEW_DYNAMIC_projectId ON TEW_DYNAMIC (xprojectId);
CREATE INDEX TEW_DYNAMIC_taskId ON TEW_DYNAMIC (xtaskId);
CREATE INDEX TEW_PROJECT_archive ON TEW_PROJECT (xarchive);
CREATE INDEX TEW_PROJECT_completed ON TEW_PROJECT (xcompleted);
CREATE INDEX TEW_PROJECT_creatorPerson ON TEW_PROJECT (xcreatorPerson);
CREATE INDEX TEW_PROJECT_deleted ON TEW_PROJECT (xdeleted);
CREATE INDEX TEW_PROJECT_executor ON TEW_PROJECT (xexecutor);
CREATE INDEX TEW_PROJECT_title ON TEW_PROJECT (xtitle);
CREATE INDEX TEW_PROJECT_type ON TEW_PROJECT (xtype);
CREATE INDEX TEW_PROJECTEXTFIELD_RELE_displayName ON TEW_PROJECTEXTFIELD_RELE (xdisplayName);
CREATE INDEX TEW_PROJECTEXTFIELD_RELE_extFieldName ON TEW_PROJECTEXTFIELD_RELE (xextFieldName);
CREATE INDEX TEW_PROJECTEXTFIELD_RELE_projectId ON TEW_PROJECTEXTFIELD_RELE (xprojectId);
CREATE INDEX TEW_PROJECTGROUP_creatorPerson ON TEW_PROJECTGROUP (xcreatorPerson);
CREATE INDEX TEW_PROJECTGROUP_name ON TEW_PROJECTGROUP (xname);
CREATE INDEX TEW_PROJECTGROUP_owner ON TEW_PROJECTGROUP (xowner);
CREATE INDEX TEW_PROJECTGROUP_RELE_groupId ON TEW_PROJECTGROUP_RELE (xgroupId);
CREATE INDEX TEW_PROJECTGROUP_RELE_projectId ON TEW_PROJECTGROUP_RELE (xprojectId);
CREATE INDEX TEW_PROJECT_manageablePersonList_element ON TEW_PROJECT_manageablePersonList (xmanageablePersonList);
CREATE INDEX TEW_PROJECT_manageablePersonList_join ON TEW_PROJECT_manageablePersonList (PROJECT_XID);
CREATE INDEX TEW_PROJECT_participantGroupList_element ON TEW_PROJECT_participantGroupList (xparticipantGroupList);
CREATE INDEX TEW_PROJECT_participantGroupList_join ON TEW_PROJECT_participantGroupList (PROJECT_XID);
CREATE INDEX TEW_PROJECT_participantIdentityList_element ON TEW_PROJECT_participantIdentityList (xparticipantIdentityList);
CREATE INDEX TEW_PROJECT_participantIdentityList_join ON TEW_PROJECT_participantIdentityList (PROJECT_XID);
CREATE INDEX TEW_PROJECT_participantPersonList_element ON TEW_PROJECT_participantPersonList (xparticipantPersonList);
CREATE INDEX TEW_PROJECT_participantPersonList_join ON TEW_PROJECT_participantPersonList (PROJECT_XID);
CREATE INDEX TEW_PROJECT_participantUnitList_element ON TEW_PROJECT_participantUnitList (xparticipantUnitList);
CREATE INDEX TEW_PROJECT_participantUnitList_join ON TEW_PROJECT_participantUnitList (PROJECT_XID);
CREATE INDEX TEW_PROJECT_starPersonList_element ON TEW_PROJECT_starPersonList (xstarPersonList);
CREATE INDEX TEW_PROJECT_starPersonList_join ON TEW_PROJECT_starPersonList (PROJECT_XID);
CREATE INDEX TEW_REVIEW_archive ON TEW_REVIEW (xarchive);
CREATE INDEX TEW_REVIEW_claimed ON TEW_REVIEW (xclaimed);
CREATE INDEX TEW_REVIEW_completed ON TEW_REVIEW (xcompleted);
CREATE INDEX TEW_REVIEW_creatorPerson ON TEW_REVIEW (xcreatorPerson);
CREATE INDEX TEW_REVIEW_deleted ON TEW_REVIEW (xdeleted);
CREATE INDEX TEW_REVIEW_endTime ON TEW_REVIEW (xendTime);
CREATE INDEX TEW_REVIEW_executor ON TEW_REVIEW (xexecutor);
CREATE INDEX TEW_REVIEW_executorIdentity ON TEW_REVIEW (xexecutorIdentity);
CREATE INDEX TEW_REVIEW_executorUnit ON TEW_REVIEW (xexecutorUnit);
CREATE INDEX TEW_REVIEW_name ON TEW_REVIEW (xname);
CREATE INDEX TEW_REVIEW_overtime ON TEW_REVIEW (xovertime);
CREATE INDEX TEW_REVIEW_parent ON TEW_REVIEW (xparent);
CREATE INDEX TEW_REVIEW_permissionObj ON TEW_REVIEW (xpermissionObj);
CREATE INDEX TEW_REVIEW_priority ON TEW_REVIEW (xpriority);
CREATE INDEX TEW_REVIEW_project ON TEW_REVIEW (xproject);
CREATE INDEX TEW_REVIEW_remindRelevance ON TEW_REVIEW (xremindRelevance);
CREATE INDEX TEW_REVIEW_startTime ON TEW_REVIEW (xstartTime);
CREATE INDEX TEW_REVIEW_tagContent ON TEW_REVIEW (xtagContent);
CREATE INDEX TEW_REVIEW_taskId ON TEW_REVIEW (xtaskId);
CREATE INDEX TEW_REVIEW_taskSequence ON TEW_REVIEW (xtaskSequence);
CREATE INDEX TEW_REVIEW_workStatus ON TEW_REVIEW (xworkStatus);
CREATE INDEX TEW_SYSTEMCONFIG_configCode ON TEW_SYSTEMCONFIG (xconfigCode);
CREATE INDEX TEW_TAG_owner ON TEW_TAG (xowner);
CREATE INDEX TEW_TAG_project ON TEW_TAG (xproject);
CREATE INDEX TEW_TAG_tag ON TEW_TAG (xtag);
CREATE INDEX TEW_TASK_archive ON TEW_TASK (xarchive);
CREATE INDEX TEW_TASK_claimed ON TEW_TASK (xclaimed);
CREATE INDEX TEW_TASK_completed ON TEW_TASK (xcompleted);
CREATE INDEX TEW_TASK_creatorPerson ON TEW_TASK (xcreatorPerson);
CREATE INDEX TEW_TASK_deleted ON TEW_TASK (xdeleted);
CREATE INDEX TEW_TASK_endTime ON TEW_TASK (xendTime);
CREATE INDEX TEW_TASK_executor ON TEW_TASK (xexecutor);
CREATE INDEX TEW_TASK_executorIdentity ON TEW_TASK (xexecutorIdentity);
CREATE INDEX TEW_TASK_executorUnit ON TEW_TASK (xexecutorUnit);
CREATE INDEX TEW_TASK_name ON TEW_TASK (xname);
CREATE INDEX TEW_TASK_overtime ON TEW_TASK (xovertime);
CREATE INDEX TEW_TASK_parent ON TEW_TASK (xparent);
CREATE INDEX TEW_TASK_priority ON TEW_TASK (xpriority);
CREATE INDEX TEW_TASK_project ON TEW_TASK (xproject);
CREATE INDEX TEW_TASK_remindRelevance ON TEW_TASK (xremindRelevance);
CREATE INDEX TEW_TASK_reviewed ON TEW_TASK (xreviewed);
CREATE INDEX TEW_TASK_startTime ON TEW_TASK (xstartTime);
CREATE INDEX TEW_TASK_summay ON TEW_TASK (xsummay);
CREATE INDEX TEW_TASK_workStatus ON TEW_TASK (xworkStatus);
CREATE INDEX TEW_TASKDETAIL_project ON TEW_TASKDETAIL (xproject);
CREATE INDEX TEW_TASKEXTFIELD_name ON TEW_TASKEXTFIELD (xname);
CREATE INDEX TEW_TASKEXTFIELD_project ON TEW_TASKEXTFIELD (xproject);
CREATE INDEX TEW_TASKGROUP_creatorPerson ON TEW_TASKGROUP (xcreatorPerson);
CREATE INDEX TEW_TASKGROUP_memo ON TEW_TASKGROUP (xmemo);
CREATE INDEX TEW_TASKGROUP_name ON TEW_TASKGROUP (xname);
CREATE INDEX TEW_TASKGROUP_owner ON TEW_TASKGROUP (xowner);
CREATE INDEX TEW_TASKGROUP_project ON TEW_TASKGROUP (xproject);
CREATE INDEX TEW_TASKGROUP_RELE_project ON TEW_TASKGROUP_RELE (xproject);
CREATE INDEX TEW_TASKGROUP_RELE_taskGroupId ON TEW_TASKGROUP_RELE (xtaskGroupId);
CREATE INDEX TEW_TASKGROUP_RELE_taskId ON TEW_TASKGROUP_RELE (xtaskId);
CREATE INDEX TEW_TASKLIST_creatorPerson ON TEW_TASKLIST (xcreatorPerson);
CREATE INDEX TEW_TASKLIST_deleted ON TEW_TASKLIST (xdeleted);
CREATE INDEX TEW_TASKLIST_memo ON TEW_TASKLIST (xmemo);
CREATE INDEX TEW_TASKLIST_name ON TEW_TASKLIST (xname);
CREATE INDEX TEW_TASKLIST_owner ON TEW_TASKLIST (xowner);
CREATE INDEX TEW_TASKLIST_project ON TEW_TASKLIST (xproject);
CREATE INDEX TEW_TASKLIST_taskGroup ON TEW_TASKLIST (xtaskGroup);
CREATE INDEX TEW_TASKLIST_RELE_project ON TEW_TASKLIST_RELE (xproject);
CREATE INDEX TEW_TASKLIST_RELE_taskGroupId ON TEW_TASKLIST_RELE (xtaskGroupId);
CREATE INDEX TEW_TASKLIST_RELE_taskId ON TEW_TASKLIST_RELE (xtaskId);
CREATE INDEX TEW_TASKLIST_RELE_taskListId ON TEW_TASKLIST_RELE (xtaskListId);
CREATE INDEX TEW_TASKRELEVANCE_bundle ON TEW_TASKRELEVANCE (xbundle);
CREATE INDEX TEW_TASKRELEVANCE_creatorPerson ON TEW_TASKRELEVANCE (xcreatorPerson);
CREATE INDEX TEW_TASKRELEVANCE_name ON TEW_TASKRELEVANCE (xname);
CREATE INDEX TEW_TASKRELEVANCE_project ON TEW_TASKRELEVANCE (xproject);
CREATE INDEX TEW_TASKRELEVANCE_task ON TEW_TASKRELEVANCE (xtask);
CREATE INDEX TEW_TASKRELEVANCE_type ON TEW_TASKRELEVANCE (xtype);
CREATE INDEX TEW_TASKTAG_RELE_owner ON TEW_TASKTAG_RELE (xowner);
CREATE INDEX TEW_TASKTAG_RELE_project ON TEW_TASKTAG_RELE (xproject);
CREATE INDEX TEW_TASKTAG_RELE_tagId ON TEW_TASKTAG_RELE (xtagId);
CREATE INDEX TEW_TASKTAG_RELE_taskId ON TEW_TASKTAG_RELE (xtaskId);
CREATE INDEX TEW_TASKVIEW_creatorPerson ON TEW_TASKVIEW (xcreatorPerson);
CREATE INDEX TEW_TASKVIEW_isExcutor ON TEW_TASKVIEW (xisExcutor);
CREATE INDEX TEW_TASKVIEW_memo ON TEW_TASKVIEW (xmemo);
CREATE INDEX TEW_TASKVIEW_name ON TEW_TASKVIEW (xname);
CREATE INDEX TEW_TASKVIEW_owner ON TEW_TASKVIEW (xowner);
CREATE INDEX TEW_TASKVIEW_project ON TEW_TASKVIEW (xproject);
CREATE INDEX TEW_TASKVIEW_workCompleted ON TEW_TASKVIEW (xworkCompleted);
CREATE INDEX TEW_TASKVIEW_workOverTime ON TEW_TASKVIEW (xworkOverTime);
CREATE INDEX TEW_TASKVIEW_choosePriority_element ON TEW_TASKVIEW_choosePriority (xchoosePriority);
CREATE INDEX TEW_TASKVIEW_choosePriority_join ON TEW_TASKVIEW_choosePriority (TASKVIEW_XID);
CREATE INDEX TEW_TASKVIEW_chooseWorkTag_element ON TEW_TASKVIEW_chooseWorkTag (xchooseWorkTag);
CREATE INDEX TEW_TASKVIEW_chooseWorkTag_join ON TEW_TASKVIEW_chooseWorkTag (TASKVIEW_XID);
CREATE INDEX TEW_TASK_manageablePersonList_element ON TEW_TASK_manageablePersonList (xmanageablePersonList);
CREATE INDEX TEW_TASK_manageablePersonList_join ON TEW_TASK_manageablePersonList (TASK_XID);
CREATE INDEX TEW_TASK_participantList_element ON TEW_TASK_participantList (xparticipantList);
CREATE INDEX TEW_TASK_participantList_join ON TEW_TASK_participantList (TASK_XID);
CREATE INDEX VAL_META_booleanValue ON VAL_META (xbooleanValue);
CREATE INDEX VAL_META_dateTimeValue ON VAL_META (xdateTimeValue);
CREATE INDEX VAL_META_dateValue ON VAL_META (xdateValue);
CREATE INDEX VAL_META_doubleValue ON VAL_META (xdoubleValue);
CREATE INDEX VAL_META_integerValue ON VAL_META (xintegerValue);
CREATE INDEX VAL_META_longValue ON VAL_META (xlongValue);
CREATE INDEX VAL_META_stringValue ON VAL_META (xstringValue);
CREATE INDEX VAL_META_timeValue ON VAL_META (xtimeValue);
CREATE INDEX VAL_META_listValueList_element ON VAL_META_listValueList (xlistValueList);
CREATE INDEX VAL_META_listValueList_join ON VAL_META_listValueList (META_XID);
CREATE INDEX VAL_META_mapValueMap_element ON VAL_META_mapValueMap (xmapValueMap);
CREATE INDEX VAL_META_mapValueMap_join ON VAL_META_mapValueMap (META_XID);
CREATE INDEX VAL_META_mapValueMap_key ON VAL_META_mapValueMap (xkey);
